package org.processmining.common.frame;

import java.awt.Component;

import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.plaf.basic.BasicComboBoxRenderer;

public class ComboBoxRenderer extends BasicComboBoxRenderer
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	JComboBox<String> combo = new JComboBox<String>();
	
	public ComboBoxRenderer(JComboBox<String> combo){
		this.combo = combo;
		
		combo.setPrototypeDisplayValue("configure width");
	}
	
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
	{
		if (isSelected)
		{
			setBackground(list.getSelectionBackground());
			setForeground(list.getSelectionForeground());
			if (-1 < index)
			{
				if(combo.getItemAt(index) != null){
					list.setToolTipText(combo.getItemAt(index).toString());
				}			
			}
		}
		else
		{
			setBackground(list.getBackground());
			setForeground(list.getForeground());
		}
		setFont(list.getFont());
		setText((value == null) ? "" : value.toString());
		return this;
	}
}