package org.processmining.common.frame;
 
import java.awt.BorderLayout;
import java.awt.Desktop;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class CreateLinkInMessageBox extends JPanel {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
    public static void main(String[] argv) throws URISyntaxException {
    
    	JPanel panel = new JPanel();
		// Adds introduction with a link to the OCBC website
		JEditorPane jep = new JEditorPane("text/html", "This software is used to edit and output an OCBC model. "
				+ "It refers to the mxGraph editor and is an open source software. "
				+ "The source codes are available in the OCBC package at <a href='https://svn.win.tue.nl/repos/prom/Packages/OCBC/'>"
			  	+ "https://svn.win.tue.nl/repos/prom/Packages/OCBC/</a>. "
				+ "For more information, please visit <a href='http://www.win.tue.nl/ocbc/'>"
			  	+ "http://www.win.tue.nl/ocbc/</a>.");
		jep.setEditable(false);
		jep.setOpaque(false);
		jep.addHyperlinkListener(new HyperlinkListener() {						
			public void hyperlinkUpdate(HyperlinkEvent hle) {				
			    if (HyperlinkEvent.EventType.ACTIVATED.equals(hle.getEventType())) {
			    	if (Desktop.isDesktopSupported()) {
			    		try {
			  	            try {
								Desktop.getDesktop().browse(new URI(hle.getURL().toString()));
							} catch (URISyntaxException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
			  	          } catch (IOException e) { /* TODO: error handling */ }			  	        		    					  	          
			  	  	 }
			    }
			}
		});
		panel.add(jep, BorderLayout.CENTER);  	
  	   
	  	JFrame f = new JFrame("Manual");
	  	f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	  	f.getContentPane().add(panel, BorderLayout.CENTER);
	  	f.setSize(400, 150);
	  	f.setVisible(true);
    }
}