package org.processmining.common.memory;

import java.util.HashMap;
import java.util.Map;

import org.processmining.ocbc.log.factory.XFactoryRegistry;
import org.processmining.ocbc.log.model.XAttribute;
import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCORelation;
import org.processmining.ocbc.log.model.XOCObject;
import org.processmining.ocbc.log.model.impl.XOCEventImpl;
import org.processmining.ocbc.log.model.impl.XOCORelationImpl;
import org.processmining.ocbc.log.model.impl.XOCObjectImpl;

/**
* Measures the approximate size of an object in memory, given a Class which
* has a no-argument constructor.
*/
public class Sizeof
{
	
    public static void main (String [] args) throws Exception
    {
        // Warm up all classes/methods we will use
        runGC ();
        usedMemory ();
        // Array to keep strong references to allocated objects
        final int count = 100000;
        Object [] objects = new Object [count];
        
        String key = "key";
		String value = "value";
		XAttribute attribute = null;	
		Map<String,XOCObject> idVSObjectMapForLog = new HashMap<String,XOCObject>();
        long heap1 = 0;
        // Allocate count+1 objects, discard the first one
        for (int i = -1; i < count; ++ i)
        {
            Object object = null;
            
            // Instantiate your data here and assign it to object
            object = new XOCEventImpl ();
//            object = new XOCObjectImpl("null");
//              object = new XOCORelationImpl("null");
//            object = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
            
//            object = new ArrayList<String>();
//            object.add("1");
//            object.add("2");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            object.add("3");
//            
//            int k = object.size();
            
//            object = new HashMap<String, String>();
//            Map<String, String> mapMy = (HashMap<String, String>) object;
//            mapMy.put("1", "hello");
//            mapMy.put("2", "hello");
//            mapMy.put("3", "hello");
//            mapMy.put("4", "hello");
            
//            object = new XOCObjectModelImpl ();
            
			XOCEvent eventXOC = (XOCEventImpl) object;
			eventXOC.setOrderNum(1);
			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
			eventXOC.getAttributes().put(attribute.getKey(), attribute);
			
			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
			eventXOC.getAttributes().put("2", attribute);
		
			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
			eventXOC.getAttributes().put("3", attribute);
//			
//			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
//			eventXOC.getAttributes().put("4", attribute);
//			
//			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
//			eventXOC.getAttributes().put("5", attribute);
//			
//			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
//			eventXOC.getAttributes().put("6", attribute);
//			
//			attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
//			eventXOC.getAttributes().put("7", attribute);
			
//			
            int objectNumInObjectModel = 4;
            int attributeNumInObject = 5;
            int objectRelationNumInObjectModel = 3;
            int attributeNumInObjectRelation = 4;
//            int relatedObjectNumInEvent = 3;
//            
        	//add object to object model
            for(int j=0; j<objectNumInObjectModel; j++){
                XOCObject objectXOC = new XOCObjectImpl("objectXOC");	
                
                String objectId = "objectXOC" + j;		
                for(int k=0; k<attributeNumInObject; k++){
                	attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
                	objectXOC.getAttributes().put(attribute.getKey() + k, attribute);
                }             
                eventXOC.getObjectModel().getObjectSet().add(objectXOC);
//                idVSObjectMapForLog.put(objectId, objectXOC);
            }
//            
        	//add object relation to object model
            for(int j=0; j<objectRelationNumInObjectModel; j++){
            	XOCORelation objectRelation = new XOCORelationImpl("objectXOC");	
                for(int k=0; k<attributeNumInObjectRelation; k++){
                	attribute = XFactoryRegistry.instance().currentDefault().createAttributeLiteral(key, value, null);
                	objectRelation.getAttributes().put(attribute.getKey() + k, attribute);
                }             
                eventXOC.getObjectModel().getObjectRelationSet().add(objectRelation);
            }
//            
//            //add related objects to event
//            for(int j=0; j<relatedObjectNumInEvent; j++){
//            	XOCObject objectXOC = (XOCObject) idVSObjectMapForLog.values().toArray()[0];	
//                eventXOC.getRelatedObjects().add(objectXOC);
//            }
            

            
            //object = new Object ();
            //object = new Integer (i);
            //object = new Long (i);
            //object = new String ();
            //object = new byte [128][1]
            
            if (i >= 0)
                objects [i] = object;
            else
            {
                object = null; // Discard the warm up object
                runGC ();
                heap1 = usedMemory (); // Take a before heap snapshot
            }
        }
        runGC ();
        long heap2 = usedMemory (); // Take an after heap snapshot:
        
        final int size = Math.round (((float)(heap2 - heap1))/count);
        System.out.println ("'before' heap: " + heap1 +
                            ", 'after' heap: " + heap2);
        System.out.println ("heap delta: " + (heap2 - heap1) +
            ", {" + objects [0].getClass () + "} size = " + size + " bytes");
        for (int i = 0; i < count; ++ i) objects [i] = null;
        objects = null;
    }
    private static void runGC () throws Exception
    {
        // It helps to call Runtime.gc()
        // using several method calls:
        for (int r = 0; r < 4; ++ r) _runGC ();
    }
    private static void _runGC () throws Exception
    {
        long usedMem1 = usedMemory (), usedMem2 = Long.MAX_VALUE;
        for (int i = 0; (usedMem1 < usedMem2) && (i < 500); ++ i)
        {
            s_runtime.runFinalization ();
            s_runtime.gc ();
            Thread.currentThread ().yield ();
            
            usedMem2 = usedMem1;
            usedMem1 = usedMemory ();
        }
    }
    private static long usedMemory ()
    {
        return s_runtime.totalMemory () - s_runtime.freeMemory ();
    }
    
    private static final Runtime s_runtime = Runtime.getRuntime ();
} // End of class