package org.processmining.common.number;
import javax.swing.JOptionPane;

public class ParseNumberFromString {

	private String inputText;
	public ParseNumberFromString(String inputText){
		this.inputText = inputText;
	}
	
	public ParseNumberFromString(){
	}
	
	/**
	 * parse an integer from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @param failureMessage
	 * @return
	 */
	public Integer parseInteger(String failureMessage){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, failureMessage);
	    }
		return parsedInteger;
	}
	
	/**
	 * parse an integer from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @param inputText
	 * @return
	 */
	public Integer parseIntegerFromString(String inputText){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, "Please input a integer!");
	    }
		return parsedInteger;
	}
	
	/**
	 * parse an integer from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @param inputText
	 * @param failureMessage
	 * @return
	 */
	public Integer parseIntegerFromString(String inputText, String failureMessage){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, failureMessage);
	    }
		return parsedInteger;
	}
	
	/**
	 * parse an integer from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @return
	 */
	public Integer parseInteger(){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, "Please input a integer!");
	    }
		return parsedInteger;
	}
	
	/**
	 * parse a integer from a input string with boundary;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @param inputText
	 * @param minimal
	 * @param maximal
	 * @return
	 */
	public Integer parseIntegerFromStringWithBoundary(String inputText, Integer minimal, Integer maximal){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
			if(minimal > parsedInteger || parsedInteger > maximal){
				JOptionPane.showMessageDialog(null, "Wrong! The input integer should be in " + "[" + minimal + ", " + maximal + "]");
				return null;
			}
			
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, "Wrong! Please input an integer in " + "[" + minimal + ", " + maximal + "]");
	    	return null;
	    }

		return parsedInteger;
	}
	
	/**
	 * parse a integer from a input string with boundary;
	 * if fails, show a message box and return null; otherwise return the parsed integer.
	 * @param inputText
	 * @param minimal
	 * @param maximal
	 * @param message
	 * @return
	 */
	public Integer parseIntegerFromStringWithBoundary(String inputText, Integer minimal, Integer maximal, String message){
		Integer parsedInteger = null;
		try{
			parsedInteger = Integer.parseInt(inputText);
			if(minimal > parsedInteger || parsedInteger > maximal){
//				JOptionPane.showMessageDialog(null, "Wrong! The input should be an integer in " + "[" + minimal + ", " + maximal + "]");
				JOptionPane.showMessageDialog(null, message);
				return null;
			}
			
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, message);
	    	return null;
	    }

		return parsedInteger;
	}
	
	/**
	 * parse a decimal from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed decimal.
	 * @param inputText
	 * @param failureMessage
	 * @return
	 */
	public Double parseDoubleFromString(String inputText, String failureMessage){
		Double parsedDecimal = null;
		try{
			parsedDecimal = Double.parseDouble(inputText);
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, failureMessage);
	    }
		return parsedDecimal;
	}
	
	/**
	 * parse a decimal from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed decimal.
	 * @param inputText
	 * @param minimal
	 * @param maximal
	 * @param message
	 * @return
	 */

	public Double parseDoubleFromStringWithBoundary(String inputText, double minimal, double maximal, String message){
		Double parsedDecimal = null;
		try{
			parsedDecimal = Double.parseDouble(inputText);
			if(minimal > parsedDecimal || parsedDecimal > maximal){
				JOptionPane.showMessageDialog(null, message);
				return null;
			}
			
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, message);
	    	return null;
	    }

		return parsedDecimal;
	}
	
	/**
	 * parse a decimal from a input string;
	 * if fails, show a message box and return null; otherwise return the parsed decimal.
	 * @param inputText
	 * @param minimal
	 * @param maximal
	 * @return
	 */

	public Double parseDoubleFromStringWithBoundary(String inputText, double minimal, double maximal){
		Double parsedDecimal = null;
		try{
			parsedDecimal = Double.parseDouble(inputText);
			if(minimal > parsedDecimal || parsedDecimal > maximal){
//				JOptionPane.showMessageDialog(null, "Wrong! The input should be a decimal in " + "[" + minimal + ", " + maximal + "]");
				JOptionPane.showMessageDialog(null, "Wrong! The input should be a decimal in " + "[" + minimal + ", " + maximal + "]");
				return null;
			}
			
	    }
	    catch(NumberFormatException nfe){
	    	JOptionPane.showMessageDialog(null, "Wrong! Please input a decimal in " + "[" + minimal + ", " + maximal + "]");
	    	return null;
	    }

		return parsedDecimal;
	}
	
    public static void main(String[] args) {
    	ParseNumberFromString parseNumberFromString = new ParseNumberFromString("4");
//    	parseNumberFromString.parseDoubleFromStringWithBoundary(0,1);
//    	parseNumberFromString.parseIntegerFromStringWithBoundary(0, Integer.MAX_VALUE);
    }
}