package org.processmining.common.runningtime;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;


public class RunningTime {
	
	public RunningTime() {
		
	}	

	/**
	 * output the running time information into a txt file.
	 * @param wirteLine The words are written into the file
	 * @param clearFile True: clear the file specified by the path
	 * @param absolutePath Indicate the file path; if null, the default path "D:\\timeDiscovery.txt" is used
	 */
	public static void writeTimeInformationIntoFile(String wirteLine, boolean clearFile, String absolutePath){
		String path = "D:\\timeDiscovery.txt";//set the default path in case the input path is null
		if(absolutePath != null){
			path = absolutePath;
		}
		File log = new File(path);
	    try{
		    if(log.exists()==false || clearFile){
	            System.out.println("We made a new file for recording running time information.");
//	            System.out.println("wirteLine: " + wirteLine);
//	            System.out.println("clearFile: " + clearFile);
//	            System.out.println("absolutePath: " + absolutePath);
	            log.delete();
	            log.createNewFile();
	          
		    }
		    PrintWriter out = new PrintWriter(new FileWriter(log, true));
		    out.append(wirteLine + "\n");
		    out.close();
	    }catch(IOException e){
	        System.out.println("COULD NOT LOG!!");
	    }
	}
	
    public static void main(String[] args) throws Exception {
    	String timeStamp = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Calendar.getInstance().getTime());
		RunningTime.writeTimeInformationIntoFile("current time: " + timeStamp, false, "D:\\test.txt");
    	RunningTime.writeTimeInformationIntoFile("output information", false, "D:\\test.txt");
    }
}
