package org.processmining.common.table;
 
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

 
/**
 * @version 1.0
 * @author guangming
 *
 */
public class CreateTablePanel extends JPanel { 
//public class CreateTablePanel extends JScrollPane { 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private JTable table;
    private MyTableModel model;

    
    private String tableName;
    private JScrollPane scrollpane;
    public CreateTablePanel(String tableName) {   	
    	model = new MyTableModel();
	    table = new JTable(model);
	    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);// 水平滚动条	      
	    table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
//	      table.setPreferredScrollableViewportSize(new Dimension(500, 300));
//	      table.setFillsViewportHeight(true);	      
	    scrollpane = new JScrollPane(table);
	    this.add(scrollpane);
    }

    public void updateTable(){
    	model.fireTableStructureChanged();
    }
    
    public JScrollPane getScrollPane(){
    	return scrollpane;
    }
    
    public MyTableModel getTableModel(){
    	return model;
    }
    
    public String getTableName(){
    	return tableName;
    }
    
    public JTable getTable(){
    	return table;
    }
    public void setFieldRow(List<String> nameList) {
    	if(nameList != null){
            for(int i=0; i<nameList.size(); i++){
            	model.setName(nameList.get(i), i);
            }
            model.setC(nameList.size());
            model.fireTableStructureChanged();
    	}
    }
    
	public void addRecordRow(List<Object> valueList) {
		if(valueList != null){
			int currentRowCount = model.getRowCount();
			model.setRC(currentRowCount+1, currentRowCount, 0);
	        for(int i=0; i<valueList.size(); i++){
	        	model.setRC(valueList.get(i), currentRowCount, i+1);
	        }
	        model.setR(currentRowCount+1);
	        model.fireTableStructureChanged();
		}
	}

//	public void addRecordRow(List<Object> valueList) {
//		if(valueList != null){
//			int currentRowCount = model.getRowCount();
//			model.setRC(currentRowCount+1, currentRowCount, 0);
//	        for(int i=0; i<valueList.size(); i++){
//	        	model.setRC(valueList.get(i), currentRowCount, i+1);
//	        }
//	        model.setR(currentRowCount+1);
//	        model.fireTableStructureChanged();
//		}
//	}
	
	public List<Object> getRecordRow(int row){
		List<Object> valueList = new ArrayList<Object>();
		int columnCount = model.getColumnCount();
		for(int i=0; i<columnCount; i++){
			valueList.add(model.getValueAt(row, i));
		}		
		return valueList;
	}
	
	public int getRowCount(){	
		return model.getRowCount();
	}
	   
	public void clearAllTableRows(){
		model.setR(0);
		updateTable();
	}
	
    public static void main(String[] args) {
    	CreateTablePanel createTablePanel = new CreateTablePanel("");
//    	createTablePanel.getScrollPane().setSize(2000, 5000);
    	//
	    int C = 10;
    	MyTableModel model = (MyTableModel) createTablePanel.getTable().getModel();
	      model.setC(C); 
	      model.setName("index", 0);
	      model.setName("field", 1);
	      model.setName("field2324353", 2);
	      model.setName("field", 3);
	      model.setName("field", 4);
	      model.setValueAt("0", 0, 0);
	      model.setValueAt("name0", 0, 1);
	      model.setValueAt("1", 1, 0);
	      model.setValueAt("name1", 1, 1);
	      model.setValueAt("2", 2, 0);
	      model.setValueAt("name2", 2, 1);
	      model.setR(3);
	      model.setR(0);
	      model.setValueAt("0", 0, 0);
	      model.setValueAt("name0", 0, 1);
	      model.setR(1);
	      createTablePanel.getTable().setModel(model);
	      createTablePanel.updateTable();
    	createTablePanel.getTable().setPreferredScrollableViewportSize(new Dimension(1000, 300));
    	JFrame frame = new JFrame();
		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		frame.add(createTablePanel);
		frame.setVisible(true);
    }
}