package org.processmining.common.table;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
 
public class MyTableModel2 extends AbstractTableModel {
    private static final long serialVersionUID = 1L;
    
    private int r = 0;
    private int c = 0;
//    private Object[][] store;
//    private String[] names;
    private List<List<Object>> storeMatrix = new ArrayList<List<Object>>();
    private List<String> nameList = new ArrayList<String>();
    private String tableName;
//    public static final int MAXR = 100000;
//    public static final int MAXC = 200;
    
    public MyTableModel2() {
//        store = new Object[MAXR][MAXC];
//        names = new String[MAXC];
    	System.out.println("new table model dynamic");
    }
 
    public int getColumnCount() {
 
        return c;
    }
 
    public int getRowCount() {
 
        return r;
    }
 
    public boolean isCellEditable(int row, int col) {
    	 
//        if (col < 2) {
            return true;
//        } else {
//            return false;
//        }
    }
    
    public Object getValueAt(int row, int col) {
//    	if(store[arg0][arg1] == null){
//    		System.out.println("\n store[arg0][arg1] == null");
//    		store[arg0][arg1] = "null";
//    	}
////    	fireTableCellUpdated(arg0, arg1);
//        return store[arg0][arg1];
    	if(row >= storeMatrix.size()){
    		for(int i=0; i<=row-storeMatrix.size(); i++){
    			storeMatrix.add(new ArrayList<Object>());
    		}
    	}
    	int rowLength = col-storeMatrix.get(row).size();
    	if(col >= rowLength){
    		for(int i=0; i<=rowLength; i++){
    			storeMatrix.get(row).add("null");
    		}
    	}
    	
    	if(storeMatrix.get(row).get(col) == null){
    		storeMatrix.get(row).set(col, "null");
    	}
//    	fireTableCellUpdated(arg0, arg1);
        return storeMatrix.get(row).get(col);
    }
 
    public void setValueAt(Object value, int row, int col) {
    	if(value != null){
        	if(row >= storeMatrix.size()){
        		for(int i=0; i<=row-storeMatrix.size(); i++){
        			storeMatrix.add(new ArrayList<Object>());
        		}
        	}
        	int rowLength = col-storeMatrix.get(row).size();
        	if(col >= rowLength){
        		for(int i=0; i<=rowLength; i++){
        			storeMatrix.get(row).add("null");
        		}
        	}

            if (storeMatrix.get(row).get(col) instanceof Integer && !(value instanceof Integer)) {
                try {
                	storeMatrix.get(row).set(col,new Integer(value.toString()));
                    fireTableCellUpdated(row, col);
                } catch (NumberFormatException e) {
//                    JOptionPane.showMessageDialog(TableCheck.this, "The \""
//                            + getColumnName(col)
//                            + "\" column accepts only integer values.");
                }
            } else {
            	storeMatrix.get(row).set(col, value);
            	fireTableCellUpdated(row, col);
            }

    	}
    }

    private void printDebugData() {
//        int numRows = getRowCount();
//        int numCols = getColumnCount();
//        int selectedRowCount = 0;
//        for (int i = 0; i < numRows; i++) {
//            System.out.print(" row " + i + ":");
//            if((boolean) store[i][0]) selectedRowCount ++;
//            for (int j = 0; j < numCols; j++) {
//                System.out.print(" " + store[i][j]);
//            }
//            System.out.println();
//        }
////        selectedRowNumber.setName("row number: " + selectedRowCount);
//        System.out.println("--------------------------");
    }
    
    public String getColumnName(int columnIndex) {
//        if(columnIndex < MAXC){
//    		return names[columnIndex];
//    	}
//        else
//        	return "";
        if(nameList.size() > columnIndex){
    		return nameList.get(columnIndex);
    	}
        else
        	return "";
    }
    
    public void setName(String s1, int pos) {
//    	if(pos < MAXC){
//    		names[pos] = s1;
//    	}   

    	if(pos >= nameList.size()){
     		for(int i=0; i<=pos-nameList.size(); i++){
     			nameList.add("null");
     		}
     	}
    	nameList.set(pos, s1);
    }
 
    public void setC(int c) {
        this.c = c;
    }
 
    public void setR(int r) {
        this.r = r;
    }
 
    public void setRC(Object rs, int r1, int c1) {
//        store[r1][c1] = rs;
    	setValueAt(rs, r1, c1);
    }
    
    //set the table content
//    public void setStore(Object[][] store) {
//        this.store = store;
//    }
    
//    public Object[][] getStore() {
//        return store;
//    }
    
    //set the column names
    public void setNames(String[] names) {
    	this.c = names.length;
//        this.names = names;
    	nameList = new ArrayList<>();
    	for(int i=0; i<names.length; i++){
    		nameList.add(names[i]);
    	}
    }
    
   @Override
    public Class getColumnClass(int c) {
//    	System.out.println("\n table structure getColumnClass");
    	return getValueAt(0, c).getClass();
  	}

   public void updateTable(){
   		fireTableStructureChanged();
   }
   
   public String getTableName(){
   		return tableName;
   }
   
   //remove the index column
   public List<String> getFieldRow() {
	   List<String> columNameList = new ArrayList<String>();	
	   for(int i=1; i<c; i++){
		   columNameList.add(nameList.get(i));
	   }
	   return columNameList;
   }
   
   //automatically add the index column
   public void setFieldRow(List<String> nameList) {
	   	if(nameList != null){
	   		setName("index", 0);
            for(int i=0; i<nameList.size(); i++){
            	setName(nameList.get(i), i+1);
            }
            setC(nameList.size()+1);
            fireTableStructureChanged();
	   	}
   }
   
   //by default, add a index value for the add row
   public void addRecordRow(List<Object> valueList) {
		if(valueList != null){
			int currentRowCount = getRowCount();
			setRC(currentRowCount+1, currentRowCount, 0);
	        for(int i=0; i<valueList.size(); i++){
	        	setRC(valueList.get(i), currentRowCount, i+1);
	        }
	        setR(currentRowCount+1);
	        fireTableStructureChanged();
		}
	}

	public void removeRecordRow(int rowIndex) {		
		List<List<Object>> rowContentsList = new ArrayList<List<Object>>();
		for(int i=0; i<getRowCount(); i++){
			if(rowIndex != i){
				List<Object> rowContents = getRecordRow(i);
				rowContentsList.add(rowContents);
			}
					
		}
		clearAllTableRows();
		for(List<Object> rowContents : rowContentsList){
			addRecordRow(rowContents);
		}
	}
	
	public void removeRecordRowSet(int[] rowIndexSet) {	
		Arrays.sort(rowIndexSet);		
		for(int i=rowIndexSet.length-1; i>=0; i--){
			removeRecordRow(rowIndexSet[i]);
			System.out.println("selected index： " + rowIndexSet[i]);
			updateTable();
		}
	}
	
	//get contents of a row except the first column (index)
	public List<Object> getRecordRow(int row){
		List<Object> valueList = new ArrayList<Object>();
		int columnCount = getColumnCount();
		for(int i=1; i<columnCount; i++){
			valueList.add(getValueAt(row, i));
		}		
		return valueList;
	}	
	
    /*
     * get the index of column by name without taking into consideration the first column ("index")
     * input: column name
     * output: index of existent column (>0) or -1 (the column is inexistent)
     */
    public int getColumnIndexByName(String columnName) {
    	int index = -1;
    	List<String> columnNameList = getFieldRow();
    	for(int i=0; i<columnNameList.size(); i++){
    		if(columnNameList.get(i).equals(columnName)){
    			index = i;
    			break;
    		}
    	}
    	if(index == -1){
    		System.out.println("input column: " + columnName);
    		for(String column : columnNameList){
    			System.out.println("existent column: " + column);
    		}
    		JOptionPane.showMessageDialog(null, "Wrong! the column " + columnName + " does not exist in the table");
    	}
    	return index;
    }
    
    /*
     * select record list where the constraint column = value (e.g., get * with fk_commande=5)
     * input: constraint column name (constraintColumn, nullable: no)
     * and constraint value (constraintValue, nullable: no)
     * output: target column value list (size == 0, if there is no values satisfying the constraint or targetColumn == null) 
     */
	public List<List<Object>> getRecordListWithColumnConstraint(String constraintColumn, String constraintValue){
		List<List<Object>> recordList = new ArrayList<List<Object>>();
		if(constraintColumn != null && constraintValue != null){
			System.out.println("constraintColumn: " + constraintColumn);
			int constraintColumnIndex = getColumnIndexByName(constraintColumn);
			System.out.println("constraintColumnIndex: " + constraintColumnIndex);
			for(int i=0; i<r; i++){
				List<Object> recordValueList = getRecordRow(i);
				String constraintColumnValue = (String) recordValueList.get(constraintColumnIndex);
				if(constraintValue.equals(constraintColumnValue)){
					recordList.add(recordValueList);
				}
			}
		}
		else{
			JOptionPane.showMessageDialog(null, "Wrong! The input parameters constraint column or"
					+ " value should not be null; return a empty list of list (List<List<Object>>)");
		}			
		return recordList;
	}	
	
    /*
     * select values of target column where the constraint column = value (e.g., get fk_commade with rowid=5)
     * input: target column name (targetColumn, nullable: no), constraint column name (constraintColumn, nullable: yes)
     * and constraint value (constraintValue, nullable: yes)
     * output: target column value list (size == 0, if there is no values satisfying the constraint or targetColumn == null) 
     */
	public List<Object> getColumnValuesWithColumnConstraint(String targetColumn, String constraintColumn, String constraintValue){
		List<Object> valueList = new ArrayList<Object>();
		if(targetColumn != null){			
			System.out.println("constraintColumn: " + constraintColumn);
			int targetColumnIndex = getColumnIndexByName(targetColumn);
			System.out.println("targetColumnIndex: " + targetColumnIndex);
			if(constraintColumn != null && constraintValue != null){
				int constraintColumnIndex = getColumnIndexByName(constraintColumn);
				for(int i=0; i<r; i++){
					List<Object> recordValueList = getRecordRow(i);
					String constraintColumnValue = (String) recordValueList.get(constraintColumnIndex);
					if(constraintValue.equals(constraintColumnValue)){
						valueList.add(recordValueList.get(targetColumnIndex));
					}
				}
			}
			else{//there are no constraints
				for(int i=0; i<r; i++){
					List<Object> recordValueList = getRecordRow(i);
					valueList.add(recordValueList.get(targetColumnIndex));
				}
			}
		}
		else{
			JOptionPane.showMessageDialog(null, "Wrong! The target column should not be null; return a empty list");
		}			
		return valueList;
	}	
	
	public void clearAllTableRows(){
		setR(0);
	}
 
	public void copyToModel(MyTableModel2 inputModel){
//		inputModel.clearAllTableRows();
//		inputModel.setC(0);
//		inputModel.setR(0);
		
		
		inputModel.setFieldRow(getFieldRow());
		for(int i=0; i<getRowCount(); i++){
			inputModel.addRecordRow(getRecordRow(i));
			System.out.println("record size" + getRecordRow(i).size());
		}
		System.out.println(getColumnCount());
//		inputModel.setStore(store);
		inputModel.setC(c);
		inputModel.setR(r);
		
//		for(inputModel.names){
//			
//		}
	}
}