package org.processmining.dolibarr.operationrobot.io;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.mxgraph.util.mxConstants;

 
 
public class AlignSimulationLogForDolibarr {
 
	private List<String> alignedEventList = new ArrayList<String>();
	private Map<String, List<String>> alignedActivityVSAttributeList = new HashMap<String, List<String>>();
	private Map<String, Map<String, Object>> alignedEventVSAttributeNameVSAttributeContent = new HashMap<String, Map<String, Object>>();
	
	private Map<String, List<String>> orderVSOrderLineList = new HashMap<String, List<String>>();
	private Map<String,String> orderLineIdVSOrderId = new HashMap<String, String>();
	
	private Map<String, List<String>> invoiceVSOrderList = new HashMap<String, List<String>>();
	private Map<String, List<String>> invoiceVSOrderLineList = new HashMap<String, List<String>>();
	
	private Map<String, List<String>> shipmentVSOrderList = new HashMap<String, List<String>>();
	private Map<String, List<String>> shipmentVSOrderLineList = new HashMap<String, List<String>>();
	
	//record the cardinality information
	private Map<String, List<String>> paymentVSInvoiceList = new HashMap<String, List<String>>();
	private Map<String, List<String>> invoiceVSPaymentList = new HashMap<String, List<String>>();
	private Map<String, List<String>> orderVSInvoiceList = new HashMap<String, List<String>>();
	private Map<String, List<String>> orderVSShipmentList = new HashMap<String, List<String>>();
	
	private Map<String, Map<String, String>> objectIdVSAttributeNameVSValue = new HashMap<String, Map<String, String>>();
	private int globalEventIndex = 1;
	boolean parsedFlag = false;//indicate if the log is already parsed (i.e., if the parseLog method is called)
	
	public List<String> getEventList(){
		return alignedEventList;
	}
	
	public Map<String, List<String>> getActivityVSAttributeListMap(){
		return alignedActivityVSAttributeList;
	}
	
	public Map<String, Map<String, Object>> getEventVSAttributeNameVSAttributeContentMap(){
		return alignedEventVSAttributeNameVSAttributeContent;
	}
	
	public void alignSimulationLog(List<String> eventList, Map<String, List<String>> activityVSAttributeListInput,
			Map<String, Map<String, Object>> eventVSAttributeNameVSAttributeContentInput){
		//clone the input eventVSAttributeNameVSAttributeContentInput
		Map<String, List<String>> activityVSAttributeList = new HashMap<String, List<String>>();
		for(String activity : activityVSAttributeListInput.keySet()){
			activityVSAttributeList.put(activity, new ArrayList<String>());
			for(String attribute : activityVSAttributeListInput.get(activity)){
				activityVSAttributeList.get(activity).add(attribute);
			}
		}
		Map<String, Map<String, Object>> eventVSAttributeNameVSAttributeContent = new HashMap<String, Map<String, Object>>();
		for(String eventId : eventVSAttributeNameVSAttributeContentInput.keySet()){
			eventVSAttributeNameVSAttributeContent.put(eventId, new HashMap<String, Object>());
			for(String attributeName : eventVSAttributeNameVSAttributeContentInput.get(eventId).keySet()){
				Object attributeValue = eventVSAttributeNameVSAttributeContentInput.get(eventId).get(attributeName);
				if(attributeValue instanceof List){
					List<Map<String, Object>> paymentLineList = (List<Map<String, Object>>) attributeValue;
					List<Map<String, Object>> paymentLineListClone = new ArrayList<Map<String, Object>>();
					for(Map<String, Object> paymentLine: paymentLineList){
						Map<String, Object> paymentLineClone = new HashMap<String, Object>();
							for(String attribute : paymentLine.keySet()){
								paymentLineClone.put(attribute, paymentLine.get(attribute));
							}
						paymentLineListClone.add(paymentLineClone);
					}
					eventVSAttributeNameVSAttributeContent.get(eventId).put(attributeName, paymentLineListClone);
				}
				else{
					eventVSAttributeNameVSAttributeContent.get(eventId).put(attributeName, attributeValue);
				}
			}
				
		}		
		
		for(String eventId : eventList){
			System.out.println("eventId in align log kfgz: " + eventId);
        	String activity = eventId.split("\\)")[1];
        	System.out.println("activity in align log: " + activity);
        	
        	
			if(activity.equals(mxConstants.createCustomerOrder)){		
				System.out.println("equal to: " + mxConstants.createCustomerOrder);
				String orderId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.orderId);
				orderVSOrderLineList.put(orderId, new ArrayList<String>());
				System.out.println("orderId: " + orderId);
				String newEventId = "(" + (globalEventIndex ++) + ")" + activity;
				alignedEventList.add(newEventId);
				alignedActivityVSAttributeList.put(activity, activityVSAttributeList.get(activity));
				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));
			}
			else if(activity.equals(mxConstants.addCustomerOrderLine)){
				System.out.println("equal to: " + mxConstants.addCustomerOrderLine);
				String orderId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.orderId);
				String orderLineId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.orderLineId);
				String productName = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.productName);//should be standardized in future, such as "productName"
				String warehouseName = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.warehouse);
				System.out.println("eventId: " + eventId);
				System.out.println("orderId: " + orderId);
				System.out.println("orderLineId: " + orderLineId);
				orderVSOrderLineList.get(orderId).add(orderLineId);
				orderLineIdVSOrderId.put(orderLineId, orderId);
				objectIdVSAttributeNameVSValue.put(orderLineId, new HashMap<String, String>());
				objectIdVSAttributeNameVSValue.get(orderLineId).put(mxConstants.productName, productName);
				objectIdVSAttributeNameVSValue.get(orderLineId).put(mxConstants.warehouse, warehouseName);
				
				String newEventId = "(" + (globalEventIndex ++) + ")" + activity;
				alignedEventList.add(newEventId);
				alignedActivityVSAttributeList.put(activity, activityVSAttributeList.get(activity));
				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));
			}
			//record the corresponding order line list and order list for each invoice
//			else if(activity.equals(mxConstants.createCustomerInvoice)){
//
//				String invoiceId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.invoiceId);
//				if(!invoiceVSOrderLineList.containsKey(invoiceId)){
//					invoiceVSOrderLineList.put(invoiceId, new ArrayList<String>());
//				}
//				if(!invoiceVSOrderList.containsKey(invoiceId)){
//					invoiceVSOrderList.put(invoiceId, new ArrayList<String>());
//				}
//
//				List<Map<String, Object>> invoiceLineList = (List<Map<String, Object>>) eventVSAttributeNameVSAttributeContent
//						.get(eventId).get(mxConstants.invoiceLines);
//				for(Map<String, Object> invoiceLine : invoiceLineList){
//					String orderLineId = (String) invoiceLine.get(mxConstants.orderLineId);
//					if(!invoiceVSOrderLineList.get(invoiceId).contains(orderLineId)){
//						invoiceVSOrderLineList.get(invoiceId).add(orderLineId);
//					}
//					String orderId = orderLineIdVSOrderId.get(orderLineId);
//					if(!invoiceVSOrderList.get(invoiceId).contains(orderId)){
//						invoiceVSOrderList.get(invoiceId).add(orderId);
//					}
//					if(!orderVSInvoiceList.containsKey(orderId)){
//						orderVSInvoiceList.put(orderId, new ArrayList<String>());
//					}
//					if(!orderVSInvoiceList.get(orderId).contains(invoiceId)){
//						orderVSInvoiceList.get(orderId).add(invoiceId);
//					}
//				}
//				
//				//update the activity based on the order list size
//				//if corresponding one order, the activity is create_customer_invoice_for_one_order
//				//otherwise, the activity is create_customer_invoice_for_multiple_orders
//				if(invoiceVSOrderList.get(invoiceId).size() == 1){
//					String newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerInvoiceForOneOrder;
//					activityVSAttributeList.get(activity).remove(mxConstants.invoiceLines);//remove the line attributes
//					eventVSAttributeNameVSAttributeContent.get(eventId).remove(mxConstants.invoiceLines);//remove the line attributes
//					String orderId = invoiceVSOrderList.get(invoiceId).get(0);
//					alignedEventList.add(newEventId);
//					alignedActivityVSAttributeList.put(mxConstants.createCustomerInvoiceForOneOrder, activityVSAttributeList.get(activity));
//					alignedActivityVSAttributeList.get(mxConstants.createCustomerInvoiceForOneOrder).add(mxConstants.orderId);
//					alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));	
//					alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.orderId, orderId);														
//				}
//				else{
//					String newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerInvoiceForMultipleOrders;
//					alignedEventList.add(newEventId);
//					alignedActivityVSAttributeList.put(mxConstants.createCustomerInvoiceForMultipleOrders, activityVSAttributeList.get(activity));
//					alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));									
//				
//					//add the checking order events
//					for(String orderId : invoiceVSOrderList.get(invoiceId)){
//						//add new checking order events
//						String activityName = mxConstants.checkCustomerOrderForOneCustomer;
//						String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + activityName;
//						List<String> checkOrderActivityAttributeList = new ArrayList<String>();
//						checkOrderActivityAttributeList.add(mxConstants.orderId);
//						Map<String, Object> attributeNameVSAttributeContent = new HashMap<String, Object>();
//						attributeNameVSAttributeContent.put(mxConstants.orderId, orderId);
//						alignedEventList.add(newCreatedEventId);
//						alignedActivityVSAttributeList.put(activityName, checkOrderActivityAttributeList);
//						alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, attributeNameVSAttributeContent);
//					}
//					
//					//add event: generating invoice after checking orders
//					String activityName = mxConstants.generateInvoiceAfterCheckingOrders;
//					String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + activityName;
//					List<String> checkOrderActivityAttributeList = new ArrayList<String>();					
//					Map<String, Object> attributeNameVSAttributeContent = new HashMap<String, Object>();
//					
//					alignedEventList.add(newCreatedEventId);
//					alignedActivityVSAttributeList.put(activityName, checkOrderActivityAttributeList);
//					alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, attributeNameVSAttributeContent);
//				}
//								
//				//add the removing invoice line events
//				for(String orderId : invoiceVSOrderList.get(invoiceId)){
//					for(String orderLineId : orderVSOrderLineList.get(orderId)){
//						//add new created events
//						String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.removeCustomerInvoiceLine;
//						alignedEventList.add(newCreatedEventId);
//						alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, new HashMap<String, Object>());
//					}
//				}
//				//add the adding invoice line events
//				for(String orderLineId : invoiceVSOrderLineList.get(invoiceId)){
//					int index = invoiceVSOrderLineList.get(invoiceId).indexOf(orderLineId);
//					String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.addCustomerInvoiceLine;
//					alignedEventList.add(newCreatedEventId);
//					alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, invoiceLineList.get(index));
//				}
//				System.out.println("order list size: " + invoiceVSOrderList.get(invoiceId).size());
//				System.out.println("order line list size: " + invoiceVSOrderLineList.get(invoiceId).size());
//				
//				List<String> invoiceLineAttributeList = new ArrayList<String>();
//				if(invoiceLineList.size() > 0){
//					invoiceLineAttributeList = new ArrayList<String>(invoiceLineList.get(0).keySet());
//				}
//				alignedActivityVSAttributeList.put(mxConstants.removeCustomerInvoiceLine, new ArrayList<String>());
//				alignedActivityVSAttributeList.put(mxConstants.addCustomerInvoiceLine, invoiceLineAttributeList);
//
//			}
			//record the corresponding order line list and order list for each shipment.to do
//			else if(activity.equals(mxConstants.createCustomerShipment)){
//
//				String shipmentId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.shipmentId);
//				if(!shipmentVSOrderLineList.containsKey(shipmentId)){
//					shipmentVSOrderLineList.put(shipmentId, new ArrayList<String>());
//				}
//				if(!shipmentVSOrderList.containsKey(shipmentId)){
//					shipmentVSOrderList.put(shipmentId, new ArrayList<String>());
//				}
//				List<Map<String, Object>> shipmentLineList = (List<Map<String, Object>>) eventVSAttributeNameVSAttributeContent
//						.get(eventId).get(mxConstants.shipmentLines);
//				for(Map<String, Object> shipmentLine : shipmentLineList){
//					String orderLineId = (String) shipmentLine.get(mxConstants.orderLineId);
//					if(!shipmentVSOrderLineList.get(shipmentId).contains(orderLineId)){
//						shipmentVSOrderLineList.get(shipmentId).add(orderLineId);
//					}
//					String orderId = orderLineIdVSOrderId.get(orderLineId);
//					if(!shipmentVSOrderList.get(shipmentId).contains(orderId)){
//						shipmentVSOrderList.get(shipmentId).add(orderId);
//					}
//					if(!orderVSShipmentList.containsKey(orderId)){
//						orderVSShipmentList.put(orderId, new ArrayList<String>());
//					}
//					if(!orderVSShipmentList.get(orderId).contains(shipmentId)){
//						orderVSShipmentList.get(orderId).add(shipmentId);
//					}
//				}
//				
//				//update the activity based on the order list size
//				//if corresponding one order, the activity is create_customer_shipment_for_one_order
//				//otherwise, the activity is create_customer_shipment_for_multiple_orders.
//				//currently, one shipment just corresponds to one order
//				if(shipmentVSOrderList.get(shipmentId).size() == 1){
////					String newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerShipmentForOneOrder;
//					String newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerShipmentPreparation;
//					String orderId = shipmentVSOrderList.get(shipmentId).get(0);
////					String orderLineId = orderVSOrderLineList.get(orderId).get(0);
////					String warehouseName = objectIdVSAttributeNameVSValue.get(orderLineId).get(mxConstants.warehouse);
//					String warehouseName = (String) shipmentLineList.get(0).get(mxConstants.warehouse);
//					
//					alignedEventList.add(newEventId);
//					alignedActivityVSAttributeList.put(mxConstants.createCustomerShipmentPreparation, new ArrayList<String>());
//					alignedActivityVSAttributeList.get(mxConstants.createCustomerShipmentPreparation).add(mxConstants.orderId);
//					alignedActivityVSAttributeList.get(mxConstants.createCustomerShipmentPreparation).add(mxConstants.warehouse);
//					alignedEventVSAttributeNameVSAttributeContent.put(newEventId, new HashMap<String, Object>());
//					alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.orderId, orderId);
//					alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.warehouse, warehouseName);
////					alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.warehouse, "w007");
//				}
//				//for the future when one shipment can corresponds to multiple orders
//				else{
//					
//				}
//				
//				//add the adding shipment line events
//				for(String orderLineId : shipmentVSOrderLineList.get(shipmentId)){
//					int index = shipmentVSOrderLineList.get(shipmentId).indexOf(orderLineId);
//					String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.addCustomerShipmentLine;
//					String productName = objectIdVSAttributeNameVSValue.get(orderLineId).get(mxConstants.productName);
//					alignedEventList.add(newCreatedEventId);
//					alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, shipmentLineList.get(index));
//					alignedEventVSAttributeNameVSAttributeContent.get(newCreatedEventId).put(mxConstants.productName, productName);
//				}
//				
//				System.out.println("order list size: " + shipmentVSOrderList.get(shipmentId).size());
//				System.out.println("order line list size: " + shipmentVSOrderLineList.get(shipmentId).size());
//				
//				List<String> invoiceLineAttributeList = new ArrayList<String>();
//				if(shipmentLineList.size() > 0){
//					invoiceLineAttributeList = new ArrayList<String>(shipmentLineList.get(0).keySet());
//				}
//				alignedActivityVSAttributeList.put(mxConstants.addCustomerShipmentLine, invoiceLineAttributeList);
//				alignedActivityVSAttributeList.get(mxConstants.addCustomerShipmentLine).add(mxConstants.productName);
//
//				//add the creating shipment event
//				String newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerShipmentForOneOrder;
//				activityVSAttributeList.get(activity).remove(mxConstants.shipmentLines);//remove the line attributes
//				eventVSAttributeNameVSAttributeContent.get(eventId).remove(mxConstants.shipmentLines);//remove the line attributes
//				alignedEventList.add(newEventId);
//				alignedActivityVSAttributeList.put(mxConstants.createCustomerShipmentForOneOrder, activityVSAttributeList.get(activity));
//				alignedActivityVSAttributeList.get(mxConstants.createCustomerShipmentForOneOrder).add(mxConstants.orderId);
////				alignedActivityVSAttributeList.get(mxConstants.createCustomerShipmentForOneOrder).add(mxConstants.warehouse);
//				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));
//				alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.orderId, shipmentVSOrderList.get(shipmentId).get(0));
////				alignedEventVSAttributeNameVSAttributeContent.get(newEventId).put(mxConstants.warehouse, "w001");
//			}
//			else if(activity.equals(mxConstants.createCustomerPayment)){
//				List<Map<String, Object>> paymentLineList = (List<Map<String, Object>>) eventVSAttributeNameVSAttributeContent
//						.get(eventId).get(mxConstants.paymentLines) ;				
//				
//				//add createCustomerPaymentPreparation event
//				String activityName = mxConstants.createCustomerPaymentPreparation;
//				String newEventId = "(" + (globalEventIndex ++) + ")" + activityName;
//				String invoiceIdFirst = (String) paymentLineList.get(0).get(mxConstants.invoiceId);
//				List<String> attributeList = new ArrayList<String>();
//				attributeList.add(mxConstants.invoiceId);
//				Map<String, Object> attributeNameVSAttributeContent = new HashMap<String, Object>();
//				attributeNameVSAttributeContent.put(mxConstants.invoiceId, invoiceIdFirst);
//				alignedEventList.add(newEventId);
//				alignedActivityVSAttributeList.put(activityName, attributeList);
//				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, attributeNameVSAttributeContent);				
//				
//				//add the creating payment line event
//				Map<String, String> invoiceVSAmount = new HashMap<String, String>();
//				Map<String, String> invoiceVSEventId = new HashMap<String, String>();				
//				
//				for(Map<String, Object> paymentLine : paymentLineList){		
//					String invoiceId = (String) paymentLine.get(mxConstants.invoiceId);
//					String amount = (String) paymentLine.get(mxConstants.amount);
//					
//					//record the cardinality information
//					String paymentId = (String) eventVSAttributeNameVSAttributeContent.get(eventId).get(mxConstants.paymentId);
//					if(!paymentVSInvoiceList.containsKey(paymentId)){
//						paymentVSInvoiceList.put(paymentId, new ArrayList<String>());
//					}
//					if(!paymentVSInvoiceList.get(paymentId).contains(invoiceId)){
//						paymentVSInvoiceList.get(paymentId).add(invoiceId);
//					}
//					if(!invoiceVSPaymentList.containsKey(invoiceId)){
//						invoiceVSPaymentList.put(invoiceId, new ArrayList<String>());
//					}
//					if(!invoiceVSPaymentList.get(invoiceId).contains(paymentId)){
//						invoiceVSPaymentList.get(invoiceId).add(paymentId);
//					}
//					
//					System.out.println("amount: " + amount);
//					if(!invoiceVSAmount.containsKey(invoiceId)){
//						invoiceVSAmount.put(invoiceId, amount);
//						String newCreatedEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.addCustomerPaymentLine;
//						alignedEventList.add(newCreatedEventId);
//						alignedEventVSAttributeNameVSAttributeContent.put(newCreatedEventId, paymentLine);
//						invoiceVSEventId.put(invoiceId, newCreatedEventId);
//					}
//					else{
//						String existentEventId = invoiceVSEventId.get(invoiceId);
//						String amountText = (String) alignedEventVSAttributeNameVSAttributeContent.get(existentEventId).get(mxConstants.amount);
//						System.out.println("amountText: " + amountText);
//						String newAmount =  String.valueOf(Double.parseDouble(amountText) + Double.parseDouble(amount));
//						System.out.println("newAmount: " + newAmount);
//						alignedEventVSAttributeNameVSAttributeContent.get(existentEventId).put(mxConstants.amount, newAmount);
//					}					
//				}								
//				List<String> paymentLineAttributeList = new ArrayList<String>();
//				if(paymentLineList.size() > 0){
//					paymentLineAttributeList = new ArrayList<String>(paymentLineList.get(0).keySet());
//				}
//				alignedActivityVSAttributeList.put(mxConstants.addCustomerPaymentLine, paymentLineAttributeList);	
//				
//				//add the creating payment event
//				newEventId = "(" + (globalEventIndex ++) + ")" + mxConstants.createCustomerPayment;
//				activityVSAttributeList.get(activity).remove(mxConstants.paymentLines);//remove the line attributes
//				eventVSAttributeNameVSAttributeContent.get(eventId).remove(mxConstants.paymentLines);//remove the line attributes
//				alignedEventList.add(newEventId);
//				alignedActivityVSAttributeList.put(mxConstants.createCustomerPayment, activityVSAttributeList.get(activity));
//				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));
//			}
			else{
				System.out.println("else");
				String newEventId = "(" + (globalEventIndex ++) + ")" + activity;
				alignedEventList.add(newEventId);
				alignedActivityVSAttributeList.put(activity, activityVSAttributeList.get(activity));
				alignedEventVSAttributeNameVSAttributeContent.put(newEventId, eventVSAttributeNameVSAttributeContent.get(eventId));
			}
		}	
		
		//output the cardinality information
		System.out.println("************order-invoice*****************");
		for(String orderId : orderVSInvoiceList.keySet()){
			int invoiceListSize = orderVSInvoiceList.get(orderId).size();
			System.out.println(orderId + " corresponds to size: " + invoiceListSize);
		}
		System.out.println("************invoice-order*****************");
		for(String invoiceId : invoiceVSOrderList.keySet()){
			int orderListSize = invoiceVSOrderList.get(invoiceId).size();
			System.out.println(invoiceId + " corresponds to size: " + orderListSize);
		}
		
		//output the cardinality information
		System.out.println("************payment-invoice*****************");
		for(String paymentId : paymentVSInvoiceList.keySet()){
			int invoiceListSize = paymentVSInvoiceList.get(paymentId).size();
			System.out.println(paymentId + " corresponds to size: " + invoiceListSize);
		}
		System.out.println("************invoice-payment*****************");
		for(String invoiceId : invoiceVSPaymentList.keySet()){
			int payemtnListSize = invoiceVSPaymentList.get(invoiceId).size();
			System.out.println(invoiceId + " corresponds to size: " + payemtnListSize);
		}
		
		System.out.println("************order-shipment*****************");
		for(String orderId : orderVSShipmentList.keySet()){
			int shipmentListSize = orderVSShipmentList.get(orderId).size();
			System.out.println(orderId + " corresponds to size: " + shipmentListSize);
		}
		System.out.println("************shipment-order*****************");
		for(String shipmentId : shipmentVSOrderList.keySet()){
			int orderListSize = shipmentVSOrderList.get(shipmentId).size();
			System.out.println(shipmentId + " corresponds to size: " + orderListSize);
		}
	}

}