package org.processmining.dolibarr.operationrobot.panels;
 
import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JSplitPane;

import org.processmining.dolibarr.operationrobot.plugin.PopulateDolibarrDatabasePlugin;


/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class BuildClickInterface extends JPanel {
    public static void main(String[] args) throws Exception {
    	
//    	BuildClickInterface databaseInspector = new BuildClickInterface();
//        JFrame frame = new JFrame();
//        frame.add(databaseInspector);
//        frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
//        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//        frame.setVisible(true);
    }
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static final int STARTX = 100;
    public static final int STARTY = 100;
    public static final int DEFAULT_WIDTH = 1500;
    public static final int DEFAULT_HEIGHT = 600;
    private ImportSimulationLogPanel simulationLogPanel;
    private MatchDolibarrClickPanel matchDolibarrClickPanel;
    private ClickInstancePanel dolibarrClickPanel;
    private EditDolibarrClickPanel editDolibarrClickPanel;
    private PopulateDolibarrDatabasePlugin populateDolibarrDatabaseUI;
    
    public BuildClickInterface(PopulateDolibarrDatabasePlugin populateDolibarrDatabaseUI) throws Exception {
    	this.populateDolibarrDatabaseUI = populateDolibarrDatabaseUI;
 
        setLayout(new BorderLayout());     
        JPanel topPanel = new JPanel();
        topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.X_AXIS));

        
        simulationLogPanel = new ImportSimulationLogPanel(this);
        matchDolibarrClickPanel = new MatchDolibarrClickPanel(this);

        editDolibarrClickPanel = new EditDolibarrClickPanel(this);
        dolibarrClickPanel = new ClickInstancePanel(this);
        
//      JPanel leftPanel = new JPanel();
//      leftPanel.setLayout(new BoxLayout(leftPanel, BoxLayout.Y_AXIS));       
//        leftPanel.add(Box.createVerticalStrut(10));
//        leftPanel.add(simulationLogPanel);
//        leftPanel.add(Box.createVerticalStrut(10));
//        leftPanel.add(editDolibarrClickPanel);
        
        JSplitPane topLeft = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        topLeft.setLeftComponent(simulationLogPanel);
        topLeft.setRightComponent(matchDolibarrClickPanel);
        topLeft.setResizeWeight(0.01);   
        topLeft.setBorder(BorderFactory.createEmptyBorder());
        
        JSplitPane leftPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        leftPanel.setTopComponent(topLeft);
        leftPanel.setBottomComponent(editDolibarrClickPanel);
        leftPanel.setResizeWeight(0.01);   
        leftPanel.setBorder(BorderFactory.createEmptyBorder());
        
        JSplitPane completePanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        completePanel.setLeftComponent(leftPanel);
        completePanel.setRightComponent(dolibarrClickPanel);
        completePanel.setResizeWeight(0.2);   
        completePanel.setBorder(BorderFactory.createEmptyBorder());

		
//		this.add(new JScrollPane(completePanel));
    	this.add(completePanel);
    }
 
    public ClickInstancePanel getDolibarrClickPanel(){
    	return dolibarrClickPanel;
    }

    public EditDolibarrClickPanel getEditDolibarrClickPanel(){
    	return editDolibarrClickPanel;
    }
    
    public ImportSimulationLogPanel getSimulationLogPanel(){
    	return simulationLogPanel;
    }
    
    public MatchDolibarrClickPanel getMatchDolibarrClickPanel(){
    	return matchDolibarrClickPanel;
    }
    
    public PopulateDolibarrDatabasePlugin getPopulateDolibarrDatabaseUI(){
    	return populateDolibarrDatabaseUI;
    }
}