package org.processmining.dolibarr.operationrobot.panels;
 
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import org.processmining.common.dialogue.IOFileDialogue;
import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.logconversion.configurations.ReadConfigurationsFromXML;
import org.processmining.ocbc.logconversion.configurations.WriteConfigurationsIntoXML;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class ClickInstancePanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {

    }
    
//    private JComboBox<String> eventNameBox = new JComboBox<String>();
//    private JComboBox<String> typeBox = new JComboBox<String>();
    private JComboBox<String> logBox = new JComboBox<String>();
    private JTextField logEventNameField = new JTextField();
    private JComboBox<String> dolibarrBox = new JComboBox<String>();
    private JComboBox<String> valueBox = new JComboBox<String>();

    private List<String> tableFieldRow = new ArrayList<String>();
    private List<String> attributeTableFieldRow = new ArrayList<String>();
    
    private JButton removeButton;
    private JButton clearButton;
    private JButton addButton;
    private JButton loadButton = new JButton("load");
    private JButton matchButton = new JButton("build");
    private JButton importConfigurationFileButton = new JButton("import");
    private JButton outputConfigurationFileButton = new JButton("output");
    private CreateTablePanel tablePanel;
    private CreateTablePanel clickAttributePanel;
    private BuildClickInterface fatherPanel;
    private File lastFile;
    private int instanceId = 1;//the id of instance; if an instance is deleted, its id is not used again
    
    //record the features of one element on the page, the feature (such tag = "order" or null (content), id = 12 (special attribute), 
    //width = "100%" (common attributes), index=3 (the third element satisfying above features))
    //are used to identify the element: (1) use the id (2)if no id (=value), use the tag=content) 
    //(3)if no content, use the tag and attribute (=value) (4)use index except the first situation
    private Map<String, Map<String, Map<String, String>>> clickVSElementVSFeatureVSValue = new HashMap<String, Map<String, Map<String, String>>>();
    private Map<String, Map<String, String>> instanceIdVSElementVSValue = new HashMap<String, Map<String, String>>();
    
    private List<String> clickInstanceList = new ArrayList<String>();//record the click instances (id) of dolibarr
    private List<String> eventList = new ArrayList<String>();//record the events (id) in simulation log
    
    private Map<String, Map<String, String>> clickInstanceVSElementNameVSValue = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, Map<String, String>>> activityVSClickVSElementVSAttribute = new HashMap<String, Map<String, Map<String, String>>>();

    
    private Map<String, List<String>> columnNameVSValueList = new HashMap<String, List<String>>();
    private ConfigurationParameters configuration = new ConfigurationParameters();
    private int selectedRow = -1; //record the value returned by  table.getSelectedRow()
    
    public ClickInstancePanel(final BuildClickInterface fatherPanel) {
    	this.fatherPanel = fatherPanel;   	
    	addButton = new JButton("add");
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the add button");

				String type = mxConstants.click;
				String dolibarrItem = (String) dolibarrBox.getSelectedItem();
				clickVSElementVSFeatureVSValue = fatherPanel.getEditDolibarrClickPanel().getClickVSElementVSFeatureVSValue();

				if(dolibarrItem != null){
					if(type.equals(mxConstants.click)){
						System.out.println("enter function of adding one click in ClickInstancePanel");	
						boolean differenceFlag = false;
						String newEventId = null;
						String newClickInstanceId = null;
						//make sure the new id is unique (different from existing ones)
						while(!differenceFlag){
							String id = (instanceId++) + "";
//							newEventId = logItem + "_" + id;
							newEventId = logEventNameField.getText();
							newClickInstanceId = dolibarrItem + "_" + id;
							if(!clickInstanceList.contains(newClickInstanceId) && !eventList.contains(newEventId)){
								differenceFlag = true;
							}
						}										
						//add the new click record into table in the click panel    
						List<Object> valueList = new ArrayList<Object>();
						valueList.add(newEventId);
						valueList.add(newClickInstanceId);
						selectedRow = tablePanel.getTable().getSelectedRow();
						tablePanel.getTableModel().addRecordRow(selectedRow+1,valueList);				
						tablePanel.updateTable();	
						//add elements in corresponding lists
//						eventList.add(newEventId);
//						clickInstanceList.add(newClickInstanceId);
						eventList.add(selectedRow+1, newEventId);
						clickInstanceList.add(selectedRow+1, newClickInstanceId);
						//add empty attributes for the click instance
						clickInstanceVSElementNameVSValue.put(newClickInstanceId, new HashMap<String, String>());
						String clickType = newClickInstanceId.split("_")[0];						
																	
						for(String elementName : fatherPanel.getEditDolibarrClickPanel().getClickVSAttributeList().get(clickType)){
							
							Map<String, String> featureVSValue = clickVSElementVSFeatureVSValue.get(dolibarrItem).get(elementName);										
							String elementType = featureVSValue.get(mxConstants.ElementType);
							String defaultValue = featureVSValue.get(mxConstants.DefaultValue);
							if(elementType.equals(mxConstants.attribute) || elementType.equals(mxConstants.hierarchy)){
								 clickInstanceVSElementNameVSValue.get(newClickInstanceId).put(elementName, defaultValue);
							}
						}
					}
//					else if(type.equals(mxConstants.attribute) && selectedClickRow >-1){	    	   
//						String selectedClickInstanceId = tablePanel.getTable().getModel().getValueAt
//								(selectedClickRow, tableFieldRow.indexOf(mxConstants.dolibarr_click_instance)).toString();
//						
//						
//		 			    if(!clickInstanceVSElementNameVSValue.containsKey(selectedClickInstanceId)){
//		 			    	clickInstanceVSElementNameVSValue.put(selectedClickInstanceId, new HashMap<String, String>());
//		 			    }
//		 			    clickInstanceVSElementNameVSValue.get(selectedClickInstanceId).put(dolibarrItem, valueItem);						
//		 			    
//			    	    updateAttributeTable(selectedClickInstanceId, clickInstanceVSElementNameVSValue);
//					}
				}		
			}
		});
    	
    	 
    	clearButton = new JButton("clear");
    	clearButton.addActionListener(new ActionListener()
 		{
 			public void actionPerformed(ActionEvent e)
 			{			
// 				JTable table = activityImpactingColumnTablePanel.getTable();
// 				MyTableModel tableModel = (MyTableModel) table.getModel();
//				String currentTableName = selectedTablePanel.getTablename();
//				for(int i=0; i<activityBox.getItemCount(); i++){
//					String tableAndActivityColumn = currentTableName + "-" + activityBox.getItemAt(i);
//					tableColumnVSImpactedTableColumns.remove(tableAndActivityColumn);
//				}				
//				//remove the selected record from table
//				tableModel.clearAllTableRows();
//				tableModel.updateTable();
 			}																					
 		}); 
         
        removeButton = new JButton("remove");
        removeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				JTable table = tablePanel.getTable();
				MyTableModel tableModel = (MyTableModel) table.getModel();
				int[] selectedRowSet = table.getSelectedRows();
				tableModel.removeRecordRowSet(selectedRowSet);
				
				List<Integer> selectedRowList = new ArrayList<Integer>();				
				for(int i=0; i<selectedRowSet.length; i++){
					selectedRowList.add(selectedRowSet[i]);
					System.out.println("selectedRowSet[i]:" + selectedRowSet[i]);
				}
				System.out.println("selectedRowList size:" + selectedRowList.size());
				System.out.println("eventList before:" + eventList.size());
				
				List<String> removedElementListEvent = new ArrayList<String>();	
				List<String> removedElementListClick = new ArrayList<String>();
				for(int index : selectedRowList){
					removedElementListEvent.add(eventList.get(index));
					removedElementListClick.add(clickInstanceList.get(index));
				}
				eventList.removeAll(removedElementListEvent);
				clickInstanceList.removeAll(removedElementListClick);
				System.out.println("eventList after:" + eventList.size());
			}
		});       
                     
        loadButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the load button");
				fatherPanel.getPopulateDolibarrDatabaseUI().getRunDolibarrPanel().updateRunningPanel(clickInstanceList, clickInstanceVSElementNameVSValue);					
			}
		});
        
        matchButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				//clear the table
				eventList.clear();
				clickInstanceList.clear();
				clickInstanceVSElementNameVSValue.clear();
				
				System.out.print("\n click the match button");
//				fatherPanel.getPopulateDolibarrDatabaseUI().getRunDolibarrPanel().updateClickListPanel(clickInstanceList);		
				
//				List<String> eventListLog = fatherPanel.getSimulationLogPanel().getAlignedEventList();	
//				Map<String, Map<String, Object>> eventVSAttributes = fatherPanel.getSimulationLogPanel().getAlignedEventVSAttributes();
				
				List<String> eventListLog = fatherPanel.getSimulationLogPanel().getEventList();	
				Map<String, Map<String, Object>> eventVSAttributes = fatherPanel.getSimulationLogPanel().getEventVSAttributes();
				
				Map<String, List<String>> activityVSClickList = fatherPanel.getMatchDolibarrClickPanel().getActivityVSClickListMap();
				activityVSClickVSElementVSAttribute = fatherPanel
						.getMatchDolibarrClickPanel().getActivityVSClickVSElementVSAttributeMap();
				for(String activityName : activityVSClickVSElementVSAttribute.keySet()){
					System.out.println("activityName: " + activityName);
				}
				
				clickVSElementVSFeatureVSValue = fatherPanel.getEditDolibarrClickPanel().getClickVSElementVSFeatureVSValue();	
				for(String eventId : eventListLog){
					Map<String, Object> attributeNameVSValue = eventVSAttributes.get(eventId);
					String activity = eventId.split("\\)")[1];
					int clickCounter = 1;
					for(String clickType : activityVSClickList.get(activity)){
						String id = (instanceId++) + "";
//						newEventId = logItem + "_" + id;
						String newEventId = eventId + "_" + clickCounter;
						String clickInstanceId = clickType + "_" + id;
						eventList.add(newEventId);
						clickInstanceList.add(clickInstanceId);
						clickCounter ++;
//						System.out.println();
						clickInstanceVSElementNameVSValue.put(clickInstanceId, new HashMap<String, String>());
						System.out.println("clickInstanceId: " + clickInstanceId);
						for(String elementName : fatherPanel.getEditDolibarrClickPanel().getClickVSAttributeList().get(clickType)){
							System.out.println("elementName: " + elementName);
							if(clickVSElementVSFeatureVSValue.containsKey(clickType)
									&& clickVSElementVSFeatureVSValue.get(clickType).containsKey(elementName)){
								System.out.println("contanins elementName");
								Map<String, String> featureVSValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName);										
								String elementType = featureVSValue.get(mxConstants.ElementType);			
								String value = null;
								if(elementType.equals(mxConstants.attribute) || elementType.equals(mxConstants.hierarchy) ||
										elementType.equals(mxConstants.attributeMultiple)){
									System.out.println("attribute yes");
									System.out.println("activity as attribute: " + activity);
									if(activityVSClickVSElementVSAttribute.containsKey(activity)){
										System.out.println("contains activity");
										if(activityVSClickVSElementVSAttribute.get(activity).containsKey(clickType)){
											System.out.println("contains clickType");
											if(activityVSClickVSElementVSAttribute.get(activity).get(clickType).containsKey(elementName)){
												System.out.println("contains elementName");
											}
										}
									}
									
									
									
									if(activityVSClickVSElementVSAttribute.containsKey(activity)
											&& activityVSClickVSElementVSAttribute.get(activity).containsKey(clickType)
											&& activityVSClickVSElementVSAttribute.get(activity).get(clickType).containsKey(elementName)
											&& !activityVSClickVSElementVSAttribute.get(activity).get(clickType).get(elementName).equals("null")){
										String attributeName = activityVSClickVSElementVSAttribute.get(activity).get(clickType).get(elementName);
										System.out.println("attributeName: " + attributeName);	
										if(attributeNameVSValue.get(attributeName) == null){
											JOptionPane.showMessageDialog(null, "Wrong! The element " + elementName + 
													" of " + clickType + " of " + activity + " is not assigned to a"
													+ "corresponding attribute!");
											break;
										}
										else{
											value = attributeNameVSValue.get(attributeName).toString();
											System.out.println("value: " + value);
										}
									}
									else{
										value = featureVSValue.get(mxConstants.DefaultValue);
										System.out.println("DefaultValue: " + value);
									}
									clickInstanceVSElementNameVSValue.get(clickInstanceId).put(elementName, value);						 
								}
							}
						}	
					}					
				}

	    		columnNameVSValueList.put(mxConstants.simulation_log_event, eventList);
	    		columnNameVSValueList.put(mxConstants.dolibarr_click_instance, clickInstanceList);
	    		updateInstanceTable(columnNameVSValueList);	    		
//				updateInstanceTable(eventList, activityVSClick);
			}
		});
        
		importConfigurationFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Click Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Select", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					System.out.println("selected file is not empty!");
					lastFile = file.getParentFile();
			    	ConfigurationParameters configuration = new ConfigurationParameters();
			    	configuration.getNameVSMapListParameterMap().put(mxConstants.columnNameVSValueList, null);
	 				configuration.getNameVSMapMapParameterMap().put(mxConstants.clickInstanceVSElementNameVSValue, null);	 						
	 			    
		          	ReadConfigurationsFromXML reader = new ReadConfigurationsFromXML(configuration);
		    		reader.parserXml(file.getAbsolutePath(), null);
		    		
		    		if(configuration.getNameVSMapListParameterMap().get(mxConstants.columnNameVSValueList) == null){
		    			JOptionPane.showMessageDialog(null, "Wrong! The imported file is not of correct format!");   
		    		}
		    		else{
		    			JOptionPane.showMessageDialog(null, "Succeed importing a file!"); 
			    		columnNameVSValueList = configuration.getNameVSMapListParameterMap().get(mxConstants.columnNameVSValueList);
			    		clickInstanceVSElementNameVSValue = configuration.getNameVSMapMapParameterMap().get(mxConstants.clickInstanceVSElementNameVSValue);
			    		
			    		eventList = columnNameVSValueList.get(mxConstants.simulation_log_event);
			    		clickInstanceList = columnNameVSValueList.get(mxConstants.dolibarr_click_instance);
			    		updateInstanceTable(columnNameVSValueList);
//			    		clickVSAttributeList = configuration.getNameVSMapListParameterMap().get(mxConstants.clickVSAttributeList);
//			    		clickNameListPanel.updateListPanel(new ArrayList<String>(clickVSAttributeList.keySet()));			    		
		    		}				
				}
			}
		});
	
        
        outputConfigurationFileButton.addActionListener(new ActionListener() {
 			@Override
 			public void actionPerformed(ActionEvent arg0) {
 				System.out.println("generate logs");				    

 				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Click Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Output", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){			
					lastFile = file.getParentFile();
		        	if(clickInstanceList.size() == 0){
	 					JOptionPane.showMessageDialog(null, "The instance list is empty! Please create and then output!"); 
	 				}
	 				else{
	 					columnNameVSValueList.put(mxConstants.simulation_log_event, eventList);
	 	 			    columnNameVSValueList.put(mxConstants.dolibarr_click_instance, clickInstanceList);
	 	 			    configuration.getNameVSMapListParameterMap().put(mxConstants.columnNameVSValueList, columnNameVSValueList);
	 	 			    configuration.getNameVSMapMapParameterMap().put(mxConstants.clickInstanceVSElementNameVSValue, clickInstanceVSElementNameVSValue); 		
	 					WriteConfigurationsIntoXML writer = new WriteConfigurationsIntoXML(configuration);

						String fileName = file.getAbsolutePath();
	 					if(fileName.contains(".")){
	 						writer.createXml(fileName);
	 					}
	 					else{
	 						writer.createXml(fileName + ".xml");
	 					}
	 				}	    		
				}								   	   		
 			}
 		});
        
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1, 4));
        buttonPanel.setMaximumSize(new Dimension(2000,40));
        clearButton.setMaximumSize(new Dimension(100,40));
//        buttonPanel.add(removeButton);
        buttonPanel.add(importConfigurationFileButton);
        buttonPanel.add(matchButton);       
        buttonPanel.add(loadButton);
        buttonPanel.add(outputConfigurationFileButton);
//        buttonPanel.add(addButton);
//        buttonPanel.add(clearButton);      
        
//        typeBox.addItem(mxConstants.click);
//        typeBox.addItem(mxConstants.attribute);
//        typeBox.addItemListener(new ItemListener() {			
//			public void itemStateChanged(ItemEvent e) {
//				String selectedItem = typeBox.getSelectedItem().toString();
//				if(selectedItem.equals(mxConstants.click)){
//					List<String> clickNameList = fatherPanel.getEditDolibarrClickPanel().getClickNameList();
//					updateDolibarrBox(clickNameList);
//				}
//				else if(selectedItem.equals(mxConstants.attribute)){
//					int row = tablePanel.getTable().getSelectedRow();
//					String selectedInstanceClickId = tablePanel.getTable().getModel().getValueAt
//							(row, tableFieldRow.indexOf(mxConstants.dolibarr_click_instance)).toString();
//					String selectedInstanceClickType = selectedInstanceClickId.split("_")[0];
//					List<String> attributeNameList = fatherPanel.getEditDolibarrClickPanel().getClickVSAttributeList().get(selectedInstanceClickType);
//					updateDolibarrBox(attributeNameList);
//				}				
//			}
//		});
//
//        typeBox.setEditable(false);
        
        logBox.setEditable(true);
        logBox.setPrototypeDisplayValue("t");
        logBox.setRenderer(new ComboBoxRenderer(logBox));
        
        dolibarrBox.setEditable(false);
        dolibarrBox.setPrototypeDisplayValue("text here text ");
        dolibarrBox.setRenderer(new ComboBoxRenderer(dolibarrBox));
        dolibarrBox.addItemListener(new ItemListener() {			
			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				if(dolibarrBox.getSelectedItem() != null){
					logEventNameField.setText(dolibarrBox.getSelectedItem().toString());
				}				
			}
		});
        
        valueBox.setEditable(true);
        valueBox.setPrototypeDisplayValue("h");
        valueBox.setRenderer(new ComboBoxRenderer(valueBox));
        
    	JPanel selectionPanel = new JPanel();
    	selectionPanel.setLayout(new GridLayout(1, 5));        
    	selectionPanel.setMaximumSize(new Dimension(2000,40));
    	selectionPanel.setLayout(new BoxLayout(selectionPanel, BoxLayout.X_AXIS));    
//    	tableBox.setMaximumSize(new Dimension(50,30));
//    	tableBox.setMaximumSize( tableBox.getPreferredSize() );
//    	selectionPanel.add(typeBox);
    	selectionPanel.add(removeButton);
    	logEventNameField.setMaximumSize(new Dimension(5000,30));
    	logEventNameField.setPreferredSize(new Dimension(150,30));
    	logEventNameField.setToolTipText("Please input the event name corresponding to the selected click type");
    	selectionPanel.add(logEventNameField);
    	
//    	selectionPanel.add(logBox);
    	selectionPanel.add(dolibarrBox);
//    	selectionPanel.add(valueBox);
    	selectionPanel.add(addButton);
    	

    	
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    	tablePanel = new CreateTablePanel("");       
        tableFieldRow.add("index");
        tableFieldRow.add(mxConstants.simulation_log_event);
        tableFieldRow.add(mxConstants.click_instance);       
        tablePanel.setFieldRow(tableFieldRow);
        tablePanel.updateTable();
        ((MyTableModel)tablePanel.getTable().getModel()).setTableEditableFlag(false);
        tablePanel.getTable().addMouseListener(new MouseAdapter() {
	    	public void mouseClicked(MouseEvent e) {
        		JTable table = (JTable)e.getSource();
	    	    int row = table.getSelectedRow();
	    	    int column = table.getSelectedColumn();

	    	    selectedRow = row;
	    	    
	    	    System.out.println("tableFieldRow.indexOf(mxConstants.dolibarr_click_instance): " + tableFieldRow.indexOf(mxConstants.dolibarr_click_instance));
	    	    String selectedClickInstanceId = tablePanel.getTable().getModel().getValueAt
						(row, tableFieldRow.indexOf(mxConstants.dolibarr_click_instance)).toString();
	    	    //add empty attributes for the click instance	    	   
	    	    if(!clickInstanceVSElementNameVSValue.containsKey(selectedClickInstanceId)){
	    	    	System.out.println("set selectedClickInstanceId in click");
	    	    	clickInstanceVSElementNameVSValue.put(selectedClickInstanceId, new HashMap<String, String>());
	    	    }				
				String clickType = selectedClickInstanceId.split("_")[0];						
				Map<String, Map<String, Map<String, String>>> clickVSElementVSFeatureVSValue = fatherPanel
						.getEditDolibarrClickPanel().getClickVSElementVSFeatureVSValue();												
				for(String elementName : fatherPanel.getEditDolibarrClickPanel().getClickVSAttributeList().get(clickType)){
					Map<String, String> featureVSValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName);										
					String elementType = featureVSValue.get(mxConstants.ElementType);
					String defaultValue = featureVSValue.get(mxConstants.DefaultValue);
					if(elementType.equals(mxConstants.attribute) || elementType.equals(mxConstants.hierarchy)){
						System.out.println("attribute in click");
						if(!clickInstanceVSElementNameVSValue.get(selectedClickInstanceId).containsKey(elementName)){
							clickInstanceVSElementNameVSValue.get(selectedClickInstanceId).put(elementName, defaultValue);
							System.out.println("set defaultValue in click");
						}						 
					}
				}				
	    	    updateAttributeTable(selectedClickInstanceId, clickInstanceVSElementNameVSValue);		    	    	    	   
	    	}
        });

        clickAttributePanel = new CreateTablePanel("");
        attributeTableFieldRow = new ArrayList<String>();
        attributeTableFieldRow.add("index");
        attributeTableFieldRow.add(mxConstants.click_element_name);
//        attributeTableFieldRow.add(mxConstants.event_attribute_name);
        attributeTableFieldRow.add(mxConstants.value);       
        clickAttributePanel.setFieldRow(attributeTableFieldRow);
        clickAttributePanel.updateTable();
        
        clickAttributePanel.getTable().getModel().addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {                                 	
                int col = e.getColumn();               
                int row = e.getFirstRow();  
                System.out.println("col: " + col);
                if(col > -1 && col != attributeTableFieldRow.indexOf(mxConstants.click_element_name)){
                	MyTableModel model = (MyTableModel) clickAttributePanel.getTable().getModel();
                    String elementName = (String) model.getValueAt(row, attributeTableFieldRow.indexOf(mxConstants.click_element_name));
                	String newValue = (String) model.getValueAt(row, col);     
                	int selectedInstanceRow = tablePanel.getTable().getSelectedRow();
                	String selectedClickInstanceId = tablePanel.getTable().getModel().getValueAt
							(selectedInstanceRow, tableFieldRow.indexOf(mxConstants.dolibarr_click_instance)).toString();				
					
	 			    if(!clickInstanceVSElementNameVSValue.containsKey(selectedClickInstanceId)){
	 			    	clickInstanceVSElementNameVSValue.put(selectedClickInstanceId, new HashMap<String, String>());
	 			    }
	 			    clickInstanceVSElementNameVSValue.get(selectedClickInstanceId).put(elementName, newValue);						
	 			    
//		    	    updateAttributeTable(selectedClickInstanceId, clickInstanceVSElementNameVSValue);
                } 
            }  
        }); 
        

        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(buttonPanel);     
        this.add(selectionPanel);
        this.add(tablePanel);
        this.add(clickAttributePanel);
        this.setBorder(BorderFactory.createTitledBorder("click instance"));        
    }
 
    /*
     * update the table activity impacting panel for the input table
     */
    public void update(String tableName){
    	System.out.println("update activity impacting panel");
    	//update table box and its child boxes
//        String currentTableName = selectedTablePanel.getTablename();        
//        updateActivityBox(currentTableName);      
//        updateTableBox(currentTableName);        
//        updateTable(currentTableName);
    }
    
    public void updateActivityBox(String currentTableName){
//    	//update activity box-show all activity columns related the selected class
//    	String selectedClassName = tableStructurePanel.getClassName();
//        activityBox.removeAllItems();
//        if(tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().containsKey(selectedClassName)){
//			for(String activityColumnName : tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().get(selectedClassName).keySet()){	
//				System.out.println("activityColumnName: " + activityColumnName);		
//				activityBox.addItem(activityColumnName);	
//			}
//		}     
    }
    
    public void updateDolibarrBox(List<String> elementList){
    	dolibarrBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			dolibarrBox.addItem(element);	
			}
    	}
    	else{
    		dolibarrBox.addItem("tag_name");
    	}
    }
    
    public void updateInstanceTable(Map<String, List<String>> columnNameVSValueList){
        //update the mapping table   	
    	tablePanel.clearAllTableRows();
    	tableFieldRow.clear();
    	tableFieldRow.add("index");
    	String lastColumnName = null;
        for(String columnName : columnNameVSValueList.keySet()){
        	tableFieldRow.add(columnName);
        	lastColumnName = columnName;
        }
        tablePanel.setFieldRow(tableFieldRow);
        int recordNum = columnNameVSValueList.get(lastColumnName).size();
        for(int i=0; i<recordNum; i++){
        	List<Object> valueList = new ArrayList<Object>();
        	for(String columnName : columnNameVSValueList.keySet()){
        		String unit = columnNameVSValueList.get(columnName).get(i);
        		valueList.add(unit);	
            }
			tablePanel.addRecordRow(valueList);
			
        }
        tablePanel.updateTable();       
    }
    
    /*
     * show the attributes of a selected instance 
     */
    public void updateAttributeTable(String instanceId, Map<String, Map<String, String>> clickInstanceVSElementNameVSValue){
        //update the mapping table   	
    	clickAttributePanel.clearAllTableRows();
    	
    	if(clickInstanceVSElementNameVSValue != null && clickInstanceVSElementNameVSValue.keySet().contains(instanceId)){
    		for(String elementName : clickInstanceVSElementNameVSValue.get(instanceId).keySet()){//key: llx_projet-datec
    			List<Object> valueList = new ArrayList<Object>();
    			Object value = clickInstanceVSElementNameVSValue.get(instanceId).get(elementName);
    			System.out.println("value in updateAttributeTable: " + value);
    			valueList.add(elementName);
//    			if(activityVSClickVSElementVSAttribute.containsKey(activity)
//						&& activityVSClickVSElementVSAttribute.get(activity).containsKey(clickType)
//						&& activityVSClickVSElementVSAttribute.get(activity).get(clickType).containsKey(elementName)){
//					String attributeName = activityVSClickVSElementVSAttribute.get(activity).get(clickType).get(elementName);
//    			}
//    			valueList.add("");			
    			valueList.add(value);
    			clickAttributePanel.addRecordRow(valueList);
    			clickAttributePanel.updateTable();
            }
    	}       
    }

    public List<String> getClickInstanceList(){
    	return clickInstanceList;
    }
    
    public Map<String, Map<String, String>> getClickInstanceVSElementNameVSValue(){
    	return clickInstanceVSElementNameVSValue;
    }
}