package org.processmining.dolibarr.operationrobot.panels;
 
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import org.processmining.common.dialogue.IOFileDialogue;
import org.processmining.common.frame.CreateListPanel;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.logconversion.configurations.ReadConfigurationsFromXML;
import org.processmining.ocbc.logconversion.configurations.WriteConfigurationsIntoXML;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class EditDolibarrClickPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private JLabel boxesLable = new JLabel(" locate button/field: ");
    private JComboBox<String> elementTypeBox = new JComboBox<String>();//click or necessary input of click
    private JComboBox<String> elementNameBox = new JComboBox<String>();
    private JComboBox<String> tagNameBox = new JComboBox<String>();
    private JComboBox<String> tagValueBox = new JComboBox<String>();
    private JComboBox<String> attributeNameBox = new JComboBox<String>();
    private JComboBox<String> attributeValueBox = new JComboBox<String>();
    private JComboBox<String> indexBox = new JComboBox<String>();
    private JComboBox<String> defaultValueBox = new JComboBox<String>();
    private JComboBox<String> dependencyBox = new JComboBox<String>();
    private JComboBox<String> directionBox = new JComboBox<String>();
    
    private JButton removeButton;
    private JButton clearButton;
    private JButton addButton;
    private JButton importConfigurationFileButton = new JButton("import");
    private JButton chooseConfigurationFilePathButton = new JButton("choose path");
    private JButton outputConfigurationFileButton = new JButton("output");
    private JTextField selectedConfigurationFilePath = new JTextField();
    private File lastFile;
    
    private CreateTablePanel tablePanel;
    private BuildClickInterface fatherPanel;
    
    private String selectedClickType;
    
    private CreateListPanel clickNameListPanel = new CreateListPanel(null, "click types");
    private List<String> tableFieldRow = new ArrayList<String>();
    //record the features of one element on the page, the feature (such tag = "order" or null (content), id = 12 (special attribute), 
    //width = "100%" (common attributes), index=3 (the third element satisfying above features))
    //are used to identify the element: (1) use the id (2)if no id (=value), use the tag=content) 
    //(3)if no content, use the tag and attribute (=value) (4)use index except the first situation
//    private Map<String, Map<String, String>> pageElementNameVSFeatureVSValue = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, Map<String, String>>> clickVSElementVSFeatureVSValue = new HashMap<String, Map<String, Map<String, String>>>();
    //record the attribute element names of clicks
    private Map<String, List<String>> clickVSAttributeList = new HashMap<String, List<String>>();
  //record the parent element list of one element
    private Map<String, List<String>> elementVSParentElementList = new HashMap<String, List<String>>();
    private ConfigurationParameters configuration = new ConfigurationParameters();
    public EditDolibarrClickPanel(final BuildClickInterface fatherPanel) {
    	this.fatherPanel = fatherPanel;  	

    	clickNameListPanel.getJList().addListSelectionListener(new ListSelectionListener() {			
			public void valueChanged(ListSelectionEvent e) {
				// TODO Auto-generated method stub
				tablePanel.clearAllTableRows();
				String selectedItem = clickNameListPanel.getJList().getSelectedValue();
				selectedClickType = selectedItem;
				if(clickVSAttributeList.containsKey(selectedItem)){
					for(String elementName : clickVSAttributeList.get(selectedItem)){
//						Map<String, String> featureVSValue = pageElementNameVSFeatureVSValue.get(elementName);		
						Map<String, String> featureVSValue = clickVSElementVSFeatureVSValue.get(selectedItem).get(elementName);	
						String elementType = featureVSValue.get(mxConstants.ElementType);
						String tagName = featureVSValue.get(mxConstants.TagName);
						String tagValue = featureVSValue.get(mxConstants.TagValue);
						String attributeName = featureVSValue.get(mxConstants.AttributeName);
						String attributeValue = featureVSValue.get(mxConstants.AttributeValue);
						String index = featureVSValue.get(mxConstants.ElementIndex);
						String defaultValue = featureVSValue.get(mxConstants.DefaultValue);
						String dependentElement = featureVSValue.get(mxConstants.Dependency);
						String direction = featureVSValue.get(mxConstants.Direction);
						
						List<Object> valueList = new ArrayList<Object>();
						valueList.add(elementType);
						valueList.add(elementName);
						valueList.add(tagName);
						valueList.add(tagValue);
						valueList.add(attributeName);
						valueList.add(attributeValue);
						valueList.add(index);
						valueList.add(defaultValue);	
						valueList.add(dependentElement);	
						valueList.add(direction);	
						tablePanel.addRecordRow(valueList);
					}
					tablePanel.updateTable();
				}				
				//update the click box in the match click panel		
				
//				fatherPanel.getMatchDolibarrClickPanel().updateClickNameBox(clickNameListPanel.getValueList());
//				fatherPanel.getMatchDolibarrClickPanel().setClickNameBox(selectedItem);
				fatherPanel.getDolibarrClickPanel().updateDolibarrBox(clickNameListPanel.getValueList());
			}
		});
    	
    	addButton = new JButton("add");
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the button");			    
				
				String elementType = (String) elementTypeBox.getSelectedItem();
				String elementName = (String) elementNameBox.getSelectedItem();
				String tagName = (String) tagNameBox.getSelectedItem();
				String tagValue = (String) tagValueBox.getSelectedItem();
				String attributeName = (String) attributeNameBox.getSelectedItem();
				String attributeValue = (String) attributeValueBox.getSelectedItem();
				String index = (String) indexBox.getSelectedItem();
				String defaultValue = (String) defaultValueBox.getSelectedItem();
		    	
				if(elementName != null && tagName != null ){
					List<Object> valueList = new ArrayList<Object>();
					valueList.add(elementType);
					valueList.add(elementName);
					valueList.add(tagName);
					valueList.add(tagValue);
					valueList.add(attributeName);
					valueList.add(attributeValue);
					valueList.add(index);
					valueList.add(defaultValue);
					
					Map<String, String> featureVSValue = new HashMap<String, String>();
					featureVSValue.put(mxConstants.TagName, tagName);
					featureVSValue.put(mxConstants.TagValue, tagValue);
					featureVSValue.put(mxConstants.ElementIndex, index);
					featureVSValue.put(mxConstants.DefaultValue, defaultValue);
					featureVSValue.put(mxConstants.AttributeName, attributeName);
					featureVSValue.put(mxConstants.AttributeValue, attributeValue);
					featureVSValue.put(mxConstants.ElementType, elementType);
					
					if(elementType.equals(mxConstants.click) || elementType.equals(mxConstants.clickFake)){	
						if(clickVSAttributeList.containsKey(elementName)){
							JOptionPane.showMessageDialog(null, "Wrong! The click type already exists!");
						}
						else{
							//update the table
							tablePanel.clearAllTableRows();
							tablePanel.addRecordRow(valueList);
							tablePanel.updateTable();
							//record the element
							clickVSElementVSFeatureVSValue.put(elementName, new HashMap<String, Map<String, String>>());
							clickVSElementVSFeatureVSValue.get(elementName).put(elementName, featureVSValue);
							clickVSAttributeList.put(elementName, new ArrayList<String>());
							clickVSAttributeList.get(elementName).add(elementName);
							clickNameListPanel.addElement(elementName);
							clickNameListPanel.rankElement();//sort by alphabet
							clickNameListPanel.getJList().setSelectedValue(elementName, true);
						}												
					}
					else if(elementType.equals(mxConstants.attribute) || elementType.equals(mxConstants.hierarchy) ||
							elementType.equals(mxConstants.attributeMultiple)) {
						String selectedClickName = clickNameListPanel.getJList().getSelectedValue();
						if(selectedClickName == null){
							JOptionPane.showMessageDialog(null, "Please select a click in the list for the attribute element!");
						}
						else{
							if(clickVSAttributeList.get(selectedClickName).contains(elementName)){
								JOptionPane.showMessageDialog(null, "Wrong! element already exists!");
							}
							else{
								//update the table
								tablePanel.addRecordRow(valueList);
								tablePanel.updateTable();
								//record the element
								clickVSElementVSFeatureVSValue.get(selectedClickName).put(elementName, featureVSValue);
								clickVSAttributeList.get(selectedClickName).add(elementName);
							}						
						}
					}					
				}				
			}
		});
    	
    	 
    	clearButton = new JButton("clear");
    	clearButton.addActionListener(new ActionListener()
 		{
 			public void actionPerformed(ActionEvent e)
 			{			
// 				JTable table = activityImpactingColumnTablePanel.getTable();
// 				MyTableModel tableModel = (MyTableModel) table.getModel();
//				String currentTableName = selectedTablePanel.getTablename();
//				for(int i=0; i<activityBox.getItemCount(); i++){
//					String tableAndActivityColumn = currentTableName + "-" + activityBox.getItemAt(i);
//					tableColumnVSImpactedTableColumns.remove(tableAndActivityColumn);
//				}				
//				//remove the selected record from table
//				tableModel.clearAllTableRows();
//				tableModel.updateTable();
 			}																					
 		}); 
         
        removeButton = new JButton("remove");
        removeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				JTable table = tablePanel.getTable();
				MyTableModel tableModel = (MyTableModel) table.getModel();
				int selectdRow  = table.getSelectedRow();
				if(selectdRow >= 0){					
					//remove the record from the (mapping) variables 				
					String selectedClickName = clickNameListPanel.getJList().getSelectedValue();
					String elementType = (String) tableModel.getValueAt(selectdRow, tableFieldRow.indexOf(mxConstants.ElementType));
					String elementName = (String) tableModel.getValueAt(selectdRow, tableFieldRow.indexOf(mxConstants.ElementName));
					clickVSElementVSFeatureVSValue.get(selectedClickName).remove(elementName);
					if(elementType.equals(mxConstants.click) || elementType.equals(mxConstants.clickFake)){
						clickVSAttributeList.remove(selectedClickName);
						clickNameListPanel.removeElement(elementName);
					}
					else if(elementType.equals(mxConstants.attribute) || elementType.equals(mxConstants.hierarchy) ||
							elementType.equals(mxConstants.attributeMultiple)){						
						clickVSAttributeList.get(selectedClickName).remove(elementName);
					}
					//remove the selected record from table
					tableModel.removeRecordRow(selectdRow);
					tableModel.updateTable();											
				}

			}																					
		});       
              
		importConfigurationFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Click Type Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Select", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					System.out.println("selected file is not empty!");
					lastFile = file.getParentFile();
					System.out.println(file.getName());  
			    	ConfigurationParameters configuration = new ConfigurationParameters();
			    	configuration.getNameVSMapMapMapParameterMap().put(mxConstants.clickVSElementVSFeatureVSValue, null);
	 				configuration.getNameVSMapListParameterMap().put(mxConstants.clickVSAttributeList, null);

		          	ReadConfigurationsFromXML reader = new ReadConfigurationsFromXML(configuration);
		    		reader.parserXml(file.getAbsolutePath(), null);
		    		
		    		clickVSElementVSFeatureVSValue = configuration.getNameVSMapMapMapParameterMap().get(mxConstants.clickVSElementVSFeatureVSValue);
		    		clickVSAttributeList = configuration.getNameVSMapListParameterMap().get(mxConstants.clickVSAttributeList);
		    		if(clickVSAttributeList == null){
		    			JOptionPane.showMessageDialog(null, "Wrong! The imported file is not of correct format!");   
		    		}
		    		else{
		    			JOptionPane.showMessageDialog(null, "Succeed importing a file!"); 
			    		clickNameListPanel.updateListPanel(new ArrayList<String>(clickVSAttributeList.keySet()));
			    		clickNameListPanel.rankElement();//sort by alphabet
			    		clickNameListPanel.updateListPanel(clickNameListPanel.getValueList());
			    		//update the click box in the match click panel		
//						fatherPanel.getMatchDolibarrClickPanel().updateClickNameBox(clickNameListPanel.getValueList());
						fatherPanel.getDolibarrClickPanel().updateDolibarrBox(clickNameListPanel.getValueList());						  
		    		}
				}
			}
		});
        
        outputConfigurationFileButton.addActionListener(new ActionListener() {
 			@Override
 			public void actionPerformed(ActionEvent arg0) {
 				System.out.println("output logs");	
 				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Click Type Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Output", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					lastFile = file.getParentFile();
	 				configuration.getNameVSMapMapMapParameterMap().put(mxConstants.clickVSElementVSFeatureVSValue, clickVSElementVSFeatureVSValue);
	 				configuration.getNameVSMapListParameterMap().put(mxConstants.clickVSAttributeList, clickVSAttributeList);	 				

	 				if(clickVSAttributeList.keySet().size() == 0 && clickVSElementVSFeatureVSValue.keySet().size() == 0){
	 					JOptionPane.showMessageDialog(null, "The click type list is empty! Please create and then output!"); 
	 				}
	 				else{
	 					WriteConfigurationsIntoXML writer = new WriteConfigurationsIntoXML(configuration);
	 					String fileName = file.getAbsolutePath();
	 					if(fileName.contains(".")){
	 						writer.createXml(fileName);
	 					}
	 					else{
	 						writer.createXml(fileName + ".xml");
	 					}
						
//						JOptionPane.showMessageDialog(null, "Succeed outputing file: " + file.getAbsolutePath() + ".xml" + " !"); 
	 				}
				}	        				
 			}
 		});
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1, 5));
        buttonPanel.setMaximumSize(new Dimension(2000,40));
        selectedConfigurationFilePath.setMaximumSize(new Dimension(100,40));
        buttonPanel.add(removeButton);
        buttonPanel.add(importConfigurationFileButton);
//        buttonPanel.add(chooseConfigurationFilePathButton);
 //       buttonPanel.add(selectedConfigurationFilePath);
        buttonPanel.add(outputConfigurationFileButton);   
        buttonPanel.add(addButton);

        
        elementNameBox.setEditable(true);
		tagNameBox.setEditable(true);
		tagValueBox.setEditable(true);
		attributeNameBox.setEditable(true);
		attributeValueBox.setEditable(true);
		indexBox.setEditable(true);
		defaultValueBox.setEditable(true);
		dependencyBox.setEditable(true);
		directionBox.setEditable(true);		
	    
		
		//set size of boxes
		((JTextField)elementNameBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)tagNameBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)tagValueBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)attributeNameBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)attributeValueBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)indexBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)defaultValueBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)dependencyBox.getEditor().getEditorComponent()).setColumns(5);
		((JTextField)directionBox.getEditor().getEditorComponent()).setColumns(5);
		
		//set tool tip for boxes
		elementTypeBox.setToolTipText(mxConstants.ElementType);
		elementNameBox.setToolTipText(mxConstants.ElementName);
		tagNameBox.setToolTipText(mxConstants.TagName);
		tagValueBox.setToolTipText(mxConstants.TagValue);
		attributeNameBox.setToolTipText(mxConstants.AttributeName);
		attributeValueBox.setToolTipText(mxConstants.AttributeValue);
		indexBox.setToolTipText(mxConstants.ElementIndex);
		defaultValueBox.setToolTipText(mxConstants.DefaultValue);	
		dependencyBox.setToolTipText(mxConstants.Dependency);
		directionBox.setToolTipText(mxConstants.Direction);
        
    	JPanel selectionPanel = new JPanel();
    	selectionPanel.setMaximumSize(new Dimension(2000,40));
    	selectionPanel.setLayout(new BoxLayout(selectionPanel, BoxLayout.X_AXIS));    
//    	tableBox.setMaximumSize(new Dimension(50,30));
//    	tableBox.setMaximumSize( tableBox.getPreferredSize() );  	
    	selectionPanel.add(boxesLable);
    	selectionPanel.add(elementTypeBox);
    	selectionPanel.add(elementNameBox);
    	selectionPanel.add(tagNameBox);
    	selectionPanel.add(tagValueBox);
    	selectionPanel.add(attributeNameBox);
    	selectionPanel.add(attributeValueBox);
    	selectionPanel.add(indexBox);
    	selectionPanel.add(defaultValueBox);
    	selectionPanel.add(dependencyBox);
    	selectionPanel.add(directionBox);		


    	this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
    	tablePanel = new CreateTablePanel("");
        tableFieldRow.add("index");
        tableFieldRow.add(mxConstants.ElementType);
        tableFieldRow.add(mxConstants.ElementName);
        tableFieldRow.add(mxConstants.TagName);
        tableFieldRow.add(mxConstants.TagValue);
        tableFieldRow.add(mxConstants.AttributeName);
        tableFieldRow.add(mxConstants.AttributeValue);
        tableFieldRow.add(mxConstants.ElementIndex);
        tableFieldRow.add(mxConstants.DefaultValue);
        tableFieldRow.add(mxConstants.Dependency);
        tableFieldRow.add(mxConstants.Direction);
        
        tablePanel.setFieldRow(tableFieldRow);
        tablePanel.updateTable();
        tablePanel.getTable().setPreferredScrollableViewportSize(new Dimension(1000, 300));
        MyTableModel model = (MyTableModel) tablePanel.getTable().getModel();
        model.addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {                                 	
                int col = e.getColumn();               
                int row = e.getFirstRow();  
                System.out.println("col: " + col);
                String selectedClickName = clickNameListPanel.getJList().getSelectedValue();
                MyTableModel model = (MyTableModel) tablePanel.getTable().getModel();
                if(col > 0 && col != 2) {          	
                    String columnName = model.getColumnName(col);
                    String elementName = (String) model.getValueAt(row, tableFieldRow.indexOf(mxConstants.ElementName));
                	String newValue = (String) model.getValueAt(row, col);
                	clickVSElementVSFeatureVSValue.get(selectedClickName).get(elementName).put(columnName, newValue);
                } 
//                else{              	              
//                	if(model.getRowCount()>row+1){
//                		JOptionPane.showMessageDialog(null, "This column cannot be modified!"); 
//                	}               	
//                }
            }  
        }); 
        
    	JPanel pageElementAttributesPanel = new JPanel();
    	pageElementAttributesPanel.setLayout(new BoxLayout(pageElementAttributesPanel, BoxLayout.Y_AXIS));
    	
    	pageElementAttributesPanel.add(buttonPanel);     
    	pageElementAttributesPanel.add(selectionPanel);
    	pageElementAttributesPanel.add(tablePanel);
        
    	JSplitPane editPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
    	editPanel.setLeftComponent(clickNameListPanel);
    	editPanel.setRightComponent(pageElementAttributesPanel);
    	editPanel.setResizeWeight(0.01);   
    	editPanel.setBorder(BorderFactory.createEmptyBorder());
        
//        this.add(clickNameListPanel);
//        this.add(pageElementAttributesPanel);
    	this.add(editPanel);
        this.setBorder(BorderFactory.createTitledBorder("edit click"));    
        update();
    }
 
    /*
     * update the table activity impacting panel for the input table
     */
    public void update(){
    	System.out.println("update activity impacting panel");
    	
    	List<String> elementList = new ArrayList<String>(); 
    	
    	updateElementTypeBox();
    	
        updateClickNameBox(null);
        
        elementList.clear();
    	elementList.add(mxConstants.form);
    	elementList.add(mxConstants.input);
    	elementList.add(mxConstants.table);
    	elementList.add(mxConstants.a);
    	elementList.add(mxConstants.tr);
    	elementList.add(mxConstants.td);
    	elementList.add(mxConstants.span);
    	elementList.add(mxConstants.select);
        updateTagNameBox(elementList);
        
        updateTagValueBox(null);
        
        elementList.clear();
    	elementList.add(mxConstants.id);
    	elementList.add("class");
    	elementList.add("name");
    	elementList.add("value");
    	elementList.add("type");
    	elementList.add("align");
        updateAttributeNameBox(elementList);
        
        updateAttributeValueBox(null);
        
        updateIndexBox(null);
        
        updateDefaultValueBox(null);
        
        dependencyBox.removeAllItems();
        dependencyBox.addItem(mxConstants.nullValue);
        
        directionBox.removeAllItems();
        directionBox.addItem(mxConstants.nullValue);
        directionBox.addItem(mxConstants.child);
        directionBox.addItem(mxConstants.parent);
    }
    
    public void updateElementTypeBox(){
    	elementTypeBox.removeAllItems();
    	elementTypeBox.addItem(mxConstants.click);	
    	elementTypeBox.addItem(mxConstants.clickFake);
    	elementTypeBox.addItem(mxConstants.clickCheck);
    	elementTypeBox.addItem(mxConstants.attribute);
    	elementTypeBox.addItem(mxConstants.attributeMultiple);
    	elementTypeBox.addItem(mxConstants.hierarchy);
    }
    
    public void updateClickNameBox(List<String> elementList){
    	elementNameBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			elementNameBox.addItem(element);	
			}
    	}
    	else{
//    		elementNameBox.addItem("<element_name>");
    		elementNameBox.addItem("null");
    	}
    }
    
    public void updateTagNameBox(List<String> elementList){
    	tagNameBox.removeAllItems();  	
    	if(elementList != null){
    		for(String element : elementList){			
    			tagNameBox.addItem(element);	
			}
    	}
    	else{
//    		tagNameBox.addItem("<tag_name>");
    		tagNameBox.addItem("null");
    	}
//    	tagNameBox.addItem("<null>");
    }
   
    public void updateTagValueBox(List<String> elementList){
    	tagValueBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			tagValueBox.addItem(element);	
			}
    	}
    	else{
    		tagValueBox.addItem("null");
    	}
    	
    	tagValueBox.addItem("dynamic");  	
    }

    public void updateAttributeNameBox(List<String> elementList){
    	attributeNameBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			attributeNameBox.addItem(element);	
			}
    	}
    	else{
    		attributeNameBox.addItem("null");
    	}
    }
   
    public void updateAttributeValueBox(List<String> elementList){
    	attributeValueBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			attributeValueBox.addItem(element);	
			}
    	}
    	else{
    		attributeValueBox.addItem("null");
    	}
    }
    
    public void updateIndexBox(List<String> elementList){
    	indexBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			indexBox.addItem(element);	
			}
    	}
    	else{
    		indexBox.addItem("0");
    		indexBox.addItem("1");
    		indexBox.addItem("2");
    	}
    }

    public void updateDefaultValueBox(List<String> elementList){
    	defaultValueBox.removeAllItems();
    	if(elementList != null){
    		for(String element : elementList){			
    			defaultValueBox.addItem(element);	
			}
    	}
    	else{
    		defaultValueBox.addItem("null");
    	}
    }
    
    public void updateTable(List<String> eventList, Map<String, Map<String, Object>> eventVSAttributes){
        //update the mapping table
    	
    	tablePanel.clearAllTableRows();
//        for(String event : eventList){//key: llx_projet-datec
//			List<Object> valueList = new ArrayList<Object>();
//			String resource = (String) eventVSAttributes.get(event).get(mxConstants.clickPerson);
//			valueList.add(event.split("\\)")[1]);
//			valueList.add(resource);
//			valueList.add("");
//			valueList.add("");
//			tablePanel.addRecordRow(valueList);
//			tablePanel.updateTable();
//
//        }
    }
    
    public List<String> getClickNameList(){
    	return clickNameListPanel.getValueList();
    }
    
    public String getSelectedClickType(){
    	return selectedClickType;
    }
    
    public Map<String, List<String>> getClickVSAttributeList(){
    	return clickVSAttributeList;
    }
    
    public Map<String, Map<String, Map<String, String>>> getClickVSElementVSFeatureVSValue(){
    	return clickVSElementVSFeatureVSValue;
    }
    
    public static void main(String[] args) {

    }

}