package org.processmining.dolibarr.operationrobot.panels;
 
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.xml.parsers.ParserConfigurationException;

import org.processmining.common.dialogue.IOFileDialogue;
import org.processmining.common.frame.CreateListPanel;
import org.processmining.dolibarr.operationrobot.io.ParseSimulationLog;
import org.xml.sax.SAXException;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class ImportSimulationLogPanel extends JPanel{
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private JButton importButton = new JButton("import simulation log");
    private JButton clearButton = new JButton("clear");
    private JList<String> clickEventList;
    private DefaultListModel<String> clickEventListModel;
    private JLabel sourceLabel;
//    private JFileChooser fileChooser;
    private JTextField selectdFilePath;
    
    private ParseSimulationLog parseSimulationLog = new ParseSimulationLog();
    private List<String> eventList = new ArrayList<String>();
    private Map<String, Map<String, Object>> eventVSAttributes = new HashMap<String, Map<String, Object>>();
    private Map<String, List<String>> activityVSAttributeList = new HashMap<String, List<String>>();
    
//    private AlignSimulationLogForDolibarr alignment = new AlignSimulationLogForDolibarr();
//    private List<String> alignedEventList = new ArrayList<String>();
//    private Map<String, Map<String, Object>> alignedEventVSAttributes = new HashMap<String, Map<String, Object>>();
//    private Map<String, List<String>> alignedActivityVSAttributeList = new HashMap<String, List<String>>();
    		
    private CreateListPanel eventClicksPanel;
    private CreateListPanel eventAttributesPanel;
//    private CreateListPanel alignedEventClicksPanel;
//    private CreateListPanel alignedEventAttributesPanel;
    private File lastFile;
//    private PicturePanel picturePanel;
    private BuildClickInterface fatherPanel;
    
    public List<String> getEventList(){
    	return eventList;
    }
    
    public Map<String, Map<String, Object>> getEventVSAttributes(){
    	return eventVSAttributes;
    }
    
//    public List<String> getAlignedEventList(){
//    	return alignedEventList;
//    }
//    
//    public Map<String, Map<String, Object>> getAlignedEventVSAttributes(){
//    	return alignedEventVSAttributes;
//    }
    
    public ImportSimulationLogPanel(final BuildClickInterface fatherPanel) {
    	this.fatherPanel = fatherPanel;   	  	
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));      
       
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
        buttonPanel.add(importButton);
        buttonPanel.add(Box.createVerticalStrut(30));
        buttonPanel.add(clearButton);
        
        buttonPanel.setMaximumSize(new Dimension(200, 20));
        
    	eventClicksPanel = new CreateListPanel(null, "events");
    	eventAttributesPanel = new CreateListPanel(null, "attributes");
//    	alignedEventClicksPanel = new CreateListPanel(null, "aligned events");
//    	alignedEventAttributesPanel = new CreateListPanel(null, "aligned attributes");
    	
    	eventClicksPanel.getJList().addListSelectionListener(new ListSelectionListener() {		
    		public void valueChanged(ListSelectionEvent e) {
    			System.out.println("\n selected value: " + eventClicksPanel.getJList().getSelectedValue());
    			String selectedEventClickListValue = eventClicksPanel.getJList().getSelectedValue();
    			if(selectedEventClickListValue != null){
    				Map<String, Object> attributes = eventVSAttributes.get(selectedEventClickListValue);
    				List<String> valueList = new ArrayList<String>();
    				if(attributes != null){

    					for(String key : attributes.keySet()){
    						if(attributes.get(key) instanceof String){
    							String value = (String) attributes.get(key);
    							valueList.add(key + ": " + value);
    						}
    						else if(attributes.get(key) instanceof List){
    							System.out.println("attribute of list type");
    							List<Map<String, String>> subAttributeUnitList = (List<Map<String, String>>) attributes.get(key);
    							valueList.add(key + ": ");
    							for(Map<String, String> subAttributeUnit : subAttributeUnitList){
    								valueList.add("-(" + (subAttributeUnitList.indexOf(subAttributeUnit) + 1) + "): ");
    								for(String subAttributeKey : subAttributeUnit.keySet()){
    									valueList.add("--" + subAttributeKey + ": " + subAttributeUnit.get(subAttributeKey));
    								}
    							}
    						}
    					}
    					eventAttributesPanel.updateListPanel(valueList);
    				}
    				System.out.print("\n sourceList.getSelectedValue(): " + selectedEventClickListValue);
    				String clickName = selectedEventClickListValue.split("\\)")[1];;
    				System.out.print("\n clickName: " + clickName);					
    			}		
    		}
		});

//    	alignedEventClicksPanel.getJList().addListSelectionListener(new ListSelectionListener() {		
//    		public void valueChanged(ListSelectionEvent e) {
//    			System.out.println("\n selected value in aligned: " + alignedEventClicksPanel.getJList().getSelectedValue());
//    			String selectedEventClickListValue = alignedEventClicksPanel.getJList().getSelectedValue();
//    			if(selectedEventClickListValue != null){
//    				Map<String, Object> attributes = alignedEventVSAttributes.get(selectedEventClickListValue);
//    				List<String> valueList = new ArrayList<String>();
//    				if(attributes != null){
//
//    					for(String key : attributes.keySet()){
//    						if(attributes.get(key) instanceof String){
//    							String value = (String) attributes.get(key);
//    							valueList.add(key + ": " + value);
//    						}
//    						else if(attributes.get(key) instanceof List){
//    							System.out.println("attribute of list type in aligned");
//    							List<Map<String, String>> subAttributeUnitList = (List<Map<String, String>>) attributes.get(key);
//    							valueList.add(key + ": ");
//    							for(Map<String, String> subAttributeUnit : subAttributeUnitList){
//    								valueList.add("-(" + (subAttributeUnitList.indexOf(subAttributeUnit) + 1) + "): ");
//    								for(String subAttributeKey : subAttributeUnit.keySet()){
//    									valueList.add("--" + subAttributeKey + ": " + subAttributeUnit.get(subAttributeKey));
//    								}
//    							}
//    						}
//    					}
//    					alignedEventAttributesPanel.updateListPanel(valueList);
//    				}
//    				System.out.print("\n sourceList.getSelectedValue() in aligned: " + selectedEventClickListValue);
//    				String clickName = selectedEventClickListValue.split("\\)")[1];;
//    				System.out.print("\n clickName in aligned: " + clickName);					
//    			}		
//    		}
//		});

    	
    	JSplitPane simulationLogPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
    	simulationLogPanel.setLeftComponent(eventClicksPanel);
    	simulationLogPanel.setRightComponent(eventAttributesPanel);
    	simulationLogPanel.setResizeWeight(0.01);   
    	simulationLogPanel.setBorder(BorderFactory.createEmptyBorder());
    	
//    	JSplitPane alignedLogPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
//    	alignedLogPanel.setLeftComponent(alignedEventClicksPanel);
//    	alignedLogPanel.setRightComponent(alignedEventAttributesPanel);
//    	alignedLogPanel.setResizeWeight(0.01);   
//    	alignedLogPanel.setBorder(BorderFactory.createEmptyBorder());
    	
//    	JSplitPane logPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
//    	logPanel.setTopComponent(simulationLogPanel);
//    	logPanel.setBottomComponent(alignedLogPanel);
//    	logPanel.setResizeWeight(0.5);   
//    	logPanel.setBorder(BorderFactory.createEmptyBorder());
        
        
    	JSplitPane completePanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
    	completePanel.setTopComponent(buttonPanel);
//    	completePanel.setBottomComponent(logPanel);
    	completePanel.setBottomComponent(simulationLogPanel);   	
    	completePanel.setResizeWeight(0.01);   
    	completePanel.setBorder(BorderFactory.createEmptyBorder());
    	
    	importButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {   
            	System.out.println("import file button is clicked!");
            	IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Simulation Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Select", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					System.out.println("selected file is not empty!");
    				String path = file.getAbsolutePath();
    				lastFile = file.getParentFile();
//            		String path = "E:\\project\\eclipse project\\OCBC\\tests\\testfiles\\ocbc-casestudies\\OrderToCash\\CPN\\CPNSimulationLogs\\log.xml";

            		try {
						parseSimulationLog.parseLog(path);
					} catch (IOException | ParseException | ParserConfigurationException | SAXException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
            		eventVSAttributes = parseSimulationLog.getEventVSAttributeNameVSAttributeContentMap();
					eventList = parseSimulationLog.getEventList();
					activityVSAttributeList = parseSimulationLog.getActivityVSAttributeListMap();
					
					//align simulation log
//					alignment.alignSimulationLog(eventList, activityVSAttributeList, eventVSAttributes);
//					alignedEventVSAttributes = alignment.getEventVSAttributeNameVSAttributeContentMap();
//					alignedEventList = alignment.getEventList();
//					alignedActivityVSAttributeList = alignment.getActivityVSAttributeListMap();
				}

            	//update the click panels
            	eventClicksPanel.updateListPanel(eventList);
//            	alignedEventClicksPanel.updateListPanel(alignedEventList);
            	
                List<String> eventKindList = new ArrayList<String>();
                Map<String, Integer> kindVSCountMap = new HashMap<String, Integer>();
                for(String eventId : eventList){
//                for(String eventId : alignedEventList){
                	String eventKind = eventId.split("\\)")[1];
                	if(!eventKindList.contains(eventKind)){
                		eventKindList.add(eventKind);
                	}
                	if(!kindVSCountMap.containsKey(eventKind)){
                		kindVSCountMap.put(eventKind, 1);
                	}
                	else{
                		int currentCount = kindVSCountMap.get(eventKind);
                		kindVSCountMap.put(eventKind, currentCount+1);
                	}               		
                }
                
                List<String> eventKindCountList = new ArrayList<String>();
                for(String eventKind : eventKindList){
                	String eventKindCount = eventKind + " :" + kindVSCountMap.get(eventKind);
                	eventKindCountList.add(eventKindCount);
                }
                
                //update the other panels
                fatherPanel.getMatchDolibarrClickPanel().setActivityVSAttributeList(activityVSAttributeList);
 //               fatherPanel.getMatchDolibarrClickPanel().setActivityVSAttributeList(alignedActivityVSAttributeList);
                fatherPanel.getMatchDolibarrClickPanel().updateList(eventKindCountList);
//                fatherPanel.getDolibarrClickPanel().updateInstanceTable(eventList, eventVSAttributes);
            }
        });
    	
    	clearButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {     
            	parseSimulationLog = new ParseSimulationLog();
            	eventVSAttributes.clear();
				eventList.clear();
				activityVSAttributeList.clear();
				
//				alignment = new AlignSimulationLogForDolibarr();
//				alignedEventVSAttributes.clear();
//				alignedEventList.clear();
//				alignedActivityVSAttributeList.clear();	
				
				eventClicksPanel.updateListPanel(eventList);
//            	alignedEventClicksPanel.updateListPanel(alignedEventList);
            	eventAttributesPanel.updateListPanel(new ArrayList<String>());
//            	alignedEventAttributesPanel.updateListPanel(new ArrayList<String>());
            	
            	fatherPanel.getMatchDolibarrClickPanel().setActivityVSAttributeList(activityVSAttributeList);
                fatherPanel.getMatchDolibarrClickPanel().updateList(new ArrayList<String>());
            }
    	});

        add(completePanel);
        this.setBorder(BorderFactory.createTitledBorder("simulation log"));    
    }
    

}