package org.processmining.dolibarr.operationrobot.panels;
 
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableColumn;

import org.processmining.common.dialogue.IOFileDialogue;
import org.processmining.common.frame.CreateListPanel;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyComboBoxEditor;
import org.processmining.common.table.MyComboBoxRenderer;
import org.processmining.common.table.MyTableModel;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.logconversion.configurations.ReadConfigurationsFromXML;
import org.processmining.ocbc.logconversion.configurations.WriteConfigurationsIntoXML;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class MatchDolibarrClickPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
//    private JComboBox<String> clickNameBox = new JComboBox<String>();

    private JButton removeButton = new JButton("remove");
    private JButton addButton = new JButton("add");
    private JButton importConfigurationFileButton = new JButton("import");
    private JButton chooseConfigurationFilePathButton = new JButton("choose path");
    private JButton outputConfigurationFileButton = new JButton("output");
    private JTextField selectedConfigurationFilePath = new JTextField();
    private File lastFile;
    
    private CreateTablePanel tablePanel;
    private BuildClickInterface fatherPanel;

  //record the attributes of each activity
    private Map<String, List<String>> activityVSAttributeList;
    //record the click name for each activity
//    private Map<String, String> activityVSClick = new HashMap<String, String>();//outdated
  //record the click list for each activity
    private Map<String, List<String>> activityVSClickList = new HashMap<String, List<String>>();
    //record the corresponding element name of each attribute of each activity
//    private Map<String, Map<String, String>> activityVSAttributeVSElement = new HashMap<String, Map<String, String>>();//outdated
    //record the corresponding attribute name of each element of each click of each activity
    private Map<String, Map<String, Map<String, String>>> activityVSClickVSElementVSAttribute = new HashMap<String, Map<String, Map<String, String>>>();
    
    private CreateListPanel activityListPanel = new CreateListPanel(null, "activities");
    private CreateListPanel clickListPanel = new CreateListPanel(null, "corresponding click types");//show the clicks corresponding one activity
    private List<String> tableFieldRow = new ArrayList<String>();

    //record the attribute element names of clicks
    private Map<String, List<String>> clickVSAttributeList = new HashMap<String, List<String>>();
    private ConfigurationParameters configuration = new ConfigurationParameters();
    
    public MatchDolibarrClickPanel(final BuildClickInterface fatherPanel) {
    	this.fatherPanel = fatherPanel;  	

//    	clickNameBox.addActionListener(new ActionListener() {			
//			public void actionPerformed(ActionEvent e) {
//				// TODO Auto-generated method stub
//				String selectedClickItem = (String) clickNameBox.getSelectedItem();
//				String selectedActivityItem = activityListPanel.getJList().getSelectedValue();
//				if(selectedActivityItem != null){
//					String activityName = selectedActivityItem.split(":")[0].trim();
//					System.out.println("add in the map: " + activityName + "-" + selectedClickItem);
////					activityVSClick.put(activityName, selectedClickItem);
////					activityVSAttributeVSElement.put(activityName, new HashMap<String, String>());
////					updateTable(activityName, selectedClickItem);
//				}				
//			}
//		});
//    	clickNameBox.setPrototypeDisplayValue("text here");
//    	clickNameBox.setRenderer(new ComboBoxRenderer(clickNameBox));
    	
    	//update the click panel when the activity changes
    	activityListPanel.getJList().addListSelectionListener(new ListSelectionListener() {			
			public void valueChanged(ListSelectionEvent e) {
				System.out.println("enter activityListPanel value changed");
				String selectedItem = activityListPanel.getJList().getSelectedValue();
				if(selectedItem != null){
					String activityName = selectedItem.split(":")[0].trim();
					System.out.println("activityName: " + activityName);
					for(String activity : activityVSClickList.keySet()){
						System.out.println("activity in the mapping: " + activity);
					}
					//update the click panel				
				    if(activityVSClickList.containsKey(activityName)){	
				    	System.out.println("contains: ");
				    	clickListPanel.updateListPanel(activityVSClickList.get(activityName));
				    }
				    else{//clear the click list panel
				    	System.out.println("not contains: ");
				    	clickListPanel.updateListPanel(new ArrayList<String>());
				    }
				    
//				    String selectedClickName = clickListPanel.getSelectedElement();
//				    updateTable(activityName, selectedClickName);
					
					//update the click box in the dolibarr click panel
//					fatherPanel.getDolibarrClickPanel().updateClickNameBox(activityListPanel.getValueList());
				}
			}
		});
    	 
    	//update the table panel when the click changes
    	clickListPanel.getJList().addListSelectionListener(new ListSelectionListener() {			
			public void valueChanged(ListSelectionEvent e) {
				String selectedItem = activityListPanel.getJList().getSelectedValue();
				if(selectedItem != null){
					String activityName = selectedItem.split(":")[0].trim();	    
				    String selectedClickName = clickListPanel.getSelectedElement();
				    
				    updateTable(activityName, selectedClickName);
					
					//update the click box in the dolibarr click panel
//					fatherPanel.getDolibarrClickPanel().updateClickNameBox(activityListPanel.getValueList());
				}				
			}
		});
    	
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String selectedItem = activityListPanel.getJList().getSelectedValue();
				if(selectedItem != null){
					String activityName = selectedItem.split(":")[0].trim();
//					String selectedClickName = clickNameBox.getSelectedItem().toString();
					String selectedClickName = fatherPanel.getEditDolibarrClickPanel().getSelectedClickType();
					if(selectedClickName != null){
						int selectedIndex = clickListPanel.getJList().getSelectedIndex();
						if(!activityVSClickList.containsKey(activityName)){		    	
							activityVSClickList.put(activityName, new ArrayList<String>());						
					    }
						if(!activityVSClickList.get(activityName).contains(selectedClickName)){		
							if(selectedIndex >= 0){
								activityVSClickList.get(activityName).add(selectedIndex + 1, selectedClickName);
							}
							else{
								activityVSClickList.get(activityName).add(0,selectedClickName);	
							}

							clickListPanel.updateListPanel(activityVSClickList.get(activityName));
					    }		
					}
					else{
						JOptionPane.showMessageDialog(null, "Wrong! Please select a click type in the click types list in the edit click panel!");
					}
				}					
			}
		});
		
    	removeButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String selectedItem = activityListPanel.getJList().getSelectedValue();
				String activityName = selectedItem.split(":")[0].trim();
				String selectedClickName = clickListPanel.getSelectedElement();
				if(selectedClickName != null){
					if(activityVSClickList.containsKey(activityName)){
						activityVSClickList.get(activityName).remove(selectedClickName);
					}
					clickListPanel.removeElement(selectedClickName);
				}						
			}
		});
    	
		importConfigurationFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Mapping Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Select", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					System.out.println("selected file is not empty!");
					lastFile = file.getParentFile();
			    	ConfigurationParameters configuration = new ConfigurationParameters();
			    	configuration.getNameVSMapMapMapParameterMap().put(mxConstants.activityVSClickVSElementVSAttribute, null);
	 				configuration.getNameVSMapListParameterMap().put(mxConstants.activityVSClickList, null);
	 				
		          	ReadConfigurationsFromXML reader = new ReadConfigurationsFromXML(configuration);
		    		reader.parserXml(file.getAbsolutePath(), null);
		    		
		    		if(configuration.getNameVSMapListParameterMap().get(mxConstants.activityVSClickList) == null){
		    			JOptionPane.showMessageDialog(null, "Wrong! The imported file is not of correct format!");   
		    		}
		    		else{
		    			JOptionPane.showMessageDialog(null, "Succeed importing a file!"); 
		    			activityVSClickVSElementVSAttribute = configuration.getNameVSMapMapMapParameterMap().get(mxConstants.activityVSClickVSElementVSAttribute);
			    		activityVSClickList = configuration.getNameVSMapListParameterMap().get(mxConstants.activityVSClickList);		    		
		    		}		    		
				}				
			}
		});      
    	
        outputConfigurationFileButton.addActionListener(new ActionListener() {
 			@Override
 			public void actionPerformed(ActionEvent arg0) {
 				System.out.println("generate logs");
 				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("Mapping Log (.xml)", "xml", JFileChooser.FILES_ONLY, "Output", lastFile);
            	File file = fileImporter.getSelectedFile();
				if(file != null){			
					lastFile = file.getParentFile();
	 				for(int i=0; i<activityListPanel.getJList().getModel().getSize(); i++){
	 					String item = activityListPanel.getJList().getModel().getElementAt(i);
	 					String activity = item.split(":")[0].trim();
	 					if(!activityVSClickList.containsKey(activity) || activityVSClickList.get(activity).size() == 0){
	 						JOptionPane.showMessageDialog(null, "Warning! Some activities have no corresponding click types!"); 
	 						break;
	 					}
	 				}
	 				if(activityVSClickList.keySet().size() == 0 && activityVSClickVSElementVSAttribute.keySet().size() == 0){
	 					JOptionPane.showMessageDialog(null, "The mapping is empty! Please create and then output!"); 
	 				}
	 				else{
	 					configuration.getNameVSMapListParameterMap().put(mxConstants.activityVSClickList, activityVSClickList);
	 	 				configuration.getNameVSMapMapMapParameterMap().put(mxConstants.activityVSClickVSElementVSAttribute, activityVSClickVSElementVSAttribute);
	 					WriteConfigurationsIntoXML writer = new WriteConfigurationsIntoXML(configuration);
	 					String fileName = file.getAbsolutePath();
	 					if(fileName.contains(".")){
	 						writer.createXml(fileName);
	 					}
	 					else{
	 						writer.createXml(fileName + ".xml");
	 					}
	 				}	    		
				}	
				
 				
			
//				JFileChooser fileChooser = new JFileChooser();  
//				fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);  
//				fileChooser.showDialog(new JLabel(), "select");  
//				if(lastFile != null){
//			    	System.out.println(lastFile);  
//			    	fileChooser.setCurrentDirectory(lastFile);
//			    }
//		        File fileDirectory = fileChooser.getSelectedFile();  		      
//		        if(fileDirectory != null){
//		        	String absolutePath = fileDirectory.getAbsolutePath();				
//		        	lastFile = fileDirectory;
////	 				String pathD = "E:\\project\\eclipse project\\OCBC\\tests\\testfiles\\ocbc-casestudies\\OrderToCash\\XOCLog\\5orders26events\\normal\\dolibarr";
//	 				File file = new File(absolutePath); 
//	 				for(int i=0; i<activityListPanel.getJList().getModel().getSize(); i++){
//	 					String item = activityListPanel.getJList().getModel().getElementAt(i);
//	 					String activity = item.split(":")[0].trim();
//	 					if(!activityVSClickList.containsKey(activity) || activityVSClickList.get(activity).size() == 0){
//	 						JOptionPane.showMessageDialog(null, "Warning! Some activities have no corresponding click types!"); 
//	 						break;
//	 					}
//	 				}
//	 				if(activityVSClickList.keySet().size() == 0 && activityVSClickVSElementVSAttribute.keySet().size() == 0){
//	 					JOptionPane.showMessageDialog(null, "The mapping is empty! Please create and then output!"); 
//	 				}
//	 				else{
//	 					configuration.getNameVSMapListParameterMap().put(mxConstants.activityVSClickList, activityVSClickList);
//	 	 				configuration.getNameVSMapMapMapParameterMap().put(mxConstants.activityVSClickVSElementVSAttribute, activityVSClickVSElementVSAttribute);
//	 					WriteConfigurationsIntoXML writer = new WriteConfigurationsIntoXML(configuration);
//	 					String fileName = "matchClick.xml";
//						writer.createXml(file.getAbsolutePath() + "\\" + fileName);
//						JOptionPane.showMessageDialog(null, "Succeed outputing a file " + absolutePath + fileName + " !"); 
//	 				}	 				
//		        }
//		        else{
//		        	JOptionPane.showMessageDialog(null, "Wrong! Please a directory for saving configuretion file!");
//		        }		        				
 			}
 		});
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1, 5));
        buttonPanel.setMaximumSize(new Dimension(2000,40));
        buttonPanel.add(removeButton);
        buttonPanel.add(importConfigurationFileButton);
        buttonPanel.add(outputConfigurationFileButton);   
        buttonPanel.add(addButton);
        
    	this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
    	tablePanel = new CreateTablePanel("");
        tableFieldRow.add("index");
        tableFieldRow.add("type");
        tableFieldRow.add(mxConstants.ElementName);
        tableFieldRow.add(mxConstants.AttributeName);
        
        tablePanel.setFieldRow(tableFieldRow);
        tablePanel.updateTable();

        MyTableModel model = (MyTableModel) tablePanel.getTable().getModel();
        model.addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {                                 	
                int col = e.getColumn();               
                int row = e.getFirstRow();  
                System.out.println("col: " + col);
                String selectedItem = activityListPanel.getJList().getSelectedValue();
                String selectedActivity = selectedItem.split(":")[0].trim();
                String selectedClick = clickListPanel.getSelectedElement();
                
                if(col >= tableFieldRow.indexOf(mxConstants.AttributeName)){
                	MyTableModel model = (MyTableModel) tablePanel.getTable().getModel();
                    String columnName = model.getColumnName(col);
                    String elementName = (String) model.getValueAt(row, tableFieldRow.indexOf(mxConstants.ElementName));
                    String newAttributeName = (String) model.getValueAt(row, col);
                    //if the default value column changed
                    if(columnName.equals(mxConstants.AttributeName)){  
                    	if(!activityVSClickVSElementVSAttribute.containsKey(selectedActivity)){
                    		activityVSClickVSElementVSAttribute.put(selectedActivity, new HashMap<String, Map<String, String>>());
                    	}
                       	if(!activityVSClickVSElementVSAttribute.get(selectedActivity).containsKey(selectedClick)){
                    		activityVSClickVSElementVSAttribute.get(selectedActivity).put(selectedClick, new HashMap<String, String>());
                    	}
                       	activityVSClickVSElementVSAttribute.get(selectedActivity).get(selectedClick).put(elementName, newAttributeName);                   	                    	
                    }
                } 
            }  
        }); 
        
    	JPanel pageElementAttributesPanel = new JPanel();
    	pageElementAttributesPanel.setLayout(new BoxLayout(pageElementAttributesPanel, BoxLayout.Y_AXIS));
    	
    	pageElementAttributesPanel.add(buttonPanel);    
    	pageElementAttributesPanel.add(clickListPanel);
    	pageElementAttributesPanel.add(new JScrollPane(tablePanel));
        
    	JSplitPane editPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
    	editPanel.setLeftComponent(activityListPanel);
    	editPanel.setRightComponent(pageElementAttributesPanel);
    	editPanel.setResizeWeight(0.01);   
    	editPanel.setBorder(BorderFactory.createEmptyBorder());

    	this.add(editPanel);
        this.setBorder(BorderFactory.createTitledBorder("match click"));    
        update();
    }
 
    /*
     * update the table activity impacting panel for the input table
     */
    public void update(){
    	System.out.println("update activity impacting panel");
    	
    	List<String> elementList = new ArrayList<String>(); 
    	
        updateClickNameBox(null);
        

    }
    

    
    public void updateClickNameBox(List<String> elementList){
//    	String selectedItem = (String) clickNameBox.getSelectedItem();
//    	clickNameBox.removeAllItems();
//    	if(elementList != null){
//    		for(String element : elementList){			
//    			clickNameBox.addItem(element);	
//			}   		
//    	}
//    	if(selectedItem != null){
//    		System.out.println("setSelectedItem: " + selectedItem);
//			clickNameBox.setSelectedItem(selectedItem);
//		}
    }
   
    public void setClickNameBox(String element){
//    	if(element != null){
//			clickNameBox.setSelectedItem(element);
//		}
    }
    
    //update the attribute matching panel
    public void updateTable(String activityName, String clickName){
	    tablePanel.clearAllTableRows();
	    Map<String, List<String>> clickVSAttributeList = fatherPanel.getEditDolibarrClickPanel().getClickVSAttributeList();
		//remove the click row (the first row)	
	    List<String> clickVSOnlyAttributeList = new ArrayList<String>();
		if(clickVSAttributeList.get(clickName) != null){
			for(String elementName : clickVSAttributeList.get(clickName)){		
		    	clickVSOnlyAttributeList.add(elementName);
		    }
		    clickVSOnlyAttributeList.remove(0);
		}
		
		String[] values = new String[activityVSAttributeList.get(activityName).size()+1];
		values[0] = "null";
		for(String attributeName : activityVSAttributeList.get(activityName)){		
			values[activityVSAttributeList.get(activityName).indexOf(attributeName)+1] = attributeName;
		}
		
		for(String elementName : clickVSOnlyAttributeList){		
			List<Object> valueList = new ArrayList<Object>();
			valueList.add("attribute/input");
			valueList.add(elementName);
			
			//if the value is assigned, show what is assigned; otherwise show "null" 
			String value = "null";							
			if(activityVSClickVSElementVSAttribute.containsKey(activityName) 
					&& activityVSClickVSElementVSAttribute.get(activityName).containsKey(clickName)
					&& activityVSClickVSElementVSAttribute.get(activityName).get(clickName).containsKey(elementName)){
				System.out.println("contain activityName: " + activityName);
				value = activityVSClickVSElementVSAttribute.get(activityName).get(clickName).get(elementName);
				System.out.println("value name before: " + value);		
				System.out.println("attribute name: " + elementName);
				System.out.println("value name after: " + value);		
			}
			System.out.println("value: " + value);	
			valueList.add(value);				
			tablePanel.addRecordRow(valueList);				
		}		
		tablePanel.updateTable();			

	    TableColumn col = tablePanel.getTable().getColumnModel().getColumn(tableFieldRow.indexOf(mxConstants.AttributeName));
	    tablePanel.getTable().setRowHeight(20);
	    
	    col.setCellEditor(new MyComboBoxEditor(values));
	    col.setCellRenderer(new MyComboBoxRenderer(values));		
    }
    
    public void updateList(List<String> valueList){
    	activityListPanel.updateListPanel(valueList);
    }
    
    public void setActivityVSAttributeList(Map<String, List<String>> activityVSAttributeList){
    	this.activityVSAttributeList = activityVSAttributeList;
    }
    
    public static void main(String[] args) {
    	Map<String, String> test = new HashMap<String, String>();
    	test.put("", "a");
    }

    
    public Map<String, List<String>> getActivityVSClickListMap(){
    	return activityVSClickList;
    }
    
    public Map<String, List<String>> getActivityVSAttributeListMap(){
    	return activityVSAttributeList;
    }
    
    public Map<String, Map<String, Map<String, String>>>  getActivityVSClickVSElementVSAttributeMap(){
    	return activityVSClickVSElementVSAttribute;
    }
}

