package org.processmining.dolibarr.operationrobot.panels; 
 
import static javafx.concurrent.Worker.State.FAILED;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.common.frame.CreateListPanel;
import org.processmining.dolibarr.operationrobot.plugin.PopulateDolibarrDatabasePlugin;
import org.processmining.mxgraph.util.mxConstants;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.events.DocumentEvent;
import org.w3c.dom.html.HTMLCollection;
import org.w3c.dom.html.HTMLFormElement;
import org.w3c.dom.html.HTMLSelectElement;

import com.sun.webkit.dom.HTMLElementImpl;

import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.concurrent.Worker;
import javafx.embed.swing.JFXPanel;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebEvent;
import javafx.scene.web.WebView;
  
public class RunDolibarrPanel extends JPanel {
 
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JFXPanel jfxPanel = new JFXPanel();
    private static WebEngine engine;
 
    private JPanel dolibarrPanel = new JPanel();
    private JPanel statusBar = new JPanel(new BorderLayout(5, 0));
    private final JPanel panel = new JPanel(new BorderLayout());
    private final JLabel lblStatus = new JLabel();


    private final JButton btnGo = new JButton("Go");
    private final JButton clickButton = new JButton("Click");
    private final JTextField txtURL = new JTextField("http://localhost:81/dolibarr/");
    private final JProgressBar progressBar = new JProgressBar();
    private PopulateDolibarrDatabasePlugin populateDolibarrDatabasePlugin;
    
    //monitor panel elements
    private CreateListPanel clickListPanel = new CreateListPanel(null, "clicks");
    private CreateListPanel attributeListPanel = new CreateListPanel(null, "attributes");
    
    private Map<String, Map<String, String>> clickInstanceVSElementNameVSValue = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, Map<String, String>>> clickVSElementVSFeatureVSValue = new HashMap<String, Map<String, Map<String, String>>>();
    //record the object id on page for each object id in simulation log
    private Map<String, String> logObjectIdVSPageObjectId = new HashMap<String, String>();
    
    private boolean automaticRunningFlag = false;
    private boolean oneExecutionFlag = false;
    private boolean automaticRunningFirstTimeFlag = true;
    private String previousAddress;
    private String currentAddress;
    
    private Document document;
//    private HTMLDocument document;
    private DocumentEvent documentEvent;
    
    private String globalElementName = null;//used to find the element when there is dependency
    
    private int clickIndex = 1;

    private Map<Integer, String> indexVSclickType = new HashMap<Integer, String>();
    private Map<Integer, String> indexVSItemType = new HashMap<Integer, String>();
    
    private JButton nextStepButton = new JButton("execute one");
    private JButton runButton = new JButton("run");
    private JButton stopButton = new JButton("stop");
    
    public RunDolibarrPanel(final PopulateDolibarrDatabasePlugin populateDolibarrDatabasePlugin) {
        super();
        initComponents();        
    	
        this.populateDolibarrDatabasePlugin = populateDolibarrDatabasePlugin;
        
        List<String> clickList = new ArrayList<String>(indexVSclickType.values());
//        clickList.add(e);
        clickListPanel.updateListPanel(clickList);
        clickListPanel.getJList().setSelectedIndex(5);
        
        clickListPanel.getJList().addListSelectionListener(new ListSelectionListener() {
			
			public void valueChanged(ListSelectionEvent e) {
				// TODO Auto-generated method stub
				String selectedClickInstance = clickListPanel.getJList().getSelectedValue();			
				List<String> attributeList = new ArrayList<String>();
				if(clickInstanceVSElementNameVSValue.containsKey(selectedClickInstance)){
					for(String attributeName : clickInstanceVSElementNameVSValue.get(selectedClickInstance).keySet()){
						String attributeValue = clickInstanceVSElementNameVSValue.get(selectedClickInstance).get(attributeName).toString();
						String attributeComplex = attributeName + ": " + attributeValue;
						attributeList.add(attributeComplex);
					}
					
				}
				attributeListPanel.updateListPanel(attributeList);
			}
		});
        
    }
    
    /*
     * update the list in the click instance panel
     */
    public void updateRunningPanel(List<String> clickList, Map<String, Map<String, String>> clickInstanceVSElementNameVSValue){
    	clickListPanel.updateListPanel(clickList);
    	this.clickInstanceVSElementNameVSValue = clickInstanceVSElementNameVSValue;
    	this.clickVSElementVSFeatureVSValue = populateDolibarrDatabasePlugin.getSimulationLogPanel().getEditDolibarrClickPanel().getClickVSElementVSFeatureVSValue();
        automaticRunningFlag = false;
        oneExecutionFlag = false;
        clickIndex = 1;
    }

    private void initComponents() {
    	createBrower();
 
        ActionListener al = new ActionListener() {
            @Override 
            public void actionPerformed(ActionEvent e) {
                loadURL(txtURL.getText());
            }
        };
 
        btnGo.addActionListener(al);
        txtURL.addActionListener(al);
        clickButton.addActionListener(new ActionListener() {			
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub			
			}
		});
        
        progressBar.setPreferredSize(new Dimension(150, 18));
        progressBar.setStringPainted(true);
  
        JPanel topBar = new JPanel(new BorderLayout(5, 0));
        topBar.setBorder(BorderFactory.createEmptyBorder(3, 5, 3, 5));
        topBar.add(txtURL, BorderLayout.CENTER);
        topBar.add(btnGo, BorderLayout.EAST);
//        topBar.add(clickButton, BorderLayout.WEST);
        

        statusBar.setBorder(BorderFactory.createEmptyBorder(3, 5, 3, 5));
        statusBar.add(lblStatus, BorderLayout.CENTER);
        statusBar.add(progressBar, BorderLayout.EAST);
        
        topBar.setMaximumSize(new Dimension(2000, 30));
        statusBar.setMaximumSize(new Dimension(2000, 30));
        
        
        dolibarrPanel.setLayout(new BoxLayout(dolibarrPanel, BoxLayout.Y_AXIS));
        dolibarrPanel.add(topBar);
        dolibarrPanel.add(jfxPanel);
        dolibarrPanel.add(statusBar);
        
        
        JPanel bottonPanel = new JPanel(new GridLayout(1, 3));
//        JPanel bottonPanel = new JPanel();
        bottonPanel.setMaximumSize(new Dimension(1000, 50));      
        bottonPanel.add(nextStepButton);
        bottonPanel.add(runButton);
        bottonPanel.add(stopButton);
        
//        while(true);
        
        nextStepButton.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				System.out.println("execute one is clicked");
				
				if(!automaticRunningFlag){
					oneExecutionFlag = true;
					loadURL(txtURL.getText());
				}
			}
		});
        
        runButton.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				System.out.println("runButtonis clicked");
				automaticRunningFlag = true;
				
//				if(automaticRunningFirstTimeFlag){
//					clickIndex = 0;
////					automaticRunningFirstTimeFlag = false;
//				}
//				else{
//					clickIndex = 1;
//				}
//				
//			    clickIndex = 1;//*****hide if for convenience (without login)
			    
//				txtURL.setText("http://localhost:81/dolibarr/");
//				txtURL.setText("http://localhost/mouseEvent.php");

			    loadURL(txtURL.getText());
			}
		});
        
        stopButton.addActionListener(new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {
				System.out.println("stopButton is clicked");
				automaticRunningFlag = false;
			}
		});
        
        JSplitPane listPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);

        
        listPanel.setTopComponent(clickListPanel);
        listPanel.setBottomComponent(attributeListPanel);
        listPanel.setResizeWeight(0.5);
        
        JSplitPane monitorPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        monitorPanel.setTopComponent(bottonPanel);
        monitorPanel.setBottomComponent(listPanel);
        monitorPanel.setResizeWeight(0.01);
        
        JSplitPane completePanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        completePanel.setLeftComponent(monitorPanel);
        completePanel.setRightComponent(dolibarrPanel);
        completePanel.setResizeWeight(0.01);       
        
        this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        this.add(completePanel);
    }
 
    private void createBrower() {    	
    	
        Platform.runLater(new Runnable() {
        	
        	int counter = 0;
        	public void myNewThread(final WebView view){
        		
        		Thread thread = new Thread(){
             	   public void run(){
             	     System.out.println("myNewThread Running");
             	     
              	    try {
 						Thread.sleep(5000);
 					} catch (InterruptedException e) {
 						// TODO Auto-generated catch block
 						e.printStackTrace();
 					}//括号里面的5000代表5000毫秒，也就是5秒，可以该成你需要的时间
              	    
              	 
//             	     System.out.println("engine.getDocument() address" + view.getEngine().getDocument());
            	     HTMLElementImpl  myinputText = (HTMLElementImpl) view.getEngine().getDocument().getElementById("id-top");  
             	     if(myinputText != null){
		               	System.out.println("my inputText exist");
		               }
		               else{
		               	System.out.println("my inputText not exist");
		               }
//             	     view.getEngine().getLoadWorker().stateProperty().addListener(
//                              new ChangeListener<Worker.State>() {
//                                  @Override
//                                  public void changed( ObservableValue<? extends Worker.State> ov,
//                                                       Worker.State oldState, Worker.State newState ) {
//                                 	 NodeList list = view.getEngine().getDocument().getElementsByTagName("body");
//
//                             	     System.out.println("size: " + list.getLength());
//                                  }
//                              }
//             	     );
//             	     System.out.println("engine.getDocument() address" + view.getEngine().getDocument());
//             	     HTMLElementImpl  myinputText = (HTMLElementImpl) view.getEngine().getDocument().getElementById("id-top");  
//             	     
//             	     
//             	     
//             	     if(view.getEngine() == engine){
//             	    	 System.out.println("engine same");
//             	     }
//             	     else{
//             	    	 System.out.println("engine not same");
//             	     }
//             	     
//              	     if(view.getEngine().getDocument() == engine.getDocument()){
//             	    	 System.out.println("getDocument same");
//             	     }
//             	     else{
//             	    	 System.out.println("getDocument not same");
//             	     }
//              	    
//             	     if(myinputText != null){
//                      	System.out.println("my inputText exist");
//                      }
//                      else{
//                      	System.out.println("my inputText not exist");
//                      }

             	    
             	   System.out.println("myNewThread end");
             	   }
             	};
             	thread.start();
        	}
            @Override 
            public void run() {
            	
            	final WebView view = new WebView();
                System.out.println("new webview");
//                Scene scene = new Scene(view);
//                jfxPanel.setScene(scene);
                
                engine = view.getEngine();
    
                
                engine.titleProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> observable, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override 
                            public void run() {
//                                RunDolibarrPanel.this.setTitle(newValue);
//                            	System.out.println("titleProperty");
                            }
                        });
                    }
                });
 
                engine.setOnStatusChanged(new EventHandler<WebEvent<String>>() {
                    @Override 
                    public void handle(final WebEvent<String> event) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override 
                            public void run() {
                                lblStatus.setText(event.getData());
//                                System.out.println("setOnStatusChanged");
                            }
                        });
                    }
                });
                
                engine.locationProperty().addListener(new ChangeListener<String>() {
                    @Override
                    public void changed(ObservableValue<? extends String> ov, String oldValue, final String newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override 
                            public void run() {
                                txtURL.setText(newValue);
//                                System.out.println("locationProperty");
                            }
                        });
                    }
                });
 
                engine.getLoadWorker().workDoneProperty().addListener(new ChangeListener<Number>() {
                    @Override
                    public void changed(ObservableValue<? extends Number> observableValue, Number oldValue, final Number newValue) {
                        SwingUtilities.invokeLater(new Runnable() {
                            @Override 
                            public void run() {
                                progressBar.setValue(newValue.intValue());
//                                System.out.println("workDoneProperty");
                            }
                        });
                    }
                });

                engine.getLoadWorker()
                        .exceptionProperty()
                        .addListener(new ChangeListener<Throwable>() {
 
                            public void changed(ObservableValue<? extends Throwable> o, Throwable old, final Throwable value) {
                                if (engine.getLoadWorker().getState() == FAILED) {
                                    SwingUtilities.invokeLater(new Runnable() {
                                        @Override public void run() {
                                            JOptionPane.showMessageDialog(
                                                    panel,
                                                    (value != null) ?
                                                    engine.getLocation() + "\n" + value.getMessage() :
                                                    engine.getLocation() + "\nUnexpected error.",
                                                    "Loading error...",
                                                    JOptionPane.ERROR_MESSAGE);
                                        }
                                    });
                                }
                            }
                        });

                
                
                engine.getLoadWorker().stateProperty().addListener(
                        new ChangeListener<Worker.State>() {
                            @Override
                            public void changed( ObservableValue<? extends Worker.State> ov,
                                                 Worker.State oldState, Worker.State newState ) {
                            	System.out.println("enter stateProperty change");
                            	if (newState == Worker.State.SUCCEEDED && automaticRunningFlag == false){
                            		
//                                    System.out.println("clickType in automaticRunningFlag == true: " + clickType);
                                    
//                            		currentAddress = txtURL.getText();
//                            		if(!currentAddress.equals(previousAddress)){
//                            			previousAddress = currentAddress;
//
//                                  		clickListPanel.getJList().setSelectedIndex(clickIndex);
//                                  		clickIndex ++;
//                                		System.out.println("clickType in automaticRunningFlag == false: " + clickIndex);
//                            		}
                           		
                            	}
                            	
                                if (newState == Worker.State.SUCCEEDED && (automaticRunningFlag == true || oneExecutionFlag == true)) {                                     	
                                	oneExecutionFlag = false;
                                	
                                	document =  engine.getDocument();
                                	documentEvent = (DocumentEvent) engine.getDocument();
                                	
                                	if(clickIndex == 0){

                                		Element nameField = document.getElementById("username");
                                  	    Element passwordField = document.getElementById("password");
                                  	    HTMLFormElement loginForm = ( HTMLFormElement ) engine.getDocument().getElementById("login");
                                  	    
                                  		nameField.setAttribute("Value", "administrator");                                  		
                                  		passwordField.setAttribute("Value", "kfgz0874981211");                               	    
                                  	
                                  		loginForm.submit();
                                  		clickIndex ++ ;
                                	}
                                	
                                	boolean nextClick = true;
                                	while(clickIndex > 0 && nextClick){
	                                	String clickInstanceId = clickListPanel.getJList().getModel().getElementAt(clickIndex-1);
	                                	String clickType = clickInstanceId.split("_")[0];
	                                	
	                                    //make the current item selected
	                                    if(clickIndex < clickListPanel.getJList().getModel().getSize() 
	                                    		&& clickIndex > 1){
	                                    	clickListPanel.getJList().setSelectedIndex(clickIndex-1);
	                                    }
	                                    else{
	                                    	clickListPanel.getJList().setSelectedIndices(new int[]{});
	                                    }
	                                    
	                                    
	                                    System.out.println("clickInstanceId in automaticRunningFlag == true: " + clickInstanceId);
	                                    System.out.println("clickIndex in automaticRunningFlag == true: " + clickIndex);
	                                   
	                                    document = engine.getDocument();
	                                    if(clickType != null && document != null){
	                                    	
	                                    	//find the click
	                                    	System.out.println("clickType in automaticRunningFlag: " + clickType);
	                                    	System.out.println("document.getDocumentElement(): " + document.getDocumentElement());
	                                    	Element element = getElementByElementName(document.getDocumentElement(), clickType, clickType, null, clickInstanceId);
	                            			String tagName = clickVSElementVSFeatureVSValue.get(clickType).get(clickType).get(mxConstants.TagName);
	                            			String clickElementType = clickVSElementVSFeatureVSValue.get(clickType).get(clickType).get(mxConstants.ElementType);
	                            		
	                                    	//populate the element values
	                                    	if(clickInstanceVSElementNameVSValue.containsKey(clickInstanceId)){	
	                                    		System.out.println("clickInstanceVSElementNameVSValue.containsKey(clickInstanceId");
	                                    		for(String elementName : clickInstanceVSElementNameVSValue.get(clickInstanceId).keySet()){
	                                    			String attributeTagName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.TagName);
	                                    			String elementType = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.ElementType);
	                                    			String elementValue = clickInstanceVSElementNameVSValue.get(clickInstanceId).get(elementName);
	                                    			System.out.println("elementType: " + elementType);
	                                    			if(elementType.equals(mxConstants.attribute)){
	                                    				System.out.println("elementType equals to attribute");
	                                        			Element attributeElement = getElementByElementName(document.getDocumentElement(), clickType, elementName, null, clickInstanceId);
	                                        			//record the object id for (order, invoice)
	                                        			if(clickType.equals(mxConstants.BuildObjectIdMapping)){
	                                        				System.out.println("read elements");
	                                        				String content = attributeElement.getTextContent();
	                                        				logObjectIdVSPageObjectId.put(elementValue, content);
	                                        				System.out.println("elementValue in log: " + elementValue);
	                                        				System.out.println("content on page: " + content);
//	                                        				engine.reload();
	                                        				
	                                        			}
	                                        			else if(clickType.equals(mxConstants.SearchObject) || clickType.equals(mxConstants.SearchShipment)){
	                                        				System.out.println("search elements");                                    				
	                                        				String pageId = logObjectIdVSPageObjectId.get(elementValue);
	                                        				polulateElement(attributeElement, attributeTagName, pageId);	 
	                                        				System.out.println("elementValue: " + elementValue);
	                                        				System.out.println("pageId: " + pageId);
	                                        				if(pageId == null){
	                                        					JOptionPane.showMessageDialog(null, "Wrong! The searched (page) id is null");
	                                        				}
	                                        			}
	                                        			else if(clickType.equals(mxConstants.SearchSupplierOrder) && elementName.equals(mxConstants.SearchContent)){
	                                        				System.out.println("search elements");                                    				
	                                        				String pageId = logObjectIdVSPageObjectId.get(elementValue);
	                                        				polulateElement(attributeElement, attributeTagName, pageId);	 
	                                        				System.out.println("elementValue: " + elementValue);
	                                        				System.out.println("pageId: " + pageId);
	                                        			}
	                    
//	                                        			else if(clickType.equals(mxConstants.InputAmoutForInvoiceWhenPaying)){
//	                                        				System.out.println("InputAmoutForInvoiceWhenPaying");                                    				
//	                                        				String pageId = logObjectIdVSPageObjectId.get(elementValue);
//	                                        				polulateElement(attributeElement, attributeTagName, pageId);	 
//	                                        				System.out.println("elementValue: " + elementValue);
//	                                        				System.out.println("pageId: " + pageId);
//	                                        			}
	                                        			
//	                                        			else if(clickType.equals("Dispatch")){
//	                                        				System.out.println("enter Dispatch in attributes");                                    				
//	                                        				 
//	                                        				element = getElementByTagAndAttributeValue(document.getDocumentElement(), "img", "src", "/dolibarr/theme/eldy/img/object_product.png", 0);
//	                                        				
//	                                        				System.out.println("element.getTextContent(): " + element.getTextContent());
//	                                        				
//	                                        				element = getElementByTagAndContent(document.getDocumentElement(), "a", " p006", 0);
//	                        
//	                                        				if(element == null){
//	                                        					System.out.println(" p006 is null");
//	                                        				}
//	                                        				else{
//	                                        					System.out.println(" p006 is not null");
//	                                        				}                                        		
//	                                        			}
	                                        			else if(clickType.equals(mxConstants.RemoveAllCustomerInvoiceLines)){
	                                        				System.out.println("remove all invoice lines");                                    				
	                                        				HTMLElementImpl removeButton = null;
	                                        				HTMLElementImpl removeButtonYes = null;
	                                        				boolean existenceFlag = true;
	                                        				while(existenceFlag){
	                                        					removeButton = (HTMLElementImpl) getElementByElementName(document.getDocumentElement(), clickType, 
	                                        							mxConstants.RemoveAllCustomerInvoiceLines, null, clickInstanceId);	                                        					
	                                        					removeButtonYes = (HTMLElementImpl) getElementByElementName(document.getDocumentElement(), clickType, 
	                                        							mxConstants.RemoveAllCustomerInvoiceLinesYes, null, clickInstanceId);
	                                        					if(removeButton != null && removeButtonYes != null){
	                                        						removeButton.click();
		                                        					removeButtonYes.click();
	                                        					}
	                                        					else{
	                                        						existenceFlag = false;
	                                        					}	                                        					
	                                        				}
	                                        			}
	                                        			else{
	                                        				System.out.println("populate elements");
	                                        				polulateElement(attributeElement, attributeTagName, elementValue);	 
	                                        			}
	                                    			}       
	                                    			else if(elementType.equals(mxConstants.attributeMultiple)){
                                        				System.out.println("attributeMultiple");                                    				
                                        				List<Element> attributeElementList = getElementListByElementName(document.getDocumentElement(), clickType, elementName, null, clickInstanceId);
                                        				for(Element attributeElement: attributeElementList){
                                        					polulateElement(attributeElement, attributeTagName, elementValue);	 	 
                                            				System.out.println("elementValue: " + elementValue);                                          				
                                        				}
                                        				
                                        			}                           			                                 			
	                                      		}
	                                    	}       
	                                    	System.out.println("clickElementType: " + clickElementType);
	                                    	if(clickElementType.equals(mxConstants.clickFake)){
	                                    		System.out.println("fake click");	                                    		
	                                    		nextClick = true;	                                    		
//	                                    		triggerClick(element, tagName); 

	                                    	}
	                                    	else if(clickElementType.equals(mxConstants.clickCheck)){
	                                    		System.out.println("check box click");	                                    		
	                                    		nextClick = true;	                                    		
	                                    		triggerClick(element, tagName); 

	                                    	}
	                                    	else if(clickElementType.equals(mxConstants.click)){
	                                    		System.out.println("real click");                                   	
	                                    		nextClick = false;
	                                    		//trigger the click
	                                			triggerClick(element, tagName); 
	                                			System.out.println("finish real click");
	                                    	}     

	                                    	runButton.setText("run(" +  clickIndex + ")");
		                                    clickIndex ++;
		                                    currentAddress = txtURL.getText();
		                                    previousAddress = currentAddress;
		                                    if(clickIndex > clickListPanel.getJList().getModel().getSize()){
		                                    	automaticRunningFlag = false;
		                                    }
		                                    System.out.println("finish one step");
		                                    
	                                    }
	                                    else{
	                                    	nextClick = false;
	                                    }
	                                    	                              			
                                	}
                                }
                            }
                        }
                );
                
                jfxPanel.setScene(new Scene(view));

                Platform.setImplicitExit(false);
            }
        });
    }
    

    
    
    public void printNodeInformation(Node node){
    	for(int j=0; j< node.getChildNodes().getLength(); j++){
 	    	Node item = node.getChildNodes().item(j);
 	    	System.out.println("****************");
 	    	System.out.println("getNodeName:" + item.getNodeName());
 	    	System.out.println("getNodeValue:" + item.getNodeValue());
 	    	if(item.getChildNodes().getLength()>0){
 	    		printNodeInformation(item);
 	    	}
 	    }
    }
    
    public Element getElementByElementName(Element parentElement, String clickType, String elementName, String parentElementName, String clickInstanceId){   
    	String tagName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.TagName);
		String tagValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.TagValue);
		String attributeName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.AttributeName);
		String attributeValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.AttributeValue);
		String elementIndex = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.ElementIndex);
		String dependentElementName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.Dependency);
		String direction = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.Direction);
		int index = Integer.parseInt(elementIndex);
		Element element = null;
		//locate the element by id or other ways
//		if(tagValue.equals(mxConstants.table)){
//			
//		}
		System.out.println("elementName: " + elementName);
		System.out.println("dependentElementName: " + dependentElementName);
		System.out.println("parentElementName: " + parentElementName);
		//if the element has a dependent element (parent element),
		//we should find the dependent element first
		if(dependentElementName == null || dependentElementName.equals("null") || dependentElementName.equals(parentElementName)){
			if(attributeName.equals(mxConstants.id)){
				element = document.getElementById(attributeValue);
			}
			//if no id, and tag value is not empty
			else if(tagValue != null && !tagValue.equals("null")){
				if(tagValue.equals(mxConstants.dynamic)){
					System.out.println("dynamic");
					tagValue = clickInstanceVSElementNameVSValue.get(clickInstanceId).get(elementName);
					element = getElementByTagAndContent(parentElement, tagName, tagValue, index);
				}
				else if(tagValue.equals(mxConstants.live)){
					System.out.println("live");
					String logValue = clickInstanceVSElementNameVSValue.get(clickInstanceId).get(elementName);
					System.out.println("logValue: " + logValue);
					
					tagValue = logObjectIdVSPageObjectId.get(logValue);
					System.out.println("tagValue: " + tagValue);
					element = getElementByTagAndContent(parentElement, tagName, tagValue, index);
				}
				else{
					System.out.println("other");
					element = getElementByTagAndContent(parentElement, tagName, tagValue, index);
				}  
			}
			//if no id, tag value, and attribute name and value are not empty
			else if(attributeName != null & !attributeName.equals("null") && attributeValue != null & !attributeValue.equals("null")){
				element = getElementByTagAndAttributeValue(parentElement, tagName, attributeName, attributeValue, index);
			}		
			else{
				element = (Element) parentElement.getElementsByTagName(tagName).item(index);  
			}
			if(element == null){
				String fatherTagName = parentElement.getTagName();
				System.out.println("fatherTagName: " + fatherTagName);
				System.out.println("cannot fine the corresponding element: " + clickType + "-" + elementName);
				System.out.println("tagName: " + tagName);
				System.out.println("tagValue: " + tagValue);
				System.out.println("attributeName: " + attributeName);
				System.out.println("attributeValue: " + attributeValue);
				System.out.println("elementIndex: " + elementIndex);
			}
			else{
				System.out.println("find element: " + elementName);
			}
		}
		else{
			System.out.println("search hierarchy");
			if(direction.equals(mxConstants.parent)){
				System.out.println("parent: ");
				System.out.println("parentElementName in in parent: " + parentElementName);
				Element dependentElement = getElementByElementName(parentElement, clickType, dependentElementName, parentElementName, clickInstanceId);
				System.out.println("get dependentElementName in in parent: " + dependentElementName);
				element = getElementByElementName(dependentElement, clickType, elementName, dependentElementName, clickInstanceId);
				System.out.println("get elementName in parent: " + elementName);
			}
			else if(direction.equals(mxConstants.child)){
				Element dependentElement = getElementByElementName(parentElement, clickType, dependentElementName, parentElementName, clickInstanceId);
				//reverse to the element from its child element through compare the tag name (stop when the same tag name appear)
				boolean reverseFlag = false;
				while(!reverseFlag){
					element = (Element) dependentElement.getParentNode();
					String tagNameTemp = element.getTagName();		
					System.out.println("tagNameTemp in while in child: " + tagNameTemp);
					if(tagName.equals(tagNameTemp.toLowerCase())){
						reverseFlag = true;
					}
					else{
						dependentElement = element;
					}
				}				
			}			
		}

    	return element;
    }
    
    /**
     * get element list which satisfy the features (such as tag name and value, attribute name and value)
     * @param parentElement
     * @param clickType
     * @param elementName
     * @param parentElementName
     * @param clickInstanceId
     * @return
     */
    public List<Element> getElementListByElementName(Element parentElement, String clickType, String elementName, String parentElementName, String clickInstanceId){   
    	String tagName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.TagName);
		String tagValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.TagValue);
		String attributeName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.AttributeName);
		String attributeValue = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.AttributeValue);
		String elementIndex = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.ElementIndex);
		String dependentElementName = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.Dependency);
		String direction = clickVSElementVSFeatureVSValue.get(clickType).get(elementName).get(mxConstants.Direction);
		int index = Integer.parseInt(elementIndex);
		List<Element> elementList = null;
		Element element = null;
		System.out.println("elementName: " + elementName);
		System.out.println("dependentElementName: " + dependentElementName);
		System.out.println("parentElementName: " + parentElementName);
		//if the element has a dependent element (parent element),
		//we should find the dependent element first
		if(dependentElementName == null || dependentElementName.equals("null") || dependentElementName.equals(parentElementName)){
			if(tagValue != null && !tagValue.equals("null")){
				if(tagValue.equals(mxConstants.dynamic)){
					System.out.println("dynamic");
					tagValue = clickInstanceVSElementNameVSValue.get(clickInstanceId).get(elementName);
					elementList = getElementListByTagAndContent(parentElement, tagName, tagValue);
				}
				else if(tagValue.equals(mxConstants.live)){
					System.out.println("live");
					String logValue = clickInstanceVSElementNameVSValue.get(clickInstanceId).get(elementName);
					System.out.println("logValue: " + logValue);
					
					tagValue = logObjectIdVSPageObjectId.get(logValue);
					System.out.println("tagValue: " + tagValue);
					elementList = getElementListByTagAndContent(parentElement, tagName, tagValue);
				}
				else{
					System.out.println("other");
					elementList = getElementListByTagAndContent(parentElement, tagName, tagValue);
				}  
			}
			//if no id, tag value, and attribute name and value are not empty
			else if(attributeName != null & !attributeName.equals("null") && attributeValue != null & !attributeValue.equals("null")){
				elementList = getElementListByTagAndAttributeValue(parentElement, tagName, attributeName, attributeValue);
			}		
			else{
				elementList = (List<Element>) parentElement.getElementsByTagName(tagName);  
			}
			
			if(elementList == null){
				String fatherTagName = parentElement.getTagName();
				System.out.println("fatherTagName: " + fatherTagName);
				System.out.println("cannot fine the corresponding element: " + clickType + "-" + elementName);
				System.out.println("tagName: " + tagName);
				System.out.println("tagValue: " + tagValue);
				System.out.println("attributeName: " + attributeName);
				System.out.println("attributeValue: " + attributeValue);
				System.out.println("elementIndex: " + elementIndex);
			}
			else{
				System.out.println("find element list: " + elementList.size());
			}
		}
		else{
			System.out.println("search hierarchy");
			if(direction.equals(mxConstants.parent)){
				System.out.println("parent: ");
				System.out.println("parentElementName in in parent: " + parentElementName);
				Element dependentElement = getElementByElementName(parentElement, clickType, dependentElementName, parentElementName, clickInstanceId);
				System.out.println("get dependentElementName in in parent: " + dependentElementName);
				elementList = getElementListByElementName(dependentElement, clickType, elementName, dependentElementName, clickInstanceId);
				System.out.println("get elementName in parent: " + elementName);
			}
			//multiple element can be achieved by child
//			else if(direction.equals(mxConstants.child)){
//				Element dependentElement = getElementByElementName(parentElement, clickType, dependentElementName, parentElementName, clickInstanceId);
//				//reverse to the element from its child element through compare the tag name (stop when the same tag name appear)
//				boolean reverseFlag = false;
//				while(!reverseFlag){
//					element = (Element) dependentElement.getParentNode();
//					String tagNameTemp = element.getTagName();		
//					System.out.println("tagNameTemp in while in child: " + tagNameTemp);
//					if(tagName.equals(tagNameTemp.toLowerCase())){
//						reverseFlag = true;
//					}
//					else{
//						dependentElement = element;
//					}
//				}				
//			}			
		}

    	return elementList;
    }
    
    //populate the element
    public void polulateElement(Element element, String type, String value){
    	if(element != null){
    		System.out.println("type: " + type);
    		System.out.println("value: " + value);
    		if(type.equals(mxConstants.input)){    			
    			element.setAttribute("Value", value);  
    		}	
        	else if(type.equals(mxConstants.span) || type.equals(mxConstants.textarea)){
        		element.setTextContent(value);     
        	}
        	else if(type.equals(mxConstants.select)){
          		HTMLSelectElement selection = (HTMLSelectElement) element;
          	    HTMLCollection operations = selection.getOptions();
         	    for(int i=0; i<operations.getLength(); i++){
         	    	Node operation = operations.item(i);
         	    	String content = operation.getTextContent();
         	    	if(content.contains(value)){
         	    		selection.setSelectedIndex(i);
         	    		break;
         	    	}         	    	
         	    }
        	}
    	}
    	else{
    		JOptionPane.showMessageDialog(this, "Wrong! Could not find the element!");
    	}  	
    }
    
    //populate the element
//    public void readElement(Element element, String type){
//    	String value = null;
//    	
//    	if(type.equals(mxConstants.input)){
//			element.setAttribute("Value", value);  
//		}	
//    	else if(type.equals(mxConstants.span)){
//    		element.setTextContent(value);     
//    	}
//    	else if(type.equals(mxConstants.select)){
//      		HTMLSelectElement selection = (HTMLSelectElement) element;
//      	    HTMLCollection operations = selection.getOptions();
//     	    for(int i=0; i<operations.getLength(); i++){
//     	    	Node operation = operations.item(i);
//     	    	String content = operation.getTextContent();
//     	    	if(content.contains(value)){
//     	    		selection.setSelectedIndex(i);
//     	    		break;
//     	    	}
//     	    	
//     	    }
//    	}
//    }
	//triger the click
    public void triggerClick(Element element, String type){

		if(type.equals(mxConstants.form)){
			System.out.println("click is of form: ");
			HTMLFormElement clickElement = ( HTMLFormElement ) element; 
			clickElement.submit();
		}
//		else if(type.equals(mxConstants.a) || type.equals(mxConstants.span)){
		else{
//	        HTMLAnchorElementImpl clickElement = (HTMLAnchorElementImpl) element;
//	        clickElement.click();  
			System.out.println("click is not of form: ");
	        HTMLElementImpl clickElement = (HTMLElementImpl) element;
	        clickElement.click();  
		}
		System.out.println("finish trigger click");
    }
    
    public Element getElementByTag(Document document, String tagName, int index){
    	Element element = null;	       		
    	//get all elements having the tag name
  	    NodeList inputElements = document.getElementsByTagName(tagName);
  	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //get all elements having the text content
 	    for(int i=0; i<inputElements.getLength(); i++){
 	    	Element elementCandidate = (Element) inputElements.item(i);
 	    	satisfiedElementList.add(elementCandidate);
  		}   
 	    //get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	element = satisfiedElementList.get(index);
 	    }    
    	return element;
    }
    
    /*
     * get an element from table 
     */
  //   public Element getElementFromTable(Document document, String clickType, String tableElementName, String tagName, String textContent, int index){
   public Element getElementFromTable(){
  //   	Element tableElement = getElementByElementName(clickType, tableElementName);
   	Element tableElement = getElementByTagAndAttributeValue(document, "table", "class", "noborder", 0);
    	if(tableElement == null){
			System.out.println("cannot fine tableElement");
		}
		else{
			System.out.println("find tableElement");
		}
    	//search the target row
    	Element targetRow = null;
    	for(int i=0; i<tableElement.getElementsByTagName("tr").getLength(); i++){
    		Element tableRow = (Element) tableElement.getElementsByTagName("tr").item(i);

        	if(tableRow == null){
    			System.out.println("cannot fine tableRow: " + i);
    		}
    		else{
    			System.out.println("find tableRow: " + i);
    		}
    		Element elementKey = getElementByTagAndContent(tableRow, "a", "p009", 0);
 
     	   if(elementKey == null){
   			System.out.println("cannot fine elementKey: ");
	   		}
	   		else{
	   			System.out.println("find elementKey: ");
	   		}
    		if(elementKey != null){
    			targetRow = tableRow;
    			break;
    		}
    		

    	}
    	Element element = null;	   
		////locate the target element
		if(targetRow != null){
			element = getElementByTagAndAttributeValue(targetRow, "input", "type", "text", 0);
			if(element == null){
	   			System.out.println("cannot fine element: ");
		   		}
		   		else{
		   			System.out.println("find element: ");
		   		}
		}
		element.setAttribute("Value", "6");
//    	//get all elements having the tag name
//  	    NodeList inputElements = document.getElementsByTagName(tagName);
//  	    List<Element> satisfiedElementList = new ArrayList<Element>();
//  	    //get all elements having the text content
// 	    for(int i=0; i<inputElements.getLength(); i++){
// 	    	Element elementCandidate = (Element) inputElements.item(i);
//  			String nodeText = elementCandidate.getTextContent();
//  			if(nodeText != null && nodeText.equals(textContent)){
//  				satisfiedElementList.add(elementCandidate);
//  			}
//  		}   
// 	    //get the element by the index
// 	    if(satisfiedElementList.size() > index){
// 	    	element = satisfiedElementList.get(index);
// 	    }    
    	return element;
    }
    
    /**
     * @param document the DOM document of the page
     * @param tagName the tag name of the elements
     * @param textContent the text content of the elements
     * @param index indicate which one (starting from 0) to choose if there a list of elements satisfying tag name and text content
     * @return a element on the page satisfying the above constraints or null if there does not exist
     */
    public Element getElementByTagAndContent(Document document, String tagName, String textContent, int index){
    	Element element = null;	      	
    	//get all elements having the tag name
  	    NodeList inputElements = document.getElementsByTagName(tagName);
  	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //get all elements having the text content
 	    for(int i=0; i<inputElements.getLength(); i++){
 	    	Element elementCandidate = (Element) inputElements.item(i);
  			String nodeText = elementCandidate.getTextContent();
  			if(nodeText != null && nodeText.equals(textContent)){
  				satisfiedElementList.add(elementCandidate);
  			}
  		}   
 	    //get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	element = satisfiedElementList.get(index);
 	    }    
    	return element;
    }
    
    /**
     * @param parentElement the parent element
     * @param tagName the tag name of the elements
     * @param textContent the text content of the elements
     * @param index indicate which one (starting from 0) to choose if there a list of elements satisfying tag name and text content
     * @return a element on the page satisfying the above constraints or null if there does not exist
     */
    public Element getElementByTagAndContent(Element parentElement, String tagName, String textContent, int index){
    	Element element = null;	      	
    	//get all elements having the tag name
  	    NodeList inputElements = parentElement.getElementsByTagName(tagName);
  	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //get all elements having the text content
 	    for(int i=0; i<inputElements.getLength(); i++){
 	    	Element elementCandidate = (Element) inputElements.item(i);
  			String nodeText = elementCandidate.getTextContent();
//  			System.out.println("nodeText in getElementByTagAndContent: " + nodeText);
  			if(nodeText != null && nodeText.equals(textContent)){
  				satisfiedElementList.add(elementCandidate);
  			}
  		}   
 	    //get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	element = satisfiedElementList.get(index);
 	    }    
    	return element;
    }
    
    /**
     * get the element list in which each element's tagName contains the input textContent, e.g., if the textContent is qty, all the element on the page contain qty will be returned
     * @param parentElement the parent element
     * @param tagName the tag name of the elements
     * @param textContent the text content of the elements
     * @param index indicate which one (starting from 0) to choose if there a list of elements satisfying tag name and text content
     * @return a element on the page satisfying the above constraints or null if there does not exist
     */
    public List<Element> getElementListByTagAndContent(Element parentElement, String tagName, String textContent){
    	//get all elements having the tag name
  	    NodeList inputElements = parentElement.getElementsByTagName(tagName);
  	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //get all elements having the text content
 	    for(int i=0; i<inputElements.getLength(); i++){
 	    	Element elementCandidate = (Element) inputElements.item(i);
  			String nodeText = elementCandidate.getTextContent();
  			System.out.println("nodeText in getElementByTagAndContent: " + nodeText);
  			if(nodeText != null && nodeText.contains(textContent)){
  				satisfiedElementList.add(elementCandidate);
  			}
  		}    
    	return satisfiedElementList;
    }
    
    /**
     * @param document the DOM document of the page
     * @param tagName the tag name of the elements
     * @param attributeName a constraint attribute
     * @param attributeValue the value of the constraint attribute
     * @param index indicate which one (starting from 0) to choose if there a list of elements satifying tag name and attribute name and value
     * @return an element satisfying the constraints or null if there does not exist
     */
    public Element getElementByTagAndAttributeValue(Document document, String tagName, 
    	String attributeName, String attributeValue, int index){
    	Element element = null;	  
    	//get all elements having the tag name
	    NodeList elements = document.getElementsByTagName(tagName);
	    List<Element> satisfiedElementList = new ArrayList<Element>();
	    //get all elements having the attribute name and value
 	    for(int i=0; i<elements.getLength(); i++){
 	    	Element elementCandidate = (Element) elements.item(i);
  			String realValue = elementCandidate.getAttribute(attributeName);
  			if(realValue != null && realValue.equals(attributeValue)){
  				satisfiedElementList.add(elementCandidate);
  			}

  		} 
 	    //get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	element = satisfiedElementList.get(index);
 	    }
 	    
    	return element;
    }
    
    /**
     * @param parentElement the parent element
     * @param tagName the tag name of the elements
     * @param attributeName a constraint attribute
     * @param attributeValue the value of the constraint attribute
     * @param index indicate which one (starting from 0) to choose if there a list of elements satifying tag name and attribute name and value
     * @return an element satisfying the constraints or null if there does not exist
     */
    public Element getElementByTagAndAttributeValue(Element parentElement, String tagName, 
    	String attributeName, String attributeValue, int index){
    	Element element = null;	  
    	//get all elements having the tag name
	    NodeList elements = parentElement.getElementsByTagName(tagName);
	    List<Element> satisfiedElementList = new ArrayList<Element>();
	    //get all elements having the attribute name and value
 	    for(int i=0; i<elements.getLength(); i++){
 	    	Element elementCandidate = (Element) elements.item(i);
  			String realValue = elementCandidate.getAttribute(attributeName);
  			if(realValue != null && realValue.equals(attributeValue)){
  				satisfiedElementList.add(elementCandidate);
  			}
  		} 
 	    //get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	element = satisfiedElementList.get(index);
 	    }	    
    	return element;
    }
    
    /**
     * get the element list in which each element's attribute value contains the input attributeValue, 
     * e.g., if the value is qty, all the element on the page contain qty will be returned
     * @param parentElement the parent element
     * @param tagName the tag name of the elements
     * @param attributeName a constraint attribute
     * @param attributeValue the value of the constraint attribute
     * @param index indicate which one (starting from 0) to choose if there a list of elements satifying tag name and attribute name and value
     * @return an element satisfying the constraints or null if there does not exist
     */
    public List<Element> getElementListByTagAndAttributeValue(Element parentElement, String tagName, 
    	String attributeName, String attributeValue){
    	//get all elements having the tag name
	    NodeList elements = parentElement.getElementsByTagName(tagName);
	    List<Element> satisfiedElementList = new ArrayList<Element>();
	    //get all elements having the attribute name and value
 	    for(int i=0; i<elements.getLength(); i++){
 	    	Element elementCandidate = (Element) elements.item(i);
  			String realValue = elementCandidate.getAttribute(attributeName);
  			if(realValue != null && realValue.contains(attributeValue)){
  				satisfiedElementList.add(elementCandidate);
  			}
  		} 
    	return satisfiedElementList;
    }
    
    /**
     * @param document the DOM document of the page
     * @param id the id of the selection element
     * @param textContent the text content of option which will be set selected
     * if no satisfied option, nothing changes
     */
    public void setSelectionByIdAndContent(Document document, String id, String textContent){
  		HTMLSelectElement selection = (HTMLSelectElement) document.getElementById(id);
  	    HTMLCollection operations = selection.getOptions();
 	    for(int i=0; i<operations.getLength(); i++){
 	    	Node operation = operations.item(i);
 	    	String content = operation.getTextContent();
 	    	if(content.contains(textContent)){
 	    		selection.setSelectedIndex(i);
 	    		break;
 	    	}
 	    	
 	    }
    }
    
    /**
     * @param document the DOM document of the page
     * @param id the id of the selection element
     * @param inputName indicate which attribute will be modified 
     * @param inputValue indicate the new value for the attribute after modification
     */
    public void setValueById(Document document, String id, String inputName, String inputValue){
    	Element element = document.getElementById(id);
    	element.setAttribute(inputName, inputValue);
    }
    
    /**
     * @param document the DOM document of the page
     * @param tagName the tag name of the elements
     * @param attributeName a constraint attribute
     * @param attributeValue the value of the constraint attribute
     * @param inputName indicate which attribute will be modified 
     * @param inputValue indicate the new value for the attribute after modification
     * @param index indicate which one (starting from 0) to choose if there a list of elements satifying tag name and text content
     */
    public void setValueByTagAndAttributeValue(Document document, String tagName, String attributeName, 
    		String attributeValue, String inputName, String inputValue, int index){
	    NodeList elements = document.getElementsByTagName(tagName);
	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //add the value for the "Ref.customer" attribute
 	    for(int i=0; i<elements.getLength(); i++){
 	    	Element element = (Element) elements.item(i);
  			String realValue = element.getAttribute(attributeName);
  			System.out.println("attribute realValue: " + realValue);
  			if(realValue != null && realValue.equals(attributeValue)){ 
  				satisfiedElementList.add(element);
  			}
  		} 
		//get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	satisfiedElementList.get(index).setAttribute(inputName, inputValue); 
 	    }
    }
    
    /**
     * @param document the DOM document of the page
     * @param tagName the tag name of the elements
     * @param attributeName a constraint attribute
     * @param attributeValue the value of the constraint attribute
     * @param inputName indicate which attribute will be modified 
     * @param inputValue indicate the new value for the attribute after modification
     * @param index indicate which one (starting from 0) to choose if there a list of elements satifying tag name and attribute name and value (be contained)
     */
    public void setValueByTagAndAttributeValueContainment(Document document, String tagName, String attributeName, 
    		String attributeValue, String inputName, String inputValue, int index){
	    NodeList elements = document.getElementsByTagName(tagName);
	    List<Element> satisfiedElementList = new ArrayList<Element>();
  	    //add the value for the "Ref.customer" attribute
 	    for(int i=0; i<elements.getLength(); i++){
 	    	Element element = (Element) elements.item(i);
  			String realValue = element.getAttribute(attributeName);
  			System.out.println("attribute realValue: " + realValue);
  			if(realValue != null && realValue.contains(attributeValue)){ 
  				satisfiedElementList.add(element);
  			}
  		} 
		//get the element by the index
 	    if(satisfiedElementList.size() > index){
 	    	satisfiedElementList.get(index).setAttribute(inputName, inputValue); 
 	    }
    }
    
    public void loadURL(final String url) {
//        String tmp = toURL(url);
//        
//        if (tmp == null) {
//            tmp = toURL("http://" + url);
//        }
//        if(engine == null){
//        	System.out.println("empty");
//        }
//        else{
//        	System.out.println("not empty: " + tmp);
//        	engine.load(tmp);
//        }
    	System.out.println("loadURL");
        Platform.runLater(new Runnable() {
            @Override 
            public void run() {
                String tmp = toURL(url);
                System.out.println("run");
                if (tmp == null) {
                    tmp = toURL("http://" + url);
                }
 
//                engine.load(tmp);
              if(engine == null){
            	System.out.println("empty");
            }
            else{
            	System.out.println("not empty: " + tmp);
            	engine.load(tmp);
            }
            }
        });
    }

    private static String toURL(String str) {
        try {
            return new URL(str).toExternalForm();
        } catch (MalformedURLException exception) {
                return null;
        }
    }



    public static void main(String[] args) {
    	RunDolibarrPanel browser = new RunDolibarrPanel(null);
        browser.setVisible(true);
//        browser.loadURL("https://accounts.google.com/ServiceLogin?service=mail&continue=https://mail.google.com/mail/#identifier");
        browser.loadURL("http://localhost:81/dolibarr/");
 //       browser.loadURL("http://localhost/mouseEvent.php");
        
        JFrame frame = new JFrame();
        frame.add(browser);
        frame.setVisible(true);
        frame.setPreferredSize(new Dimension(1024, 600));
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
    }
}

