package org.processmining.mxgraph.examples.swing.io;
import java.io.FileNotFoundException;

import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.CrelOCEdge;
import org.processmining.ocbc.models.CrelRTEdge;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.impl.OCBCModelImpl;
import org.processmining.ocbc.models.visualization.ModelLayoutBuilder;
public class TransformToOCBCSemanticModel {
	private OCBCModel model = new OCBCModelImpl("OCBC model");
    private ModelLayoutBuilder builder = new ModelLayoutBuilder(model);
    
    public static void main(String[] args) throws FileNotFoundException {
    	 
//        TransformToOCBCSemanticModel ajavademo = new TransformToOCBCSemanticModel();
//        System.out.println("\n" + ajavademo.model.getModelName());
//        System.out.println("\n" + ajavademo.model.getAllActivities().size());
//        FileInputStream is = new FileInputStream("E:\\understandableModel.ocml");
//        ajavademo.parse(is);
//        
//        System.out.println("\n" + ajavademo.model.getAllActivities().size());
//        
//        JFrame frame = new JFrame();  
//        frame.setSize(1000, 500);  
//        frame.setTitle("Activity Diagram");  
//        frame.getContentPane().add(new JScrollPane(ajavademo.model.getGraph()));  
//          
//         frame.setBounds(50, 50, 700, 800);  
//          
//         frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);  
//         frame.setVisible(true);  
    }

    public void transform(mxGraph graph){
    	Object[] allVertexs = graph.getChildVertices(graph.getDefaultParent());
    	Object[] allEdges = graph.getChildEdges(graph.getDefaultParent());
    	for(int i=0; i<allVertexs.length; i++){
    		String displayName = ((mxCell)allVertexs[i]).getValue().toString();
    		String id = ((mxCell)allVertexs[i]).getId();
    		String type = ((mxCell)allVertexs[i]).getAttributes().get(mxConstants.TYPE);
    		double positionX = ((mxCell)allVertexs[i]).getGeometry().getX();
    		double positionY = ((mxCell)allVertexs[i]).getGeometry().getY();
    		double height = ((mxCell)allVertexs[i]).getGeometry().getHeight();
    		double width = ((mxCell)allVertexs[i]).getGeometry().getWidth();
			
			System.out.println("displayName: " + displayName);
			System.out.println("id: " + id);
			System.out.println("type: " + type);
			System.out.println("positionX: " + positionX);
			System.out.println("positionY: " + positionY);
			System.out.println("height: " + height);
			System.out.println("width: " + width);
			
			System.out.println("------------------");
								
            builder.addNode(type, displayName, id, positionX, positionY, height, width);
        }
    	
    	for(int i=0; i<allEdges.length; i++){
//			((mxCell)allEdges[i]).setValue("edge");
//			((mxCell)allEdges[i]).set
			System.out.println("value: " + ((mxCell)allEdges[i]).getValue());
			System.out.println("Id: " + ((mxCell)allEdges[i]).getId());
			System.out.println("getSource().getId(): " + ((mxCell)allEdges[i]).getSource().getId());
			System.out.println("getTarget().getId(): " + ((mxCell)allEdges[i]).getTarget().getId());
			mxCell currentCell = (mxCell) allEdges[i];
			String edgeType = currentCell.getAttributes().get(mxConstants.TYPE);
			System.out.println("edgeType: " + edgeType);
    		String id = currentCell.getId();
    		
    		
    		if(edgeType.equals(mxConstants.CLASSRELATION)) {
    			System.out.println("enter: " + mxConstants.CLASSRELATION);
//    			String displayName = currentCell.getValue().toString();
    			String relationshipType = currentCell.getAttributes().get(mxConstants.RELATIONSHIPTYPE);
    			String sourceNodeId = currentCell.getSource().getId();
        		String targetNodeId = currentCell.getTarget().getId();
    			String sourceAlwaysCardinality = currentCell.getAttributes().get(mxConstants.SOURCEALWAYSCARDINALITY);
    			String sourceEventuallyCardinality = currentCell.getAttributes().get(mxConstants.SOURCEEVENTUALLYCARDINALITY);
    			String targetAlwaysCardinality = currentCell.getAttributes().get(mxConstants.TARGETALWAYSCARDINALITY);
    			String targetEventuallyCardinality = currentCell.getAttributes().get(mxConstants.TARGETEVENTUALLYCARDINALITY);

    			builder.addClassEdge(id, relationshipType, sourceNodeId, 
    					sourceAlwaysCardinality, sourceEventuallyCardinality, targetNodeId, targetAlwaysCardinality,  targetEventuallyCardinality,
    				0, 0, 55, 55);
    			}
    		else if(edgeType.equals(mxConstants.ACTIVITYRELATION)) {
    			System.out.println("enter: " + mxConstants.ACTIVITYRELATION);
    			String cardinalityType = currentCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
    			String sourceNodeId = currentCell.getSource().getId();
        		String targetNodeId = currentCell.getTarget().getId();
        		String cardinalityTypeForSource;
        		String cardinalityTypeForTarget;
    			switch(cardinalityType)
    	        {
    	        	case mxConstants.RESPONSE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);
    					break;
    				case mxConstants.UNARYRESPONSE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);
    					break;
    				case mxConstants.NONRESPONSE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);
    					break;
    				case mxConstants.PRECEDENCE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);      	
    					break;
    				case mxConstants.UNARYPRECEDENCE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);
    					break;
    				case mxConstants.NONPRECEDENCE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);        	
    					break;
    				case mxConstants.COEXISTENCE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);       	
    					break;
    				case mxConstants.NONCOEXISTENCE: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);  	
    					break;
    				//for the conjunction of constraint types
    				case mxConstants.RESPONSE_PRECEDENCE: 	
    				case mxConstants.UNARYRESPONSE_UNARYPRECEDENCE: 	
    				case mxConstants.COEXISTENCE_COEXISTENCE:
    				case mxConstants.NONRESPONSE_NONPRECEDENCE:
    				case mxConstants.NONCOEXISTENCE_NONCOEXISTENCE: 
    					cardinalityTypeForSource = cardinalityType.split("-")[0];
    					cardinalityTypeForTarget = cardinalityType.split("-")[1];
    					builder.addActivityEdge(id + "_0", sourceNodeId, targetNodeId, cardinalityTypeForSource, 0, 0);
						builder.addActivityEdge(id + "_1", targetNodeId, sourceNodeId, cardinalityTypeForTarget, 0, 0);		
    					break;	

    				default: builder.addActivityEdge(id, sourceNodeId, targetNodeId, cardinalityType, 0, 0);
    	        }
    		}
    		else if(edgeType.equals(mxConstants.AOCRELATION)) {
    			String sourceAlwaysCardinality = currentCell.getAttributes().get(mxConstants.SOURCEALWAYSCARDINALITY);
    			String sourceEventuallyCardinality = currentCell.getAttributes().get(mxConstants.SOURCEEVENTUALLYCARDINALITY);
    			String targetAlwaysCardinality = currentCell.getAttributes().get(mxConstants.TARGETALWAYSCARDINALITY);
    			
    			mxCell startCell = (mxCell) currentCell.getSource();
    			String sourceId;
        		String targetId;
    			if(startCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.ACTIVITYCELL)){
    				sourceId = currentCell.getSource().getId();
            		targetId = currentCell.getTarget().getId();
    			}
    			else{
    				targetId = currentCell.getSource().getId();
    				sourceId = currentCell.getTarget().getId();
    			}
    			
    			builder.addAOCEdge(id, sourceId, 
    					sourceAlwaysCardinality, sourceEventuallyCardinality, targetId, targetAlwaysCardinality,  
        				0, 0);
    		}

    			
		}
    	
    	for(int i=0; i<allEdges.length; i++){
//			((mxCell)allEdges[i]).setValue("edge");
//			((mxCell)allEdges[i]).set
			System.out.println("value: " + ((mxCell)allEdges[i]).getValue());
			System.out.println("Id: " + ((mxCell)allEdges[i]).getId());
			System.out.println("getSource().getId(): " + ((mxCell)allEdges[i]).getSource().getId());
			System.out.println("getTarget().getId(): " + ((mxCell)allEdges[i]).getTarget().getId());
			mxCell currentCell = (mxCell) allEdges[i];
			String edgeType = currentCell.getAttributes().get(mxConstants.TYPE);
			System.out.println("edgeType: " + edgeType);
    		String id = currentCell.getId();
    		
    		if(edgeType.equals(mxConstants.CRELOCRELATION)) {    			
    			mxCell startCell = (mxCell) currentCell.getSource().getParent();
    			mxCell endCell = (mxCell) currentCell.getTarget().getParent();
    			String sourceId;
    			String targetId;
    			String cardinalityType;
    			//if the start cell is the activity relation
    			if(startCell.getAttributes().containsKey(mxConstants.TYPE) && 
    					startCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.ACTIVITYRELATION)){
    				sourceId = startCell.getId();
    	    		targetId = currentCell.getTarget().getId();
    	    		cardinalityType = startCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
    			}
    			//if the end cell is the activity relation
    			else{
    				targetId = currentCell.getSource().getId();
    				sourceId = endCell.getId();
    				cardinalityType = endCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
    			}
    			System.out.println("id: " + id);
    			System.out.println("sourceId: " + sourceId);
    			System.out.println("targetId: " + targetId);
    			if(cardinalityType.split("-").length > 1){
    				builder.addCrelOCEdge(id, sourceId + "_0", targetId,  0, 0);
    				builder.addCrelOCEdge(id, sourceId + "_1", targetId,  0, 0);
    			}
    			else{
    				builder.addCrelOCEdge(id, sourceId, targetId,  0, 0);
    			} 			
    		}   			
    		else if(edgeType.equals(mxConstants.CRELRTRELATION)) {
    			mxCell startCell = (mxCell) currentCell.getSource().getParent();
    			mxCell endCell = (mxCell) currentCell.getTarget().getParent();
    			String sourceId;
    			String targetId;
    			String cardinalityType;
    			System.out.println("start type: " + startCell.getAttributes().get(mxConstants.TYPE));
    			System.out.println("end type: " + endCell.getAttributes().get(mxConstants.TYPE));
    			if(startCell.getAttributes().containsKey(mxConstants.TYPE) && 
    					startCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.ACTIVITYRELATION)){
    				System.out.println("ACTIVITYRELATION");
    				sourceId = startCell.getId();
    	    		targetId = endCell.getId();
    	    		cardinalityType = startCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
    			}
    			else{
    				System.out.println("not ACTIVITYRELATION");
    				targetId = startCell.getId();
    				sourceId = endCell.getId();
    				cardinalityType = endCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
    			}
    			System.out.println("id: " + id);
    			System.out.println("sourceId: " + sourceId);
    			System.out.println("targetId: " + targetId);
    			
    			if(cardinalityType.split("-").length > 1){
    				builder.addCrelRTEdge(id, sourceId + "_0", targetId,  0, 0);
    				builder.addCrelRTEdge(id, sourceId + "_1", targetId,  0, 0);
    			}
    			else{
    				builder.addCrelRTEdge(id, sourceId, targetId,  0, 0);
    			} 
    		}
    	}

    	System.out.println("\n activity node size: " + model.getAllActivities().size());
    	for(ActivityNode activityNode : model.getAllActivities()){
        	System.out.println("\n activity id: " + activityNode.getID());
        	System.out.println("\n activity name: " + activityNode.getNodeName());
        }   
    	
    	System.out.println("\n class node size: " + model.getAllClasses().size());
    	for(ClassNode classNode : model.getAllClasses()){
        	System.out.println("\n class id: " + classNode.getID());
        	System.out.println("\n class name: " + classNode.getNodeName());
        }   
    	
    	System.out.println("\n activity relation size: " + model.getAllActivityRelations().size());
    	for(ActivityEdge activityEdge : model.getAllActivityRelations()){
        	System.out.println("\n activityEdge id: " + activityEdge.getID());
        	System.out.println("\n activityEdge type: " + activityEdge.getCardinalityType());
        }   
        
    	System.out.println("\n class relation size: " + model.getAllClassRelations().size());
    	for(ClassEdge edge : model.getAllClassRelations()){
        	System.out.println("\n edge id: " + edge.getID());
        	System.out.println("\n edge name: " + edge.getEdgeName());
        	System.out.println("\n source always name: " + edge.getSourceAlwaysCardinality().toString());
        	System.out.println("\n source eventually name: " + edge.getSourceEventuallyCardinality().toString());
        	System.out.println("\n target always name: " + edge.getTargetAlwaysCardinality().toString());
        	System.out.println("\n target eventually name: " + edge.getTargetEventuallyCardinality().toString());
        }  
    	
    	System.out.println("\n aoc relation size: " + model.getAllAOCRelations().size());
    	for(AOCEdge edge : model.getAllAOCRelations()){
        	System.out.println("\n edge id: " + edge.getID());
        	System.out.println("\n Activity always name: " + edge.getActivityAlwaysCardinality());
        	System.out.println("\n Activity eventually name: " + edge.getActivityEventuallyCardinality().toString());
        	System.out.println("\n class name: " + edge.getClassCardinality());
        } 
    	
    	System.out.println("\n crel rt relation size: " + model.getAllCrelRTRelations().size());
        for(CrelRTEdge edge : model.getAllCrelRTRelations()){
        	System.out.println("\n activityEdge id: " + edge.getID());
        	System.out.println("\n activityEdge id: " + edge.getRelatedActivityRelation().getID());
        	System.out.println("\n classEdge id: " + edge.getRelatedClassRelation().getID());
        }
        
        System.out.println("\n crel oc relation size: " + model.getAllCrelOCRelations().size());
        for(CrelOCEdge edge : model.getAllCrelOCRelations()){
        	System.out.println("\n activityEdge id: " + edge.getID());
        	System.out.println("\n activityEdge id: " + edge.getRelatedActivityRelation().getID());
        	System.out.println("\n class id: " + edge.getRelatedClass().getID());

        }

    }
    
    public OCBCModel getModel(){
    	return model;
    } 
  }