package org.processmining.mxgraph.examples.swing.listener;
import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.model.mxGeometry;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;

public class AddElementListenerBeforeSplitCardinality{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private mxGraphComponent graphComponent;
//	private BasicGraphEditor graphEditor;
    private double souceLabelPosition = -0.6;
    private double targetLabelPosition = 0.4;
    private double connectorSize = 5;
    private double connectorX = 0.2;
    private static final int X_SOURCE = 50, Y_SOURCE = 50 ,PAGE_WIDTH = 1300, 
    HORIZONTAL_STEP = 150, VERTICAL_STEP = 100, SHAPE_WIDTH = 50,
		    SHAPE_HEIGHT = 60;
    
	public AddElementListenerBeforeSplitCardinality(final mxGraphComponent graphComponent) {
	    super();
	    this.graphComponent = graphComponent;
	}
	
	public void transformCell(mxCell newCell ){
    	if(graphComponent.getGraph().getModel().contains(newCell)){
    		if(newCell.isVertex()){

        		System.out.println("add node");
        		System.out.println("newCell.getValue().toString()" + newCell.getValue().toString());

        		graphComponent.getGraph().refresh();
        		if(newCell.getValue().toString().equals(mxConstants.CLASSCELL)){
        			//add necessary attribute for nodes
        			newCell.getAttributes().put(mxConstants.TYPE, mxConstants.CLASSCELL);                           		
            		newCell.getAttributes().put(mxConstants.TABLE, "table_name");
            		newCell.getAttributes().put(mxConstants.ROWID, mxConstants.PK);
        		}
        		else if(newCell.getValue().toString().equals(mxConstants.ACTIVITYCELL)){
        			newCell.getAttributes().put(mxConstants.TYPE, mxConstants.ACTIVITYCELL);
        			newCell.getAttributes().put(mxConstants.TABLE, "table_name");
        			newCell.getAttributes().put(mxConstants.ACTIVITY, "column-name");
        		}
        		else if(newCell.getAttributes().containsKey(mxConstants.TYPE) &&
        				newCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.CONNECTOR)){                       			
        			System.out.println("connector");
        			//if the connector has no parent edge, remove it
        			mxCell parentCell = (mxCell) newCell.getParent();
        			if(parentCell.getAttributes().get(mxConstants.TYPE) == null){
        				System.out.println("getParent().type == null");
        				graphComponent.getGraph().removeCells(new Object[]{newCell});
        			}
        			graphComponent.getGraph().refresh();

        		}   

        	}                  		
    		//if the edge's type is null, it is a new created edge. Other wise, it is copied
        	else if(newCell.isEdge() && !newCell.getAttributes().containsKey(mxConstants.TYPE)){
        		Object value = newCell.getValue();
                System.out.println("add edge");
                System.out.println(value);

                mxCell sourceCell = (mxCell) newCell.getSource();
                mxCell targetCell = (mxCell) newCell.getTarget();                               
                String sourceType = sourceCell.getAttributes().get(mxConstants.TYPE);
                String targetType = targetCell.getAttributes().get(mxConstants.TYPE);
                String sourceName = (String) sourceCell.getValue();
                String targetName = (String) targetCell.getValue();
                
                mxCell sourceParentCell = (mxCell) sourceCell.getParent();
            	mxCell targetParentCell = (mxCell) targetCell.getParent();
            	String sourceParentType = sourceParentCell.getAttributes().get(mxConstants.TYPE);
                String targetParentType = targetParentCell.getAttributes().get(mxConstants.TYPE);
                
                System.out.println(targetCell.getAttributes().get("type"));
                System.out.println(sourceCell.getAttributes().get("type"));
                                                 
                //class relation
                if(sourceType.equals(mxConstants.CLASSCELL) && targetType.equals(mxConstants.CLASSCELL)){                               	
                	//insert value (class relation type)	
                	newCell.setValue("name");                                	
                	//insert attributes of type and cardinalities	
                	newCell.getAttributes().put(mxConstants.TYPE, mxConstants.CLASSRELATION);
                	newCell.getAttributes().put(mxConstants.RELATIONSHIPTYPE, sourceName + "-name-" + targetName);
                	newCell.getAttributes().put(mxConstants.SOURCEALWAYSCARDINALITY, "*");
                	newCell.getAttributes().put(mxConstants.SOURCEEVENTUALLYCARDINALITY, "*");
                	newCell.getAttributes().put(mxConstants.TARGETALWAYSCARDINALITY, "*");
                	newCell.getAttributes().put(mxConstants.TARGETEVENTUALLYCARDINALITY, "*");
					
                	System.out.println("create class relation");

        			//close to the start of edges
        			mxGeometry geoSource = new mxGeometry(souceLabelPosition, souceLabelPosition, 0, 0);
	    			mxCell sourceLabel = new mxCell(mxConstants.SQUARESYMBOL + "*" +  mxConstants.DIAMONDSYMBOL + "*", geoSource,
	    					mxConstants.LABEL_NORMAL);
	    			geoSource.setRelative(true);
	    			sourceLabel.setVertex(true);
	    			sourceLabel.getAttributes().put(mxConstants.TYPE, mxConstants.LABLE);
	    			sourceLabel.getAttributes().put(mxConstants.CARDINALITYPOSITION, mxConstants.SOURCECARDINALITY);
	    			graphComponent.getGraph().addCell(sourceLabel, newCell);
	    			
	    			//close to the end of edges
	    			mxGeometry geoTarget = new mxGeometry(targetLabelPosition, targetLabelPosition, 0, 0);
	    			mxCell targetLabel = new mxCell(mxConstants.SQUARESYMBOL + "*" + mxConstants.DIAMONDSYMBOL + "*", geoTarget,
	    					mxConstants.LABEL_NORMAL);
	    			geoTarget.setRelative(true);
	    			targetLabel.setVertex(true);
	    			targetLabel.getAttributes().put(mxConstants.TYPE, mxConstants.LABLE);
	    			targetLabel.getAttributes().put(mxConstants.CARDINALITYPOSITION, mxConstants.TARGETCARDINALITY);
	    			graphComponent.getGraph().addCell(targetLabel, newCell);
	    			
	    			//add the connector
	    			mxGeometry middlePositon = new mxGeometry(connectorX, 0, connectorSize, connectorSize);
	    			mxCell middleConnecor = new mxCell(" ", middlePositon, mxConstants.CONNECTOR_FOCUSED);
	    			middleConnecor.getAttributes().put(mxConstants.TYPE, mxConstants.CONNECTOR);
	    			middlePositon.setRelative(true);
	    			middleConnecor.setVertex(true);            		    			             		    		                       		    			
	    			graphComponent.getGraph().addCell(middleConnecor, newCell);             		    		
		    			
                	graphComponent.getGraph().getModel().setStyle(newCell, mxConstants.CLASSRELATION);
                	graphComponent.getGraph().refresh();
                }
                //aoc relation
                else if(sourceType.equals(mxConstants.CLASSCELL) && targetType.equals(mxConstants.ACTIVITYCELL) ||
                		sourceType.equals(mxConstants.ACTIVITYCELL) && targetType.equals(mxConstants.CLASSCELL)){
                	newCell.getAttributes().put(mxConstants.TYPE, mxConstants.AOCRELATION);
                   	newCell.getAttributes().put(mxConstants.SOURCEALWAYSCARDINALITY, "*");
                	newCell.getAttributes().put(mxConstants.SOURCEEVENTUALLYCARDINALITY, "*");
                	newCell.getAttributes().put(mxConstants.TARGETALWAYSCARDINALITY, "*");

                	
                	System.out.println("create AOCRelation");    
        			System.out.println(mxConstants.DIAMONDSYMBOL);
        			                       		
        			mxGeometry geoSource = new mxGeometry(souceLabelPosition, souceLabelPosition, 0, 0);           		    		         		    			
		    			mxGeometry geoTarget = new mxGeometry(targetLabelPosition, targetLabelPosition, 0, 0);
	    			geoTarget.setRelative(true); 
	    			geoSource.setRelative(true);
	    			
	    			mxCell sourceLabel;
	    			mxCell targetLabel;
	    			
	    			if(!sourceType.equals(mxConstants.ACTIVITYCELL)){
	    				newCell.setSource(targetCell);
	    				newCell.setTarget(sourceCell);
	    			}
	    			
    				sourceLabel = new mxCell(mxConstants.SQUARESYMBOL + "*" + mxConstants.DIAMONDSYMBOL +"*", geoSource,
    						mxConstants.LABEL_NORMAL);
    				targetLabel = new mxCell("*", geoTarget,
    						mxConstants.LABEL_NORMAL);
    				sourceLabel.setVertex(true);
	    			sourceLabel.getAttributes().put(mxConstants.CARDINALITYPOSITION, mxConstants.SOURCECARDINALITY);
    				targetLabel.setVertex(true);
    				targetLabel.getAttributes().put(mxConstants.CARDINALITYPOSITION, mxConstants.TARGETCARDINALITY);
    				//the first cell added into the graph is the label close to the activity side
    				graphComponent.getGraph().addCell(sourceLabel, newCell);
	    			graphComponent.getGraph().addCell(targetLabel, newCell);

	    			sourceLabel.getAttributes().put(mxConstants.TYPE, mxConstants.LABLE);
	    			targetLabel.getAttributes().put(mxConstants.TYPE, mxConstants.LABLE);
                	//AOC relation
                	graphComponent.getGraph().getModel().setStyle(newCell, mxConstants.AOCRELATION);
                	String style = graphComponent.getGraph().getModel().getStyle(newCell);
//                	String style = newCell.getStyle();
                	System.out.println("aoc styleName: " + style);
                	graphComponent.getGraph().refresh();
                }
                //activity relation
                else if(sourceType.equals(mxConstants.ACTIVITYCELL) && targetType.equals(mxConstants.ACTIVITYCELL)){
                	System.out.println("create ActivityRelation");
                	newCell.getAttributes().put(mxConstants.TYPE, mxConstants.ACTIVITYRELATION);  
                	newCell.getAttributes().put(mxConstants.CARDINALITYTYPE, mxConstants.UNARYRESPONSE);
                	
                	//add the connector
//                	graphComponent.getGraph().getModel().beginUpdate();
                	mxGeometry middlePositon = new mxGeometry(connectorX, 0, connectorSize, connectorSize);
//		    			mxCell middleConnecor = new mxCell(" ", middlePositon, mxConstants.STYLE_SHAPE+"="+mxConstants.SHAPE_RHOMBUS);
                	String connectorStyle = mxConstants.CONNECTOR_FOCUSED;
                	if(graphComponent.getGraph().isConnectorEnabled()){
                		connectorStyle = mxConstants.CONNECTOR_FOCUSED;
                	}
                	else{
                		connectorStyle = mxConstants.CONNECTOR_TRANSPARENT;
                	}
                	mxCell middleConnecor = new mxCell(" ", middlePositon, connectorStyle);
		    		middleConnecor.getAttributes().put(mxConstants.TYPE, mxConstants.CONNECTOR);
		    		middlePositon.setRelative(true);
		    		middleConnecor.setVertex(true);   		    				    					    			 
		    		graphComponent.getGraph().addCell(middleConnecor, newCell);	    			
                	            	
                	//activity relation
                	graphComponent.getGraph().getModel().setStyle(newCell, mxConstants.UNARYRESPONSE);
                	graphComponent.getGraph().refresh();
//                	graphComponent.getGraph().getModel().endUpdate();                               	                     
                }
                                               
    			//crel rt relation (two nodes are of connector types and  
                //one's father is of class edge type and another one is of activity edge type)
                else if(sourceType.equals(mxConstants.CONNECTOR) && targetType.equals(mxConstants.CONNECTOR) &&
                		(!sourceParentType.equals(targetParentType))){   
                	//make sure the crel relation is from activity edge (source) to class/class edge
                	if(!sourceParentType.equals(mxConstants.ACTIVITYRELATION)){
                		newCell.setSource(targetCell);
		    			newCell.setTarget(sourceCell);
                	}
                	newCell.getAttributes().put(mxConstants.TYPE, mxConstants.CRELRTRELATION); 
                	System.out.println("create connect rt relation");                                	
                	graphComponent.getGraph().getModel().setStyle(newCell, mxConstants.CRELRELATION);
                	graphComponent.getGraph().refresh();
                }
                
                //crel oc relation
                else if((sourceType.equals(mxConstants.CONNECTOR) && sourceParentType.equals(mxConstants.ACTIVITYRELATION) && targetType.equals(mxConstants.CLASSCELL))
                		|| (sourceType.equals(mxConstants.CLASSCELL) && targetParentType.equals(mxConstants.ACTIVITYRELATION) && targetType.equals(mxConstants.CONNECTOR))){
                	//make sure the crel relation is from activity edge (source) to class/class edge
                	if(sourceParentType == null || !sourceParentType.equals(mxConstants.ACTIVITYRELATION)){
                		newCell.setSource(targetCell);
		    			newCell.setTarget(sourceCell);
                	}
                	newCell.getAttributes().put(mxConstants.TYPE, mxConstants.CRELOCRELATION); 
                	System.out.println("create connect oc relation");                              	
                	graphComponent.getGraph().getModel().setStyle(newCell, mxConstants.CRELRELATION);
                	graphComponent.getGraph().refresh();
                }   
                //forbid other relations
                else{
                	graphComponent.getGraph().removeCells(new Object[]{newCell});                			
                	graphComponent.getGraph().refresh();
                }
	    			graphComponent.validateGraph();
        	}                   	
    	}
	}
	
    public static void main(String[] args) {
    	
//        JFrame frame = new JFrame("Hello world");
//       
//        FilterPanel panel = new FilterPanel();
//       
//        frame.add(panel);
//
//        frame.setSize(600, 400);
//        frame.setVisible(true);
       
     }

}