package org.processmining.mxgraph.examples.swing.listener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import org.processmining.mxgraph.examples.swing.editor.BasicGraphEditor;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.swing.mxGraphOutline;
import org.processmining.mxgraph.util.mxResources;

public class GraphComponentMouseWheelListener implements MouseWheelListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

    private BasicGraphEditor modelEditor; 
    private mxGraphComponent graphComponent;
    private mxGraphOutline graphOutline;
    
	public GraphComponentMouseWheelListener(BasicGraphEditor modelEditor) {
		this.modelEditor = modelEditor;
		this.graphComponent = modelEditor.getGraphComponent();
		this.graphOutline = modelEditor.getGraphOutline();
	}
	
	public void mouseWheelMoved(MouseWheelEvent e){
		if (e.getSource() instanceof mxGraphOutline
				|| e.isControlDown()){
			if (e.getWheelRotation() < 0){
				graphComponent.zoomIn();
			}
			else{
				graphComponent.zoomOut();
			}
			double scale = graphComponent.getGraph().getView().getScale();
			modelEditor.status(mxResources.get("scale") + ": "
					+ (int) (100 * scale)
					+ "%");
			
			//update the value in the zoom combobox
			modelEditor.getToolBar().getZoomBox().setSelectedItem((int) (100 * scale) + "%");
		}
	}
	

}