package org.processmining.mxgraph.examples.swing.panels;
 
import java.awt.Cursor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import org.processmining.common.table.MyTableModel;
import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class AttributePanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private JTable table;
    private MyTableModel tableModel;
    private JTextField attributeNameField;
    
    /**
     * record the attribute name (customer), attribute type (column or pk) and value type (int)
     */
    private JComboBox<String> attributeBox;
    private JComboBox<String> typeBox;
    private JComboBox<String> valueTypeBox;
    
    private JButton addAttributeButton;
    private JButton removeAttributeButton;
    private mxGraphComponent graphComponent;
    public AttributePanel(final mxGraphComponent graphComponent) {
    	this.graphComponent = graphComponent;
		attributeBox = new JComboBox<String>();//the first box    
	    typeBox = new JComboBox<String>();//the second box  
	    valueTypeBox = new JComboBox<String>();//the third box  
		attributeBox.setEditable(true);
        typeBox.setEditable(true);
        valueTypeBox.setEditable(true);
	    
//	    typeBox.setMaximumSize(new Dimension(800,30));
	    addAttributeButton = new JButton("add");
	    addAttributeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				mxCell selectedCell = (mxCell) graphComponent.getGraph().getSelectionCell();
				String attributeName = (String) attributeBox.getSelectedItem();
				String attributeType = (String) typeBox.getSelectedItem();
				String attributeValueType = (String) valueTypeBox.getSelectedItem();

//				if(selectedCell != null && attributeName != null && !selectedCell.getAttributes().containsKey(attributeName)){
				if(attributeName == null || attributeName.equals("")){
					JOptionPane.showMessageDialog(null, "Wrong! The attribute cannot be empty! Please input an attribute.");			
				}
				else if(selectedCell.getAttributeNameList().contains(attributeName)){
					JOptionPane.showMessageDialog(null, "Wrong! The attribute is existent! Please input another attribute.");		
				}
				else if(!selectedCell.getAttributeNameList().contains(attributeName)){
					List<Object> valueList = new ArrayList<Object>();
					valueList.add(attributeName);
					valueList.add(attributeType);
					valueList.add(attributeValueType);
					tableModel.addRecordRow(valueList);
					tableModel.updateTable();
//					selectedCell.getAttributes().put(attributeName, attributeValue + "-unnecessary");
					selectedCell.getAttributes().put(attributeName, attributeType + "-" + attributeValueType);
					selectedCell.getAttributeNameList().add(attributeName);
				}				
			}																					
		});	
	    
	    removeAttributeButton = new JButton("remove");	  
	    removeAttributeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				mxCell selectedCell = (mxCell) graphComponent.getGraph().getSelectionCell();
				int selectdRow  = table.getSelectedRow();
				if(selectedCell != null && selectdRow >= 0){
					String selectedAttribute = (String) tableModel.getValueAt(selectdRow, 1);//get the attribute name
					if(!mxConstants.NECESSARYATTRIBUTELIST.contains(selectedAttribute)){

						
						tableModel.removeRecordRow(selectdRow);
						tableModel.updateTable();
						selectedCell.getAttributes().remove(selectedAttribute);
					}		
				}
			}																					
		});	
	    
	    attributeNameField = new JTextField("");
	    tableModel = new MyTableModel();
//	    tableModel.setNames(new String[] {"index", "attribute", "value", "necessary"});
	    tableModel.setNames(new String[] {"index", "attribute", "category", "value"});
	    table = new JTable(tableModel);
//	    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);// 水平滚动条
	    table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
	    
        table.getModel().addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {  
                      
                int col = e.getColumn();               
                int row = e.getFirstRow();  
                if( col>1){
		        	String attributeName = (String) tableModel.getValueAt(row, 1);
		        	String attributeCategory = (String) tableModel.getValueAt(row, 2);
		        	String attributeValue = (String) tableModel.getValueAt(row, 3);
		        	mxCell selectedCell = (mxCell) graphComponent.getGraph().getSelectionCell();
		        	System.out.println("attributeName: " + attributeName);
		        	System.out.println("attributeCategory: " + attributeCategory);
		        	System.out.println("attributeValue:" + attributeValue + "end");
		        	//currently, we forbid modifying the type attribute
		        	if(selectedCell.isVertex() && !attributeName.equals(mxConstants.TYPE)){
		        		String categoryValueComplex = attributeCategory;
		        		if(attributeValue != null && !attributeValue.equals("")){
		        			categoryValueComplex = categoryValueComplex + "-" + attributeValue;
		        		}
			        	selectedCell.getAttributes().put(attributeName, categoryValueComplex);	
		        	}
		        	else if(selectedCell.isEdge() && !attributeName.equals(mxConstants.TYPE)){
		        		String categoryValueComplex = (String) tableModel.getValueAt(row, col);
			        	selectedCell.getAttributes().put(attributeName, categoryValueComplex);	
		        	}
		        		        			     
                }  		              
            }  
        }); 
						
		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		
		JPanel addAttriutePanel = new JPanel();
//		GridLayout gridLayout = new GridLayout(0,2);
		addAttriutePanel.setLayout(new BoxLayout(addAttriutePanel, BoxLayout.X_AXIS));

		addAttriutePanel.add(Box.createHorizontalStrut(2));
		addAttriutePanel.add(attributeBox);
		addAttriutePanel.add(Box.createHorizontalStrut(2));
		addAttriutePanel.add(typeBox);
		addAttriutePanel.add(Box.createHorizontalStrut(2));
		addAttriutePanel.add(valueTypeBox);
		addAttriutePanel.add(Box.createHorizontalStrut(2));	
		addAttriutePanel.add(addAttributeButton);
		addAttriutePanel.add(Box.createHorizontalStrut(2));
		addAttriutePanel.add(removeAttributeButton);
        
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		this.add(Box.createVerticalStrut(5));
		this.add(scrollPane);
		this.add(Box.createVerticalStrut(2));
		this.add(addAttriutePanel);
    }
 
    public String getDataname() {
        return dataname;
    }
 
    public void setDataname(String dataname) {
        this.dataname = dataname;
    }
 
    private JComboBox box = new JComboBox();
    private String dataname = "";
    
	/**
	 * update the update attribute panel based on the selected cell;
	 * the attribute panel display two kinds of attributes:node attribute (type,table,rowid) and fields attribute, e.g., name,quantity.
	 * a node attribute, type: ClassCell-11; a field attribute, quantity: field-Integer
	 */
	public void updateAttributePanel(mxCell selectedCell){
		if(selectedCell.isEdge()){
			//update the attribute panel for the selected cell
			attributeBox.setEnabled(true);
	        typeBox.setEnabled(true);
	        valueTypeBox.setEnabled(true);
	        addAttributeButton.setEnabled(true);
	        removeAttributeButton.setEnabled(true);
	        

	        //update the table panel
			tableModel.clearAllTableRows();

			
			if(selectedCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.AOCRELATION)){
				mxCell classCell = (mxCell) selectedCell.getTarget();
				
				//check the attribute of AOCEdge
				for(String key : selectedCell.getAttributes().keySet()){
					String categoryValue = selectedCell.getAttributes().get(key);			
					String category = categoryValue.split("-")[0];
					String value = null;
					if(categoryValue.split("-").length == 2){
						value = categoryValue.split("-")[1];
					}	
					//if it is the mapping
					if(category.equals(mxConstants.mapping)){
//						System.out.println("aoc has a mapping: " + key + "," + value);
						String classColumn = key;
						//if the class contain the column (i.e., the class attribute whose category is column)
						if(classCell.getAttributes().containsKey(classColumn) &&
								classCell.getAttributes().get(classColumn).split("-")[0].equals(mxConstants.column)){
							String activityAttribute = categoryValue.split("-")[1];
							List<Object> attributeMapping = new ArrayList<Object>();
							attributeMapping.add(classColumn);
							attributeMapping.add(category);
							attributeMapping.add(activityAttribute);
							tableModel.addRecordRow(attributeMapping);
						}					
					}
					else{

						List<Object> valueList = new ArrayList<Object>();
						valueList.add(key);
						valueList.add(category);
						valueList.add(value);
						tableModel.addRecordRow(valueList);
					}	
				}
				
				//check the attribute of classCell to see if all its column exist in the AOCEdge mapping
				for(String key : classCell.getAttributes().keySet()){
					String value = classCell.getAttributes().get(key);
					String category = value.split("-")[0];
					if(category.equals(mxConstants.column)){
						String classColumn = key;
						if(!selectedCell.getAttributes().containsKey(classColumn)){
							selectedCell.getAttributes().put(classColumn, mxConstants.mapping + "-" + mxConstants.nullValue);
							List<Object> attributeMapping = new ArrayList<Object>();
							attributeMapping.add(classColumn);
							attributeMapping.add(mxConstants.mapping);
							attributeMapping.add(mxConstants.nullValue);
							tableModel.addRecordRow(attributeMapping);
						}
					}
				}
			}	
			
			else if(selectedCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.CLASSRELATION)){
				updateAttributePanelForClassRelationship(selectedCell);
			}
			tableModel.updateTable();
	    	
		}
		else if(selectedCell.isVertex()){
			//update the attribute panel for the selected cell
	    	attributeBox.setEnabled(true);
	        typeBox.setEnabled(true);
	        valueTypeBox.setEnabled(true);
	        addAttributeButton.setEnabled(true);
	        removeAttributeButton.setEnabled(true);	
			tableModel.clearAllTableRows();
			if(selectedCell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.CLASSCELL)){
				updateAttributePanelForClass(selectedCell);
			}
		}		    				
	}
	
	public void disableAttributePanel(){
		//clear attribute panel
    	tableModel.clearAllTableRows();
    	tableModel.updateTable();
    	attributeNameField.setEnabled(false);
    	attributeBox.setEnabled(false);
        typeBox.setEnabled(false);
        valueTypeBox.setEnabled(false);
        addAttributeButton.setEnabled(false);
        removeAttributeButton.setEnabled(false);
		
	}
	
	/**
	 * update the update attribute panel based on the selected class;
	 * the table in the attribute panel show rows, in which a row (attribute name, category (column, pk or fk),attribute value type)
	 * the first box shows some name examples (customer, address), the second box shows column, pk, fk, and the third box shows all value types (int, varchar(256))
	 * @param selectedCell
	 */
	public void updateAttributePanelForClass(mxCell selectedCell){
		//update the box items	  
		attributeBox.removeAllItems();
		attributeBox.addItem(mxConstants.TABLE);
		attributeBox.addItem(mxConstants.ROWID);
		
        typeBox.removeAllItems();
	    typeBox.addItem(mxConstants.column);
	    typeBox.addItem(mxConstants.FK);
	    typeBox.addItem(mxConstants.PK);
//	    typeBox.addItem(mxConstants.ACTIVITY);
//	    typeBox.addItem(mxConstants.CONSTRAINT);
        
        valueTypeBox.removeAllItems();
	    valueTypeBox.addItem(mxConstants.Int);
	    valueTypeBox.addItem(mxConstants.Varchar);
	    valueTypeBox.addItem(mxConstants.Double);
	    valueTypeBox.addItem(mxConstants.Datetime);
	    valueTypeBox.addItem(mxConstants.Text);
	    
	    //update the table
		for(String key : getCellAttributeListofCategory(selectedCell, mxConstants.PK)){
			List<Object> row = new ArrayList<Object>();		
			row.add(key);	
			row.add(mxConstants.PK);	
			row.add(selectedCell.getAttributes().get(key).split("-")[1]);
			tableModel.addRecordRow(row);
		}
		for(String key : getCellAttributeListofCategory(selectedCell, mxConstants.FK)){
			List<Object> row = new ArrayList<Object>();		
			row.add(key);	
			row.add(mxConstants.FK);	
			row.add(selectedCell.getAttributes().get(key).split("-")[1]);
			tableModel.addRecordRow(row);
		}
		for(String key : getCellAttributeListofCategory(selectedCell, mxConstants.column)){
			List<Object> row = new ArrayList<Object>();		
			row.add(key);	
			row.add(mxConstants.column);	
			row.add(selectedCell.getAttributes().get(key).split("-")[1]);
			tableModel.addRecordRow(row);
		}
	}
	
	/**
	 * update the update attribute panel based on the selected class relationship;
	 * the table in the attribute panel show rows, in which a row (fk,refer,pk)
	 * the first box shows all fks of the child table (source class) and the third box shows all pks of the father table (target class)
	 * @param selectedCell
	 */
	public void updateAttributePanelForClassRelationship(mxCell selectedCell){
		//update the box items
		attributeBox.setEditable(true);
        typeBox.setEditable(true);
        valueTypeBox.setEditable(true);
        
		mxCell childCell = (mxCell) selectedCell.getSource();
		mxCell parentCell = (mxCell) selectedCell.getTarget();
		//add fk into boxes
		attributeBox.removeAllItems();
		for(String fk : getCellAttributeListofCategory(childCell, mxConstants.FK)){
			attributeBox.addItem(fk);;
		}
		
        typeBox.removeAllItems();
        typeBox.addItem(mxConstants.reference);
        
        //add pk into boxes
        valueTypeBox.removeAllItems();
		for(String pk : getCellAttributeListofCategory(parentCell, mxConstants.PK)){
			valueTypeBox.addItem(pk);;
		}
		//update the table
		tableModel.setNames(new String[] {"index", "fk", "reference", "pk"});
		
		//check the attribute of class relationship
		for(String key : selectedCell.getAttributes().keySet()){
			String categoryValue = selectedCell.getAttributes().get(key);			
			String category = categoryValue.split("-")[0];
			String value = null;
			if(categoryValue.split("-").length == 2){
				value = categoryValue.split("-")[1];
			}	
			//if it is the mapping
			if(category.equals(mxConstants.reference)){
				List<Object> attributeMapping = new ArrayList<Object>();
				attributeMapping.add(key);
				attributeMapping.add(category);
				attributeMapping.add(value);
				tableModel.addRecordRow(attributeMapping);				
			}
//			else{
//
//				List<Object> valueList = new ArrayList<Object>();
//				valueList.add(key);
//				valueList.add(category);
//				valueList.add(value);
//				tableModel.addRecordRow(valueList);
//			}	
		}
	}
	
	/**
	 * get the attribute name list of one call for one category
	 * @param cell
	 * @param category
	 * @return
	 */
	public List<String> getCellAttributeListofCategory(mxCell cell, String category){
		List<String> attributeList = new ArrayList<String>();		
		for(String key : cell.getAttributes().keySet()){
			String categoryValue = cell.getAttributes().get(key);			
			String categoryAttr = categoryValue.split("-")[0];

			if(category.equals(categoryAttr)){
				attributeList.add(key);
			}
		}
		return attributeList;
	}
	
//	public List<Object> transformAttributeToRecord(){
//		
//	}
	
    public static void main(String[] args) {
    	 
    }
}