package org.processmining.mxgraph.examples.swing.panels;
import java.awt.GridLayout;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.processmining.mxgraph.examples.swing.editor.BasicGraphEditor;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.ocbc.discovery.metrics.ComputeBehavioralPrecision;

public class SliderPanelOld extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private mxGraphComponent graphComponent;
	private BasicGraphEditor graphEditor;
	public static final Map<String, Object[]> behavioralConstraintTypeVSCellSet = new HashMap<String, Object[]>();
	private JSlider sliderPrecision;
	private JSlider sliderFitness;
	private JSlider sliderGeneralization;
	
	public SliderPanelOld(final mxGraphComponent graphComponent, final BasicGraphEditor graphEditor) {
	    super();
	    this.graphEditor = graphEditor;	    		
	    setLayout(new GridLayout(1, 2));
   
		// Add status label to show the status of the slider
		final JLabel status = new JLabel("Slide the slider and you can get its value", JLabel.CENTER);
		// Set the slider
		sliderFitness = new JSlider(JSlider.VERTICAL);	
		sliderFitness.setBorder(BorderFactory.createTitledBorder("fitness: 1"));	    
		sliderFitness.setMinorTickSpacing(10);
		sliderFitness.setPaintTicks(true);		
		// Set the labels to be painted on the slider
		sliderFitness.setPaintLabels(true);
		sliderFitness.setValue(100);
		// Add positions label in the slider
		Hashtable<Integer, JLabel> position = new Hashtable<Integer, JLabel>();
		position.put(0, new JLabel("0"));
		position.put(50, new JLabel("0.5"));
		position.put(100, new JLabel("1.0"));		
		// Set the label to be drawn
		sliderFitness.setLabelTable(position);		
		// Add change listener to the slider
		sliderFitness.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				status.setText("Value of the slider is: " + ((JSlider)e.getSource()).getValue());
			}
		});
		
		sliderPrecision = new JSlider(JSlider.VERTICAL);	
		sliderPrecision.setBorder(BorderFactory.createTitledBorder("precision: 1"));	    
		sliderPrecision.setMinorTickSpacing(10);
		sliderPrecision.setPaintTicks(true);		
		// Set the labels to be painted on the slider
		sliderPrecision.setPaintLabels(true);
		// Add positions label in the slider
//		Hashtable<Integer, JLabel> position = new Hashtable<Integer, JLabel>();
		position.put(0, new JLabel("0"));
		position.put(50, new JLabel("0.5"));
		position.put(100, new JLabel("1.0"));		
		// Set the label to be drawn
		sliderPrecision.setLabelTable(position);
		
		ComputeBehavioralPrecision computeBehavioralPrecision = new ComputeBehavioralPrecision();
//		double precision = computeBehavioralPrecision.computePrecision(graphEditor.getOCBCModel().getModelSourceLog(), graphEditor.getOCBCModel()); 
//		sliderPrecision.setValue((int) (precision*100));
//		double shortPrecison = ((double)((int) (precision*100)))/100;
//		sliderPrecision.setBorder(BorderFactory.createTitledBorder("precision: " + shortPrecison));
		
		// Add change listener to the slider
		sliderPrecision.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				sliderPrecision.setBorder(BorderFactory.createTitledBorder("precision: " + ((double)sliderPrecision.getValue())/100));
				status.setText("Value of the slider is: " + ((JSlider)e.getSource()).getValue());
			}
		});

		//add generalization slider
		sliderGeneralization = new JSlider(JSlider.VERTICAL);	
		sliderGeneralization.setBorder(BorderFactory.createTitledBorder("generalization: 1"));	    
		sliderGeneralization.setMinorTickSpacing(10);
		sliderGeneralization.setPaintTicks(true);		
		// Set the labels to be painted on the slider
		sliderGeneralization.setPaintLabels(true);
		sliderGeneralization.setValue(100);
		// Add positions label in the slider
//		Hashtable<Integer, JLabel> position = new Hashtable<Integer, JLabel>();
		position.put(0, new JLabel("0"));
		position.put(50, new JLabel("0.5"));
		position.put(100, new JLabel("1.0"));		
		// Set the label to be drawn
		sliderGeneralization.setLabelTable(position);		
		// Add change listener to the slider
		sliderGeneralization.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				status.setText("Value of the slider is: " + ((JSlider)e.getSource()).getValue());
			}
		});
		// Add the slider to the panel
		this.add(sliderFitness);
		this.add(sliderPrecision);
		this.add(sliderGeneralization);
	}

	public JSlider getPrecisionSlider(){
		return sliderPrecision;
	}
	
	public JSlider getFitnessSlider(){
		return sliderFitness;
	}
	
    public static void main(String[] args) {
    	
        JFrame frame = new JFrame("Hello world");
       
        SliderPanelOld panel = new SliderPanelOld(null, null);
       
        frame.add(panel);

        frame.setSize(600, 400);
        frame.setVisible(true);
       
     }

}