package org.processmining.mxgraph.examples.swing.visualization;

import java.util.Hashtable;
import java.util.Map;

import javax.swing.JFrame;

import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.mxgraph.view.mxStylesheet;

public class Style{

    public static void createStyle(mxGraph graph) {        
//    	this.graph = graph;
	    mxStylesheet stylesheet = graph.getStylesheet();
	    Hashtable<String, Object> style = new Hashtable<String, Object>();
//	    String defaultEdgeStyle = mxConstants.EDGESTYLE_ELBOW;
	    String defaultEdgeStyle = mxConstants.EDGESTYLE_SEGMENT;
	    //remove the end arrow of the default edge
	    stylesheet.getDefaultEdgeStyle().remove(mxConstants.STYLE_ENDARROW);	
	    stylesheet.getDefaultVertexStyle().clear();
	    
	    /*
	     * in the future, add the style of combined edges(response + unary-precedence)
	     */
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_IMAGE, "/org/processmining/mxgraph/examples/swing/images/class.png"); 
	    stylesheet.putCellStyle(mxConstants.CLASSCELL, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_EDGE, mxConstants.SHAPE_LINE); 
	    stylesheet.putCellStyle(mxConstants.STRAIGHTLINE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_DASHED, true);    
	    style.put(mxConstants.STYLE_STROKECOLOR , "blue");
	    style.put(mxConstants.STYLE_DASH_PATTERN, mxConstants.AOCRELATION_DASHED_PATTERN);
	    style.put(mxConstants.STYLE_EDGE, defaultEdgeStyle);
	    stylesheet.putCellStyle(mxConstants.AOCRELATION, style);
	    
//	    style = new Hashtable<String, Object>();	    
//	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_OPEN);
//	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
//	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
//	    stylesheet.putCellStyle(mxConstants.AOCRELATION, style);
	    
	    style = new Hashtable<String, Object>();    
	    style.put(mxConstants.STYLE_EDGE, mxConstants.SHAPE_LINE); 
	    style.put(mxConstants.STYLE_DASHED, "1"); 
	    style.put(mxConstants.STYLE_STROKECOLOR , "blue");
	    style.put(mxConstants.STYLE_DASH_PATTERN, mxConstants.CRELRELATION_DASHED_PATTERN);
	    stylesheet.putCellStyle(mxConstants.CRELRELATION, style);
	    	
	    style = new Hashtable<String, Object>();	    
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_OPEN);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, defaultEdgeStyle); 
	    stylesheet.putCellStyle(mxConstants.CLASSRELATION, style);
	    
	    style = new Hashtable<String, Object>();	    
	    style.put(mxConstants.STYLE_FONTCOLOR , "black");
	    stylesheet.putCellStyle(mxConstants.CARDINALITY, style);	    
	    
//	    style = new Hashtable<String, Object>();	    
//	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
//	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_BLOCK);
//	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
//	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_ELBOW); 
//	    stylesheet.putCellStyle(mxConstants.ACTIVITYRELATION, style);
	    
	   
//	    style = (Hashtable<String, Object>) ((Hashtable<String, Object>) stylesheet.getCellStyle(mxConstants.ACTIVITYRELATION)).clone();  
	    //currently, set the edge style of unary response and precedence as elbow

	    
	    style = new Hashtable<String, Object>();    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT);     
	    style.put(mxConstants.STYLE_DASHED, "1"); 
	    stylesheet.putCellStyle(mxConstants.NoConstraints, style);
	    
	    style = new Hashtable<String, Object>();    	    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_DOUBLE_BLOCK);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.RESPONSE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_BLOCK);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, defaultEdgeStyle); 
	    stylesheet.putCellStyle(mxConstants.UNARYRESPONSE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_DOUBLE_BLOCK);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.NONRESPONSE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_DOUBLE_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.PRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, defaultEdgeStyle); 
	    stylesheet.putCellStyle(mxConstants.UNARYPRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_DOUBLE_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.NONPRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.COEXISTENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.NONCOEXISTENCE, style);
	    
	    //combined cardinalities
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_DOUBLE_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_ELBOW); 
	    stylesheet.putCellStyle(mxConstants.RESPONSE_PRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_DOUBLE_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.NONRESPONSE_NONPRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_BLOCK_DOT);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.UNARYRESPONSE_UNARYPRECEDENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.COEXISTENCE_COEXISTENCE, style);
	    
	    style = new Hashtable<String, Object>();    	    
	    style.put(mxConstants.STYLE_STARTARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_OVAL);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT); 
	    stylesheet.putCellStyle(mxConstants.NONCOEXISTENCE_NONCOEXISTENCE, style);
	    
	    style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RHOMBUS);
        style.put(mxConstants.STYLE_LABEL_BORDERCOLOR, "blue");
        stylesheet.putCellStyle(mxConstants.CONNECTOR_FOCUSED, style);
        
	    style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RHOMBUS);
        stylesheet.putCellStyle(mxConstants.CONNECTOR_TRANSPARENT, style);
        
	    style = new Hashtable<String, Object>();
        style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_RHOMBUS);
        style.put(mxConstants.STYLE_LABEL_BORDERCOLOR, "red");
        stylesheet.putCellStyle(mxConstants.CONNECTOR_VIOLATING, style);
        
	    style = new Hashtable<String, Object>();
	    style.put(mxConstants.STYLE_RESIZABLE, "0");
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_RIGHT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_TOP);
        style.put(mxConstants.STYLE_FONTCOLOR, "black");
        stylesheet.putCellStyle(mxConstants.LABEL_NORMAL, style);
        
	    style = new Hashtable<String, Object>();
	    style.put(mxConstants.STYLE_RESIZABLE, "0");
        style.put(mxConstants.STYLE_ALIGN, mxConstants.ALIGN_RIGHT);
        style.put(mxConstants.STYLE_VERTICAL_ALIGN, mxConstants.ALIGN_TOP);
        style.put(mxConstants.STYLE_FONTCOLOR, "red");
        stylesheet.putCellStyle(mxConstants.LABEL_FOCUSED, style);
        
	    style = new Hashtable<String, Object>();
	    style.put(mxConstants.STYLE_OPACITY, 0);
	    style.put(mxConstants.STYLE_TEXT_OPACITY, 0);
	    style.put(mxConstants.STYLE_FILL_OPACITY, 0);
	    style.put(mxConstants.STYLE_STROKE_OPACITY, 0);	    
        stylesheet.putCellStyle(mxConstants.TRANSPARENTEDGE, style);
        
	    style = new Hashtable<String, Object>();
	    style.put(mxConstants.STYLE_OPACITY, 0);
	    style.put(mxConstants.STYLE_TEXT_OPACITY, 0);
	    style.put(mxConstants.STYLE_FILL_OPACITY, 0);
	    style.put(mxConstants.STYLE_STROKE_OPACITY, 0);	    
        stylesheet.putCellStyle(mxConstants.HIGHLIGHTEDGE, style);
        
	    style = new Hashtable<String, Object>();					
	    style.put(mxConstants.STYLE_OPACITY, 0);
	    style.put(mxConstants.STYLE_TEXT_OPACITY, 0);
	    style.put(mxConstants.STYLE_FILL_OPACITY, 0);
        stylesheet.putCellStyle(mxConstants.TRANSPARENTCARDINALITY, style);
        
	    style = new Hashtable<String, Object>();	
	    style.put(mxConstants.STYLE_DASHED, "1"); 
	    style.put(mxConstants.STYLE_DASH_PATTERN, mxConstants.AOCRELATION_DASHED_PATTERN);
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT);
	    style.put(mxConstants.STYLE_TEXT_OPACITY, 0);
        stylesheet.putCellStyle(mxConstants.TRANSPARENTAOCEDGENAME, style);
        
	    style = new Hashtable<String, Object>();	
	    style.put(mxConstants.STYLE_ENDARROW, mxConstants.ARROW_OPEN);
	    style.put(mxConstants.STYLE_STROKECOLOR , "black");
	    style.put(mxConstants.STYLE_EDGE, mxConstants.EDGESTYLE_SEGMENT);
	    style.put(mxConstants.STYLE_TEXT_OPACITY, 0);
        stylesheet.putCellStyle(mxConstants.TRANSPARENTCLASSEDGENAME, style);
        
        
        
        
//	    for(String styleName : stylesheet.getStyles().keySet()){
//	    	System.out.println("styleName: " + styleName);
//	    }
    }

    /*
     * add a new style element (element key + element value) to the style of a cell;
     * if the element key exists, update the element value
     */
    public static void addStyleElementToCell(mxCell cell, String styleElementKey, String styleElementValue){
    	String style = cell.getStyle();
		String newStyle = "";
		boolean existentFlag = false;
		String[] styleAttributes = style.split(";");
		for(int k=0; k<styleAttributes.length; k++){
			if(styleAttributes[k].contains(styleElementKey)){
				System.out.println("add containment: " + styleElementKey);
				styleAttributes[k] = styleElementKey + "=" + styleElementValue;
				existentFlag = true;
			}
			newStyle = newStyle + styleAttributes[k] + ";";
		}
		if(!existentFlag){
			newStyle = newStyle + styleElementKey + "=" + styleElementValue + ";";
		}
		cell.setStyle(newStyle);
		System.out.println("set styleName: " + style);
		System.out.println("set newStyle: " + newStyle);
    }

    /*
     * get a element value from the style of a cell by element key;
     * if the element key does not exist, return null
     */
    public static String getStyleElementValueFromCell(mxGraph graph, mxCell cell, String styleElementKey){
    	mxStylesheet stylesheet = graph.getStylesheet();
    	String style = cell.getStyle();
    	System.out.println("get styleName: " + style);
		String value = null;
		String[] styleAttributes = style.split(";");
		for(int k=0; k<styleAttributes.length; k++){
			String styleElement = styleAttributes[k];
			Map<String, Object> styleMap = stylesheet.getCellStyle(styleElement);
			if(styleMap != null){
				if(styleMap.containsKey(styleElementKey)){
					System.out.println("containtment style element: " + style);
					value = (String) styleMap.get(styleElementKey);	
				}
			}
			else if(styleElement.contains(styleElementKey)){
				System.out.println("contain input key: " + styleElement);
				value = styleElement.split("=")[1];				
			}			
		}	
		return value;
    }
    
    public static void main(String[] args) {
    	
    	mxGraph graph = new mxGraph();
    	 Object parent = graph.getDefaultParent();
         graph.getModel().beginUpdate();
         Style style = new Style();
         style.createStyle(graph);
         
         mxCell v3 = (mxCell) graph.insertVertex(parent, null, "3", 180, 130, 30, 30);
         mxCell v4 = (mxCell) graph.insertVertex(parent, null, "4", 280, 230, 30, 30);
         mxCell v5 = (mxCell) graph.insertVertex(parent, null, "5", 380, 330, 30, 30);
         mxCell v6 = (mxCell) graph.insertVertex(parent, null, "6", 480, 430, 30, 30);
         
         mxStylesheet stylesheet = graph.getStylesheet();
 	    for(String styleName : stylesheet.getStyles().keySet()){
	    	System.out.println("outside styleName: " + styleName);
	    }
 	    
         graph.insertEdge(parent, null, "Edge", v3, v4,"AOCRelation");
         graph.insertEdge(parent, null, "Edge", v4, v5);
         graph.insertEdge(parent, null, "Edge", v4, v6);
         graph.insertEdge(parent, null, "Edge", v5, v6);
         
         graph.getModel().endUpdate();
        JFrame frame = new JFrame();
    	
//        frame.executeLayout();
        mxGraphComponent graphComponent = new mxGraphComponent(graph);
        frame.getContentPane().add(graphComponent);
        graphComponent.refresh();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(400, 320);
        frame.setVisible(true);
    }
}