package org.processmining.ocbc.conformance.checkers;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.models.OCBCModel;

public class ActivityExistenceChecking {
	private List<XOCEvent> deviatingEventList = new ArrayList<XOCEvent>();//record the events with inexistent activity in the model
	
	public List<XOCEvent> getDeviatingEventList(){
		return deviatingEventList;
	}
	
	public void checking(XOCLog log, OCBCModel model)
	{		
		List<String> activityNameList = model.getAllActivityNames();
		for(XOCEvent event : log.getAllEvents()){		
			String activity = event.getAttributes().get(xConstants.ACTIVITY).toString();
			if(!activityNameList.contains(activity)){
				deviatingEventList.add(event);
			}
		}
	}  	
}