package org.processmining.ocbc.conformance.checkers;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.processmining.common.structure.IntegerPair;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.XOCObject;
import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.models.OCBCModel;



public class MonotonicityChecking {
//	private Map<ClassEdge, Map<XOCObject, List<XOCObject>>> violatedSourceClassRelationVSObjectVSRelatedObjectList = new HashMap<ClassEdge, Map<XOCObject, List<XOCObject>>>();
//	private Map<ClassEdge, Map<XOCObject, List<XOCObject>>> violatedTargetClassRelationVSObjectVSRelatedObjectList = new HashMap<ClassEdge, Map<XOCObject, List<XOCObject>>>();
 
	private List<XOCObject> disappearedObjectList = new ArrayList<XOCObject>();
	private List<XOCObject> classChangedObjectList = new ArrayList<XOCObject>();
	
	
	public void checking(XOCLog log, OCBCModel model){	
		for(XOCObject object : log.getObjectList()){
			List<IntegerPair> lifecyclePeriodList = object.getLifecyclePeriodList();		
			if(lifecyclePeriodList.size() > 0){
				int endEventOrderNum = lifecyclePeriodList.get(0).getSecondValue() != null ? lifecyclePeriodList.get(0).getSecondValue() : log.size();
				if(endEventOrderNum < log.size()){
					disappearedObjectList.add(object);
				}			
			}
			if(object.getXOCAttributes().get(xConstants.CLASS) != null){
				Set<String> valueSet = new HashSet<String>(object.getXOCAttributes().get(xConstants.CLASS).getValueList());
				if(valueSet.size() > 1){
					classChangedObjectList.add(object);
				}
			}		
		}
	}
	
	public List<XOCObject> getDisappearedObjectList(){
		return disappearedObjectList;
	}
	
	public List<XOCObject> getClassChangedObjectList(){
		return classChangedObjectList;
	}
	
	public static void main(String[] str){
		List<String> valueList = new ArrayList<String>();
		valueList.add("a");
		valueList.add("d");
		valueList.add("b");
//		Object[] valueSet = valueList.to;
//		for(int i=0; i<valueSet.length; i++){			
//			System.out.println("valueSet[i]: " + valueSet[i]);
//		}
		Set<String> foo = new HashSet<String>(valueList);
		System.out.println("foo.size(): " + foo.size());
	}
}