package org.processmining.ocbc.conformance.checkers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.XOCObject;
import org.processmining.ocbc.models.OCBCModel;

public class ObjectExistenceChecking {
	private Map<XOCEvent, List<XOCObject>> eventVSInexistentObjectList = new HashMap<XOCEvent, List<XOCObject>>();//record the objects referred to by an event but not existing in the object model when the event occurs
	private List<XOCEvent> deviatingEventList = new ArrayList<XOCEvent>();//record the deviating events
	
	public Map<XOCEvent, List<XOCObject>> getEventVSInexistentObjectListMap(){
		return eventVSInexistentObjectList;
	}
	
	public List<XOCEvent> getDeviatingEventList(){
		return deviatingEventList;
	}
	
	public void checking(XOCLog log, OCBCModel model){		
		for(XOCEvent event : log.getAllEvents()){
			eventVSInexistentObjectList.put(event, new ArrayList<XOCObject>());
			for(XOCObject object : event.getRelatedObjects()){
				if(!object.isAliveAtEvent(event)){
					eventVSInexistentObjectList.get(event).add(object);
				}
			}
			if(eventVSInexistentObjectList.get(event).size() == 0){
				eventVSInexistentObjectList.remove(event);
			}
			else{
				deviatingEventList.add(event);
			}
		}
	}  	
}