package org.processmining.ocbc.conformance.checkers;

import java.util.List;

import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.XOCObject;

/*
 * checking idea:
 */
public class ObjectModelsContainmentChecking {

	public ObjectModelsContainmentCheckingResult checking(XOCLog log)
	{
		ObjectModelsContainmentCheckingResult checkingResult = new ObjectModelsContainmentCheckingResult();		
		for(int i=0; i<log.size()-1; i++){
			for(int j=i+1; j<log.size(); j++){
				XOCEvent precedingEvent = log.get(i);
				XOCEvent subsequentEvent = log.get(j);
				
				//check if Obj(e1) is less or equal to Obj(e2) and if class(e1) is less or equal to class(e2)			
				List<XOCObject> differenceObjects = subsequentEvent.getObjectModel().computeLess(precedingEvent.getObjectModel());//get the objects which are include in precedingEvent.model but not in subsequentEvent.model
				if(!differenceObjects.isEmpty()){
					checkingResult.linkDifferenceWithEventPair(precedingEvent, subsequentEvent, differenceObjects);
				}
			}
		}		
		return checkingResult;
	}   
}