package org.processmining.ocbc.conformance.software;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import org.processmining.ocbc.conformance.visualization.views.ConformanceCheckingResultView;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.models.OCBCModel;

public class ConformanceCheckingSoftware extends JPanel{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

//	private SlickerTabbedPane multiplePane;
	private JTabbedPane multiplePane;
	private SoftwareParameterInterface softwareParameterInterface;
	private JComponent resultWithModel;
	public ConformanceCheckingSoftware(){
//		multiplePane = new SlickerTabbedPane("", new Color(240, 240, 240, 230), new Color(0, 0, 0, 230),
//				new Color(220, 220, 220, 150));
		
		multiplePane = new JTabbedPane();
		softwareParameterInterface = new SoftwareParameterInterface(this);
		multiplePane.addTab("parameter", softwareParameterInterface);
//		multiplePane.setSize(1800, 1000);
		this.add(multiplePane);
	}
	
    public JTabbedPane getMultiplePane(){
    	return multiplePane;
    }
    
//    public SlickerTabbedPane getMultiplePane(){
//    	return multiplePane;
//    }
		
	public void updateConformanceCheckingPanel(XOCLog inputLog, OCBCModel inputModel){
		ConformanceCheckingResultView modelPerspective = new ConformanceCheckingResultView();  
		if(resultWithModel != null){
			multiplePane.remove(resultWithModel);
		}		
		
	
//		modelPerspective.setObjectModelValidityCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getValidityOfObjectModelSelectionFlag());
//		modelPerspective.setFulfilmentCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getFulfilmentSelectionFlag());
//		modelPerspective.setActivityExistenceCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getActivityExistenceSelectionFlag());
//		modelPerspective.setObjectExistenceCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getObjectExistenceSelectionFlag());
//		modelPerspective.setProperClassesCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getProperClassesSelectionFlag());		
//		modelPerspective.setObjectNumberPerEventCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getObjectsPerEventSelectionFlag());
//		modelPerspective.setEventNumberPerObjectCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getEventsPerObjectSelectionFlag());
//		modelPerspective.setBehavioralConstraintsCheckerSwitch(softwareParameterInterface.
//				getParameterPanel().getBehavioralConstraintsSelectionFlag());
		
		modelPerspective.setParameterPanel(softwareParameterInterface.
				getParameterPanel());
		resultWithModel = modelPerspective.conformanceChecking(null, inputLog, inputModel);
        multiplePane.addTab("conformance checking result", resultWithModel);   
        multiplePane.setSelectedComponent(resultWithModel);
	}	
	
	public static void main(String[] args) throws Exception{  					
        ConformanceCheckingSoftware softwarePanel = new ConformanceCheckingSoftware();
		JFrame frame = new JFrame();
        frame.getContentPane().add(softwarePanel.getMultiplePane());
		frame.setSize(1800, 1000);
		frame.setVisible(true);	  	
//		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize()); 
		frame.setExtendedState(javax.swing.JFrame.MAXIMIZED_BOTH);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
	

