package org.processmining.ocbc.conformance.visualization.interaction;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.Map;

import org.processmining.mxgraph.examples.swing.editor.BasicGraphEditor;
import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.conformance.visualization.views.ResultModelView;
import org.processmining.ocbc.log.model.XOCObject;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.OCBCModel;

public class CCModelGraphMouseListener extends MouseAdapter{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;


//	private BasicGraphEditor graphEditor;
    private double souceLabelPosition = -0.6;
    private double targetLabelPosition = 0.4;
    private double connectorSize = 5;
    private double connectorX = 0.2;
	
    private BasicGraphEditor modelEditor;
    private ResultModelView conformanceCheckingModelView;
    private OCBCModel model;
	private mxGraphComponent graphComponent;
	private Map<ClassEdge, List<XOCObject>> violatedSourceClassRelationVSObjectList;
	private Map<ClassEdge, List<XOCObject>> violatedTargetClassRelationVSObjectList;
	private Map<String, ClassEdge> violatedClassRelationIdVSRelation;
	public CCModelGraphMouseListener(ResultModelView conformanceCheckingModelView) {
		this.conformanceCheckingModelView = conformanceCheckingModelView;
		this.graphComponent = conformanceCheckingModelView.getGraphComponent();
		this.model = conformanceCheckingModelView.getModel();
//		this.violatedSourceClassRelationVSObjectList = conformanceCheckingModelView.getViolatedSourceClassRelationVSObjectListMap();
//		this.violatedTargetClassRelationVSObjectList = conformanceCheckingModelView.getViolatedTargetClassRelationVSObjectListMap();
		this.violatedClassRelationIdVSRelation = conformanceCheckingModelView.getViolatedClassRelationIdVSRelationMap();
	}
	
//	public void setModelEditor(BasicGraphEditor modelEditor){
//		this.modelEditor = modelEditor;
//		
//	}
//	
//	public void setConformanceCheckingModelView(ResultModelView conformanceCheckingModelView){
//		this.conformanceCheckingModelView = conformanceCheckingModelView;
//	}
	
	/**
	 * 
	 */
	public void mousePressed(MouseEvent e)
	{
		// Handles context menu on the Mac where the trigger is on mousepressed
		System.out.println("mousePressed in GraphComponentMouseListener");
		
		int dragStartX = e.getX();
		int dragStartY = e.getY();

		System.out.println("graphComponent dragStartX: " + dragStartX);
		System.out.println("graphComponent dragStartY: " + dragStartY);
	}

	/**
	 * 
	 */
	public void mouseReleased(MouseEvent e)
	{
		System.out.println("mouseReleased in GraphComponentMouseListener");
		if(model.getModelEnvironment().equals(mxConstants.model_editor)){
			modelEditor.updateEditor();

			System.out.println("released in BasicGraphEditor");
			if (e.isPopupTrigger())
			{
				modelEditor.showGraphPopupMenu(e);
			}
		}

	}
	
	/**
	 * monitor the clicking event
	 */
    public void mouseClicked(MouseEvent e) {  
    	System.out.println("mouseClicked in CCModelGraphMouseListener");
    	String modelEnvironment = model.getModelEnvironment();
    	System.out.println("modelEnvironment: " + modelEnvironment);
        // TODO Auto-generated method stub  
    	mxCell selectedCell = (mxCell) graphComponent.getGraph().getSelectionCell();

	    	
    	if(selectedCell != null){	    	
    		System.out.println("selectedCell is not null in CCModelGraphMouseListener");
			String cellType = selectedCell.getAttributes().get(mxConstants.TYPE);
			System.out.println("cellType: " + cellType);
			String cellId = selectedCell.getId();
			System.out.println("cellId: " + cellId);
			
			if(cellType.equals(mxConstants.CLASSRELATION)){
				System.out.println(mxConstants.CLASSRELATION);
				conformanceCheckingModelView.updateDeviationHierarchyPanelForClassRelation(cellId);
				System.out.println("violatedSourceClassRelationVSObjectList contain selected cell in CCModelGraphMouseListener");
			}			
			else if(cellType.equals(mxConstants.ACTIVITYRELATION)){
				System.out.println(mxConstants.ACTIVITYRELATION);
				String cardinalityType = selectedCell.getAttributes().get(mxConstants.CARDINALITYTYPE);
				conformanceCheckingModelView.updateDeviationHierarchyPanelForActivityRelation(cellId, cardinalityType);
				System.out.println("updateDeviationHierarchyPanelForActivityRelation in CCModelGraphMouseListener");
			}
			else if(cellType.equals(mxConstants.AOCRELATION)){
				System.out.println(mxConstants.AOCRELATION);
				conformanceCheckingModelView.updateDeviationHierarchyPanelForAOCRelation(cellId);
				System.out.println("updateDeviationHierarchyPanelForAOCRelation in CCModelGraphMouseListener");
			}
    	}
    	graphComponent.getGraph().refresh();	  
		        
    }  
}