/*
 * Copyright (c) 2007 Christian W. Guenther (christian@deckfour.org)
 * 
 * LICENSE:
 * 
 * This code is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 * 
 * EXEMPTION:
 * 
 * License to link and use is also granted to open source programs which are not
 * licensed under the terms of the GPL, given that they satisfy one or more of
 * the following conditions: 1) Explicit license is granted to the ProM and
 * ProMimport programs for usage, linking, and derivative work. 2) Carte blance
 * license is granted to all programs developed at Eindhoven Technical
 * University, The Netherlands, or under the umbrella of STW Technology
 * Foundation, The Netherlands. For further exemptions not covered by the above
 * conditions, please contact the author of this code.
 */
package org.processmining.ocbc.conformance.visualization.views;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.processmining.ocbc.conformance.plugin.ParameterPanel;
import org.processmining.ocbc.conformance.visualization.panels.ActivityExistencePanel;
import org.processmining.ocbc.conformance.visualization.panels.BebavioralConstraintsPanel;
import org.processmining.ocbc.conformance.visualization.panels.EventNumberPerObjectPanel;
import org.processmining.ocbc.conformance.visualization.panels.FulfilmentPanel;
import org.processmining.ocbc.conformance.visualization.panels.MonotonicityPanel;
import org.processmining.ocbc.conformance.visualization.panels.OMValidityPanel;
import org.processmining.ocbc.conformance.visualization.panels.ObjectExistencePanel;
import org.processmining.ocbc.conformance.visualization.panels.ObjectNumberPerEventPanel;
import org.processmining.ocbc.conformance.visualization.panels.ProperClassesPanel;
import org.processmining.ocbc.log.inspector.panels.XOCLogViewer;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.models.OCBCModel;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;


/**
 * @author Christian W. Guenther (christian@deckfour.org)
 * 
 */
public class ResultTextView extends JPanel {

	private static final long serialVersionUID = -6450104278248630541L;
	protected ConformanceCheckingResultView conformanceCheckingResultView;
//	protected LogViewUI logViewUI;
	protected XOCLogViewer logPreviewUI;
//	protected LogAttributesUI logAttributesUI;

//	protected SlickerTabbedPane tabPane;
	protected JScrollPane tabPane;
	protected JPanel textPane;

	public ConformanceCheckingResultView getConformanceCheckingResultView(){
		return conformanceCheckingResultView;
	}

	public ResultTextView(XOCLog log, OCBCModel model, String[] stringResult, ConformanceCheckingResultView conformanceCheckingResultView) {
		this.conformanceCheckingResultView = conformanceCheckingResultView;
		int resultNum = stringResult.length;
		
		setOpaque(false);
		setBorder(BorderFactory.createEmptyBorder());
		setLayout(new BorderLayout());	
		SlickerTabbedPane multiplePane = new SlickerTabbedPane("", new Color(240, 240, 240, 230), new Color(0, 0, 0, 230),
				new Color(220, 220, 220, 150));
		textPane = new JPanel(new GridLayout(1,resultNum));
		for(int i=0; i<resultNum; i++){
			JTextArea text = new JTextArea(stringResult[i]);
			textPane.add(text);
		}

		ParameterPanel parameterPanel = conformanceCheckingResultView.getParameterPanel();

//		long uint = 1;	
//		long startTime = System.currentTimeMillis(); 
//		long durationTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("validityPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		OMValidityPanel validityPanel = new OMValidityPanel(this, log, model);	
//		multiplePane.addTab("validity", validityPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("validityPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~validityPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("fulfilmentPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		FulfilmentPanel fulfilmentPanel = new FulfilmentPanel(this, log, model);
//		multiplePane.addTab("fulfilment", fulfilmentPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("fulfilmentPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~fulfilmentPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("activityExistencePanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		ActivityExistencePanel activityExistencePanel = new ActivityExistencePanel(this, log, model);
//		multiplePane.addTab("activity existence", activityExistencePanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("activityExistencePanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~activityExistencePanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("objectExistencePanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		ObjectExistencePanel objectExistencePanel = new ObjectExistencePanel(this, log, model);
//		multiplePane.addTab("object existence", objectExistencePanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("objectExistencePanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~objectExistencePanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("properClassesPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		ProperClassesPanel properClassesPanel = new ProperClassesPanel(this, log, model);
//		multiplePane.addTab("proper classes", properClassesPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("properClassesPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~properClassesPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("eventNumberPerObjectPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		EventNumberPerObjectPanel eventNumberPerObjectPanel = new EventNumberPerObjectPanel(this, log, model);
//		multiplePane.addTab("events per object", eventNumberPerObjectPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("eventNumberPerObjectPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~eventNumberPerObjectPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("objectNumberPerEventPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		ObjectNumberPerEventPanel objectNumberPerEventPanel = new ObjectNumberPerEventPanel(this, log, model);
//		multiplePane.addTab("objects per event", objectNumberPerEventPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("objectNumberPerEventPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~objectNumberPerEventPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		
//		RunningTime.writeTimeInformationIntoFile("bebavioralConstraintsPanel start time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");		
//		BebavioralConstraintsPanel bebavioralConstraintsPanel = new BebavioralConstraintsPanel(this, log, model);
//		multiplePane.addTab("behavioral constraints", bebavioralConstraintsPanel);
//		durationTime = (System.currentTimeMillis() - startTime)/uint;
//		startTime = System.currentTimeMillis();
//		RunningTime.writeTimeInformationIntoFile("bebavioralConstraintsPanel end time: " + System.currentTimeMillis()/uint, false, "D:\\timeConformanceChecking.txt");
//		RunningTime.writeTimeInformationIntoFile("~~~~~~~~~~~~~~bebavioralConstraintsPanel duration time: " + durationTime, false, "D:\\timeConformanceChecking.txt");
//		

		
//		if(parameterPanel.getValidityOfObjectModelSelectionFlag()){
		//if a panel contains deviations, its name is highlighted with a flag of star (i.e., "*")
		String deviatingFlag = "";
		if(conformanceCheckingResultView.getObjectModelValidityCheckerSwitch()){
			OMValidityPanel validityPanel = new OMValidityPanel(this, log, model);	
			deviatingFlag = "";
			if(!validityPanel.getDeviatingEventList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("validity" + deviatingFlag, validityPanel);
		}
//		if(parameterPanel.getFulfilmentSelectionFlag()){
		if(conformanceCheckingResultView.getFulfilmentCheckerSwitch()){
			FulfilmentPanel fulfilmentPanel = new FulfilmentPanel(this, log, model);
			deviatingFlag = "";
			if(!fulfilmentPanel.getViolatedClassRelationList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("fulfilment" + deviatingFlag, fulfilmentPanel);
		}
//		if(parameterPanel.getMonotonicitySelectionFlag()){
		if(conformanceCheckingResultView.getMonotonicityCheckerSwitch()){
			MonotonicityPanel monotonicityPanelPanel = new MonotonicityPanel(this, log, model);
			deviatingFlag = "";
			if(!monotonicityPanelPanel.getDisappearedObjectList().isEmpty() || !monotonicityPanelPanel.getClassChangedObjectList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("monotonicity" + deviatingFlag, monotonicityPanelPanel);
		}
//		if(parameterPanel.getActivityExistenceSelectionFlag()){
		if(conformanceCheckingResultView.getActivityExistenceCheckerSwitch()){
			ActivityExistencePanel activityExistencePanel = new ActivityExistencePanel(this, log, model);
			deviatingFlag = "";
			if(!activityExistencePanel.getDeviatingEventList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("activity existence" + deviatingFlag, activityExistencePanel);
		}
//		if(parameterPanel.getObjectExistenceSelectionFlag()){
		if(conformanceCheckingResultView.getObjectExistenceCheckerSwitch()){
			ObjectExistencePanel objectExistencePanel = new ObjectExistencePanel(this, log, model);
			deviatingFlag = "";
			if(!objectExistencePanel.getDeviatingEventList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("object existence" + deviatingFlag, objectExistencePanel);
		}
//		if(parameterPanel.getProperClassesSelectionFlag()){
		if(conformanceCheckingResultView.getProperClassesCheckerSwitch()){
			ProperClassesPanel properClassesPanel = new ProperClassesPanel(this, log, model);
			deviatingFlag = "";
			if(!properClassesPanel.getDeviatingEventList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("proper classes" + deviatingFlag, properClassesPanel);
		}
//		if(parameterPanel.getEventsPerObjectSelectionFlag()){
		if(conformanceCheckingResultView.getEventNumberPerObjectCheckerSwitch()){
			EventNumberPerObjectPanel eventNumberPerObjectPanel = new EventNumberPerObjectPanel(this, log, model);
			deviatingFlag = "";
			if(!eventNumberPerObjectPanel.getViolatedAOCRelationList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("events per object" + deviatingFlag, eventNumberPerObjectPanel);
		}
//		if(parameterPanel.getObjectsPerEventSelectionFlag()){
		if(conformanceCheckingResultView.getObjectNumberPerEventCheckerSwitch()){
			ObjectNumberPerEventPanel objectNumberPerEventPanel = new ObjectNumberPerEventPanel(this, log, model);
			deviatingFlag = "";
			if(!objectNumberPerEventPanel.getViolatedAOCRelationList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("objects per event" + deviatingFlag, objectNumberPerEventPanel);
		}
//		if(parameterPanel.getBehavioralConstraintsSelectionFlag()){
		if(conformanceCheckingResultView.getBehavioralConstraintsCheckerSwitch()){
			BebavioralConstraintsPanel bebavioralConstraintsPanel = new BebavioralConstraintsPanel(this, log, model);	
			deviatingFlag = "";
			if(!bebavioralConstraintsPanel.getViolatedBehavioralConstraintList().isEmpty()){
				deviatingFlag = "*";
			}
			multiplePane.addTab("behavioral constraints" + deviatingFlag, bebavioralConstraintsPanel);
		}
		
		this.add(multiplePane);
	}

	public void updateVisualization(boolean logChanged, boolean tagsChanged) {
		
//		logPreviewUI.updateVisualization(logChanged, tagsChanged);
//		logViewUI.updateVisualization(logChanged, tagsChanged);
	}
}
