package org.processmining.ocbc.discovery.filter;

import java.util.ArrayList;
import java.util.List;

import org.processmining.framework.util.Pair;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.OCBCModel;

public class SimplifyModel {
	private OCBCModel model;
	private FilterFunction filter = new  FilterFunction();
	private List<String> overlappingActivityEdgeIds = new ArrayList<String>();
	public SimplifyModel(OCBCModel model){
		this.model = model;
	}
	

	public void filterTransitiveActicityEdges(){
//			List<Pair<ActivityNode, ActivityNode>> OneToOneActivityPair = new ArrayList<Pair<ActivityNode, ActivityNode>>();
		List<Pair<String, String>> OneToOneActivityPair = new ArrayList<Pair<String, String>>();
		for(ActivityNode activityNodeBefore : model.getAllActivities()){
			for(ActivityNode activityNodeAfter : model.getAllActivities()){
				if(!activityNodeBefore.equals(activityNodeAfter)){
					List<ActivityEdge> unaryResponseEdges = filter.filterActivityRelations(model.getAllActivityRelations(), activityNodeBefore.getID().toString(),
							activityNodeAfter.getID().toString(), mxConstants.UNARYRESPONSE);
					List<ActivityEdge> unaryPrecedenceEdges = filter.filterActivityRelations(model.getAllActivityRelations(), activityNodeAfter.getID().toString(),
							activityNodeBefore.getID().toString(), mxConstants.UNARYPRECEDENCE);
					if(unaryResponseEdges.size() == 1 && unaryPrecedenceEdges.size() == 1){
						OneToOneActivityPair.add(new Pair<String, String>(activityNodeBefore.getID().toString(), activityNodeAfter.getID().toString()));
					}
				}
			}
		}
		
		for(Pair<String, String> sequentialActivityPair : model.getSequentialActivityPairList()){
			 System.out.printf("\n a new pair");
			System.out.printf("\n first" + sequentialActivityPair.getFirst());
			System.out.printf("\n second" + sequentialActivityPair.getSecond());
		}
		
		 System.out.printf("\n size of OneToOneActivityPair" + OneToOneActivityPair.size());
		
		 for(ActivityNode activityNode : model.getAllActivities()){
			 //consider the activity node as the soruce node
			 List<ActivityEdge> relatedEdgesSource = filter.filterActivityRelations(model.getAllActivityRelations(), activityNode.getID().toString(),
						null, null);
			 //check if there are overlapping edges for one activity
			 for(ActivityEdge activityEdgeFirst : relatedEdgesSource){
				 for(ActivityEdge activityEdgeSecond : relatedEdgesSource){
					 //the two edges are not the same one edge
					 if(!activityEdgeFirst.equals(activityEdgeSecond)){
						 //if the types of two edges are the same
						 if(activityEdgeFirst.getCardinalityType().equals(activityEdgeSecond.getCardinalityType())){
							 ActivityNode firstNode = activityEdgeFirst.getTargetNode();
							 ActivityNode secondNode = activityEdgeSecond.getTargetNode();
							 //check the two nodes are one-to-one activity pair
							 for(Pair<String, String> activityPair : OneToOneActivityPair){
								 if(activityPair.getFirst().equals(firstNode.getID().toString()) &&
										 activityPair.getSecond().equals(secondNode.getID().toString())){
									 Pair<String, String> sequentialActivityPair = new Pair<String, String>(activityNode.getID().toString(), firstNode.getID().toString());
									 //if the activityNode happens before the activityPair
									 if(model.getSequentialActivityPairList().contains(sequentialActivityPair))
										 overlappingActivityEdgeIds.add(activityEdgeSecond.getID());
									 else
										 overlappingActivityEdgeIds.add(activityEdgeFirst.getID());
								 }
							 } 
						 }					 
					 }
				 }
			 }
			 
			 //consider the activity node as the target node
			 List<ActivityEdge> relatedEdgesTarget = filter.filterActivityRelations(model.getAllActivityRelations(), null,
						activityNode.getID().toString(), null);
			 //check if there are overlapping edges for one activity
			 for(ActivityEdge activityEdgeFirst : relatedEdgesTarget){
				 for(ActivityEdge activityEdgeSecond : relatedEdgesTarget){
					//the two edges are not the same one edge
					 if(!activityEdgeFirst.equals(activityEdgeSecond)){
						 //if the types of two edges are the same
						 if(activityEdgeFirst.getCardinalityType().equals(activityEdgeSecond.getCardinalityType())){
							 ActivityNode firstNode = activityEdgeFirst.getReferenceNode();
							 ActivityNode secondNode = activityEdgeSecond.getReferenceNode();
							 //check the two nodes are one-to-one activity pair
							 for(Pair<String, String> activityPair : OneToOneActivityPair){
								 if(activityPair.getFirst().equals(firstNode.getID().toString()) &&
										 activityPair.getSecond().equals(secondNode.getID().toString())){
									 Pair<String, String> sequentialActivityPair = new Pair<String, String>(activityNode.getID().toString(), firstNode.getID().toString());
									 //if the activityNode happens before the activityPair
									 if(model.getSequentialActivityPairList().contains(sequentialActivityPair))
										 overlappingActivityEdgeIds.add(activityEdgeSecond.getID());
									 else
										 overlappingActivityEdgeIds.add(activityEdgeFirst.getID());
								 }
							 }
						 }
					 }
				 }
			 }
			 System.out.printf("\n size of overlappingActivityEdges" + overlappingActivityEdgeIds.size());
		 }
		 
		for(String activityEdgeId : overlappingActivityEdgeIds){
//			model.removeModelActivityEdge(activityEdgeId);
		}		
		model.setTransitiveRelationIdList(overlappingActivityEdgeIds);
	}

	public List<String> getTransitiveActivityRelationIdList(){
		return overlappingActivityEdgeIds;
	}
	
    public static void main(String[] args) throws Exception {
  
    }
}