package org.processmining.ocbc.discovery.metrics;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.discovery.filter.FilterFunction;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.visualization.ModelLayoutBuilder;


public class BehaviorConstraintComplex {
	protected ActivityNode referenceActivityNode;
	protected ActivityNode targetActivityNode;
	protected List<ClassNode> classNodeList = new ArrayList<ClassNode>();
	protected List<AOCEdge> aOCRelationList = new ArrayList<AOCEdge>();
	protected List<ActivityEdge> activityRelationList = new ArrayList<ActivityEdge>();
	
	private XOCLog log;
	private ModelLayoutBuilder builder;
	private Map<String, String> nodeNameVSNodeId;
	
	private FilterFunction filter = new  FilterFunction();
	private Map<String, Map<String, List<String>>> activityEdgeVSEventVSPrecedenceEventList = new HashMap<String, Map<String, List<String>>>();
	private Map<String, Map<String, List<String>>> activityEdgeVSEventVSResponseEventList = new HashMap<String, Map<String, List<String>>>();
	private Map<String, Map<String, Map<String, List<String>>>> refActivityVSTarActivityVSTypeVSConstraintList = new HashMap<String, Map<String, Map<String, List<String>>>>();
	private List<String> brotherRelationIdList = new ArrayList<String>();
	private Integer idCounter;
	
	public BehaviorConstraintComplex(){
	}
	
	public ActivityNode getReferenceActivity(){
		return referenceActivityNode;
	}
	
	public void setReferenceActivity(ActivityNode referenceActivityNode){
		this.referenceActivityNode = referenceActivityNode;
	}
	
	public ActivityNode getTargetActivity(){
		return targetActivityNode;
	}
	
	public void setTargetActivity(ActivityNode targetActivityNode){
		this.targetActivityNode = targetActivityNode;
	}	
    
	public List<ClassNode> getClassNodeList(){
		return classNodeList;
	}
	
	public List<AOCEdge> getAOCRelationList(){
		return aOCRelationList;
	}
	
	public List<ActivityEdge> getActivityRelationList(){
		return activityRelationList;
	}
	

	
    public static void main(String[] args) throws Exception {
    	  
    }

}