package org.processmining.ocbc.discovery.metrics;

public class PrecisionFormular {
	
	/*
	 * average: the average of instances of variants
	 * instanceNum: the number of instances of one variant
	 */
	public static double computeVariantPrecision(double average, double instanceNum){
		double variantPrecision = 0;
		
//		double denominator = Math.pow(instanceNum + 1, 2)/average + 1;
//		variantPrecision = 1 - 1/denominator;
//		return variantPrecision;
		
//		double k = 0.3;
//		double variantPrecision = 0;
//		double firstPart = 1 - (1/(1 + (instanceNum + 1)/average));
//		variantPrecision = firstPart*(1-k/(instanceNum + 1));
//		
//		return variantPrecision;
		double relativeParameter = 4.0;
		double averageParameter = 5;
		double relativeValue = (instanceNum + 1)/(average+1);
		double relativePart = 1- Math.pow(Math.E, -relativeParameter*relativeValue);
//		double averagePart = 1- Math.pow(Math.E, -averageParameter*average);
		double averagePart = 1- Math.pow(Math.E, -averageParameter*instanceNum);
		
//		for(x=0; x<10; x = x + 0.5){
//			double denominator = 1- Math.pow(Math.E, -k*x);
//			System.out.println("the value " + x + " of denominator: " + denominator);
//		}
		variantPrecision = relativePart*averagePart;
		return variantPrecision;
	}
	
	public static void main(String[] args) throws Exception{  		
		double maximalNumber = 10000;
		int maximalTypeNumber = 9;
//		System.out.println("λ1：" + "e");
//		System.out.println("σ1：" + "e");
		for(int k=0; k<100; k++){
			System.out.println("****************************");
			Integer num[] = new Integer[(int) (Math.random()*maximalTypeNumber) + 1];
			for(int j=0; j< num.length; j++){
				num[j] = 0;
			}
			for(int j=0; j< num.length; j++){
				
				num[j] = (int) (Math.random()*maximalNumber);
				System.out.println("model: " + num.length + ";");
				System.out.print("log:");
				for(int i=0; i< num.length; i++){
//					System.out.print("num" + i + ":" + num[i]);
					if(i == num.length-1){
						System.out.print(num[i] + ";");
					}
					else{
						System.out.print(num[i] + ",");
					}					
				}		
				System.out.println("");
				
				double average = 0;
				double sum = 0;
				double precision = 0;
				
				for(int i=0; i< num.length; i++){
					sum = sum + num[i];
				}
				average = sum / num.length;
				
//				double product = 1; 
//				for(int i=0; i< num.length; i++){
//					product = product*num[i];
//				}
//				average = Math.pow(product,1.0/num.length);
				
				
//				System.out.println("average: " + average);
				
				for(int i=0; i< num.length; i++){
					
					precision = precision + computeVariantPrecision(average, num[i]);
//					System.out.println("precision in process: " + precision);
					
				}
				double variantNum = num.length;
				precision = precision/variantNum;
				System.out.println("precision: " + precision);	
				if(j != num.length-1){
					System.out.println("----------------------------");
				}				
			}
		}		
    }		
}
