package org.processmining.ocbc.discovery.metrics;

public class ProbabilityFunction {

    /**
     * n的阶乘
     * @param n 要计算的阶
     * @return n!
     */
    public static double computeFactorial(int n){
        if(1==n || 0==n)
            return 1;
        else
            return n*computeFactorial(n-1);
    }
    
    /**
     * compute m*(m+1)*...*n where n>=m
     * @param m start value
     * @param n end value
     * @return m*(m+1)*...*n
     */
    public static double computeContinuousProduct(int n, int m){
    	double product = 1; 
    	if(m == 0){
    		m = 1;
    	}
    	for(int i=0; i<=n-m; i++){
    		product = product*(m+i);
    	}
        return product;
    }
    
    /**
     * 组合数
     * @param n 总个数，C的下标
     * @param m 要选取的个数，C的上标
     * @return  n!/(n-m)!m! where n>m
     * */
    public static double computeCombination(int n,int m){   
//    	System.out.println("");
//    	System.out.println("n: " + n);
//    	System.out.println("m: " + m);
//    	System.out.println("computeFactorial(m): " + computeFactorial(m));
//    	System.out.println("computeFactorial(n-m): " + computeFactorial(n-m));
    	
        return computeFactorial(n)/(computeFactorial(m)*computeFactorial(n-m));
        
//    	System.out.println("computeContinuousProduct(n,m): " + computeContinuousProduct(n,m));
//    	System.out.println("computeFactorial(n-m): " + computeFactorial(n-m));
//    	return computeContinuousProduct(n,m)/computeContinuousProduct(n-m,1);
    	
//    	double product = 1;
//    	for(int k=0; k<n; k++){
//    		if(n-k>=m && n-m-k>=1){
//    			product = product*((n-k)/(n-m-k));
//    		}
//    		else if(n-k<m && n-m-k>=1){
//    			product = product*(1/(n-m-k));
//    		}
//    		else if(n-k>=m && n-m-k<1){
//    			product = product*(n-k);
//    		}
//    	}
//    	
//    	return product;
    }
    
    /**
     * 排列数
     * @param n 总个数，A的下标
     * @param m 要排列的个数，A的上标
     * @return  n!/(n-m)!
     * */
    public static double computePermutation(int n,int m){
        return computeFactorial(n)/computeFactorial(n-m);
    }
    
    public static void main(String[] str){
    	System.out.println("computeCombination(3,1): " + computeCombination(3,1));
    }
}