package org.processmining.ocbc.discovery.metrics;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ClassNode;


public class XOCCase {
	//a uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classNodeId
	//b uit: use a combination as the id: sourceActivityNodeId + "-" + activityRelationId + "-" + targetActivityNodeId + "-" + classRelationId
	protected String id;
	protected String referenceActivityName;
	protected String targetActivityName;
	protected XOCEvent referenceEvent;
	protected List<XOCEvent> precedenceTargetEventList = new ArrayList<XOCEvent>();	
	protected List<XOCEvent> responseTargetEventList = new ArrayList<XOCEvent>();	
	
	protected List<ClassNode> classNodeList = new ArrayList<ClassNode>();	
	protected List<AOCEdge> aOCRelationList = new ArrayList<AOCEdge>();
	protected int typeFlag;//0: oc; 1: rt

	protected String classRelationId;	
	
	public XOCCase(){
	}
	
	public void setId(String id){
		this.id = id;
	}
	
	public String getId(){
		return id;
	}
	
	public String getReferenceActivityName(){
		return referenceActivityName;
	}
	
	public void setReferenceActivityName(String referenceActivityName){
		this.referenceActivityName = referenceActivityName;
	}
	
	public String getTargetActivityName(){
		return targetActivityName;
	}
	
	public void setTargetActivityName(String targetActivityName){
		this.targetActivityName = targetActivityName;
	}	
    
	public List<ClassNode> getClassNodeList(){
		return classNodeList;
	}
	
	public List<AOCEdge> getAOCRelationList(){
		return aOCRelationList;
	}
	
	public List<XOCEvent> getResponseTargetEventList(){
		return responseTargetEventList;
	}	
	
	public void setResponseTargetEventList(List<XOCEvent> responseTargetEventList){
		this.responseTargetEventList = responseTargetEventList;
	}
	
	public List<XOCEvent> getPrecedenceTargetEventList(){
		return precedenceTargetEventList;
	}	
	
	public void setPrecedenceTargetEventList(List<XOCEvent> precedenceTargetEventList){
		this.precedenceTargetEventList = precedenceTargetEventList;
	}
	
	public String getClassRelationId(){
		return classRelationId;
	}
	
	public void setClassRelationId(String classRelationId){
		this.classRelationId = classRelationId;
	}
	
	public int getType(){
		return typeFlag;
	}
	
	public void setType(int typeFlag){
		this.typeFlag = typeFlag;
	}
	
    public static void main(String[] args) throws Exception {
    	  
    }

}