package org.processmining.ocbc.discovery.metrics;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import org.processmining.mxgraph.examples.swing.io.TransformToOCBCSemanticModel;
import org.processmining.mxgraph.io.mxCodec;
import org.processmining.mxgraph.util.mxXmlUtils;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.plugins.OCBCEditorConstants;
import org.processmining.ocbc.models.io.ImportFromFile;
import org.processmining.ocbc.models.visualization.cell.MNodeCell;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;
import org.w3c.dom.Document;


public class getImplicitConstraintsForFamily {
	private OCBCUnitFamily family;
	private Map<String, OCBCUnitFamily> idVSUnitFamily = new HashMap<String, OCBCUnitFamily>();
	private List<String> pathList = new ArrayList<String>();
	public getImplicitConstraintsForFamily(OCBCUnitFamily family, Map<String, OCBCUnitFamily> idVSUnitFamily){
		this.family = family;
		this.idVSUnitFamily = idVSUnitFamily;
	}
	
	public List<String> getPathList(){
		return pathList;		
	}
	

//	public List<String> transformPathIntoConstraintList(String ){
//		
//	}


	
    public static void main(String[] args) throws Exception {
		   FileInputStream input = new FileInputStream("D:\\path.ocbcmml");
//			InputStream inputStream = new FileInputStream("d:/123.ocbcmml");
			
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			byte[] buffer = new byte[1024];
			int len;
			while ((len = input.read(buffer)) > -1 ) {
			    baos.write(buffer, 0, len);
			}
			baos.flush();

			// Open new InputStreams using the recorded bytes
			// Can be repeated as many times as you wish
			InputStream inputA = new ByteArrayInputStream(baos.toByteArray()); 
			InputStream inputB = new ByteArrayInputStream(baos.toByteArray()); 
			
	        Scanner scanner = new Scanner(inputA, "UTF-8");
	        String fileString = scanner.useDelimiter("\\A").next();
	        scanner.close();
	        
	        String versionString = fileString.split("\n")[0];
			String versionName = versionString.split("\"")[1];
			String removeVersion = fileString.substring(fileString.indexOf('\n')+1);
			System.out.println("model file: " + removeVersion);
			
			OCBCModel model = null;
			if(versionName.equals(OCBCEditorConstants.VERSION2_0)){
				mxGraph graphX = new mxGraph();
				Document document = mxXmlUtils.parseXml(removeVersion);
				
				mxCodec codec = new mxCodec(document);
				codec.decode(document.getDocumentElement(), graphX.getModel());
				
				System.out.println("version 2");
				TransformToOCBCSemanticModel transformer = new TransformToOCBCSemanticModel();
				transformer.transform(graphX);
				model = transformer.getModel();
				model.setGraphX(graphX);
				model.setModelFile(mxXmlUtils.parseXml(removeVersion));
				model.setModelVersion(OCBCEditorConstants.VERSION2_0);
			}
			else{
				
				ImportFromFile fileParse = new ImportFromFile();       
		        fileParse.parse(inputB);
		        model = fileParse.getModel();
		        model.setModelVersion(OCBCEditorConstants.VERSION1_0);
		        int i=0;
		        for(MyOriginalCell cell : model.getGraphCells()){
		        	i++;
		        	System.out.println("cell number" + i);
		        	if(cell instanceof MNodeCell){
		 //       		System.out.println("cell name" + cell.getUserObject().toString());
		 //       		System.out.println("number of related edges" + model.getRelatedEdgeCellsForOneCell(cell).size());
		        	}
		        }
			}			
	      
//	        for(ActivityEdge activityEdge : model.getAllActivityRelations()){
//	        	System.out.println("\n activityEdge id: " + activityEdge.getID());
//	        	System.out.println("\n activityEdge name: " + activityEdge.getCardinalityType());
//	        }   
//	        
//	        for(CrelRTEdge edge : model.getAllCrelRTRelations()){
//	        	System.out.println("\n CrelRTEdge id: " + edge.getID());
//	        	System.out.println("\n CrelRTEdge name: " + edge.getRelatedActivityRelation().getID());
//
//	        }
//	        
//	        for(CrelOCEdge edge : model.getAllCrelOCRelations()){
//	        	System.out.println("\n CrelOCEdge id: " + edge.getID());
//	        	System.out.println("\n CrelOCEdge name: " + edge.getRelatedActivityRelation().getID());
//
//	        }
	        SearchOCBCUnitFamily searchOCBCUnitFamily = new SearchOCBCUnitFamily(model);
	        Map<String, OCBCUnitFamily> idVSUnitFamily = searchOCBCUnitFamily.getIdVSUnitFamily();
	        List<OCBCUnitFamily> familyList = searchOCBCUnitFamily.search();
	        
	        System.out.println("\n ***********************");
	        System.out.println("\n family size: " + idVSUnitFamily.size());
	        
	        for(String familyId : idVSUnitFamily.keySet()){
	        	System.out.println("\n ***********************");
	        	OCBCUnitFamily family = idVSUnitFamily.get(familyId);
	        	System.out.println("\n familyId: " + familyId);
	        	System.out.println("\n family reference id: " + family.getReferenceActivity().getID());
	        	System.out.println("\n family reference name: " + family.getReferenceActivity().getNodeName());
	        	System.out.println("\n family target id: " + family.getTargetActivity().getID());
	        	System.out.println("\n family target name: " + family.getTargetActivity().getNodeName());
	        	System.out.println("\n family type: " + family.getType());
	        	for(String unitId : family.getIdVSUnit().keySet()){
	        		OCBCUnit unit = family.getIdVSUnit().get(unitId);
	        		System.out.println("\n unitId: " + unit.getId());
	        		System.out.println("\n getCardinalityType: " + unit.getActivityRelation().getCardinalityType());
	        	}
	        	System.out.println("\n **********path*************");
	        	getImplicitConstraintsForFamily searchPath = new getImplicitConstraintsForFamily(family, idVSUnitFamily);
//	        	List<String> pathList = searchPath.searchForFamilyA();
//	        	for(String path : pathList){
//	        		System.out.println("\n path: " + path);
//	        	}
	        }

//	        for(String familyId : idVSUnitFamily.keySet()){
//	        	System.out.println("\n ***********************");
//	        	OCBCUnitFamily family = idVSUnitFamily.get(familyId);
////	        	System.out.println("\n familyId: " + familyId);
////	        	System.out.println("\n family reference id: " + family.getReferenceActivity().getID());
////	        	System.out.println("\n family reference name: " + family.getReferenceActivity().getNodeName());
////	        	System.out.println("\n family target id: " + family.getTargetActivity().getID());
////	        	System.out.println("\n family target name: " + family.getTargetActivity().getNodeName());
////	        	System.out.println("\n family type: " + family.getType());
////	        	for(String unitId : family.getIdVSUnit().keySet()){
////	        		OCBCUnit unit = family.getIdVSUnit().get(unitId);
////	        		System.out.println("\n unitId: " + unit.getId());
////	        		System.out.println("\n getCardinalityType: " + unit.getActivityRelation().getCardinalityType());
////	        	}
//	        	
//	        	SearchPathListForFamily searchPath = new SearchPathListForFamily(family, idVSUnitFamily);
//	        	List<String> pathList = searchPath.search();
//	        	for(String path : pathList){
//	        		System.out.println("\n path: " + path);
//	        	}
//	        }
    }
}