package org.processmining.ocbc.discovery.metricscalculator;
 
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.discovery.metrics.MetricFormular;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class MetricsCalculator extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private JComboBox<String> clickNameBox = new JComboBox<String>();

    private JButton calculateButton = new JButton("calculate");
    
    private JComboBox<String> fitnessApproachBox = new JComboBox<String>();
    private JComboBox<String> precisionApproachBox = new JComboBox<String>();
    private JComboBox<String> generalizationApproachBox = new JComboBox<String>();
    
    private JTextField fitnessThreshold = new JTextField("0");
    private JTextField precisionThreshold = new JTextField("0");
    private JTextField generalizationThreshold = new JTextField("0");
    
    private JLabel fitnessResult = new JLabel("0");
    private JLabel precisionResult = new JLabel("0");
    private JLabel generalizationResult = new JLabel("0");
    
    private JLabel fitnessType = new JLabel("fitness");
    private JLabel precisionType = new JLabel("precision");
    private JLabel generalizationType = new JLabel("generalization");
    
    private JLabel metricTypeLable = new JLabel("metric type:   ");
    private JLabel approachLable = new JLabel("approach:   ");
    private JLabel thresholdLable = new JLabel("threshold:   ");
    private JLabel resultLable = new JLabel("result:   ");
    
    private List<JTextField> numberList = new ArrayList<JTextField>();
    private List<JCheckBox> selectionFlagList = new ArrayList<JCheckBox>();

    private String selectedFitnessApproach = "fitness1";
    private String selectedPrecisionApproach = "precision1";
    private String selectedGeneralizationApproach = "generalization1";
    
    double fitnessThresholdValue;
    double precisionThresholdValue;
    double generalizationThresholdValue;
    
    public MetricsCalculator() {
		
    	calculateButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				//read approach selection
				selectedFitnessApproach = (String) fitnessApproachBox.getSelectedItem();
				selectedPrecisionApproach = (String) precisionApproachBox.getSelectedItem();
				selectedGeneralizationApproach = (String) generalizationApproachBox.getSelectedItem();
				//read threshold input
				fitnessThresholdValue = Double.parseDouble(fitnessThreshold.getText());
				precisionThresholdValue = Double.parseDouble(precisionThreshold.getText());
				generalizationThresholdValue = Double.parseDouble(generalizationThreshold.getText());
				//read variant selection and number input
				boolean[] model = new boolean[9];
				double[] log = new double[9];
				for(int i=0; i<9; i++){
					JCheckBox selectFlag = selectionFlagList.get(i);
					if(selectFlag.isSelected()){
						model[i] = true;
					}
					else{
						model[i] = false;
					}
					JTextField numberText = numberList.get(i);
					log[i] = Double.parseDouble(numberText.getText());
					
					System.out.println("index: " + i);
					System.out.println("model[i]" + model[i]);
					System.out.println("log[i]" + log[i]);
				}
				System.out.println("selectedFitnessApproach: " + selectedFitnessApproach);
				System.out.println("selectedPrecisionApproach: " + selectedPrecisionApproach);
				System.out.println("selectedGeneralizationApproach: " + selectedGeneralizationApproach);
				
				System.out.println("fitnessThresholdValue: " + fitnessThresholdValue);
				System.out.println("precisionThresholdValue: " + precisionThresholdValue);
				System.out.println("generalizationThresholdValue: " + generalizationThresholdValue);
				
				//calculate metrics
				MetricFormular computingMetrics = new MetricFormular();
				double fitness = 0;
				double precision = 0;
				double generalization = 0;
				if(selectedFitnessApproach.equals("fitness1")){
					fitness = computingMetrics.computeFitnessBasic(9, model, log);
					System.out.println("fitness1: " + fitness);
				}
				else if(selectedFitnessApproach.equals("fitness2")){
					fitness = computingMetrics.computeFitnessWithNumThreshold(9, model, log, (int) fitnessThresholdValue);
					System.out.println("fitness2: " + fitness);
				}
				else if(selectedFitnessApproach.equals("fitness3")){
					fitness = computingMetrics.computeFitnessWithRatioThreshold(9, model, log, fitnessThresholdValue);
					System.out.println("fitness3: " + fitness);
				}
				else if(selectedFitnessApproach.equals("fitness4")){
					fitness = computingMetrics.computeFitnessHalfWithNumThreshold(9, model, log, (int) fitnessThresholdValue);
					System.out.println("fitness4: " + fitness);
				}
				
				if(selectedPrecisionApproach.equals("precision1")){
					precision = computingMetrics.computePrecisionWithNumThreshold(9, model, log, (int) precisionThresholdValue);
					System.out.println("precision1: " + precision);
				}
				else if(selectedPrecisionApproach.equals("precision2")){
					precision = computingMetrics.computePrecisionWithRatioThreshold(9, model, log, precisionThresholdValue);
					System.out.println("precision2: " + precision);
				}
				else if(selectedPrecisionApproach.equals("precision3")){
					precision = computingMetrics.computePrecisionWithEntropy(9, model, log);
					System.out.println("precision3: " + precision);
				}
								
				if(selectedGeneralizationApproach.equals("generalization1")){
					generalization = computingMetrics.computeGeneralizationForModelAndLog(generalizationThresholdValue, 9, model, log, mxConstants.generalizationAlgorithmBinomialDistribution);
					System.out.println("generalization1: " + generalization);
				}
				
				//output metrics
			    fitnessResult.setText(fitness + "");
			    precisionResult.setText(precision + "");
			    generalizationResult.setText(generalization + "");
			}
		});
    	
        
        JPanel metricTypeApproachPanel = new JPanel();
        metricTypeApproachPanel.setLayout(new GridLayout(1,3));       
        metricTypeApproachPanel.add(metricTypeLable);
        metricTypeApproachPanel.add(fitnessType);
        metricTypeApproachPanel.add(precisionType);
        metricTypeApproachPanel.add(generalizationType);
        metricTypeApproachPanel.setMaximumSize(new Dimension(800,20));
        
        JPanel selectMetricApproachPanel = new JPanel();
        selectMetricApproachPanel.setLayout(new BoxLayout(selectMetricApproachPanel, BoxLayout.X_AXIS));       
        selectMetricApproachPanel.add(approachLable);
        selectMetricApproachPanel.add(fitnessApproachBox);
        selectMetricApproachPanel.add(precisionApproachBox);
        selectMetricApproachPanel.add(generalizationApproachBox);
        selectMetricApproachPanel.setMaximumSize(new Dimension(800,20));
        fitnessApproachBox.addItem("fitness1");
        fitnessApproachBox.addItem("fitness2");
        fitnessApproachBox.addItem("fitness3");
        fitnessApproachBox.addItem("fitness4");
        precisionApproachBox.addItem("precision1");
        precisionApproachBox.addItem("precision2");
        precisionApproachBox.addItem("precision3");
        generalizationApproachBox.addItem("generalization1");
       
        JPanel inputThresholdPanel = new JPanel();
        inputThresholdPanel.setLayout(new BoxLayout(inputThresholdPanel, BoxLayout.X_AXIS));
        inputThresholdPanel.add(thresholdLable);
        inputThresholdPanel.add(fitnessThreshold);
        inputThresholdPanel.add(precisionThreshold);
        inputThresholdPanel.add(generalizationThreshold);
        inputThresholdPanel.setMaximumSize(new Dimension(800,20));
        
        JPanel resultPanel = new JPanel();
        resultPanel.setLayout(new GridLayout(1,3));     
        resultPanel.add(resultLable);
        resultPanel.add(fitnessResult);
        resultPanel.add(precisionResult);
        resultPanel.add(generalizationResult);
        resultPanel.setMaximumSize(new Dimension(800,20));
        
        
        JPanel variantMatrixPanel = new JPanel();
        variantMatrixPanel.setLayout(new GridLayout(3,3));

        for(int row=0; row<3; row++){
        	 for(int column=0; column<3; column++){
        		 String labelValue = "(" + column + "," + row + ")";
//        		 if(column == 2){
//        			 labelValue = "(" + column + "," + row + ")";
//        		 }
        		 JLabel variantLabel = new JLabel(labelValue);
        		 
        		 
        		 JTextField numberInput = new JTextField();
        		 numberInput.setText("0");
        		 numberInput.setPreferredSize(new Dimension(50,20));
        		 numberList.add(numberInput);

        		 JCheckBox selectionFlag = new JCheckBox();
        		 selectionFlagList.add(selectionFlag);
        		 
        		
        		 
        		 JPanel variantLabelPanel = new JPanel();
        		 variantLabelPanel.add(variantLabel);
        		 JPanel inputPanel = new JPanel();
        		 inputPanel.add(numberInput);
        		 inputPanel.add(selectionFlag);
        		 
        		 JPanel variantPanel = new JPanel();
        		 variantPanel.setLayout(new BoxLayout(variantPanel, BoxLayout.Y_AXIS));
        		 variantPanel.add(variantLabelPanel);
        		 variantPanel.add(inputPanel);
//        		 variantPanel.setBorder(BorderFactory.createEtchedBorder());
        		 variantPanel.setBorder(BorderFactory.createLoweredBevelBorder());
        		 variantMatrixPanel.add(variantPanel);
             }
        }
        
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));


    	
    	this.add(metricTypeApproachPanel);

    	this.add(selectMetricApproachPanel);
    	this.add(inputThresholdPanel);
    	this.add(resultPanel);
    	this.add(variantMatrixPanel);
    	this.add(calculateButton);

    }
 
    public static void main(String[] args) throws Exception  
    {  
			 
    	MetricsCalculator calculator = new MetricsCalculator();
		JFrame frame = new JFrame();
//		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		frame.setSize(800, 500);
		frame.getContentPane().add(calculator);
		frame.setVisible(true);
		System.out.print("end");
    }
}

