package org.processmining.ocbc.discovery.metricscalculator;
 
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.processmining.mxgraph.util.mxConstants;
import org.processmining.ocbc.discovery.metrics.MetricFormular;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class MetricsCalculatorAllApproach extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private JComboBox<String> clickNameBox = new JComboBox<String>();

    private JButton calculateButton = new JButton("calculate");
    
//    private JComboBox<String> fitnessApproachBox = new JComboBox<String>();
//    private JComboBox<String> precisionApproachBox = new JComboBox<String>();
//    private JComboBox<String> generalizationApproachBox = new JComboBox<String>();
    private JLabel fitness1Label = new JLabel("fitness1");
    private JLabel fitness2Label = new JLabel("fitness2");
    private JLabel fitness3Label = new JLabel("fitness3");
    private JLabel fitness4Label = new JLabel("fitness4");
    private JLabel precision1Label = new JLabel("precision1");
    private JLabel precision2Label = new JLabel("precision2");
    private JLabel precision3Label = new JLabel("precision3");
    private JLabel generalization1Label = new JLabel("generalization1");

   
    private JTextField fitness1Threshold = new JTextField("0");
    private JTextField fitness2Threshold = new JTextField("0");
    private JTextField fitness3Threshold = new JTextField("0");
    private JTextField fitness4Threshold = new JTextField("0");
    private JTextField precision1Threshold = new JTextField("0");
    private JTextField precision2Threshold = new JTextField("0");
    private JTextField precision3Threshold = new JTextField("0");
    private JTextField generalization1Threshold = new JTextField("0");
    
    private JLabel fitness1Result = new JLabel("0");
    private JLabel fitness2Result = new JLabel("0");
    private JLabel fitness3Result = new JLabel("0");
    private JLabel fitness4Result = new JLabel("0");
    private JLabel precision1Result = new JLabel("0");
    private JLabel precision2Result = new JLabel("0");
    private JLabel precision3Result = new JLabel("0");
    private JLabel generalization1Result = new JLabel("0");
    
    private JLabel fitnessType = new JLabel("fitness");
    private JLabel precisionType = new JLabel("precision");
    private JLabel generalizationType = new JLabel("generalization");
    
    private JLabel metricTypeLable = new JLabel("metric type:   ");
    private JLabel approachLable = new JLabel("approach:   ");
    private JLabel thresholdLable = new JLabel("threshold:   ");
    private JLabel resultLable = new JLabel("result:   ");
    
    private List<JTextField> numberList = new ArrayList<JTextField>();
    private List<JCheckBox> selectionFlagList = new ArrayList<JCheckBox>();

    private String selectedFitnessApproach = "fitness1";
    private String selectedPrecisionApproach = "precision1";
    private String selectedGeneralizationApproach = "generalization1";
    
    double fitness2ThresholdValue;
    double fitness3ThresholdValue;
    double fitness4ThresholdValue; 
    double precision1ThresholdValue;
    double precision2ThresholdValue;
    double generalization1ThresholdValue;
    
    public MetricsCalculatorAllApproach() {
		
    	calculateButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				//read approach selection
//				selectedFitnessApproach = (String) fitnessApproachBox.getSelectedItem();
//				selectedPrecisionApproach = (String) precisionApproachBox.getSelectedItem();
//				selectedGeneralizationApproach = (String) generalizationApproachBox.getSelectedItem();
				//read threshold input
				fitness2ThresholdValue = Double.parseDouble(fitness2Threshold.getText());
				fitness3ThresholdValue = Double.parseDouble(fitness3Threshold.getText());
				fitness4ThresholdValue = Double.parseDouble(fitness4Threshold.getText());
				precision1ThresholdValue = Double.parseDouble(precision1Threshold.getText());
				precision2ThresholdValue = Double.parseDouble(precision2Threshold.getText());
				generalization1ThresholdValue = Double.parseDouble(generalization1Threshold.getText());
				//read variant selection and number input
				boolean[] model = new boolean[9];
				double[] log = new double[9];
				for(int i=0; i<9; i++){
					JCheckBox selectFlag = selectionFlagList.get(i);
					if(selectFlag.isSelected()){
						model[i] = true;
					}
					else{
						model[i] = false;
					}
					JTextField numberText = numberList.get(i);
					log[i] = Double.parseDouble(numberText.getText());
					
					System.out.println("index: " + i);
					System.out.println("model[i]" + model[i]);
					System.out.println("log[i]" + log[i]);
				}
//				System.out.println("selectedFitnessApproach: " + selectedFitnessApproach);
//				System.out.println("selectedPrecisionApproach: " + selectedPrecisionApproach);
//				System.out.println("selectedGeneralizationApproach: " + selectedGeneralizationApproach);
//				
//				System.out.println("fitnessThresholdValue: " + fitnessThresholdValue);
//				System.out.println("precisionThresholdValue: " + precisionThresholdValue);
//				System.out.println("generalizationThresholdValue: " + generalizationThresholdValue);
				
				//calculate metrics
				MetricFormular computingMetrics = new MetricFormular();
				double fitness1 = 0;
				double fitness2 = 0;
				double fitness3 = 0;
				double fitness4 = 0;
				double precision1 = 0;
				double precision2 = 0;
				double precision3 = 0;
				double generalization1 = 0;

				fitness1 = computingMetrics.computeFitnessBasic(9, model, log);
				System.out.println("fitness1: " + fitness1);
				fitness2 = computingMetrics.computeFitnessWithNumThreshold(9, model, log, (int) fitness2ThresholdValue);
				System.out.println("fitness2: " + fitness2);
				fitness3 = computingMetrics.computeFitnessWithRatioThreshold(9, model, log, fitness3ThresholdValue);
				System.out.println("fitness3: " + fitness3);
				fitness4 = computingMetrics.computeFitnessHalfWithNumThreshold(9, model, log, (int) fitness4ThresholdValue);
				System.out.println("fitness4: " + fitness4);
				
				precision1 = computingMetrics.computePrecisionWithNumThreshold(9, model, log, (int) precision1ThresholdValue);
				System.out.println("precision1: " + precision1);
				precision2 = computingMetrics.computePrecisionWithRatioThreshold(9, model, log, precision2ThresholdValue);
				System.out.println("precision2: " + precision2);
				precision3 = computingMetrics.computePrecisionWithEntropy(9, model, log);
				System.out.println("precision3: " + precision3);
				
				generalization1 = computingMetrics.computeGeneralizationForModelAndLog(generalization1ThresholdValue, 9, model, log, mxConstants.generalizationAlgorithmBinomialDistribution);
				System.out.println("generalization1: " + generalization1);
				
				//output metrics
				fitness1Result.setText(fitness1 + "");
				fitness2Result.setText(fitness2 + "");
				fitness3Result.setText(fitness3 + "");
				fitness4Result.setText(fitness4 + "");
			    precision1Result.setText(precision1 + "");
			    precision2Result.setText(precision2 + "");
			    precision3Result.setText(precision3 + "");
			    generalization1Result.setText(generalization1 + "");			    
			}
		});
    	
        
        JPanel metricTypeApproachPanel = new JPanel();
        metricTypeApproachPanel.setLayout(new GridLayout(1,3));       
        metricTypeApproachPanel.add(metricTypeLable);
        metricTypeApproachPanel.add(fitnessType);
        metricTypeApproachPanel.add(precisionType);
        metricTypeApproachPanel.add(generalizationType);
        metricTypeApproachPanel.setMaximumSize(new Dimension(800,20));
        
        JPanel metricApproachPanel = new JPanel();
        metricApproachPanel.setLayout(new GridLayout(1,9));       
        metricApproachPanel.add(approachLable);      
        metricApproachPanel.add(fitness1Label);
        metricApproachPanel.add(fitness2Label);
        metricApproachPanel.add(fitness3Label);
        metricApproachPanel.add(fitness4Label);      
        metricApproachPanel.add(precision1Label);
        metricApproachPanel.add(precision2Label);
        metricApproachPanel.add(precision3Label);
        metricApproachPanel.add(generalization1Label);
        metricApproachPanel.setMaximumSize(new Dimension(800,20));
       
        JPanel inputThresholdPanel = new JPanel();
        inputThresholdPanel.setLayout(new GridLayout(1,9));      
        inputThresholdPanel.add(thresholdLable);
        inputThresholdPanel.add(fitness1Threshold);
        inputThresholdPanel.add(fitness2Threshold);
        inputThresholdPanel.add(fitness3Threshold);
        inputThresholdPanel.add(fitness4Threshold);
        inputThresholdPanel.add(precision1Threshold);
        inputThresholdPanel.add(precision2Threshold);
        inputThresholdPanel.add(precision3Threshold);
        inputThresholdPanel.add(generalization1Threshold);
        inputThresholdPanel.setMaximumSize(new Dimension(800,20));
        fitness1Threshold.setEditable(false);
        precision3Threshold.setEditable(false);
        
        JPanel resultPanel = new JPanel();
        resultPanel.setLayout(new GridLayout(1,3));     
        resultPanel.add(resultLable);
        resultPanel.add(fitness1Result);
        resultPanel.add(fitness2Result);
        resultPanel.add(fitness3Result);
        resultPanel.add(fitness4Result);
        resultPanel.add(precision1Result);
        resultPanel.add(precision2Result);
        resultPanel.add(precision3Result);
        resultPanel.add(generalization1Result);
        resultPanel.setMaximumSize(new Dimension(800,20));
        
        
        JPanel variantMatrixPanel = new JPanel();
        variantMatrixPanel.setLayout(new GridLayout(3,3));

        for(int row=0; row<3; row++){
        	 for(int column=0; column<3; column++){
        		 String labelValue = "(" + column + "," + row + ")";
//        		 if(column == 2){
//        			 labelValue = "(" + column + "," + row + ")";
//        		 }
        		 JLabel variantLabel = new JLabel(labelValue);
        		 
        		 
        		 JTextField numberInput = new JTextField();
        		 numberInput.setText("0");
        		 numberInput.setPreferredSize(new Dimension(50,20));
        		 numberList.add(numberInput);

        		 JCheckBox selectionFlag = new JCheckBox();
        		 selectionFlagList.add(selectionFlag);
        		 
        		
        		 
        		 JPanel variantLabelPanel = new JPanel();
        		 variantLabelPanel.add(variantLabel);
        		 JPanel inputPanel = new JPanel();
        		 inputPanel.add(numberInput);
        		 inputPanel.add(selectionFlag);
        		 
        		 JPanel variantPanel = new JPanel();
        		 variantPanel.setLayout(new BoxLayout(variantPanel, BoxLayout.Y_AXIS));
        		 variantPanel.add(variantLabelPanel);
        		 variantPanel.add(inputPanel);
//        		 variantPanel.setBorder(BorderFactory.createEtchedBorder());
        		 variantPanel.setBorder(BorderFactory.createLoweredBevelBorder());
        		 variantMatrixPanel.add(variantPanel);
             }
        }
        
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));


    	
//    	this.add(metricTypeApproachPanel);

    	this.add(metricApproachPanel);
    	this.add(inputThresholdPanel);
    	this.add(resultPanel);
    	this.add(variantMatrixPanel);
    	this.add(calculateButton);

    }
 
    public static void main(String[] args) throws Exception  
    {  
			 
    	MetricsCalculatorAllApproach calculator = new MetricsCalculatorAllApproach();
		JFrame frame = new JFrame();
//		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		frame.setSize(800, 500);
		frame.getContentPane().add(calculator);
		frame.setVisible(true);
		System.out.print("end");
    }
}

