package org.processmining.ocbc.discovery.panels;

import org.deckfour.uitopia.api.event.TaskListener.InteractionResult;
import org.processmining.contexts.uitopia.UIPluginContext;


public class OCBCMinerConfigurationUI{
	UIPluginContext context;
	
	int noSteps;
	int currentStep;
	private myStep[] mySteps;
	
	private int mapTemplateConfigurationStep;
	private int templateConfigurationStep;
	private int aprioriConfigurationStep;
	private int declarePerspectiveConfigurationStep;
	
	
	public OCBCMinerConfigurationUI(UIPluginContext context){
		this.context = context;

		
		InteractionResult result = InteractionResult.NEXT;

		
		noSteps = 0;
		mapTemplateConfigurationStep = noSteps++;
		templateConfigurationStep = noSteps++;
		aprioriConfigurationStep = noSteps++;
		declarePerspectiveConfigurationStep = noSteps++;
		
		mySteps = new myStep[noSteps];
		
//		mySteps[mapTemplateConfigurationStep] = new MapTemplateActivityConfigurationStep();
//		mySteps[mapTemplateConfigurationStep].setListener(this);
		
		mySteps[templateConfigurationStep] = new TemplateConfigurationStep();
//		mySteps[templateConfigurationStep].setListener(this);
		
//		mySteps[aprioriConfigurationStep] = new AprioriConfigurationStep();
//		mySteps[aprioriConfigurationStep].setListener(this);
		
//		mySteps[declarePerspectiveConfigurationStep] = new DeclarePerspectiveConfigurationStep();
//		mySteps[declarePerspectiveConfigurationStep].setListener(this);
		

		currentStep = 0;
		
		while (true) {
			if (currentStep < 0) {
				currentStep = 0;
			}
			if (currentStep >= noSteps) {
				currentStep = noSteps - 1;
			}
			

			result = context.showWizard("Declare Maps Miner Plugin", currentStep == 0, currentStep == noSteps - 1, mySteps[currentStep]);
		
			
			switch (result) {
				case NEXT:
					if(currentStep == mapTemplateConfigurationStep)
						go(2);
					else
						go(1);
					break;
				case PREV:
					if(currentStep == aprioriConfigurationStep)
						go(-2);
					else
						go(-1);
					break;
				case FINISHED:
					readSettings();
					
					break;
				case CANCEL:

					return;
				default:
					return;
			}
		}
	}

	private int go(int direction) {
		currentStep += direction;
		if (currentStep >= 0 && currentStep < noSteps) {
			if (mySteps[currentStep].precondition()) {
				return currentStep;
			} else {
				return go(direction);
			}
		}
		return currentStep;
	}
	
	private void readSettings(){
		for(int currentStep = 0; currentStep < noSteps; currentStep++){
			mySteps[currentStep].readSettings();
		}
	}


	
//	public void setSelectedDeclareTemplateSet(Set<DeclareTemplate> selectedDeclareTemplateSet) {
//		System.out.println("Setting delcare template set");
//		input.setSelectedDeclareTemplateSet(selectedDeclareTemplateSet);		
//	}
//
//	public void setMinSupport(int minSupport) {
//		System.out.println("Setting min support");
//		input.setMinSupport(minSupport);
//	}
//
//	public void setAlpha(int alpha) {
//		System.out.println("Setting alpha");
//		input.setAlpha(alpha);
//	}
//
//	public void setDeclarePerspectiveSet(Set<DeclarePerspective> declarePerspectiveSet) {
//		System.out.println("Setting delcare perspective");
//		input.setDeclarePerspectiveSet(declarePerspectiveSet);
//	}
//
//	public DeclareMinerInput getInput() {
//		return input;
//	}
//
//	public void setDeclareTemplateConstraintTemplateMap(Map<DeclareTemplate, ConstraintTemplate> declareTemplateConstraintTemplateMap) {
//		input.setDeclareTemplateConstraintTemplateMap(declareTemplateConstraintTemplateMap);
//	}
//
//	public void setMapTemplateConfiguration(MapTemplateConfiguration mapTemplateConfiguration) {
//		input.setMapTemplateConfiguration(mapTemplateConfiguration);
//	}
//
//	public void setAprioriKnowledgeBasedCriteria(Set<AprioriKnowledgeBasedCriteria> aprioriKnowledgeBasedCriteriaSet) {
//		input.setAprioriKnowledgeBasedCriteriaSet(aprioriKnowledgeBasedCriteriaSet);
//	}
//
//	public void setAprioriKnowledgeConceptFileName(String aprioriKnowledgeConceptFileName) {
//		input.setAprioriKnowledgeConceptFileName(aprioriKnowledgeConceptFileName);
//	}
//
//	public void setDataDeclareTemplateConstraintTemplateMap(
//			Map<DataDeclareTemplate, ConstraintTemplate> declareTemplateConstraintTemplateMap) {
//		// TODO Auto-generated method stub
//		
//	}
//
//	public void setSelectedDataDeclareTemplateSet(Set<DataDeclareTemplate> selectedDeclareTemplateSet) {
//		// TODO Auto-generated method stub
//		
//	}
}
