package org.processmining.ocbc.log.inspector.graph;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import org.jgraph.graph.GraphConstants;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;

import com.jgraph.components.labels.MultiLineVertexRenderer;

public class EventRenderer extends MultiLineVertexRenderer {

	public static enum EventType {
		TIMEOUT("TO"), MESSAGE("Mes");
		private final String s;

		EventType(String s) {
			this.s = s;
		}

		public String toString() {
			return s;
		}
	};

	/**
	 * 
	 */
	private static final long serialVersionUID = 4910262989128580150L;
	
	private MyOriginalCell cell;
	protected EventType type;

	public EventRenderer(Object cell) {
		this.cell = (MyOriginalCell) cell;
	}
	
	public void paint(Graphics g) {  
		try {  
			if (gradientColor != null && !preview && isOpaque()) {  
				setOpaque(false);  
				Graphics2D g2d = (Graphics2D) g;  
				Color color = GraphConstants.getGradientColor(cell.getAttributes());
                g2d.setPaint(color);  

 //                g2d.setPaint(Color.BLACK); 
                int height = (int) GraphConstants.getBounds(cell.getAttributes()).getHeight();
                int width = (int) GraphConstants.getBounds(cell.getAttributes()).getWidth();
//                g2d.drawRoundRect(0, 0, width, height, 30, 30);
                g2d.drawOval(10, 5, width-12, height-10);
                g2d.fillOval(10, 5, width-12, height-10);


//                g2d.fillRoundRect(0, 0, width, height, 30, 30);
            }  
            super.paint(g);  
            paintSelectionBorder(g);  
		} catch (IllegalArgumentException e) {  
            // JDK Bug: Zero length string passed to TextLayout constructor  
		} 
	       
//	       try {  
//	            if (gradientColor != null && !preview && isOpaque()) {  
//	                setOpaque(false);  
//	                Graphics2D g2d = (Graphics2D) g;  
//	                 g2d.setPaint(new GradientPaint(0, 0, getBackground(),  
//	                        getWidth(), getHeight(), Color.black, true));  
////	                 g2d.drawOval(0, 0, getWidth(), getHeight());      
////	                 g2d.fillOval(0, 0, getWidth(), getHeight()); 
//	                 int height = (int) GraphConstants.getBounds(cell.getAttributes()).getHeight();
//	                 int width = (int) GraphConstants.getBounds(cell.getAttributes()).getWidth();
////	                 g2d.drawRoundRect(10, 5, width-12, height-10, 10, 10);
//	                 g2d.drawOval(10, 5, width-12, height-10);
////	                 g2d.fillRoundRect(10, 5, width-10, height-10, 10, 10);
//	            }  
//	            super.paint(g);  
//	            paintSelectionBorder(g);  
//	        } catch (IllegalArgumentException e) {  
//	            // JDK Bug: Zero length string passed to TextLayout constructor  
//	        }  
	}
}
