package org.processmining.ocbc.log.inspector.graph;

import org.jgraph.graph.DefaultCellViewFactory;
import org.jgraph.graph.EdgeView;
import org.jgraph.graph.PortView;
import org.jgraph.graph.VertexView;
import org.processmining.ocbc.models.visualization.cell.TransparentPortCell;
import org.processmining.ocbc.models.visualization.declare.DEdgeView;
import org.processmining.ocbc.models.visualization.view.TransparentPortView;

public class LogCellViewFactory extends DefaultCellViewFactory {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7288009143327540248L;


	protected EdgeView createEdgeView(Object cell) {
		if (cell instanceof ObjectEdgeCell) {
			System.out.print("cell instanceof ClassEdgeCell");
			return new DEdgeView(cell);
		}
		else {
			System.out.print("cell instanceof DEdgeView");
			return new DEdgeView(cell);		
		}
	}

	protected VertexView createVertexView(Object object) {
		if (object instanceof ObjectCell) 
//			return new ObjectView(object);	
			return new VertexView(object);	
		else if (object instanceof EventCell) 
			return new EventView(object);
//			return new VertexView(object);
		else if (object instanceof ViolatedEventCell) 
			return new ViolatedEventView(object);
//			return new VertexView(object);
		else 
			return new VertexView(object);
		
	}

	/**
	 * Constructs a PortView view for the specified object.
	 * 
	 * @param cell
	 *            Object
	 * @return PortView
	 */
	protected PortView createPortView(Object cell) {
		if (cell instanceof TransparentPortCell) {
			return new TransparentPortView(cell);
		} else {
			return new PortView(cell);
		}
	}

}
