package org.processmining.ocbc.log.inspector.interaction;

import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.util.Set;
import java.util.UUID;

import javax.swing.JButton;

import org.processmining.ocbc.log.inspector.panels.AttributesHierarchyPanel;
import org.processmining.ocbc.log.inspector.panels.ObjectModelJGraphXPanel;
import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.EditorPanel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;
import org.processmining.ocbc.models.visualization.ModelLayoutBuilder;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;


public class GraphZoomMouseListener implements MouseWheelListener{
	OCBCModel model;
	ModelLayoutBuilder builder;
	
	UUID selectedID;
	UUID previouslySelectedID;
	

	private XOCLog log;
	private XOCEvent lastEvent;
	private XOCEvent selectEvent;
	private ObjectModelJGraphXPanel graphPanel;
	private AttributesHierarchyPanel attributesPanel;
	
	
	InformationPanel informationPanel;
	EditorPanel editorPanel;
	Set<UUID> foldedNodes;
	String elementType;
	String previouslyElementType;
	
	private JButton focusedButton;
	private JButton previouslyFocusedButton;
	
	private MyOriginalCell firstlyFocusedCell;//used for keeping the first point when drawing a edge
	int firstX;
	int firstY;
	
	private MyOriginalCell secondlyFocusedCell;//used for keeping the second point when drawing a edge
	int secondX;
	int secondY;
	
	double zoomRate = 1;
	int zoomType = 2;
	private MyOriginalCell focusedCell;
	
	public GraphZoomMouseListener(ObjectModelJGraphXPanel graphPanel, AttributesHierarchyPanel attributesPanel, XOCLog log){
		this.graphPanel = graphPanel;
		this.attributesPanel = attributesPanel;
		this.log = log;
		this.lastEvent = log.getAllEvents().get(log.getAllEvents().size()-1);
	}
	
	public void addGraphPanel(ObjectModelJGraphXPanel graphPanel){
		this.graphPanel = graphPanel;
	}
	
	public void addInformationPanel(InformationPanel informationPanel){
		this.informationPanel = informationPanel;
	}
	
	public void addEditorPanel(EditorPanel editorPanel){
		this.editorPanel = editorPanel;
	}
	
	public void setZoomType(int zoomType){
		this.zoomType = zoomType;
	}
//	public void setGraph(JGraph graph){
//		this.graph = graph;
//	}
	
	public UUID getSelectedID(){
		return selectedID;
	}
	
	public UUID getPreviouslySelectedID(){
		return previouslySelectedID;
	}
	
	/**
	 * Sets the selected ID, can be used for variables and originators (it will raise a mousePressed event)
	 * @param newID
	 */
	public void setSelectedButton(JButton focusedButton){
		this.previouslyFocusedButton = this.focusedButton;
		this.focusedButton = focusedButton;
		System.out.println("set focusedButton");
//		mousePressed(null);
	}
	
	public JButton getSelectedButton(){
//		this.previouslyFocusedButton = this.focusedButton;
		return focusedButton;
	}
	
	
	public void setSelectedCell(MyOriginalCell cell){
//		this.previouslyFocusedButton = this.focusedButton;
		this.focusedCell = cell;
//		System.out.println("set focusedButton");
//		mousePressed(null);
	}
	
	public void setSelectedEvent(XOCEvent selectEvent){
		this.selectEvent = selectEvent;
	}
	
	public MyOriginalCell getSelectedCell(){
//		this.previouslyFocusedButton = this.focusedButton;
		return focusedCell;
	}
	
	public JButton getPreviouslySelectedButton(){
//		this.previouslyFocusedButton = this.focusedButton;
		System.out.println("getPreviouslySelectedButton()");
		return this.previouslyFocusedButton;
	}
	
	public void setSelectedID(UUID newID){
		this.previouslySelectedID = this.selectedID;
		this.selectedID = newID;
//		mousePressed(null);
	}
	
	public String getElementType(){
		return elementType;
	}
	
	public String getPreviouslyElementType(){
		return previouslyElementType;
	}
	
	/**
	 * Sets the selected elementType, can be used for variables and originators (it will raise a mousePressed event)
	 * @param newID
	 */
	public void setElementType(String elementType){
		this.previouslyElementType = this.elementType;
		this.elementType = elementType;
		System.out.println("set elementType");
//		mousePressed(null);
	}

	@Override
    //利用滚轮事件将窗口放大和缩小
    public void mouseWheelMoved(MouseWheelEvent e) {
//    	graphPanel.getGraphComponent().setCenterZoom(false);
//    	graphPanel.getGraphComponent().setLocation(-500, -500);
//		System.out.println("mouseWheelMoved");
        // TODO Auto-generated method stub
		if(zoomType == 1){
	        if(e.getWheelRotation()==1){
	        	zoomRate = zoomRate*0.667;
	            System.out.println("滑轮向前。。。。");
	        }
	        if(e.getWheelRotation()==-1){
	        	zoomRate = zoomRate*1.5;
	            System.out.println("滑轮向后....");
	        }
	
	        graphPanel.updateEventGraph(graphPanel.getSelectedEvent(), zoomRate, true);
		}
		else if(zoomType == 2){
			
	        if(e.getWheelRotation()==1){
	        	graphPanel.getGraphComponent().zoomOut();

//	        	graphPanel.getGraphComponent().zoomAndCenter();
	            System.out.println("滑轮向前。。。。");
	        }
	        if(e.getWheelRotation()==-1){
	        	graphPanel.getGraphComponent().zoomIn();
	            System.out.println("滑轮向后....");
	        }
	
		}
    }
	
}
