package org.processmining.ocbc.log.io;

import java.io.File;

import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.impl.xConstants;

/** 
 * Class with the export plugin for a collection of processes
 * 
 * @author Andrea Burattin
 */

@Plugin(
	name = "Export XOC Log (.xoc)",
	returnLabels = {},
	returnTypes = {},
	parameterLabels = { "XOC Log", "File" },
	userAccessible = true
)
@UIExportPlugin(
	description = "Export XOC Log (.xoc)",//show the type in window for recording files
	extension = "xoc" // the suffix name
)
public class ExportXOCLog {

	/**
	 * This plugin is used to export a OCBC model
	 * 
	 * @param context
	 * @param xoc log
	 * @param file
	 * @throws Exception 
	 */
	@PluginVariant(
		variantLabel = "Export XOC Log (.xoc)",
		requiredParameterLabels = { 0, 1 }
	) 
	public void exportXOCLog(PluginContext context, XOCLog log, File file) throws Exception {
		context.log("Export started..."); 
		System.out.println("xoc log output");
		String logFormat = log.getAttributes().get(xConstants.FORMAT).toString();
		if(logFormat.equals(xConstants.TOTAL)){		
			OutputXMLFile generateLog = new OutputXMLFile(file.getAbsolutePath());
	        generateLog.serialize(log, xConstants.TOTAL);
		}
		else if(logFormat.equals(xConstants.UPDATE)){
			OutputXMLFile generateLog = new OutputXMLFile(file.getAbsolutePath());
	        generateLog.serialize(log, xConstants.UPDATE);
		}
		System.out.println(file);

//		FileOutputStream output = new FileOutputStream(file);
//		ExportToFile.exportToFile(model, output) ;
		context.log("Export complete!");
	} 
	

}