package org.processmining.ocbc.log.model.impl;

import java.util.Set;

import org.processmining.ocbc.log.extension.XExtension;
import org.processmining.ocbc.log.id.XID;
import org.processmining.ocbc.log.model.XAttributeMap;
import org.processmining.ocbc.log.model.XOCClass;


public class XOCClassImpl implements XOCClass {

	/**
	 * ID of this event.
	 */
	private XID ID;

	private String className;
	/**
	 * Map of attributes for this class.
	 */
	private XAttributeMap attributes;


	public XOCClassImpl(XID ID) {
		this(ID, null, null);
	}
	
	public XOCClassImpl(String className) {
		this(new XID(), className);
	}
	
	public XOCClassImpl(XAttributeMap attributes) {
		this(null, attributes);
	}

	public XOCClassImpl(XID ID, XAttributeMap attributes) {
		this(ID, attributes, null);
	}
	
	public XOCClassImpl(XID ID, String className) {
		this(ID, null, className);
	}
	
	public XOCClassImpl(XID ID, XAttributeMap attributes, String className) {
		this.ID = ID;
		this.attributes = attributes;
		this.className = className;
	}


	public XAttributeMap getAttributes() {
		return attributes;
	}


	public void setAttributes(XAttributeMap attributes) {
		this.attributes = attributes;
	}



	public String getClassName() {
		return className;
	}

	public void setClassName(String className) {
		this.className = className;
		
	}

	public boolean hasAttributes() {
		// TODO Auto-generated method stub
		return false;
	}

	public Set<XExtension> getExtensions() {
		// TODO Auto-generated method stub
		return null;
	}

	public XID getID() {
		return ID;
	}

	public void setID(XID ID) {
		this.ID = ID;
		
	}


}
