package org.processmining.ocbc.log.newformat.plugin;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JPanel;

import org.deckfour.spex.SXDocument;
import org.deckfour.spex.SXTag;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.ocbc.log.inspector.panels.XOCLogDashboard;
import org.processmining.ocbc.log.inspector.panels.XOCLogSummary;
import org.processmining.ocbc.log.inspector.panels.XOCLogViewer;
import org.processmining.ocbc.log.io.XocXmlParser;
import org.processmining.ocbc.log.model.XOCEvent;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.log.model.XOCORelation;
import org.processmining.ocbc.log.model.XOCObject;
import org.processmining.ocbc.log.model.XOCObjectModel;
import org.processmining.ocbc.log.model.XOCRRelation;
import org.processmining.ocbc.log.model.impl.XOCEventImpl;
import org.processmining.ocbc.log.model.impl.XOCLogImpl;
import org.processmining.ocbc.log.model.impl.XOCObjectModelImpl;
import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.logconversion.panels.XOCLogConversionPanel;
import org.processmining.ocbc.loggeneration.panel.datamodel.DataModelInspector;



public class XOCLogTransformVersionPlugin extends JPanel{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected XOCLogViewer viewerUI;
	protected XOCLogDashboard dashboardUI;
	protected XOCLogSummary summaryUI;
	protected DataModelInspector dataModelUI;
//	protected LogInfoUI loginfoUI;


	
	
	protected XOCLog log;
	

//	@Plugin(
//		name = "XOC Log Upgrade Plugin",
//		parameterLabels = {"XOCLog"},
//		returnLabels = { "XOC Log Upgrade Plugin" },
//		returnTypes = { XOCLogUpgradeObject.class },
//		userAccessible = true,
//		help = "Start up editor"
//	)
//	@UITopiaVariant(
//		affiliation = UITopiaVariant.EHV,
//		author = "Guangming Li",
//		email = "g.li.3@tue.nl"
//	)

	public XOCLogUpgradeObject logConvertor(UIPluginContext context, XOCLog log) throws Exception{
		
		context.log("XOC Log Upgrade Plugin starts");
		System.out.println("\n XOC Log Upgrade Plugin");
//		logConvertorPanel(context, log);		       
		return new XOCLogUpgradeObject(logUpgradePanel(context, log));
	}
	
	@Plugin(
			name = "XOCLog Upgrade Plugin Visualization", 
			parameterLabels = {"visualizer"},
			returnTypes = JComponent.class, 
			returnLabels = "Log Upgrade Plugin Visualization", 
			help = "Upgrade Plugin"
	)
	
	@Visualizer
	public JComponent visualizeConvertorPanel(UIPluginContext context, final XOCLogUpgradeObject input){
		System.out.println("XOC log Upgrade Plugin visualizer");
		context.log("welcome to XOC log Upgrade Plugin visualizer");
		JPanel resultPanel = input.panel;
		return resultPanel;
	}
	
	public JPanel logUpgradePanel(UIPluginContext context, XOCLog log) throws Exception {
		System.out.println("\n Upgrade Plugin");
		XOCLogConversionPanel logConversion = new XOCLogConversionPanel(context, log);
//		initialize(null);
//		completeGui(null);
		return logConversion;
	}
//	JTextField selectedPath;

	/*
	 * add an object model for each event through using the current object model update
	 * plus the previous object model;
	 */
	public void addObjectModelForEachEvent(XOCLog inputLog){
		for(int eventIndex=0; eventIndex<inputLog.getAllEvents().size(); eventIndex++){
			XOCEvent event = inputLog.getAllEvents().get(eventIndex);
			System.out.println("eventIndex: " + eventIndex);
			System.out.println("********object model update*************");
//			for(XOCObject object : event.getObjectModelUpdate().getObjectSet()){
//				System.out.println("object id: " + object.getAttributes().get(xConstants.ID).toString());
//			}
//			for(XOCORelation objectRelation : event.getObjectModelUpdate().getObjectRelationSet()){
//				System.out.println("object relation id: " + objectRelation.getAttributes().get(xConstants.ID).toString());
//				System.out.println("source object id: " + objectRelation.getAttributes().get(xConstants.SOURCEOBJECTID).toString());				
//				System.out.println("target object id: " + objectRelation.getAttributes().get(xConstants.TARGETOBJECTID).toString());
//				
//			}
			//get the object model
			XOCObjectModel objectModel;			
			if(eventIndex>0){
				XOCObjectModel objectModelPrevious = inputLog.getAllEvents().get(eventIndex-1).getObjectModel();
				objectModel = event.getObjectModelUpdate().plusObjectModel(objectModelPrevious);

			}
			else{
				event.getObjectModelUpdate().updateObjectRelationSet();
				objectModel = event.getObjectModelUpdate();
			}

			event.setObjectModel(objectModel);	
			
//			System.out.println("********object model*************");
//			for(XOCObject object : objectModel.getObjectSet()){
//				System.out.println("object id: " + object.getAttributes().get(xConstants.ID).toString());
//			}
//			for(XOCORelation objectRelation : objectModel.getObjectRelationSet()){
//				System.out.println("object relation id: " + objectRelation.getAttributes().get(xConstants.ID).toString());
//			}
		}		
	}
	
	/*
	 * add an object model update for each event through using the current object model 
	 * minus the previous object model;
	 * if there exist an object model update, clear it first
	 */
	public void addObjectModelUpdateForEachEvent(XOCLog inputLog){
		for(int eventIndex=0; eventIndex<inputLog.getAllEvents().size(); eventIndex++){
			XOCEvent event = inputLog.getAllEvents().get(eventIndex);
			
			//get the object model update
			XOCObjectModel objectModelUpdate;			
			if(eventIndex>0){
				XOCEvent eventPrevious = inputLog.getAllEvents().get(eventIndex-1);
				objectModelUpdate = event.getObjectModel().minusObjectModelOverlap(eventPrevious.getObjectModel());
			}
			else{
				objectModelUpdate = event.getObjectModel();
			}
			objectModelUpdate.updateObjectRelationSet();
			event.setObjectModelUpdate(objectModelUpdate);					
		}		
	}

	/*
	 * add an minimal object model for each event through using the object model update
	 * plus the source and target objects (of object relations of object model update) which are not in the object set of object model update
	 */
	public void addMinimalObjectModelForEachEvent(XOCLog inputLog){	
		for(XOCEvent event : inputLog){
			XOCObjectModel minimalObjectModel = new XOCObjectModelImpl();
			
			event.getObjectModel().generateIdVSObjectMap();
			Map<String, XOCObject> IdVSObjectMapOfObjectModel = event.getObjectModel().getIdVSObjectMap();
			
			Map<String, XOCObject> IdVSObjectMapOfObjectModelUpdate = event.getObjectModelUpdate().generateIdVSObjectMap();
			for(String objectId : IdVSObjectMapOfObjectModelUpdate.keySet()){
				minimalObjectModel.getObjectSet().add(IdVSObjectMapOfObjectModel.get(objectId));
			}			
			
			Map<String, XOCORelation> IdVSObjectRelationMapOfObjectModel = event.getObjectModel().getIdVSObjectRelationMap();
			Map<String, XOCORelation> IdVSObjectRelationMapOfObjectModelUpdate = event.getObjectModelUpdate().getIdVSObjectRelationMap();
			
			Map<String, XOCObject> IdVSObjectMapOfMinimalObjectModel = minimalObjectModel.generateIdVSObjectMap();;
			for(String objectRelationId : IdVSObjectRelationMapOfObjectModelUpdate.keySet()){
				XOCORelation objectRelation = IdVSObjectRelationMapOfObjectModel.get(objectRelationId);
				minimalObjectModel.getObjectRelationSet().add(objectRelation);
//				if(objectRelation == null){
//					System.out.println("objectRelation is null");
//				}
//				else{
//					System.out.println("objectRelation is not null");
//					if(objectRelation.getSourceObject() == null){
//						System.out.println("objectRelation.getSourceObject() is null");
//					}
//				}
				String sourceObjectId = objectRelation.getSourceObject().getAttributes().get(xConstants.ID).toString();
				String targetObjectId = objectRelation.getTargetObject().getAttributes().get(xConstants.ID).toString();
				if(!IdVSObjectMapOfMinimalObjectModel.keySet().contains(sourceObjectId)){
					XOCObject object = IdVSObjectMapOfObjectModel.get(sourceObjectId);
					minimalObjectModel.getObjectSet().add(object);
					IdVSObjectMapOfMinimalObjectModel.put(sourceObjectId, object);
				}
				if(!IdVSObjectMapOfMinimalObjectModel.keySet().contains(targetObjectId)){
					XOCObject object = IdVSObjectMapOfObjectModel.get(targetObjectId);
					minimalObjectModel.getObjectSet().add(object);
					IdVSObjectMapOfMinimalObjectModel.put(targetObjectId, object);
				}
			}
			minimalObjectModel.updateObjectRelationSet();
			event.getObjectModel().updateObjectRelationSet();
//			event.setMinimalObjectModel(minimalObjectModel);	
		}		
	}
	
	public XOCLog transformToSimpleVersion(XOCLog inputLog){
		XOCLog simpifiedLog = new XOCLogImpl();
		simpifiedLog.setAttributes(inputLog.getAttributes());
		for(int eventIndex=0; eventIndex<inputLog.getAllEvents().size(); eventIndex++){
			XOCEvent event = inputLog.getAllEvents().get(eventIndex);
			XOCEvent simplifiedEvent = new XOCEventImpl();
			XOCObjectModel objectModelDifference;
			//the event attributes and SimplifiedRelatedObjects do not change
			simplifiedEvent.setAttributes(event.getAttributes());
			simplifiedEvent.setSimplifiedRelatedObjects(event.getSimplifiedRelatedObjects());
			
			//change object model
			if(eventIndex>0){
				XOCEvent eventPrevious = inputLog.getAllEvents().get(eventIndex-1);
				objectModelDifference = event.getObjectModel().minusObjectModelOverlap(eventPrevious.getObjectModel());
			}
			else{
				objectModelDifference = event.getObjectModel();
			}
			simplifiedEvent.setObjectModel(objectModelDifference);
			
			//relate the event to the objects in the new object model
			List<XOCObject> relatedObjects = new ArrayList<XOCObject>();			
			for(XOCObject simplifiedObject : simplifiedEvent.getSimplifiedRelatedObjects()){
				String id = simplifiedObject.getAttributes().get(xConstants.ID).toString();
				if(simplifiedEvent.getObjectModel().generateIdVSObjectMap().containsKey(id)){
					XOCObject relatedObject = simplifiedEvent.getObjectModel().generateIdVSObjectMap().get(id);
					relatedObjects.add(relatedObject);
				}
				else{
					relatedObjects.add(simplifiedObject);
				}			
			}			
			simplifiedEvent.setRelatedObjects(relatedObjects);        
	        
			//add event into log
			simpifiedLog.getAllEvents().add(simplifiedEvent);
		}
		
		//create new reference relation for the new log: relate new event to new objects
		for(XOCRRelation referenceRelation : inputLog.getReferenceRelations()){
//			String objectId = referenceRelation.getTargetObject().getAttributes().get(xConstants.ID).toString();
//			String eventId = referenceRelation.getSourceEvent().getAttributes().get(xConstants.ID).toString();
//			XOCEvent event = simpifiedLog.getIdVSEventMap().get(eventId);
//			XOCObject object = event.getObjectModel().getIdVSObjectMap().get(objectId);
//			
//    		XOCRRelation referenceRelationNew = new XOCRRelationImpl(event.getAttributes().get(xConstants.ACTIVITY).toString() + "-" +
//    				object.getAttributes().get(xConstants.CLASS).toString(), event, object);      		       		
//    		referenceRelationNew.getAttributes().put(xConstants.ID, referenceRelation.getAttributes().get(xConstants.ID));
//			simpifiedLog.getReferenceRelations().add(referenceRelationNew);
		}
    	
    	
		return simpifiedLog;
	}
	
	public XOCLog transformToComplexVersion(XOCLog inputLog){
		XOCLog complexLog = new XOCLogImpl();
		complexLog.setAttributes(inputLog.getAttributes());
		XOCObjectModel objectModelCombination = null;
		for(int eventIndex=0; eventIndex<inputLog.getAllEvents().size(); eventIndex++){
			XOCEvent event = inputLog.getAllEvents().get(eventIndex);
			XOCEvent complicatedEvent = new XOCEventImpl();
			
			
			complicatedEvent.setAttributes(event.getAttributes());
			complicatedEvent.setRelatedObjects(event.getRelatedObjects());
			
			if(eventIndex>0){
				XOCObjectModel objectModelPrevious = complexLog.getAllEvents().get(eventIndex-1).getObjectModel();
				objectModelCombination = event.getObjectModel().plusObjectModel(objectModelPrevious);
			}
			else{
				objectModelCombination = event.getObjectModel();
			}

			complicatedEvent.setObjectModel(objectModelCombination);
			complexLog.getAllEvents().add(complicatedEvent);
		}
		return complexLog;
	}

//	public void createLog(XOCLog log, String logFormat, String savePath) throws IOException{		
//	
//	    System.out.println("\n path: " + savePath);	    
//		FileOutputStream fout = new FileOutputStream(savePath);
//		
//		if(logFormat.equals(xConstants.TOTAL)){
//			System.out.println("enter logFormat: " + xConstants.TOTAL);
//			for(XOCEvent event : log.getAllEvents()){										
//				log.eventList.add(event);
//			}	
//		}
//		else if(logFormat.equals(xConstants.UPDATE)){
//			System.out.println("logFormat: " + xConstants.UPDATE);
////			List<String> accumulatedObjectIdList = new ArrayList<String>();
//			Map<String, TableObject> accumulatedObjectIdVSObject = new HashMap<String, TableObject>();
//			List<String> accumulatedObjectRelationIdList = new ArrayList<String>();
//			for(Event event : eventList){					
//				List<TableObject> bornObjectList = new ArrayList<TableObject>();
//				List<ObjectRelation> bornObjectRelationList = new ArrayList<ObjectRelation>();
//				
//				for(TableObject object : event.currentObjectList){
//					String objectId = object.name;//currently, consider the name as id
//					//add the born objects
//					if(!accumulatedObjectIdVSObject.containsKey(objectId)){
//						accumulatedObjectIdVSObject.put(objectId, object);
//						//add the life cycle attribute
//						object.getAttributeMap().put(xConstants.lifecycle, xConstants.add);
//						bornObjectList.add(object);
//					}
//					//add the updated objects
//					else{
//						TableObject previousObject = accumulatedObjectIdVSObject.get(objectId);
//						Map<String, String> differentAttributeMap = previousObject.compareObjectAttributeMap(object);
//						if(differentAttributeMap.size() > 0){
//							accumulatedObjectIdVSObject.put(objectId, object);
//							TableObject updatedObject = new TableObject();
//							updatedObject.name = objectId;
//							updatedObject.className = object.className;
//							//add the life cycle attribute
//							differentAttributeMap.put(xConstants.lifecycle, xConstants.update);
//							updatedObject.setAttributeMap(differentAttributeMap);
//							bornObjectList.add(updatedObject);
//						}
//					}
//				}
//				
//				for(ObjectRelation objectRelation : event.currentObjectRelationList){
//					String relationId = objectRelation.id;
//					if(!accumulatedObjectRelationIdList.contains(relationId)){
//						accumulatedObjectRelationIdList.add(relationId);
//						objectRelation.getAttributeMap().put(xConstants.lifecycle, xConstants.add);
//						bornObjectRelationList.add(objectRelation);
//					}
//				}
//				
//				event.currentObjectList.clear();
//				event.currentObjectList.addAll(bornObjectList);
//				event.currentObjectRelationList.clear();
//				event.currentObjectRelationList.addAll(bornObjectRelationList);
//				log.eventList.add(event);
//			}
//		}
//		
//		if(log.eventList.size() == 0){
//			JOptionPane.showMessageDialog(null, "Warn! The log contains no events!"); 		
//		}
//		serialize(log, fout, logFormat);	
//		fout.close();	
//		System.out.println("logFormat: " + logFormat);
//
//	    
//	}
	
	public void serialize(XOCLog log, String savePath, String logFormat) throws IOException {		
		long start = System.currentTimeMillis();
		
	    System.out.println("\n path: " + savePath);	    
		FileOutputStream fout = new FileOutputStream(savePath);
		
		SXDocument doc = new SXDocument(fout);
		doc.addComment("This file is a XOC log. Its definition and semantic are");
		doc.addComment("available from http://www.win.tue.nl/ocbc/.");
		doc.addComment("It conforms to the XML serialization.");
		
		SXTag logTag = doc.addNode("log");
		logTag.addAttribute("xoc.version", "1.0");
		SXTag attributeTag;
		attributeTag = logTag.addChildNode("string");
		attributeTag.addAttribute("key", xConstants.FORMAT);
		attributeTag.addAttribute("value", logFormat);
		for (XOCEvent event : log.getAllEvents()) {
			System.out.print("write event:  \n" );
			SXTag eventTag = logTag.addChildNode("event");
			
			for(String attributeKey : event.getAttributes().keySet()){
				SXTag eventAttributeTag = eventTag.addChildNode("string");
				eventAttributeTag.addAttribute("key", attributeKey);
				eventAttributeTag.addAttribute("value", event.getAttributes().get(attributeKey).toString());	
			}
	
			SXTag objectModelTag = eventTag.addChildNode("model");			
			SXTag objectModeObjectsTag = objectModelTag.addChildNode("objects");
			
			
			addObjects(objectModeObjectsTag, log.createObjectModelUpdate(event).getObjectSet());			
			SXTag objectModeObjectRelationsTag = objectModelTag.addChildNode("relations");
			addObjectRelations(objectModeObjectRelationsTag, log.createObjectModelUpdate(event).getObjectRelationSet());
			
			//the reference must be written into XOC logs after object model to make it easier for future importing
			SXTag objectsTag = eventTag.addChildNode("references");
			addReferenceObjects(objectsTag, event.getRelatedObjects());
		}
		
		doc.close();
		String duration = " (" + (System.currentTimeMillis() - start)
				+ " msec.)";
		fout.close();	

	}
	
	public void addObjects(SXTag tag, List<XOCObject> objects)
			throws IOException {
						
		for (XOCObject object : objects) {
			SXTag objectTag = tag.addChildNode("object");
			
			for(String attributeKey : object.getAttributes().keySet()){
				SXTag objectAttributeTag = objectTag.addChildNode("string");
				objectAttributeTag.addAttribute("key", attributeKey);
				objectAttributeTag.addAttribute("value", object.getAttributes().get(attributeKey).toString());	
			}
		}
	}
	
	/**
	 * the function write reference objects (simple version, i.e., only with id attribute) into XOC logs
	 * @param tag
	 * @param objects
	 * @throws IOException
	 */
	public void addReferenceObjects(SXTag tag, List<XOCObject> objects)
			throws IOException {
						
		for (XOCObject object : objects) {
			SXTag objectTag = tag.addChildNode("object");			
			SXTag objectIDTag = objectTag.addChildNode("string");
			objectIDTag.addAttribute("key", "id");
//			objectIDTag.addAttribute("value", object.id);
			objectIDTag.addAttribute("value", object.getAttributes().get(xConstants.ID).toString());			
		}
	}
	
	public void addObjectRelations(SXTag tag, List<XOCORelation> objectRelations)
			throws IOException {		
		for (XOCORelation objectRelation : objectRelations) {
			SXTag objectRelationTag = tag.addChildNode("relation");;
				
			for(String attributeKey : objectRelation.getAttributes().keySet()){
				SXTag objectAttributeTag = objectRelationTag.addChildNode("string");
				objectAttributeTag.addAttribute("key", attributeKey);
				objectAttributeTag.addAttribute("value", objectRelation.getAttributes().get(attributeKey).toString());	
			}
		}
	}
	
	public static void main(String[] args) throws Exception  
    {  
		XocXmlParser XOCParser = new XocXmlParser();
		XOCParser.parse(new File("d:\\example.xoc"));		
		
		XOCLog inputLog = XOCParser.getLog();
		
		if(inputLog == null) System.out.print("null" );
		System.out.print("\n log.size" + inputLog.size());
		System.out.print("\n log.size" + inputLog.getAllEvents().size());
//		SlickerOpenLogSettings dialogue = new SlickerOpenLogSettings();
		XOCLogTransformVersionPlugin transformer = new XOCLogTransformVersionPlugin();
		
//		XOCLog simplifiedLog = transformer.transformToSimpleVersion(inputLog);
//		XOCLog complexLog = transformer.transformToComplexVersion(simplifiedLog);


		transformer.serialize(inputLog, "D:\\exampleNew.xoc", xConstants.UPDATE);
		
//        OutputXMLFile generateLog = new OutputXMLFile( "D:\\exampleNew.xoc");
//        generateLog.serialize(inputLog, xConstants.UPDATE);
//        generateLog.serialize(simplifiedLog, "2.0");
//        OutputXMLFile generateLog = new OutputXMLFile( "D:\\complicatedXOCLog.xoc");
//        generateLog.serialize(complexLog, "1.0");
        
//		XOCLogUpgradePlugin plugin = new XOCLogUpgradePlugin();
//		System.out.print("\n after plunin creation");
//		JPanel ret = plugin.logUpgradePanel(null, inputLog);
//		JFrame frame = new JFrame();
//		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
//		frame.getContentPane().add(new JScrollPane(ret));
//		frame.setVisible(true);
//		System.out.print("end");
 
    }	
}
