
package org.processmining.ocbc.logconversion.configurations;
 
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
 

/*
 * write and read map data structure into/from xml file
 */
public class ReadConfigurationsFromXML {
    private ConfigurationParameters configuration;
    public ReadConfigurationsFromXML(ConfigurationParameters configuration){
    	this.configuration = configuration;
    }
    
    public ReadConfigurationsFromXML(){
    	
    }
       
	public void parserXml(String fileName, List<String> tableList) {
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();
            Document document = db.parse(fileName);
             
            NodeList rootList = document.getChildNodes();
            Node root = rootList.item(0);
            NodeList configurations = root.getChildNodes();
            
            //build a map between the name and node
            Map<String, Node> nameVSNode = new HashMap<String, Node>();
            for (int i = 0; i < configurations.getLength(); i++) {
                Node configurationNode = configurations.item(i);
                if(configurationNode.getNodeName() != "#text"){
                    String configurationNodeName = configurationNode.getNodeName();
                    nameVSNode.put(configurationNodeName, configurationNode);
                }
            }
            //get the target tables, classes and activities
            List<String> tableClassActivity = null;
            if(tableList != null){
            	tableClassActivity = new ArrayList<String>();
            	//get the target tables
                tableClassActivity.addAll(tableList);               
                //get classes related to target tables
                Map<String, List<String>> tableVSClassList = new HashMap<String, List<String>>();
                parse_Map_String_List_Node(nameVSNode.get(ConfigurationConstants.TABLEVSCLASSLISTMAP), tableVSClassList, tableClassActivity);
                for(String table : tableList){
                	if(tableVSClassList.containsKey(table)){
                		tableClassActivity.addAll(tableVSClassList.get(table));
                	}               	
                }                
                //get activities related to target tables
                Map<String, Map<String, String>> classVSColumnVSName = new HashMap<String, Map<String, String>>();
                Map<String, Map<String, List<String>>> classVSActivityColumnVSAttributeColumns = new HashMap<String, Map<String, List<String>>>();      	
                parse_Map_Map_List_Node(nameVSNode.get(ConfigurationConstants.CLASSVSACTIVITYCOLUMNVSATTRIBUTECOLUMNSMAP), 
                		classVSActivityColumnVSAttributeColumns, tableClassActivity);
                parse_Map_String_Map_Node(nameVSNode.get(ConfigurationConstants.CLASSVSCOLUMNVSNAMEMAP),
                		classVSColumnVSName, tableClassActivity);
                for(String className : classVSActivityColumnVSAttributeColumns.keySet()){
                	for(String activityColumn : classVSActivityColumnVSAttributeColumns.get(className).keySet()){
                		if(classVSColumnVSName.containsKey(className) && classVSColumnVSName.get(className).containsKey(activityColumn)){
                			String activityName = classVSColumnVSName.get(className).get(activityColumn);
                			if(activityName != null){
                				tableClassActivity.add(activityName);
                			}                   		
                		}                		
                	}                    	                   	
                }
                for(String element : tableClassActivity){
                	System.out.println("my element: " + element);    	
                }    
            }
           
            //parse all elements related to the tableClassActivity list
            for (int i = 0; i < configurations.getLength(); i++) {
                Node configurationNode = configurations.item(i);
                if(configurationNode.getNodeName() != "#text"){
                	System.out.println(configurationNode.getNodeName());
                	
                    System.out.println("**********configuration**************");
                    String configurationNodeName = configurationNode.getNodeName();
                    System.out.println("configurationNodeName: " + configurationNodeName);
                    
                    if(configuration.getNameVSMapParameterMap().containsKey(configurationNodeName)){
                    	Map<String, String> parameter = new HashMap<String, String>();
                    	configuration.getNameVSMapParameterMap().put(configurationNodeName, parameter);
                    	parse_Map_Node(configurationNode, parameter, null);
                    }
                    else if(configuration.getNameVSMapListParameterMap().containsKey(configurationNodeName)){
                    	Map<String, List<String>> parameter = new HashMap<String, List<String>>();
                    	configuration.getNameVSMapListParameterMap().put(configurationNodeName, parameter);
                    	parse_Map_String_List_Node(configurationNode, parameter, null);
                    }
                    else if(configuration.getNameVSMapMapParameterMap().containsKey(configurationNodeName)){
                    	Map<String, Map<String, String>> parameter = new HashMap<String, Map<String, String>>();
                    	configuration.getNameVSMapMapParameterMap().put(configurationNodeName, parameter);
                    	parse_Map_String_Map_Node(configurationNode, parameter, null);
                    }
                    else if(configuration.getNameVSMapMapListParameterMap().containsKey(configurationNodeName)){
                    	Map<String, Map<String, List<String>>> parameter = new HashMap<String, Map<String, List<String>>>();
                    	configuration.getNameVSMapMapListParameterMap().put(configurationNodeName, parameter);
                    	parse_Map_Map_List_Node(configurationNode, parameter, null);
                    } 
                    else if(configuration.getNameVSMapMapMapParameterMap().containsKey(configurationNodeName)){
                    	Map<String, Map<String, Map<String, String>>> parameter = new HashMap<String, Map<String, Map<String, String>>>();
                    	configuration.getNameVSMapMapMapParameterMap().put(configurationNodeName, parameter);
                    	parse_Map_Map_Map_Node(configurationNode, parameter, null);
                    } 
                }

            }
            System.out.println("解析完毕");
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (ParserConfigurationException e) {
            System.out.println(e.getMessage());
        } catch (SAXException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
    public void parse_Map_String_List_Node(Node configurationNode, Map<String, List<String>> inputMap, List<String> constraints){
    	 NodeList mapKeyList = configurationNode.getChildNodes();
         for (int j = 0; j < mapKeyList.getLength(); j++) {
             Node mapKeyNode = mapKeyList.item(j);
             if(mapKeyNode.getNodeName() != "#text"){         	 
             	 System.out.println(mapKeyNode.getNodeName());
                 System.out.println("********mapKey****************");
                 String mapKeyName = mapKeyNode.getNodeName();
                 if(constraints == null || constraints.contains(mapKeyName) || constraints.contains(mapKeyName.split("-")[0])){
                	 NodeList mapValueElementList = mapKeyNode.getChildNodes();
                     List<String> mapValueElementNameList = new ArrayList<String>();
                     for (int k = 0; k < mapValueElementList.getLength(); k++) {
                    	 
                    	 String mapValueElementName = mapValueElementList.item(k).getTextContent();
                      	 if(mapValueElementList.item(k).getNodeName() != "#text"){ 		 
                      		 mapValueElementNameList.add(mapValueElementName);
                      		 System.out.println(mapValueElementList.item(k).getNodeName()
                                      + ":" + mapValueElementList.item(k).getTextContent());
                             System.out.println("********employeeMeta****************");
                              
                              
                      	 }                     
                     }
                     inputMap.put(mapKeyName, mapValueElementNameList);
                 }
                 
             }                       
         }               
    }
    
    public void parse_Map_String_Map_Node(Node configurationNode, Map<String, Map<String, String>> inputMap, List<String> constraints){
   	 NodeList mapKeyList = configurationNode.getChildNodes();
        for (int j = 0; j < mapKeyList.getLength(); j++) {
            Node mapKeyNode = mapKeyList.item(j);
            if(mapKeyNode.getNodeName() != "#text"){         	 
            	System.out.println(mapKeyNode.getNodeName());
                System.out.println("********mapKey****************");
                String mapKeyName = mapKeyNode.getNodeName();
                if(constraints == null || constraints.contains(mapKeyName)){
                	NodeList mapValueElementList = mapKeyNode.getChildNodes();
//                  List<String> mapValueElementNameList = new ArrayList<String>();
                	Map<String, String> childMap = new HashMap<String, String>();
                	for(int k = 0; k < mapValueElementList.getLength(); k++) {                	  
                		String mapValueElementName = mapValueElementList.item(k).getNodeName();
                   	  	if(mapValueElementList.item(k).getNodeName() != "#text"){              		                     		  
                   	  		String childMapValueName = mapValueElementList.item(k).getTextContent();
                   	  		childMap.put(mapValueElementName, childMapValueName);
                   	  		System.out.println(mapValueElementList.item(k).getNodeName()
	                                   + ":" + mapValueElementList.item(k).getTextContent());
                   	  		System.out.println("********employeeMeta****************");                                                    
                   	  	}                     
                	}
                	inputMap.put(mapKeyName, childMap);
                }               
            }                       
        }               
    }
    
    public void parse_Map_Node(Node configurationNode, Map<String, String> inputMap, List<String> constraints){	
   	 	NodeList mapKeyList = configurationNode.getChildNodes();
   	 	System.out.println("********map****************");
        for (int j = 0; j < mapKeyList.getLength(); j++) {
        	System.out.println("********key list****************");
            Node mapKeyNode = mapKeyList.item(j);
            String mapKeyName = mapKeyNode.getNodeName();
            System.out.println("mapKeyName: " + mapKeyName);
            if(constraints == null || constraints.contains(mapKeyName)){         	
                if(mapKeyNode.getNodeName() != "#text"){  
                	System.out.println("********node name****************");
                	
                    String mapValueName = mapKeyNode.getTextContent();   
                    System.out.println("mapValueName: " + mapValueName);
                    inputMap.put(mapKeyName, mapValueName);
                }     
            }
                              
        }               
    }
    
    public void parse_Map_Map_List_Node(Node configurationNode, Map<String, Map<String, List<String>>> inputMap, List<String> constraints){
   	 	NodeList mapKeyList = configurationNode.getChildNodes();
   	 	System.out.println("********map****************");
        for (int j = 0; j < mapKeyList.getLength(); j++) {
        	System.out.println("********key list****************");
            Node mapKeyNode = mapKeyList.item(j);
            String mapKeyName = mapKeyNode.getNodeName();
            if(constraints == null || constraints.contains(mapKeyName)){         	
                Map<String, List<String>> childMap = new HashMap<String, List<String>>();
                parse_Map_String_List_Node(mapKeyNode, childMap, null);

                if(mapKeyName != "#text"){  
                	System.out.println("********node name****************");            
                    inputMap.put(mapKeyName, childMap);
                } 
            }                     
        }               
    }
    
    public void parse_Map_Map_Map_Node(Node configurationNode, Map<String, Map<String, Map<String, String>>> inputMap, List<String> constraints){
   	 	NodeList mapKeyList = configurationNode.getChildNodes();
   	 	System.out.println("********map****************");
        for (int j = 0; j < mapKeyList.getLength(); j++) {
        	System.out.println("********key list****************");
            Node mapKeyNode = mapKeyList.item(j);
            String mapKeyName = mapKeyNode.getNodeName();
            if(constraints == null || constraints.contains(mapKeyName)){         	
                Map<String, Map<String, String>> childMap = new HashMap<String, Map<String, String>>();
                parse_Map_String_Map_Node(mapKeyNode, childMap, null);

                if(mapKeyName != "#text"){  
                	System.out.println("********node name****************");            
                    inputMap.put(mapKeyName, childMap);
                } 
            }                     
        }               
    }
//    
    public static void main(String args[]){
    	Map<String, Map<String, String>> tableVSObjectChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
    	
    	if(tableVSObjectChainedChildTableVSFK.keySet() == null){
    		System.out.println("null");
    	}
    	if(tableVSObjectChainedChildTableVSFK.keySet().isEmpty()){
    		System.out.println("empty");
    	}
//		if(((Map<?, ?>) tableVSObjectChainedChildTableVSFK).values() instanceof List){
//			System.out.println("List ");
//		} else if (((Map<?, ?>) tableVSObjectChainedChildTableVSFK).values() instanceof Map){
//			System.out.println("Map ");
//		} else if (((Map<?, ?>) tableVSObjectChainedChildTableVSFK).values() == null){
//			System.out.println("null ");
//		} else {
//			System.out.println(",,,");
//		}
		
//    	if(tableVSObjectChainedChildTableVSFK.keySet() instanceof Set<?>){
//    		System.out.println("set ");
//    	}
//    	if(tableVSObjectChainedChildTableVSFK.values() instanceof Collection<?>){
//    		System.out.println("Collection ");
//    	}
//    	
//    	System.out.println(tableVSObjectChainedChildTableVSFK.keySet().getClass());
//    	System.out.println(tableVSObjectChainedChildTableVSFK.values().getClass());
//    	if(tableVSObjectChainedChildTableVSFK.values().getClass()){
//    		
//    	}
//    	ReadConfigurationsFromXML dd=new ReadConfigurationsFromXML();
//        String str="D:/grade2.xml";
//        dd.init();
////        dd.createXml(str);    //创建xml
//        dd.parserXml(str);    //读取xml
    }
}