
package org.processmining.ocbc.logconversion.configurations;
 
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
 

/*
 * write and read map data structure into/from xml file
 */
public class WriteConfigurationsIntoXML {
    private Document document;
    
    private ConfigurationParameters configuration;
    
    public WriteConfigurationsIntoXML(ConfigurationParameters configuration){
    	this.configuration = configuration;
    	init();
    }
   		 
    public WriteConfigurationsIntoXML(){
    	
    }
    
    public void init() {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory
                    .newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            this.document = builder.newDocument();
        } catch (ParserConfigurationException e) {
            System.out.println(e.getMessage());
        }
    }
 
	public void createXml(String fileName) {
        Element root = this.document.createElement("configurations"); 
        this.document.appendChild(root);    
      
        for(String parameterName : configuration.getNameVSMapParameterMap().keySet()){
        	Map<String, String> parameter = configuration.getNameVSMapParameterMap().get(parameterName);
        	//create the map node add add it on the root node
            Element mapNode = this.document.createElement(parameterName); 
            root.appendChild(mapNode);       
            add_Map_Node(mapNode, parameter);
        }
        
        for(String parameterName : configuration.getNameVSMapListParameterMap().keySet()){
        	Map<String, List<String>> parameter = configuration.getNameVSMapListParameterMap().get(parameterName);
        	//create the map node add add it on the root node
            Element mapNode = this.document.createElement(parameterName); 
            root.appendChild(mapNode);       
            add_Map_String_List_Node(mapNode, parameter);
        }
        
        for(String parameterName : configuration.getNameVSMapMapParameterMap().keySet()){
        	Map<String, Map<String, String>> parameter = configuration.getNameVSMapMapParameterMap().get(parameterName);
        	//create the map node add add it on the root node
            Element mapNode = this.document.createElement(parameterName); 
            root.appendChild(mapNode);       
            add_Map_String_Map_Node(mapNode, parameter);
        }
        for(String parameterName : configuration.getNameVSMapMapListParameterMap().keySet()){
        	Map<String, Map<String, List<String>>> parameter = configuration.getNameVSMapMapListParameterMap().get(parameterName);
        	//create the map node add add it on the root node
            Element mapNode = this.document.createElement(parameterName); 
            root.appendChild(mapNode);       
            add_Map_Map_List_Node(mapNode, parameter);
        }
        for(String parameterName : configuration.getNameVSMapMapMapParameterMap().keySet()){
        	Map<String, Map<String, Map<String, String>>> parameter = configuration.getNameVSMapMapMapParameterMap().get(parameterName);
        	//create the map node add add it on the root node
            Element mapNode = this.document.createElement(parameterName); 
            root.appendChild(mapNode);       
            add_Map_Map_Map_Node(mapNode, parameter);
        }
//        for(String parameterName : parameterList.keySet()){
//        	System.out.println("parameterName: " + parameterName);
//        	Object parameter = parameterList.get(parameterName);
//        	//create the map node add add it on the root node
//            Element mapNode = this.document.createElement(parameterName); 
//            root.appendChild(mapNode);           
//        	//if the first level of parameters is of map format, current all parameter are of map format
//         
//            if(Maps.contains(parameterName)){
//            	add_Map_Node(mapNode, (Map<String, String>)parameter);
//            }
//            if(MapLists.contains(parameterName)){
//            	add_Map_String_List_Node(mapNode, (Map<String, List<String>>)parameter);
//            }
//            else if(MapMaps.contains(parameterName)){              	 
//            	add_Map_String_Map_Node(mapNode, (Map<String, Map<String, String>>)parameter);
//            }
//            else if(MapMapLists.contains(parameterName)){                  	 
//            	add_Map_Map_List_Node(mapNode, (Map<String, Map<String, List<String>>>)parameter);
//            }
            
//        	if(parameter instanceof Map){
//        		Object[] keySet = ((Map<?, ?>) parameter).keySet().toArray();
//        		if(keySet != null && keySet.length > 0){
//        			Object firstValue = ((Map<?, ?>) parameter).get(keySet[0]);  
//        			//check the second level of parameters is of what map format, current List
//        			//(e.g, Map<String, List<String>>), or Map(e.g, Map<String, Map>),
//            		if(firstValue instanceof List){ //if the  format is List      			
//            			add_Map_String_List_Node(mapNode, (Map<String, List<String>>) parameter);
//            		}
//            		else if(firstValue instanceof Map){ //if the  format is Map 
//            			Object[] keySetChild = ((Map<?, ?>) firstValue).keySet().toArray();
//                		if(keySetChild != null && keySetChild.length > 0){
//                			//check the third level of parameters is of what map format, current List
//                			//(e.g, Map<String, Map<String,List<String>>>), or String(e.g, Map<String, Map<String,String>>),
//                			Object firstValueChild = ((Map<?, ?>) firstValue).get(keySetChild[0]);  
//	            			if(firstValueChild instanceof List){//if the format is List  
//	            				add_Map_Map_List_Node(mapNode, (Map<String, Map<String, List<String>>>) parameter);
//	            			}
//	            			else if(firstValueChild instanceof String){//if the format is String  
//	            				add_Map_String_Map_Node(mapNode, (Map<String, Map<String, String>>) parameter);
//	            			}
//                		}
//            		}
//        		}
//
//        		
//        	}
//        }

        TransformerFactory tf = TransformerFactory.newInstance();
        try {
        	System.out.println("Start writing XML file!");
            Transformer transformer = tf.newTransformer();
            DOMSource source = new DOMSource(document);
            transformer.setOutputProperty(OutputKeys.ENCODING, "gb2312");
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");
            PrintWriter pw = new PrintWriter(new FileOutputStream(fileName));
            StreamResult result = new StreamResult(pw);
            transformer.transform(source, result);
            System.out.println("Succeed creating XML file!");
        } catch (TransformerConfigurationException e) {
            System.out.println(e.getMessage());
        } catch (IllegalArgumentException e) {
            System.out.println(e.getMessage());
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (TransformerException e) {
            System.out.println(e.getMessage());
        } catch (NullPointerException e) {
            System.out.println(e.getMessage());
        }
    }
 

    
    /**
     * @param root
     * @param inputMap
     * @param mapName
     */
    public void add_Map_String_List_Node(Element mapNode, Map<String, List<String>> inputMap){
        if(inputMap != null){
        	for(String stringName : inputMap.keySet()){
        		 if(stringName != null && stringName != ""){
        			 System.out.println("stringName: " + stringName);
                 	 Element stringNode = this.document.createElement(stringName); 
                 	 mapNode.appendChild(stringNode); 
                 	 for(String listElementName : inputMap.get(stringName)){
                 		System.out.println("listElementName: " + listElementName);
                 		Element listElementNode = this.document.createElement("element");       		
                 		listElementNode.appendChild(this.document.createTextNode(listElementName)); 
                 		stringNode.appendChild(listElementNode); 
                 	 }
        		 }      		
            }
        }      
    }
    
    public void add_Map_String_Map_Node(Element mapNode, Map<String, Map<String, String>> inputMap){
        if(inputMap != null){
        	 for(String stringName : inputMap.keySet()){
        		 if(stringName != null && stringName != ""){
//        			 stringName = stringName.split("\\)")[1] + "_1";
        			 System.out.println("add_Map_String_Map_Node-stringName: " + stringName);
                 	 Element stringNode = this.document.createElement(stringName); 
                 	 mapNode.appendChild(stringNode); 
                 	 for(String childMapKeyName : inputMap.get(stringName).keySet()){
                 		String childMapValueName = inputMap.get(stringName).get(childMapKeyName);				
         				Element childMapKeyNode = this.document.createElement(childMapKeyName);       		
         				childMapKeyNode.appendChild(this.document.createTextNode(childMapValueName)); 
         				stringNode.appendChild(childMapKeyNode); 
                 	 } 
        		 }       		 
             }
        }       
    }
    
    public void add_Map_Map_List_Node(Element mapNode, Map<String, Map<String, List<String>>> inputMap){
        if(inputMap != null){
            for(String mapKeyName : inputMap.keySet()){
            	Map<String, List<String>> childMap = inputMap.get(mapKeyName);
            	Element mapKeyNode = this.document.createElement(mapKeyName);       		
    			mapNode.appendChild(mapKeyNode);    			
            	add_Map_String_List_Node(mapKeyNode, childMap);
            }
        }
    }
    
    public void add_Map_Map_Map_Node(Element mapNode, Map<String, Map<String, Map<String, String>>> inputMap){
        if(inputMap != null){
            for(String mapKeyName : inputMap.keySet()){
            	Map<String, Map<String, String>> childMap = inputMap.get(mapKeyName);
            	Element mapKeyNode = this.document.createElement(mapKeyName);       		
    			mapNode.appendChild(mapKeyNode);    			
    			add_Map_String_Map_Node(mapKeyNode, childMap);
            }
        }
    }
    
    
    public void add_Map_Node(Element mapNode, Map<String, String> inputMap){
        if(inputMap != null){
            for(String mapKeyName : inputMap.keySet()){
            	if(mapKeyName != null && mapKeyName != ""){
            		String mapValueName = inputMap.get(mapKeyName);		
                	System.out.println("mapKeyName: "  + mapKeyName);
        			Element mapKeyNode = this.document.createElement(mapKeyName);     
 //       			Element mapKeyNode = this.document.createElement("A");  
        			mapKeyNode.appendChild(this.document.createTextNode(mapValueName)); 
        			mapNode.appendChild(mapKeyNode); 
            	}
            	
            }
        }
    }
    

    
    public static void main(String args[]){
    	WriteConfigurationsIntoXML dd=new WriteConfigurationsIntoXML();
        String str="D:/grade2.xml";
        dd.init();
//        dd.createXml(str);    //创建xml
//        dd.parserXml(str);    //读取xml
    }
}