package org.processmining.ocbc.logconversion.panels;
 

import java.awt.Toolkit;
import java.io.File;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JPanel;

import org.processmining.mxgraph.examples.swing.GraphEditor.CustomGraph;
import org.processmining.mxgraph.examples.swing.GraphEditor.CustomGraphComponent;
import org.processmining.mxgraph.examples.swing.editor.BasicGraphPanel;
import org.processmining.mxgraph.model.mxCell;
import org.processmining.mxgraph.model.mxICell;
import org.processmining.mxgraph.swing.mxGraphComponent;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.ocbc.discovery.impl.OCBCModelDiscovery;
import org.processmining.ocbc.log.io.XocXmlParser;
import org.processmining.ocbc.log.model.XOCLog;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.impl.OCBCModelImpl;
 
/**
 * @version 1.0
 * @author guangming li
 * there are two lists (left list and right list) to show the not-selected values and selected values, respectivly
 */
 
public class CorrelationModelPanel extends JPanel{
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
	private OCBCModel model = new OCBCModelImpl();//contain the class model and AOC relationships in the log
	private BasicGraphPanel basicGraphPanel = new BasicGraphPanel("mxGraph Editor", null, new CustomGraphComponent(new CustomGraph()));
	private XOCLogConversionPanel logConversionPanel;
	private XOCLog log;
	
    public static void main(String[] args) throws Exception {
		XocXmlParser XOCParser = new XocXmlParser();
		XOCParser.parse(new File("d:\\example.xoc"));		
		
		XOCLog inputLog = XOCParser.getLog();
		
		if(inputLog == null) System.out.print("null" );
		System.out.print("\n log.size" + inputLog.size());
		System.out.print("\n log.size" + inputLog.getAllEvents().size());
//		SlickerOpenLogSettings dialogue = new SlickerOpenLogSettings();
			 
		CorrelationModelPanel modelViewPanel = new CorrelationModelPanel(null, inputLog);
		System.out.print("\n after plunin creation");
	
		JFrame frame = new JFrame();
		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
		frame.getContentPane().add(modelViewPanel);
//		frame.add(modelViewPanel);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		System.out.print("end");	
    }
 
    public CorrelationModelPanel(XOCLogConversionPanel fatherPanel, XOCLog log) {
    	this.log = log;
    	this.logConversionPanel = fatherPanel;
		basicGraphPanel.getGraphComponent().setPageBreaksVisible(false);
		basicGraphPanel.getGraphComponent().setToolTips(false);;
		basicGraphPanel.getGraphComponent().setToolTipText("hello");
		basicGraphPanel.getGraphComponent().setPageVisible(false);
		basicGraphPanel.getGraphComponent().getHorizontalScrollBar().setToolTipText("press ctrl to zoom in/out the graph");
		basicGraphPanel.getGraphComponent().getVerticalScrollBar().setToolTipText("press ctrl to zoom in/out the graph");
//		graphComponent.setGridVisible(false);

    }
    
    /**
     * get the father panel of CorrelationModelPanel, i.e., XOCLogConversionPanel
     * @return
     */
    public XOCLogConversionPanel getXOCLogConversionPanel(){
    	return logConversionPanel;
    }
    
    /**
     * get the panel for the discovered model
     * @return
     */
    public mxGraphComponent getModelView(){
    	return basicGraphPanel.getGraphComponent(); 
    }
    
    /**
     * get the discovered model used to correlating events
     * @return
     */
    public OCBCModel getModel(){
    	return model; 
    }
    
    /**
     * discover the model (class model and AOC relationships) as graph
     * @return
     */
    public void discoverCorrelationModel() {
	    model.getGraph().getGraphLayoutCache().remove(model.getGraphCells().toArray());
    	model.getAllClasses().clear();
    	model.getGraphCells().clear();
    	
		
		OCBCModelDiscovery modelDiscovery = new OCBCModelDiscovery(log, mxConstants.balancedMetricsApproach);
		model = modelDiscovery.discover(null);	
		modelDiscovery.visualizeModel(model);
		
		mxGraph graph = basicGraphPanel.getGraphComponent().getGraph();
		
		
		for(mxCell cell: model.getGraphX().getAllCells()){
			if(cell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.CLASSCELL) || 
					cell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.ACTIVITYCELL) ||
					cell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.CLASSRELATION) ||
					cell.getAttributes().get(mxConstants.TYPE).equals(mxConstants.AOCRELATION)){
				System.out.println("cell type: " + cell.getAttributes().get(mxConstants.TYPE));
				System.out.println("cell.getChildCount(): " + cell.getChildCount());
				int childCount = cell.getChildCount();
				List<mxICell> childCellList = new ArrayList<>();
				for(int i=0; i<childCount; i++){
					System.out.println("i: " + i);
//					System.out.println("i child id: " + cell.getChildAt(i).getId());
					mxICell childCell = cell.getChildAt(i);
					childCellList.add(childCell);	
				}
				for(int i=0; i<childCount; i++){
					cell.remove(childCellList.get(i));				
				}
				
				graph.addCell(cell);
			}
		}
    }
}