package org.processmining.ocbc.loggeneration;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class TableObject {
	public String id;//the unique number for a object in the object model, table + table id
	public String rowid;//Usually I create a rowid column for each record in a table
	public String name;//the displaying name of objects in the log inspector
	public String key;//It maybe consists of several columns in a table
	public String className;	
	public String table;//indicate the source table
	public Date timestamp;
	public List<String> fatherObjectIdList = new ArrayList<String>();
	public Map<String, String> attributes = new HashMap<String, String>(); //hold the attributes for objects
	
	public Object clone() {
		TableObject clone = new TableObject();
//		try {
//			clone = (TableObject) super.clone();
//		} catch (CloneNotSupportedException e) {
//			e.printStackTrace();
//			return null;
//		}
		clone.id = this.id;
		clone.rowid = this.rowid;
		clone.name = this.name;
		clone.key = this.key;
		clone.className = this.className;
		clone.table = this.table;
		for(String key : attributes.keySet()){
			clone.attributes.put(key, attributes.get(key));
		}
		return clone;
	}
	
	public Map<String, String> getAttributeMap(){
		return attributes;
	}
	
	public void setAttributeMap(Map<String, String> attributes){
		this.attributes = attributes;
	}
	
	/**
	 * return an attribute map including the attributes only contained by input object, 
	 * and the attributes (in input object) contained in both but having different values
	 * @param object
	 * @return
	 */
	public Map<String, String> compareObjectAttributeMap(TableObject object){
		Map<String, String> differentAttributeMap = new HashMap<String, String>();
		Map<String, String> inputObjectAttributeMap = object.getAttributeMap();
		for(String key : inputObjectAttributeMap.keySet()){
			String value = inputObjectAttributeMap.get(key);		
			if(!attributes.containsKey(key)){
				differentAttributeMap.put(key, value);
			}
			else{
				String valueSelf = attributes.get(key);
				if(!valueSelf.equals(value)){
					differentAttributeMap.put(key, value);
				}
			}			
		}
		return differentAttributeMap;
	}
}