package org.processmining.ocbc.loggeneration.io;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;


public class OutputCSVFile {

    public static File createCSVFile(List<Map<String, String>> exportData, LinkedHashMap<String, String> rowMapper,
            String outPutPath, String filename) {
    	System.out.println("filename: " +filename);
    	System.out.println("outPutPath: " +outPutPath);
        File csvFile = null;
        BufferedWriter csvFileOutputStream = null;
        try {
            csvFile = new File(outPutPath + filename + ".csv");
            // csvFile.getParentFile().mkdir();
            File parent = csvFile.getParentFile();
            if (parent != null && !parent.exists()) {
                parent.mkdirs();
            }
            csvFile.createNewFile();

            // GB2312使正确读取分隔符","
            csvFileOutputStream = new BufferedWriter(new OutputStreamWriter(
                    new FileOutputStream(csvFile), "GB2312"), 1024);
            // 写入文件头部
            int i=0;
            for (String index : rowMapper.keySet()) {
            	i++;
            	String columnName = rowMapper.get(index);
                System.out.println("propertyEntry.getValue().toString(): " + columnName);
//                csvFileOutputStream.write("\"" + columnName + "\"");
                csvFileOutputStream.write(columnName);
                if (i<rowMapper.keySet().size()) {
                    csvFileOutputStream.write(",");
                }
            }
            csvFileOutputStream.newLine();

           


            // 写入文件内容
            
            for(Map<String, String> recordMapper : exportData){
            	i=0;
            	for (String index : recordMapper.keySet()) {
                	i++;
                	String columnName = recordMapper.get(index);
                    System.out.println("propertyEntry.getValue().toString(): " + columnName);
//                    csvFileOutputStream.write("\"" + columnName + "\"");
                    csvFileOutputStream.write(columnName);
                    if (i<recordMapper.keySet().size()) {
                        csvFileOutputStream.write(",");
                    }
                }
            	if (exportData.indexOf(recordMapper) < exportData.size()-1) {  
                     csvFileOutputStream.newLine();  
                }  
            }
            
//            for (Iterator iterator = exportData.iterator(); iterator.hasNext();) {  
//            	LinkedHashMap row = (LinkedHashMap) iterator.next();  
//                System.out.println(row);
//             
//                for (Iterator propertyIterator = row.entrySet().iterator(); propertyIterator.hasNext();) {  
//                    java.util.Map.Entry propertyEntry = (java.util.Map.Entry) propertyIterator.next();  
//                    csvFileOutputStream.write("\""  
//                            +  propertyEntry.getValue().toString() + "\"");  
//                   if (propertyIterator.hasNext()) {  
//                       csvFileOutputStream.write(",");  
//                    }  
//               }  
//                if (iterator.hasNext()) {  
//                   csvFileOutputStream.newLine();  
//                }  
//           }  
            csvFileOutputStream.flush();  
        } catch (Exception e) {  
           e.printStackTrace();  
        } finally {  
           try {  
                csvFileOutputStream.close();  
            } catch (IOException e) {  
               e.printStackTrace();
           }  
       }  
        return csvFile;
    }

    public static void main(String[] args) {
        List exportData = new ArrayList<Map>();
        Map row1 = new LinkedHashMap<String, String>();
        row1.put("1", "beijing");
        row1.put("2", "shanghai");
        row1.put("3", "guangzhou");
        row1.put("4", "shenzhen");
        exportData.add(row1);
//        row1 = new LinkedHashMap<String, String>();
//        row1.put("1", "21");
//        row1.put("2", "22");
//        row1.put("3", "23");
//        row1.put("4", "24");
//        exportData.add(row1);
        List propertyNames = new ArrayList();
        LinkedHashMap map = new LinkedHashMap();
        map.put("1", "first");
        map.put("2", "second");
        map.put("3", "third");
        map.put("4", "forth");
        OutputCSVFile.createCSVFile(exportData, map, "d:/", "newCSVFile");
    }
}