package org.processmining.ocbc.loggeneration.mysql.abstractlog;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.loggeneration.Event;
import org.processmining.ocbc.loggeneration.ObjectRelation;
import org.processmining.ocbc.loggeneration.TableObject; 
 

public class CreateLogFromChangeTables{

	private Connection conn = null;
      
    private ArrayList<Event> eventList = new ArrayList<Event>();
    private ArrayList<TableObject> objectList = new ArrayList<TableObject>();
    private ArrayList<String> objectIdList = new ArrayList<String>();   
    private ArrayList<TableObject> referenceObjectList = new ArrayList<TableObject>();
    private ArrayList<String> referenceObjectIdList = new ArrayList<String>();  
    private ArrayList<ObjectRelation> objectRelationList = new ArrayList<ObjectRelation>();
        	

    //record the mapping from table name to class name; we create one class for each related table
    public Map<String, String> tableVSClass = new HashMap<String, String>();;

    //for one table (name), record the tables (name) it relies on
    public Map<String, List<String>> tableVSDependentTables = new HashMap<String, List<String>>();    
    
    //record what the primary key of one table is called in its children table as foreign key
    public Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
    
    //record which classes one activity refers to
    public Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
    
    //record which table columns will be modified by one activity
    public Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
    
	public CreateLogFromChangeTables(Map<String, String> tableVSClass, Map<String, List<String>> tableVSDependentTables, 
			Map<String, List<String>> tableVSForeignKey, Map<String, List<String>> activityVSClasses, Map<String, List<String>> activityVSModifiedColumns){
		if(tableVSClass != null)
			this.tableVSClass = tableVSClass;
		if(tableVSDependentTables != null)
			this.tableVSDependentTables = tableVSDependentTables;
		if(tableVSForeignKey != null)
			this.tableVSForeignKey = tableVSForeignKey;
		if(activityVSClasses != null)
			this.activityVSClasses = activityVSClasses;		
		if(activityVSModifiedColumns != null)
			this.activityVSModifiedColumns = activityVSModifiedColumns;
	}
	
	public void connect() throws Exception{
		 String url = "jdbc:mysql://localhost:3306/erp?"
		            + "user=root&password=kfgz0874981211&useUnicode=true&characterEncoding=UTF8";
	 
        try {
             new com.mysql.jdbc.Driver();
           
            // 一个Connection代表一个数据库连接
            conn = DriverManager.getConnection(url);
            System.out.println("成功加载MySQL驱动程序");
           
            // Statement里面带有很多方法，比如executeUpdate可以实现插入，更新和删除等
        } catch (SQLException e) {
            System.out.println("MySQL操作错误");
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        } 	            
	}
		
	public void close() throws Exception{
		conn.close();
	}
	
	//extract root objects (which have no father objects) from one table
	//id or rowid
	public void extractInitialRootObjectsFromOneTable(String schema, String objectTable, String idColumn, List<String> attributeColumns, String className, List<Integer> idList) throws SQLException{
	   
		String inquiredColumns = idColumn;
		for(String attributeColumn : attributeColumns){
			inquiredColumns = inquiredColumns + "," + attributeColumn;
		}
	    String sql;
	    if(idList == null || idList.size()==0)
	    	sql = "SELECT " + inquiredColumns + " FROM " + schema + "." + objectTable;
	    else {
	    	sql = "SELECT " + inquiredColumns + " FROM " + schema + "." + objectTable + " where rowid IN(" + idList.get(0);
	    	for(int i=1; i<idList.size(); i++){
	    		sql = sql + "," + idList.get(i);
	    	}
	    	sql = sql + ")";
	    }
	    	      
        Statement stmtObjects = conn.createStatement();
        ResultSet objectResult = stmtObjects.executeQuery(sql);
     
        while (objectResult.next()) {
	            TableObject object = new TableObject();
	            object.key = objectTable + objectResult.getString(1);
	            object.id = tableVSClass.get(objectTable) + objectResult.getString(1);	            
	            object.className = className;  
	    		for(String attributeColumn : attributeColumns){
	    			String attributeValue = objectResult.getString(attributeColumns.indexOf(attributeColumn)+2);
	    			object.attributes.put(attributeColumn, attributeValue);
	    		}
	                                         
//	            if(tableVSDependentTables.containsKey(objectTable)){   
//		            for(String dependentTable : tableVSDependentTables.get(objectTable)){
//		            	List<String> dependentTableNamesInChildTables = tableVSForeignKey.get(dependentTable);
//		                sql = "SELECT " + fatherColumn +" FROM " + schema + "." + objectTable + " where id = " + objectResult.getString(1);
//		                Statement stmtFather = conn.createStatement();
//		                ResultSet fatherResult = stmtFather.executeQuery(sql);
//		                fatherResult.next();
//		                object.fatherObjectIdList.add(fatherResult.getString(1) + tableVSClass.get(dependentTable));
//		            }	           
//	            }
	            objectIdList.add(object.id);
	            objectList.add(object); 			
        }
	}
	

	@SuppressWarnings("unchecked")
	//id or rowid
	public void extractEventsFromChangeTable(String schema, String cdhdrTable, String cdposTable) throws SQLException, ParseException{				    
        String sql = "SELECT * FROM " + schema + "." + cdhdrTable;      
        Statement stmtChanges = conn.createStatement();
        ResultSet changesResult = stmtChanges.executeQuery(sql);// 
        
        //get cdhdr changes
        while (changesResult.next()) {
        	//hold the modified table field names
        	ArrayList<String> modifiedTableColumns = new ArrayList<String>(); 
        	
        	String changeNumber = changesResult.getString(5);
        	String resource = changesResult.getString(6);
        	String strTimestamp = changesResult.getString(7) + " " + changesResult.getString(8);
        	referenceObjectList.clear();
        	referenceObjectIdList.clear();
        	
            System.out
                    .println(changesResult.getString(1) + "\t" + changesResult.getString(5) + "\t" + strTimestamp);
            SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");    
            
            Date timestamp = sdf.parse(strTimestamp);   
            System.out
            		.println(timestamp);
            sql = "SELECT * FROM " + schema + "." + cdposTable +" where changenr = '" + changeNumber + "'";
            
            //record the field names of changed tables
            Statement stmtEventsForActivity = conn.createStatement();
            ResultSet eventsResultForActivity = stmtEventsForActivity.executeQuery(sql);//
            while (eventsResultForActivity.next()) {         	
            	String tableName = eventsResultForActivity.getString(6);
            	String fieldName = eventsResultForActivity.getString(8);           	 
            	modifiedTableColumns.add(tableName + "-" + fieldName);
            }
            String activity = "unknown";
        	     	
        	for(String activityCandidate : activityVSModifiedColumns.keySet()){
        		activity = activityCandidate;
        		//check if modifiedTableColumns contains all elements in activityVSModifiedColumns.get(activity)
        		for(String modifiedTableColumn : activityVSModifiedColumns.get(activity)){
        			if(!modifiedTableColumns.contains(modifiedTableColumn)){
        				activity = "unknown";
        				break;
        			}
        		}
        		if(activity != "unknown")
        			break;
        		//in the future, we should also make sure activityVSModifiedColumns.get(activity) contains all elements in modifiedTableColumns
        	}
	       	
            
            Statement stmtEvents = conn.createStatement();
            ResultSet eventsResult = stmtEvents.executeQuery(sql);// 
                         
            while (eventsResult.next()) {
            	 String modifiedTableName = eventsResult.getString(6);
            	 String modifiedTableKey = eventsResult.getString(7);
            	 String fieldName = eventsResult.getString(8);        	 
            	 String newValue = eventsResult.getString(15);
            	
            	        	               
            	 String objectId = tableVSClass.get(modifiedTableName) + modifiedTableKey;
            	 TableObject object = null;
            	 //if there does not exist an object corresponding to the operation, create a new one; otherwise, get the object
           		 if(!objectIdList.contains(objectId)){
        			 objectIdList.add(objectId);
        			 
        			 object = new TableObject();    
        			 object.key = modifiedTableName + modifiedTableKey;
        			 object.id = objectId;
                     object.className = tableVSClass.get(modifiedTableName);                  
                     objectList.add(object);
        		 }
        		 else{
        			 object = objectList.get(objectIdList.indexOf(objectId));
        		 }
           		 
           		 if(object.attributes.containsKey(fieldName)){
//           			object.attributes.replace(fieldName, newValue);//if the attribute already has value, update the value with the new value
           		 }
           		 else 
           			 object.attributes.put(fieldName, newValue);    
           		 
           		 if(!referenceObjectIdList.contains(object.id) && activityVSClasses.get(activity).contains(object.className)){
           			 referenceObjectIdList.add(object.id);
           			 referenceObjectList.add((TableObject) object.clone()); 
           		 }
           		    
            	 //check if there exist father tables for the modified table          		     
	    		 if(tableVSDependentTables.containsKey(modifiedTableName)){
	    			 System.out.println("modifiedTableName" + modifiedTableName);
	                 for(String dependentTable : tableVSDependentTables.get(modifiedTableName)){               	 
	                	 System.out.println("dependentTable" + dependentTable);
	                 	 List<String> dependentTableNamesInChildTables = tableVSForeignKey.get(dependentTable);	                 	 
	                 	 //if a foreign key is filled with a value, add a new relation; later, if the value is updated or removed, the relation should be 
	                 	 //changed or removed
	                 	 if(dependentTableNamesInChildTables.contains(fieldName)){
	                 		 sql = "SELECT " + fieldName +" FROM " + schema + "." + modifiedTableName + " where rowid = " + modifiedTableKey;
	                         Statement stmtFather = conn.createStatement();
	                         ResultSet fatherResult = stmtFather.executeQuery(sql);
	                         fatherResult.next();
	                         String strFatherKey = dependentTable + fatherResult.getString(1);
	                        
	                         //create the object relation
	                         for(TableObject fatherObject: objectList){
	         					//find the father object
	         					if(fatherObject.key.equals(strFatherKey)){
	         						ObjectRelation objectRelation = new ObjectRelation();
	         						objectRelation.id = fatherObject.id + "-" + object.id;	
	         						objectRelation.relationType = fatherObject.className + "-" + object.className;	
	         						objectRelation.sourceObjectId = fatherObject.id;
	         						objectRelation.targetObjectId = object.id;
	         						objectRelation.timestamp = object.timestamp;
	         						objectRelationList.add(objectRelation);
	         						System.out.println("create object relations");
	         					}					
	         				}						
	                	 }                        	                     
            		 }                                		                
            	 }
            }       
                  	 
          	System.out.println(changesResult.getString(1) + "\t" + changesResult.getString(5));
       	 
	       	Event event = new Event();  	
	       	modifiedTableColumns.clear();
            event.id = changesResult.getString(5) + activity;
            event.activity = activity;
            event.resource = resource;
            event.timestamp = timestamp;            
            event.referredObjectList.addAll(referenceObjectList);           

            for(TableObject object : objectList){
            	 event.currentObjectList.add((TableObject) object.clone());
            }
            event.currentObjectRelationList.addAll((List<ObjectRelation>)objectRelationList.clone());
           
            eventList.add(event);
        }
	}

	public void getObjectIdList(){
		
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<Event> getEventList(){
		return (ArrayList<Event>) eventList.clone();
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<TableObject> getObjectList(){
		return (ArrayList<TableObject>) objectList.clone();
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<ObjectRelation> getObjectRelationList(){
		return (ArrayList<ObjectRelation>) objectRelationList.clone();
	}	
}

