package org.processmining.ocbc.loggeneration.mysql.abstractlog;

import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.swing.JOptionPane;
import javax.swing.JTable;

import org.processmining.common.dialogue.DoNotShowAgainMessageBox;
import org.processmining.common.table.MyTableModel;
import org.processmining.ocbc.logconversion.configurations.ConfigurationConstants;
import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.loggeneration.Event;
import org.processmining.ocbc.loggeneration.ObjectRelation;
import org.processmining.ocbc.loggeneration.TableObject;
import org.processmining.ocbc.loggeneration.io.OutputCSVFile;
import org.processmining.ocbc.loggeneration.mysql.eventlist.CreateEventList;
import org.processmining.ocbc.loggeneration.mysql.eventlist.TableEvent;

public class CreateLogFromEventList{      
    private ArrayList<Event> eventList = new ArrayList<Event>();
    private ArrayList<TableObject> objectList = new ArrayList<TableObject>();
    private ArrayList<String> objectIdList = new ArrayList<String>();   
    private ArrayList<TableObject> referenceObjectList = new ArrayList<TableObject>();
    private ArrayList<String> referenceObjectIdList = new ArrayList<String>();  
    private ArrayList<ObjectRelation> objectRelationList = new ArrayList<ObjectRelation>();
    private ArrayList<String> objectRelationIdList = new ArrayList<String>();
        	

    //record the mapping from table name to class name; we create one class for each related table
    Map<String, List<String>> tableVSClassList = new HashMap<String, List<String>>();

    //for one table (name), record the tables (name) it relies on
    public Map<String, List<String>> tableVSFatherTables = new HashMap<String, List<String>>();    
    
//    //record what the primary key of one table is called in its children table as foreign key
//    public Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
    
    //record what the primary key of one table is called in its children table as foreign key
//   	public Map<String, Map<String, String>> tableVSTableForeignKey = new HashMap<String, Map<String, String>>();
   	Map<String, Map<String, List<String>>> tableVSTableForeignKeyList = new HashMap<String, Map<String, List<String>>>();
    //record which classes one activity refers to
    public Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
    
    //record which table columns will be modified by one activity
    public Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
    
    //for one table event column (table name + column name), which table column will be impacted through which column, table-column-[table-column-intermediacolumn]
    //e.g., question-creationdate-[question-id-id,question-creationdate-id,question-body-id]
    //e.g., order-creationdate-[order-id-id,order-creationdate-id,orderline-id-command...]
    public Map<String, List<String>> tableColumnVSImpactedTableColumns = new HashMap<String, List<String>>();
    	    
    
  //record which table columns are the attributes (e.g., resource) of an event column
//    public Map<String, List<String>> tableColumnVSAttributesColumns = new HashMap<String, List<String>>();
    Map<String, Map<String, List<String>>> classVSActivityColumnVSAttributesColumns = new HashMap<String, Map<String, List<String>>>();
    
    public Map<String, Map<String, String>> classVSColumnVSName = new HashMap<String, Map<String, String>>();
    
    public Map<String, Map<String, String>> tableClassVSColumnVSConstraint = new HashMap<String, Map<String, String>>();
    
    private Map<String, List<String>> classVSPKs = new HashMap<String, List<String>>();
    
    private Map<String, Map<String, String>> tableVSObjectChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
    
    private Map<String, Map<String, String>> activityVSReferredClassVSPath = new HashMap<String, Map<String, String>>();
    
    private Map<String, Map<String, List<String>>> tableVSObjectChainedFatherTableVSFKs = new HashMap<String, Map<String, List<String>>>();

    private Map<String, JTable> nameVSJtable = new HashMap<String, JTable>();
    
    private ConfigurationParameters configuration = new ConfigurationParameters();
	
    private DoNotShowAgainMessageBox messageBox = new DoNotShowAgainMessageBox();
    
    private CreateEventList eventListCreater ;
    
	@SuppressWarnings("unchecked")
	public CreateLogFromEventList(ConfigurationParameters configuration){
		this.configuration = configuration;
		this.eventListCreater = new CreateEventList(configuration);
		
		//MapObject
		if(configuration.getNameVSObjectParameterMap().get(ConfigurationConstants.nameVSJtableMap) != null)
			this.nameVSJtable = (Map<String, JTable>) configuration.getNameVSObjectParameterMap().get(ConfigurationConstants.nameVSJtableMap);						
							
		//MapList
		if(configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLEVSCLASSLISTMAP) != null)
			this.tableVSClassList = configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLEVSCLASSLISTMAP);
		
		if(configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLEVSFATHERTABLESMAP) != null)
			this.tableVSFatherTables = configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLEVSFATHERTABLESMAP);	

		if(configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.ACTIVITYVSCLASSESMAP) != null)
			this.activityVSClasses = configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.ACTIVITYVSCLASSESMAP);			
		
		if(configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLECOLUMNVSIMPACTEDTABLECOLUMNSMAP) != null)
			this.tableColumnVSImpactedTableColumns = configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.TABLECOLUMNVSIMPACTEDTABLECOLUMNSMAP);			
		
		if(configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.CLASSVSPKSMAP) != null)
			this.classVSPKs = configuration.getNameVSMapListParameterMap().get(ConfigurationConstants.CLASSVSPKSMAP);	
	
		//MapMap
		if(configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.TABLEVSOBJECTCHAINEDCHILDTABLEVSFKMAP) != null)
			this.tableVSObjectChainedChildTableVSFK = configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.TABLEVSOBJECTCHAINEDCHILDTABLEVSFKMAP);		

		if(configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.ACTIVITYVSREFERREDCLASSVSPATHMAP) != null)
			this.activityVSReferredClassVSPath = configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.ACTIVITYVSREFERREDCLASSVSPATHMAP);
		
		if(configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.CLASSVSCOLUMNVSNAMEMAP) != null)
			this.classVSColumnVSName = configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.CLASSVSCOLUMNVSNAMEMAP);
		
		if(configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.TABLECLASSVSCOLUMNVSCONSTRAINTMAP) != null)
			this.tableClassVSColumnVSConstraint = configuration.getNameVSMapMapParameterMap().get(ConfigurationConstants.TABLECLASSVSCOLUMNVSCONSTRAINTMAP);
		
		//MapMapList
		if(configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.TABLEVSOBJECTCHAINEDFATHERTABLEVSFKSMAP) != null)
			this.tableVSObjectChainedFatherTableVSFKs = configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.TABLEVSOBJECTCHAINEDFATHERTABLEVSFKSMAP);	 							
		
		if(configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.TABLEVSCHILDTABLEVSFKLISTMAP) != null)
			this.tableVSTableForeignKeyList = configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.TABLEVSCHILDTABLEVSFKLISTMAP);	
		
		if(configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.CLASSVSACTIVITYCOLUMNVSATTRIBUTECOLUMNSMAP) != null)
			this.classVSActivityColumnVSAttributesColumns = configuration.getNameVSMapMapListParameterMap().get(ConfigurationConstants.CLASSVSACTIVITYCOLUMNVSATTRIBUTECOLUMNSMAP);	 				
	
		

		
	}	
	
	//extract root objects (which have no father objects) from one table
	//id or rowid
//	public void extractInitialRootObjectsFromOneTable(String schema, String objectTable, String idColumn, List<String> attributeColumns, String className, List<Integer> idList) throws SQLException{
//	   
//		String inquiredColumns = idColumn;
//		for(String attributeColumn : attributeColumns){
//			inquiredColumns = inquiredColumns + "," + attributeColumn;
//		}
//	    String sql;
//	    String rowId = classVSPKs.get(className).get(0);						
//	    if(idList == null || idList.size()==0)
//	    	sql = "SELECT " + inquiredColumns + " FROM " + schema + "." + objectTable;
//	    else {
//	    	sql = "SELECT " + inquiredColumns + " FROM " + schema + "." + objectTable + " where " + rowId + " IN(" + idList.get(0);
//	    	for(int i=1; i<idList.size(); i++){
//	    		sql = sql + "," + idList.get(i);
//	    	}
//	    	sql = sql + ")";
//	    }
//	    	      
//        Statement stmtObjects = conn.createStatement();
//        ResultSet objectResult = stmtObjects.executeQuery(sql);
//     
//        while (objectResult.next()) {
//	            TableObject object = new TableObject();
//	            object.key = objectTable + objectResult.getString(1);
//	            object.id = tableVSClassList.get(objectTable).get(0) + objectResult.getString(1);	            
//	            object.className = className;  
//	    		for(String attributeColumn : attributeColumns){
//	    			String attributeValue = objectResult.getString(attributeColumns.indexOf(attributeColumn)+2);
//	    			object.attributes.put(attributeColumn, attributeValue);
//	    		}
//	                                         
////	            if(tableVSDependentTables.containsKey(objectTable)){   
////		            for(String dependentTable : tableVSDependentTables.get(objectTable)){
////		            	List<String> dependentTableNamesInChildTables = tableVSForeignKey.get(dependentTable);
////		                sql = "SELECT " + fatherColumn +" FROM " + schema + "." + objectTable + " where id = " + objectResult.getString(1);
////		                Statement stmtFather = conn.createStatement();
////		                ResultSet fatherResult = stmtFather.executeQuery(sql);
////		                fatherResult.next();
////		                object.fatherObjectIdList.add(fatherResult.getString(1) + tableVSClass.get(dependentTable));
////		            }	           
////	            }
//	            objectIdList.add(object.id);
//	            objectList.add(object); 			
//        }
//	}

	//add constraint to filter the object
	public List<String> readObjectTableIdByEventId(String schema, String impactedTable, String impactedkey, TableEvent event) throws SQLException{
		List<String> objectTableIdList = new ArrayList<String>();
    	String eventTable = event.table;
    	Integer eventId = event.id;
    	String className = event.className;
    	
//    	Map<String, List<String>> tableVSFatherTables = this.tableVSFatherTables;
    		
    	
    	//impacting itself
    	if(eventTable.equals(impactedTable)){
    		String rowId = classVSPKs.get(className).get(0);	
    		System.out.println("className in readObjectTableIdByEventId: " + className);
    		System.out.println("rowId: " + rowId);
			if(nameVSJtable.containsKey(impactedTable)){
				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(impactedTable).getModel();
				List<Object> columnValueList = tableModel.getColumnValuesWithColumnConstraint(rowId, impactedkey, eventId.toString());
				//columnValueList should contain just one value because the event and the object are from one table
				String objectId = columnValueList.get(0).toString();
				if(checkIfObjectSafisfyingConstraints(schema, eventTable, objectId))
	            	objectTableIdList.add(objectId);
			}
			
//    		String sql = "SELECT " + rowId + "  FROM " + schema + "." + impactedTable + " where " + impactedkey + " = " + eventId; 
//    		System.out.println("read itself object id by event id sql: " + sql);
//            Statement stmtObjects = conn.createStatement();
//            ResultSet objectResult = stmtObjects.executeQuery(sql);
//            
//            
//            String objectId = eventId.toString();
//            while (objectResult.next() && objectResult.getString(1) !=null){
//            	objectId = objectResult.getString(1);
//            }
//            if(checkIfObjectSafisfyingConstraints(schema, eventTable, objectId))
//            	objectTableIdList.add(objectId);
    	}
    	//impacting child table
    	else if(tableVSFatherTables.containsKey(impactedTable) && 
    			tableVSFatherTables.get(impactedTable).contains(eventTable)){  	
    		List<String> childClassNameList = tableVSClassList.get(impactedTable);
    		String childClassName = childClassNameList.get(0);
    		
			String rowId = classVSPKs.get(childClassName).get(0);	
			if(nameVSJtable.containsKey(impactedTable)){
				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(impactedTable).getModel();
				List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(rowId, impactedkey, eventId.toString());
    			
				for(Object columnValue : columnValueList){
					String objectId = columnValue.toString();
	            	if(checkIfObjectSafisfyingConstraints(schema, impactedTable, objectId))
	                	objectTableIdList.add(objectId);
				}
			}
			
//    	    String sql = "SELECT " + rowId + "  FROM " + schema + "." + impactedTable + " where " + impactedkey + " = " + eventId;    
//    	    
//    	    
//    		System.out.println("read child object id by event id sql: " + sql);
//            Statement stmtObjects = conn.createStatement();
//            ResultSet objectResult = stmtObjects.executeQuery(sql);
//         
//            String objectId = eventId.toString();
//            while (objectResult.next() && objectResult.getString(1) !=null) {
//            	objectId = objectResult.getString(1);
//            	if(checkIfObjectSafisfyingConstraints(schema, impactedTable, objectId))
//                	objectTableIdList.add(objectId);
//            }
    	}
    	//impacting parent table
    	else if(tableVSFatherTables.containsKey(eventTable) && 
    			tableVSFatherTables.get(eventTable).contains(impactedTable)){		
    		List<String> fatherClassNameList = tableVSClassList.get(impactedTable);
    		String fatherClassName = fatherClassNameList.get(0);
    		
			String rowId = classVSPKs.get(fatherClassName).get(0);		
			if(nameVSJtable.containsKey(eventTable)){
				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(eventTable).getModel();
				List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(impactedkey, rowId, eventId.toString());
				//columnValueList should contain just one value 
				String objectId = columnValueList.get(0).toString();
				if(checkIfObjectSafisfyingConstraints(schema, impactedTable, objectId))
		            	objectTableIdList.add(objectId);
			}
			
//    		String sql = "SELECT " + impactedkey + "  FROM " + schema + "." + eventTable + " where " + rowId + " = " + eventId; 
//    		
//    		System.out.println("read object fk value by event id sql: " + sql);
//            Statement stmtObjects = conn.createStatement();
//            ResultSet objectResult = stmtObjects.executeQuery(sql);
//            String fkValue = null;
//            while (objectResult.next()) {
//            	fkValue = objectResult.getString(1);
//            }
//            
//            if(checkIfObjectSafisfyingConstraints(schema, impactedTable, fkValue))
//            	objectTableIdList.add(fkValue);
            
//            //get parent object
//    		sql = "SELECT rowid  FROM " + schema + "." + impactedTable + " where rowid = " + fkValue; 
//    		System.out.println("read parent object id by event id sql: " + sql);
//    		Statement stmtFatherObject = conn.createStatement();
//            ResultSet objectFatherResult = stmtFatherObject.executeQuery(sql);
//    
//            while (objectFatherResult.next()) {
//            	objectTableIdList.add(objectFatherResult.getString(1));
//            }
    	}
    	
    	return objectTableIdList;
	}

	
	//check if object from the source table satisfy the constraints of one class
	public boolean checkIfObjectSafisfyingConstraints(String schema, String sourceTable, String objectId) throws SQLException{
		//add constraint to filter
		String className = tableVSClassList.get(sourceTable).get(0);
		boolean objectValidFlag;
		boolean objectSatisfyingConstraintFlag = false;
		boolean existCorrespondingConstraint = false;
		for(String tableClassComplex : tableClassVSColumnVSConstraint.keySet()){
			String tableName = tableClassComplex.split("-")[0];
			className = tableClassComplex.split("-")[1];
			if(tableName.equals(sourceTable)){
				existCorrespondingConstraint = true;
				Map<String, String> columnVSConstraint = tableClassVSColumnVSConstraint.get(tableClassComplex);
				boolean satisfyingAllConstraintsOfOneClassFlag = true;
				for(String column : columnVSConstraint.keySet()){					
					String constraintValue = columnVSConstraint.get(column);
					//if the constraint value is not empty (if empty, it indicate there is no constraint)
					if(!constraintValue.equals("") && !constraintValue.equals("null")){
						String rowId = classVSPKs.get(className).get(0);		
						if(nameVSJtable.containsKey(sourceTable)){
							MyTableModel tableModel = (MyTableModel) nameVSJtable.get(sourceTable).getModel();
							
							List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(column, rowId, objectId);	
							//columnValueList should contain just one value 
							Object constraint = columnValueList.get(0);						
							if(constraint == null || !((String)constraint).contains(constraintValue)){
			    	        	satisfyingAllConstraintsOfOneClassFlag = false;;
			    	        }
						}
						
//						String sql = "SELECT " + column +" FROM " + schema + "." + sourceTable + " where " + rowId + " = " + objectId;	
//						Statement stmt = conn.createStatement();
//		    	        System.out.println("\n sql constraint: " + sql);
//		    	        ResultSet rs = stmt.executeQuery(sql);
//		    	        rs.next();
//		    	        System.out.println("\n sql constraint result: " + rs.getString(1));
//		    	        if(rs == null || !rs.getString(1).contains(constraintValue)){
//		    	        	satisfyingAllConstraintsOfOneClassFlag = false;;
//		    	        }
					}
					
				}
				if(satisfyingAllConstraintsOfOneClassFlag){
					className = tableClassComplex.split("-")[1];
					objectSatisfyingConstraintFlag = true;
					break;
				}
					
			}
		}
		//there not exist constraint for the object
		if(!existCorrespondingConstraint){
			objectValidFlag = true;
		}
		//there exist constraint for the object and the object satisfy all constraints
		else if(objectSatisfyingConstraintFlag){
			objectValidFlag = true;
		}
		
		else
			objectValidFlag = false;
		
		return objectValidFlag;		
	}
	
	public void extractEventsFromEventList(List<TableEvent> nakedEventList, String schema) throws Exception{			
        for(TableEvent nakedEvent : nakedEventList){        	        	     	
        	referenceObjectList.clear();
        	referenceObjectIdList.clear();      	
        	String table = nakedEvent.table;
        	String column = nakedEvent.column;
        	Integer eventId = nakedEvent.id;
        	String activity = nakedEvent.activity;    
        	String eventClass = nakedEvent.className;
        	String tableColumn = table + "-" + column;       	
        	
    		for(String impactedComplex : tableColumnVSImpactedTableColumns.get(tableColumn)){
    			System.out.println("tableColumn: " + tableColumn);
    			System.out.println("impactedComplex: " + impactedComplex);
    			String[] tableColumnArray = impactedComplex.split("-");
    			String impactedTable = tableColumnArray[0];
    			String impactedColumn = tableColumnArray[1];
    			String impactedkey = tableColumnArray[2];  		
    			
    			//if one event modify multiple rows by the same fk
    			List<String> impactedObjectTableIdList = readObjectTableIdByEventId(schema, impactedTable, impactedkey, nakedEvent);
    			for(String impactedObjectTableId : impactedObjectTableIdList){
    				String objectId = impactedTable + impactedObjectTableId;
    	       		System.out.println("kfgz objectId: " + objectId);
                    if(objectIdList.contains(objectId))   
                    	//if the object already exists, add the impactedColumn as an object attribute
                    	updateObject(impactedTable, objectList.get(objectIdList.indexOf(objectId)), schema, impactedColumn, impactedkey);
                    else{
                    	TableObject object = new TableObject();  
              			object.id = objectId;
              			object.rowid =  impactedObjectTableId;
//                        object.className = nakedEvent.className;   
              			//build a new object
                    	addObject(impactedTable, object, schema);
                    	//add the impactedColumn as an object attribute
                    	updateObject(impactedTable, objectList.get(objectIdList.indexOf(objectId)), schema, impactedColumn, impactedkey);
                    	System.out.println("create new object: " + objectId);
                    }               	          		          		
                    TableObject referenceObject = objectList.get(objectIdList.indexOf(objectId));
//              		 //identify reference objects
//               		if(!referenceObjectIdList.contains(objectId) && activityVSClasses.get(activity).contains(referenceObject.className)){
//               			referenceObjectIdList.add(objectId);
//               			referenceObjectList.add((TableObject) referenceObject.clone()); 
//               		} 
    			}       	         		 
        	}  
    		
     		//identify reference objects
    		String eventRowId = eventId.toString();
    		
    		TableObject eventObject = null;
    		for(TableObject object : objectList){
    			if(object.rowid.equals(eventRowId) && eventClass.equals(object.className)){
    				eventObject = object;
    				break;
    			}
    		}
    		
			if(activityVSReferredClassVSPath.containsKey(activity)){
				for(String className : activityVSReferredClassVSPath.get(activity).keySet()){
    				String pathSequence = activityVSReferredClassVSPath.get(activity).get(className);
    				String[] pathSet = pathSequence.split("->");
    				List<String> pathList = new ArrayList<String>();
    				for(int i=0; i<pathSet.length; i++){
    					pathList.add(pathSet[i]);
    				}
    				
    	    		List<TableObject> startObjectList = new ArrayList<TableObject>();
    	    		List<TableObject> endObjectList = new ArrayList<TableObject>();
    	    		startObjectList.add(eventObject);
    	    		System.out.println("pathList.size(): " + pathList.size());
    	    		System.out.println("pathSequence: " + pathSequence);
    	    		System.out.println("eventObject.className: " + eventObject.className);
    	    		System.out.println("eventObject.id: " + eventObject.id);
    				if(pathList.size() > 1){
        				for(int j=1; j<pathList.size(); j++){
        					String endClassName = pathList.get(j);
        					//for each object in the object list (try to find all objects (end object list) of the target
        					//class and related to at least one object in the start object list)
        					for(TableObject endObject : objectList){
        						String endObjectId = endObject.id;
        		    			String endObjectClassName = endObject.className;
        		    			String endObjectName = endObject.name;
        		    			if(endObjectClassName.equals(endClassName)){
        		    				boolean existenceFlag = false;
        		    				//for each start object in the start object list
        		    				for(TableObject startObject : startObjectList){
        	    						//if the end object is related to the start object
        		    					String startObjectName = startObject.name;   		    					
        		    					for(ObjectRelation objectRelation : objectRelationList){
        		    						if((objectRelation.sourceObjectId.equals(startObjectName) && objectRelation.targetObjectId.equals(endObjectName)) || 
        		    								(objectRelation.sourceObjectId.equals(endObjectName) && objectRelation.targetObjectId.equals(startObjectName))){
        		    							existenceFlag = true;
        		    							break;
        		    						}  		    						
        		    					}
        		    					if(existenceFlag){
        		    						endObjectList.add(endObject);
        		    						break;
        		    					}
        	    					}
        		    			}
        					}
        					
        					//copy the end object list to the start object list, and clear end object list
        					startObjectList.clear();
        					for(TableObject endObject : endObjectList){
        						startObjectList.add(endObject);
        					}
        					endObjectList.clear();		
        				}
    				}

    				referenceObjectList.addAll(startObjectList);
				}
			}
    			
    		addEvent(nakedEvent, schema);
        }
	}
		
	//add an object (with its object-chained father objects and related relations)  into object list
	public void addObject(String sourceTable, TableObject object, String schema) throws Exception{	
//		String className = tableVSClassList.get(sourceTable).get(0);
		String objectRowId = object.rowid;		
//		CreateEventList eventList = new CreateEventList(configuration);

		
		String className = eventListCreater.getObjectClassThroughCheckingConstraint(sourceTable, objectRowId, schema);
		//if the class name is eixist
		if(className != ""){
			object.className = className;
			object.name = className + objectRowId;
			object.table = sourceTable;			
			objectIdList.add(object.id);                 
	        objectList.add(object);              	        
			
			//add object-chained father objects	               
//	        for(String fatherTable : tableVSObjectChainedChildTableVSFK.keySet()){
//	        	if(tableVSObjectChainedChildTableVSFK.get(fatherTable).keySet().contains(sourceTable)){
	        if(tableVSObjectChainedFatherTableVSFKs.keySet().contains(sourceTable)){
	        	for(String fatherTable : tableVSObjectChainedFatherTableVSFKs.get(sourceTable).keySet()){	        	
	                //get the id of the father object  
					for(String foreignKey : tableVSObjectChainedFatherTableVSFKs.get(sourceTable).get(fatherTable)){						
		   				String rowId = classVSPKs.get(className).get(0);   
		   				if(nameVSJtable.containsKey(sourceTable)){
		   					MyTableModel tableModel = (MyTableModel) nameVSJtable.get(sourceTable).getModel();
		   					List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(foreignKey, rowId, object.rowid);	   	    			
		   					for(Object columnValue : columnValueList){
		   						String fatherObjectRowId = columnValue.toString();
			                	TableObject fatherObject = new TableObject();    
//			                	fatherObject.id = tableVSClass.get(fatherTable) + fatherObjectRowId.toString();        
			                	fatherObject.id = fatherTable + fatherObjectRowId; 
			                	if(!objectIdList.contains(fatherObject.id)){
			                    	fatherObject.rowid =  fatherObjectRowId;
			                		addObject(fatherTable, fatherObject, schema);                    		
			                	}  
			                	//if father object is successfully added
			                	if(objectIdList.contains(fatherObject.id)){
			                		fatherObject = objectList.get(objectIdList.indexOf(fatherObject.id));
				            		ObjectRelation objectRelation = new ObjectRelation();
									objectRelation.id = fatherObject.id + "-" + object.id;							
									objectRelation.relationType = fatherObject.className + "-" + foreignKey + "-" + object.className;
									objectRelation.sourceObjectId = fatherObject.name;
									objectRelation.targetObjectId = object.name;
									if(!objectRelationIdList.contains(objectRelation.id)){
										objectRelationList.add(objectRelation);//remove duplication
										objectRelationIdList.add(objectRelation.id);
									}
									
									System.out.println("create father object relations");  
			                	}			                	
		   					}
		   				}					
					}
	        	}
	        }
			//add object-chained child objects
        	if(tableVSObjectChainedChildTableVSFK.containsKey(sourceTable)){
    			for(String childTable : tableVSObjectChainedChildTableVSFK.get(sourceTable).keySet()){
    				System.out.println("\n className: " + className);    				
    				//currently, we assume all the classes in one table have the same pks	
    				//the table should have at least one corresponding class
    				if(tableVSClassList.containsKey(childTable) && tableVSClassList.get(childTable).size()>0){
    		    		List<String> childClassNameList = tableVSClassList.get(childTable);
    		    		String childClassName = childClassNameList.get(0);
    		    		
    					String rowId = classVSPKs.get(childClassName).get(0);
    					String foreignKey = tableVSObjectChainedChildTableVSFK.get(sourceTable).get(childTable);
    					
    	   				if(nameVSJtable.containsKey(childTable)){
    	   					MyTableModel tableModel = (MyTableModel) nameVSJtable.get(childTable).getModel();
    	   					List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(rowId, foreignKey, objectRowId);	   	    			
    	   					for(Object columnValue : columnValueList){
    		                	String childObjectRowId = columnValue.toString();
    		                	TableObject childObject = new TableObject();           
    		                	childObject.id = childTable + childObjectRowId; 
    		                	if(!objectIdList.contains(childObject.id)){
    		                		childObject.rowid =  childObjectRowId;
    		                		addObject(childTable, childObject, schema);                    		
    		                	}  
    		                	childObject = objectList.get(objectIdList.indexOf(childObject.id));
    		            		ObjectRelation objectRelation = new ObjectRelation();
//    							objectRelation.id = childObject.id + "-" + object.id;	
    		            		objectRelation.id = object.id + "-" + childObject.id;
    							objectRelation.relationType = object.className + "-" + foreignKey + "-" + childObject.className;
    							objectRelation.sourceObjectId = object.name;
    							objectRelation.targetObjectId = childObject.name;
    							if(!objectRelationIdList.contains(objectRelation.id)){
    								objectRelationList.add(objectRelation);//remove duplication
    								objectRelationIdList.add(objectRelation.id);
    							}   							
    							System.out.println("create child object relations");
    	   					}
    	   				}
    				}		
    				else{
    					messageBox.showConfirmDialog(null, "Warn! Table " + childTable + " has no classes and no corresponding objects are created"
    							+ " in the log!");
    				}
    			}	    			
	        }	        
		}			   					             	
    }
	
	//update an object (with its attributes and related relations)  into object list
	public void updateObject(String sourceTable, TableObject object, String schema, String modifiedColumn, String impactedkey) throws Exception{
		String className = object.className;	
		String rowId = classVSPKs.get(className).get(0);   
		System.out.println("modifiedColumn: " + modifiedColumn);
		System.out.println("impactedkey: " + impactedkey);
		System.out.println("sourceTable: " + sourceTable);

		if(nameVSJtable.containsKey(sourceTable)){
			MyTableModel tableModel = (MyTableModel) nameVSJtable.get(sourceTable).getModel();			
			List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(modifiedColumn, rowId, object.rowid);	
			//columnValueList should contain just one value 
			String newValue = columnValueList.get(0).toString();	
	        String attributeName = classVSColumnVSName.get(className).get(modifiedColumn);
	        object.attributes.put(attributeName, newValue); 
	        
	        System.out.println("attributeName: " + attributeName);
			System.out.println("newValue: " + newValue);
			
	    	//check if the modified column is a fk referring to a father tables; if yes, add the father object and object relation          		     
	   		if(tableVSFatherTables.containsKey(sourceTable)){ 
	   			for(String fatherTable : tableVSFatherTables.get(sourceTable)){ 
	   				//check if the modified column is a foreign key
	   				List<String> fkList = tableVSTableForeignKeyList.get(fatherTable).get(sourceTable);
	   				boolean foreignKeyFlag = false;
	   				for(String fk : fkList){
	   					if(fk.equals(modifiedColumn))
	   						foreignKeyFlag = true;
	   				}
	   				if(foreignKeyFlag){
	                	String fatherObjectRowId = newValue;
	                	TableObject fatherObject = new TableObject();    
//	                	fatherObject.id = tableVSClass.get(fatherTable) + fatherObjectRowId;   
	                	fatherObject.id = fatherTable + fatherObjectRowId;  
	                	if(!objectIdList.contains(fatherObject.id)){
	                		fatherObject.rowid =  fatherObjectRowId;
	                		addObject(fatherTable, fatherObject, schema);     
	                	}
	                	fatherObject = objectList.get(objectIdList.indexOf(fatherObject.id));
	            		ObjectRelation objectRelation = new ObjectRelation();
						objectRelation.id = fatherObject.id + "-" + object.id;	
//						objectRelation.relationType = fatherObject.className + "-" + object.className;	
						objectRelation.relationType = fatherObject.className + "-" + modifiedColumn + "-" + object.className;//modified-2016-Oct-28
						objectRelation.sourceObjectId = fatherObject.name;
						objectRelation.targetObjectId = object.name;
						if(!objectRelationIdList.contains(objectRelation.id)){
							objectRelationList.add(objectRelation);//remove duplication
							objectRelationIdList.add(objectRelation.id);
						}              	                    		         	
	   				}
	   			}
	   		}	
		}
		
            
	   					             	
    }
	
	//add an event (with its attributes)  into event list
	@SuppressWarnings("unchecked")
	public void addEvent(TableEvent nakedEvent, String schema) throws ParseException, SQLException{			       
    	String table = nakedEvent.table;
    	String column = nakedEvent.column;
    	String activity = nakedEvent.activity;
    	String time = nakedEvent.time;      	
    	String tableActivity = table + "-" + activity;
        String className = nakedEvent.className;
        
        System.out.println("table event's activity: " + activity);
		Event event = new Event();  	
        event.id = nakedEvent.activity + nakedEvent.id;
        event.activity = nakedEvent.activity;
        
		SimpleDateFormat dateTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");  	
		SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");   				
		Date timestamp;
		
		if(time == null || time.equals("null") || time.equals("")){
			time = "2019-01-01 01:00:00";
		}
		
		if(time.length() > 12){
			timestamp = dateTime.parse(time);
		}
		else
			timestamp = date.parse(time); 			           
        event.timestamp = timestamp; 
        
        
        //add the attributes to event
        if(classVSActivityColumnVSAttributesColumns.containsKey(className)){
        	System.out.println("contain tableActivity" );
//        	for(String columnName : classVSActivityColumnVSAttributesColumns.get(className).get(column)){      		
//    			String attributeName = classVSColumnVSName.get(className).get(column); 	
//    			System.out.println("attributeName: " + attributeName);  			
//    			String rowId = classVSPKs.get(className).get(0);    
//    			if(nameVSJtable.containsKey(table)){
//    				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(table).getModel();			
//    				List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(columnName, rowId, nakedEvent.id.toString());	
//    				//columnValueList should contain just one value 
//    				String attributeValue = columnValueList.get(0).toString();	
//        	        event.attributes.put(attributeName, attributeValue); 
//    			}   			 
//        	}     
        	for(String columnName : classVSActivityColumnVSAttributesColumns.get(className).get(column)){      		
    			String attributeName = classVSColumnVSName.get(className).get(columnName); 	
    			System.out.println("attributeName: " + attributeName);  			
    			String rowId = classVSPKs.get(className).get(0);    
    			if(nameVSJtable.containsKey(table)){
    				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(table).getModel();			
    				List<Object> columnValueList= tableModel.getColumnValuesWithColumnConstraint(columnName, rowId, nakedEvent.id.toString());	
    				//columnValueList should contain just one value 
    				String attributeValue = columnValueList.get(0).toString();	
        	        event.attributes.put(attributeName, attributeValue); 
    			}   			 
        	}   
        }
           
        event.referredObjectList.addAll(referenceObjectList);           

        for(TableObject object : objectList){
        	 event.currentObjectList.add((TableObject) object.clone());
        }
        event.currentObjectRelationList.addAll((List<ObjectRelation>)objectRelationList.clone());          
        eventList.add(event);	             	
	}
	
	//output tables in which each row corresponds to one object
	public void outputTables(List<TableObject> objectList, String schema, String path){
		//output the data (tables in the csv format)     
//	    List<Map<String, String>> exportData = new ArrayList<Map<String, String>>();
	    Map<String, List<Map<String, String>>> tableVSData = new HashMap<String, List<Map<String, String>>>();
	    
	    //record the column (index and name) for tables
	    Map<String, LinkedHashMap<String, String>> tableVSColumnIndexVSName = new LinkedHashMap<String, LinkedHashMap<String, String>>();
	    
	    //ranking objects by rowid
	    List<TableObject> originalList = objectList;
		List<TableObject> rankedList = new ArrayList<TableObject>();
		//get source tables
	
		while(originalList.size()>0){
			int minimumId = Integer.MAX_VALUE;
			int  minimumIdIndex = 0;
			for(int i=0; i<originalList.size(); i++){
				int id = Integer.parseInt(originalList.get(i).rowid);		
				if(id < minimumId){
					minimumIdIndex = i;
					minimumId = id;
				}
			}					
			rankedList.add(originalList.get(minimumIdIndex));
			originalList.remove(minimumIdIndex);			
		}
		
		objectList = rankedList;
		
        for(TableObject object : objectList){
        	String tableName = object.table;
        	String rowId = object.rowid;
        	String className = object.className;	
    		String rowIdName = classVSPKs.get(className).get(0); 
    		
        	if(!tableVSData.keySet().contains(tableName)){
        		tableVSData.put(tableName, new ArrayList<Map<String, String>>());
        		tableVSColumnIndexVSName.put(tableName, new LinkedHashMap<String, String>());       		  
    			if(nameVSJtable.containsKey(tableName)){
    				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(tableName).getModel();		
    				List<String> fieldList = tableModel.getFieldRow();
    				for(int i=0; i < fieldList.size(); i++){
    					String columnName = fieldList.get(i);
    					tableVSColumnIndexVSName.get(tableName).put(Integer.toString(i), columnName);
    				}
    			}  
    			else{
    				JOptionPane.showMessageDialog(null, "Wrong, int outputTables function, the nameVSJtable "
    						+ "does not contains the table " + tableName);
    			}

        	}
        	
			if(nameVSJtable.containsKey(tableName)){
				MyTableModel tableModel = (MyTableModel) nameVSJtable.get(tableName).getModel();		
				List<String> fieldList = tableModel.getFieldRow();
				System.out.println("my tableName: " + tableName);
				for(int i=0; i < fieldList.size(); i++){
					String columnName = fieldList.get(i);
					tableVSColumnIndexVSName.get(tableName).put(Integer.toString(i), columnName);
					System.out.println("Integer.toString(i): " + Integer.toString(i));
					System.out.println("columnName: " + columnName);
				}
				
				List<List<Object>> recordList = tableModel.getRecordListWithColumnConstraint(rowIdName, rowId);
				for(List<Object> record : recordList){
					Map<String, String> row = new LinkedHashMap<String, String>();
	            	for(int i=0; i<record.size(); i++){
	            		
	            		if(record.get(i) == null){
	            			row.put(Integer.toString(i), "");
	            		}
	            		else{
	            			row.put(Integer.toString(i), record.get(i).toString());
	            		}
	            	}
	            	tableVSData.get(tableName).add(row);
				}
			}  			
        	
        }
       
        for(String tableName : tableVSData.keySet()){
        	OutputCSVFile.createCSVFile(tableVSData.get(tableName), tableVSColumnIndexVSName.get(tableName), path, tableName);
        }
        
	}
	@SuppressWarnings("unchecked")
	public ArrayList<Event> getEventList(){
		return (ArrayList<Event>) eventList.clone();
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<TableObject> getObjectList(){
		return (ArrayList<TableObject>) objectList.clone();
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<ObjectRelation> getObjectRelationList(){
		return (ArrayList<ObjectRelation>) objectRelationList.clone();
	}	
}

