package org.processmining.ocbc.loggeneration.mysql.abstractlog;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.loggeneration.Event;
import org.processmining.ocbc.loggeneration.ObjectRelation;
import org.processmining.ocbc.loggeneration.TableObject;

public class FilterLogByRemovingNullClass{      
	private List<String> allObjectIdListOfNullClass = new ArrayList<String>();
	private Map<String, String>  objectIdVSClass = new HashMap<String, String>();
	private Map<String, List<String>>  nullObjectIdVSRelatedObjectList = new HashMap<String, List<String>>();
	
	/**
	 * some class maybe used as intermediary to connect other classes; these classes have
	 * a "null" class name. we can filter their objects use the filterLog function
	 * @param eventList
	 * @return
	 */
	public List<Event> filterLog(List<Event> eventList){		
		List<Event> filterEventList = new ArrayList<Event>();
		for (Event event : eventList) {
			System.out.println("event.id: " + event.id);
			System.out.println("before filter event.referredObjectList.size()" + event.referredObjectList.size());
			//filter reference objects
			List<TableObject> objectListOfNullClass = new ArrayList<TableObject>();
			for(TableObject referredObject : event.referredObjectList){
				String className = referredObject.className;
				if(className.equals("null")){
					objectListOfNullClass.add(referredObject);
				}
			}
			event.referredObjectList.removeAll(objectListOfNullClass);
			System.out.println("after filter event.referredObjectList.size()" + event.referredObjectList.size());
			
			System.out.println("before filter event.currentObjectList.size()" + event.currentObjectList.size());
			//filter objects
			objectListOfNullClass = new ArrayList<TableObject>();
			for(TableObject object : event.currentObjectList){
//				String objectId = object.id;
				String objectId = object.name;
				
				String className = object.className;
				System.out.println("className: " + className);
				objectIdVSClass.put(objectId, className);
				if(className.equals("null")){		
					System.out.println("className is null");
					objectListOfNullClass.add(object);
					if(!allObjectIdListOfNullClass.contains(objectId)){
						System.out.println("add into allObjectIdListOfNullClass: " + objectId);
						allObjectIdListOfNullClass.add(objectId);
					}					
				}
			}
			event.currentObjectList.removeAll(objectListOfNullClass);
			System.out.println("after filter event.currentObjectList.size()" + event.currentObjectList.size());
			
			for(String nullObjectId : allObjectIdListOfNullClass){
				System.out.println("nullObjectId: " + nullObjectId);
			}
			System.out.println("before filter event.currentObjectRelationList.size()" + event.currentObjectRelationList.size());
			//filter and create object relations
			List<ObjectRelation> objectRelationListInvolvingNullClass = new ArrayList<ObjectRelation>();
			for(ObjectRelation objectRelation : event.currentObjectRelationList){
				String sourceObjectId = objectRelation.sourceObjectId;
				String targetObjectId = objectRelation.targetObjectId;
				System.out.println("sourceObjectId: " + sourceObjectId);
				System.out.println("targetObjectId: " + targetObjectId);
				if(allObjectIdListOfNullClass.contains(sourceObjectId)){
					objectRelationListInvolvingNullClass.add(objectRelation);
					System.out.println("add objectRelationListInvolvingNullClass");
					if(!nullObjectIdVSRelatedObjectList.containsKey(sourceObjectId)){
						nullObjectIdVSRelatedObjectList.put(sourceObjectId, new ArrayList<String>());
					}
					if(!nullObjectIdVSRelatedObjectList.get(sourceObjectId).contains(targetObjectId)){
						nullObjectIdVSRelatedObjectList.get(sourceObjectId).add(targetObjectId);
					}
				}
				else if(allObjectIdListOfNullClass.contains(targetObjectId)){
					objectRelationListInvolvingNullClass.add(objectRelation);
					System.out.println("add objectRelationListInvolvingNullClass");
					if(!nullObjectIdVSRelatedObjectList.containsKey(targetObjectId)){
						nullObjectIdVSRelatedObjectList.put(targetObjectId, new ArrayList<String>());
					}
					if(!nullObjectIdVSRelatedObjectList.get(targetObjectId).contains(sourceObjectId)){
						nullObjectIdVSRelatedObjectList.get(targetObjectId).add(sourceObjectId);
					}					
				}
			}
			event.currentObjectRelationList.removeAll(objectRelationListInvolvingNullClass);
			System.out.println("after filter event.currentObjectRelationList.size()" + event.currentObjectRelationList.size());
			
			
//			SXTag objectModeObjectRelationsTag = objectModelTag.addChildNode("relations");
//			addObjectRelations(objectModeObjectRelationsTag, event.currentObjectRelationList);
			
			for(String nullObjectId : nullObjectIdVSRelatedObjectList.keySet()){
				List<String> relatedObjectList = nullObjectIdVSRelatedObjectList.get(nullObjectId);
				System.out.println("relatedObjectList: " + relatedObjectList.size());	
				System.out.println("nullObjectId: " + nullObjectId);	
				//equal order line
				if(relatedObjectList.size() == 2){
					String objectIdA = relatedObjectList.get(0);
					String objectIdB = relatedObjectList.get(1);
					String classNameA = objectIdVSClass.get(objectIdA);
					String classNameB = objectIdVSClass.get(objectIdB);
					System.out.println("objectIdA: " + objectIdA);	
					System.out.println("objectIdB: " + objectIdB);	
					System.out.println("classNameA: " + classNameA);	
					System.out.println("classNameB: " + classNameB);	
					List<String> relatedClassList = new ArrayList<String>();
					relatedClassList.add(classNameA);
					relatedClassList.add(classNameB);
					if(relatedClassList.contains("order") && relatedClassList.contains("invoice")){
						if(classNameA.equals("order")){
							System.out.println("create order-invoice relation： order");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdA + "-" + objectIdB;
							objectRelation.sourceObjectId = objectIdA;
							objectRelation.targetObjectId = objectIdB;
							objectRelation.relationType = classNameA + "-artifical-" + classNameB;
							event.currentObjectRelationList.add(objectRelation);
						}
						else if(classNameA.equals("invoice")){
							System.out.println("create order-invoice relation： invoice");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdB + "-" + objectIdA;
							objectRelation.sourceObjectId = objectIdB;
							objectRelation.targetObjectId = objectIdA;
							objectRelation.relationType = classNameB + "-artifical-" + classNameA;
							event.currentObjectRelationList.add(objectRelation);
						}
					}
					else if(relatedClassList.contains("shipment") && relatedClassList.contains("order_line")){
						if(classNameA.equals("shipment")){
							System.out.println("create shipment-order_line relation： shipment");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdB + "-" + objectIdA;
							objectRelation.sourceObjectId = objectIdB;
							objectRelation.targetObjectId = objectIdA;
							objectRelation.relationType = classNameB + "-artifical-" + classNameA;
							event.currentObjectRelationList.add(objectRelation);
						}
						else if(classNameA.equals("order_line")){
							System.out.println("create shipment-order_line relation： order_line");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdB + "-" + objectIdA;
							objectRelation.sourceObjectId = objectIdB;
							objectRelation.targetObjectId = objectIdA;
							objectRelation.relationType = classNameB + "-artifical-" + classNameA;
							event.currentObjectRelationList.add(objectRelation);
						}
					}
					else if(relatedClassList.contains("invoice") && relatedClassList.contains("payment")){
						if(classNameA.equals("invoice")){
							System.out.println("create invoice-payment relation： invoice");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdB + "-" + objectIdA;
							objectRelation.sourceObjectId = objectIdB;
							objectRelation.targetObjectId = objectIdA;
							objectRelation.relationType = classNameB + "-artifical-" + classNameA;
							event.currentObjectRelationList.add(objectRelation);
						}
						else if(classNameA.equals("payment")){
							System.out.println("create invoice-payment relation： payment");		
							ObjectRelation objectRelation = new ObjectRelation();
							objectRelation.id = objectIdB + "-" + objectIdA;
							objectRelation.sourceObjectId = objectIdB;
							objectRelation.targetObjectId = objectIdA;
							objectRelation.relationType = classNameB + "-artifical-" + classNameA;
							event.currentObjectRelationList.add(objectRelation);
						}
					}
					
				}				
			}
		}
		return filterEventList;
	}
}

