package org.processmining.ocbc.loggeneration.mysql.dolibarr;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.loggeneration.mysql.abstractlog.CreateLogFromChangeTables;
import org.processmining.ocbc.loggeneration.postgresql.outputlog.OutputXMLLog;




 
 
public class CreatePickWrapDeliver {

	public static void main(String[] args) throws Exception {
		
	    //record the mapping from table name to class name; we create one class for each related table
	    Map<String, String> tableVSClass = new HashMap<String, String>();;

	    //for one table (name), record the tables (name) it relies on
	    Map<String, List<String>> tableVSDependentTables = new HashMap<String, List<String>>();    
	    
	    //record what the primary key of one table is called in its children table as foreign key
	    Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
	    
	    //record which classes one activity refers to
	    Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
	    
	    //record which table columns will be modified by one activity
	    Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
	    
	    //record which table columns will be modified by one activity
	    Map<String, List<String>> initialTableVSColumns = new HashMap<String, List<String>>();
	    
	    
		tableVSClass.put("llx_commande", "order");
		tableVSClass.put("llx_commandedet", "order line");	
		tableVSClass.put("llx_expedition", "delivery"); 
		tableVSClass.put("llx_product", "product"); 
		tableVSClass.put("llx_societe", "customer"); 

    	
    	//add father tables for order
    	tableVSDependentTables.put("llx_commande", new ArrayList<String>());
    	tableVSDependentTables.get("llx_commande").add("llx_societe"); 
    	//add father tables for order line
    	tableVSDependentTables.put("llx_commandedet", new ArrayList<String>());
    	tableVSDependentTables.get("llx_commandedet").add("llx_commande");
    	tableVSDependentTables.get("llx_commandedet").add("llx_expedition");
    	tableVSDependentTables.get("llx_commandedet").add("llx_product");   
    	//add father tables for expedition
    	tableVSDependentTables.put("llx_expedition", new ArrayList<String>());
    	tableVSDependentTables.get("llx_expedition").add("llx_societe"); 
    	
    	
    	tableVSForeignKey.put("llx_product", new ArrayList<String>());
		tableVSForeignKey.get("llx_product").add("fk_product");
    	tableVSForeignKey.put("llx_societe", new ArrayList<String>());
		tableVSForeignKey.get("llx_societe").add("fk_soc");
    	tableVSForeignKey.put("llx_commande", new ArrayList<String>());
		tableVSForeignKey.get("llx_commande").add("fk_commande");
		tableVSForeignKey.put("llx_expedition", new ArrayList<String>());
		tableVSForeignKey.get("llx_expedition").add("delivery");
    	    	
    	//add reference classes for activities
    	activityVSClasses.put("create order", new ArrayList<String>());
    	activityVSClasses.get("create order").add("order");
    	activityVSClasses.put("pick item", new ArrayList<String>());
    	activityVSClasses.get("pick item").add("order line");
    	activityVSClasses.put("wrap item", new ArrayList<String>());
    	activityVSClasses.get("wrap item").add("order line");
    	activityVSClasses.put("deliver items", new ArrayList<String>());
    	activityVSClasses.get("deliver items").add("delivery");   	    	
    	activityVSClasses.put("unknown", new ArrayList<String>());

		
    	activityVSModifiedColumns.put("create order", new ArrayList<String>());
    	activityVSModifiedColumns.get("create order").add("llx_commande-fk_soc");
    	activityVSModifiedColumns.put("pick item", new ArrayList<String>());
    	activityVSModifiedColumns.get("pick item").add("llx_commandedet-time_pick");
    	activityVSModifiedColumns.put("wrap item", new ArrayList<String>());
    	activityVSModifiedColumns.get("wrap item").add("llx_commandedet-time_wrap");
    	activityVSModifiedColumns.put("deliver items", new ArrayList<String>());
    	activityVSModifiedColumns.get("deliver items").add("llx_expedition-fk_soc");
	
    	initialTableVSColumns.put("llx_product", new ArrayList<String>());
    	initialTableVSColumns.get("llx_product").add("rowid");
    	initialTableVSColumns.get("llx_product").add("label");
    	initialTableVSColumns.get("llx_product").add("price");
    	initialTableVSColumns.put("llx_societe", new ArrayList<String>());
    	initialTableVSColumns.get("llx_societe").add("rowid");
    	initialTableVSColumns.get("llx_societe").add("nom");
    	initialTableVSColumns.get("llx_societe").add("phone");
    	initialTableVSColumns.get("llx_societe").add("email");
         
		CreateLogFromChangeTables database = new CreateLogFromChangeTables(tableVSClass, tableVSDependentTables, 
				tableVSForeignKey, activityVSClasses, activityVSModifiedColumns);
    	database.connect();   	
    	
    	//create initial objects
    	for(String table : initialTableVSColumns.keySet()){
    		database.extractInitialRootObjectsFromOneTable("onlineshopping", table, "rowid", 
    				initialTableVSColumns.get(table), tableVSClass.get(table), null);     	
    	}  	
    	
    	database.extractEventsFromChangeTable("onlineshopping", "llx_cdhdr", "llx_cdpos");     	
        OutputXMLLog generateLog = new OutputXMLLog("E:\\outputDolibarr.xoc");
        generateLog.createLog(database.getEventList(), xConstants.UPDATE);
	}
}