package org.processmining.ocbc.loggeneration.mysql.dolibarr;

import java.io.File;
import java.sql.SQLException;
import java.text.ParseException;
import java.util.List;

import org.processmining.ocbc.logconversion.configurations.ConfigurationConstants;
import org.processmining.ocbc.logconversion.configurations.ConfigurationParameters;
import org.processmining.ocbc.loggeneration.mysql.abstractlog.CreateLogFromEventList;
import org.processmining.ocbc.loggeneration.mysql.eventlist.TableEvent;
import org.processmining.ocbc.loggeneration.postgresql.outputlog.OutputXMLLog;
 
public class GenerateXOCLog {	
	private ConfigurationParameters configuration = new ConfigurationParameters();
	
	public GenerateXOCLog(ConfigurationParameters configuration){
		this.configuration = configuration;
	}
	
	public void generate(String path, String logFormat) throws SQLException, ParseException, Exception{
		//create (TableEvent) event list
		System.out.println("enter generate function");
		GenerateXOCEventStateList eventListGenerator = new GenerateXOCEventStateList(configuration);
		List<TableEvent> eveltList = eventListGenerator.createEventList();
		System.out.println("after create event list");
		String schema = configuration.getNameVSMapParameterMap().get(ConfigurationConstants.connectionParameterNameVSValueMap).get(ConfigurationConstants.SCHEMA);
		//create log from event list
		CreateLogFromEventList database = new CreateLogFromEventList(configuration); 	   	
    	database.extractEventsFromEventList(eveltList, schema);   
    	System.out.println("after extract events");
        OutputXMLLog generateLog = new OutputXMLLog(path);
        
//        FilterLogByRemovingNullClass filterNullClass = new FilterLogByRemovingNullClass();
//        filterNullClass.filterLog(database.getEventList());   
//        System.out.println("after filter events");
        
        generateLog.createLog(database.getEventList(), logFormat);   

        //transform into XOC log object
        
        
		//output the data (tables in the csv format)       
        File file = new File(path);
        String pathWithoutFileName = file.getParent();
        System.out.println("pathWithoutFileName" + pathWithoutFileName);
        int eventListSize = database.getEventList().size();
        if(eventListSize > 0){
        	   database.outputTables(database.getEventList().get(eventListSize-1).currentObjectList, schema, pathWithoutFileName + "\\tables\\");
        }    
	}
	
	
}