package org.processmining.ocbc.loggeneration.mysql.dolibarr;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.loggeneration.mysql.eventlist.TableEvent;

 

public class ReimbursementEventList{

    
//	public static void main(String[] str) throws Exception{
	public List<TableEvent> createEventList() throws Exception{
		
	    //record what the primary key of one table is called in its children table as foreign key
		Map<String, Map<String, String>> tableVSTableForeignKey = new HashMap<String, Map<String, String>>();
	    
	    //for one table (name), record the tables (name) it relies on
	    Map<String, List<String>> tableVSFatherTables = new HashMap<String, List<String>>();
	    
	   //for one table (name), record other child tables (name)
	    Map<String, List<String>> tableVSChildTables = new HashMap<String, List<String>>();
	    
	    //for one table (table name), which columns (column names) will be considered as event source, e.g., question-[creationdata, closeddate] (events related to objects)
	    Map<String, List<String>> tableVSEventColumns = new HashMap<String, List<String>>();
	    
	    //In a business process, some happening objects (events), called source objects (events), trigger the occurrences of following objects (events), 
	    //e.g., creating order will trigger pick item, deliver items.
	    //for one source table (table name), which rows (id names) will be considered as source objects, e.g., question-[181,182]
	    Map<String, List<String>> sourceTableVSRowIds = new HashMap<String, List<String>>();
	    
	    //for one table event column (table name + column name), which table column will be impacted through which column, table-column-[table-column-intermediacolumn]
	    //e.g., question-creationdate-[question-id-id,question-creationdate-id,question-body-id]
	    //e.g., order-creationdate-[order-id-id,order-creationdate-id,orderline-id-command...]
	    Map<String, List<String>> tableColumnVSImpactedTableColumns = new HashMap<String, List<String>>();
	    
	    //assign a change type to each table event column (table name + column name), e.g., "I" for insertion, "U" for update
	    Map<String, String> tableColumnVSChangeType = new HashMap<String, String>();
	    
	    //assign a activity to each table event column (table name + column name), e.g., "create project" for "projet-datec"
	    Map<String, String> tableColumnVSActivity = new HashMap<String, String>();
	    
		//build the database schema		
		tableVSFatherTables.put("llx_projet", new ArrayList<String>());
		tableVSFatherTables.get("llx_projet").add("llx_user"); 
		tableVSFatherTables.put("llx_expensereport", new ArrayList<String>());
		tableVSFatherTables.get("llx_expensereport").add("llx_user");
		tableVSFatherTables.put("llx_expensereport_det", new ArrayList<String>());
		tableVSFatherTables.get("llx_expensereport_det").add("llx_projet");
		tableVSFatherTables.get("llx_expensereport_det").add("llx_expensereport");   	
		tableVSFatherTables.put("llx_payment_expensereport", new ArrayList<String>());
		tableVSFatherTables.get("llx_payment_expensereport").add("llx_user");
		tableVSFatherTables.get("llx_payment_expensereport").add("llx_expensereport");
    	
		tableVSChildTables.put("llx_user", new ArrayList<String>());
		tableVSChildTables.get("llx_user").add("llx_projet");
		tableVSChildTables.get("llx_user").add("llx_expensereport"); 
		tableVSChildTables.get("llx_user").add("llx_payment_expensereport"); 
		tableVSChildTables.put("llx_projet", new ArrayList<String>());
		tableVSChildTables.get("llx_projet").add("llx_expensereport_det");
		tableVSChildTables.put("llx_expensereport", new ArrayList<String>());
		tableVSChildTables.get("llx_expensereport").add("llx_expensereport_det");
		tableVSChildTables.get("llx_expensereport").add("llx_payment_expensereport");
		
		
		tableVSTableForeignKey.put("llx_projet", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_projet").put("llx_expensereport_det", "fk_projet");
		tableVSTableForeignKey.put("llx_expensereport", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_expensereport").put("llx_expensereport_det", "fk_expensereport");
		tableVSTableForeignKey.get("llx_expensereport").put("llx_payment_expensereport", "fk_expensereport");
		tableVSTableForeignKey.put("llx_user", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_user").put("llx_projet", "fk_user_creat");
		tableVSTableForeignKey.get("llx_user").put("llx_payment_expensereport", "fk_user_creat");
		tableVSTableForeignKey.get("llx_user").put("llx_expensereport", "fk_user_approve");
		tableVSTableForeignKey.get("llx_user").put("llx_expensereport", "fk_user_refuse");
		tableVSTableForeignKey.get("llx_user").put("llx_expensereport", "fk_user_author");
		
		
		//build the reference relations (class-activity)
		tableVSEventColumns.put("llx_projet", new ArrayList<String>());
		tableVSEventColumns.get("llx_projet").add("datec"); 
		tableVSEventColumns.get("llx_projet").add("dateo"); 
		tableVSEventColumns.get("llx_projet").add("datee"); 		
		tableVSEventColumns.put("llx_expensereport_det", new ArrayList<String>());
		tableVSEventColumns.get("llx_expensereport_det").add("date"); 
		tableVSEventColumns.put("llx_expensereport", new ArrayList<String>());
		tableVSEventColumns.get("llx_expensereport").add("date_valid"); 
		tableVSEventColumns.get("llx_expensereport").add("date_approve"); 
		tableVSEventColumns.get("llx_expensereport").add("date_refuse"); 
		tableVSEventColumns.put("llx_payment_expensereport", new ArrayList<String>());
		tableVSEventColumns.get("llx_payment_expensereport").add("datep"); 
		
		//assign activities to events
		tableColumnVSActivity.put("llx_projet-datec", "create project");
		tableColumnVSActivity.put("llx_projet-dateo", "project start");
		tableColumnVSActivity.put("llx_projet-datee", "project end");		
		tableColumnVSActivity.put("llx_expensereport_det-date", "consume");		
		tableColumnVSActivity.put("llx_expensereport-date_valid", "submit reimbursement");
		tableColumnVSActivity.put("llx_expensereport-date_approve", "approve");
		tableColumnVSActivity.put("llx_expensereport-date_refuse", "refuse");
		tableColumnVSActivity.put("llx_payment_expensereport-datep", "pay");
		
		
		//build the cdpos table format
		tableColumnVSImpactedTableColumns.put("llx_projet-datec", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-rowid-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-title-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-fk_user_creat-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-fk_statut-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "I");
		
		
		tableColumnVSImpactedTableColumns.put("llx_expensereport_det-date", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-id-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-fk_projet-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-fk_expensereport-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport-rowid-fk_expensereport");
		tableColumnVSChangeType.put("llx_expensereport_det-date", "I");
		
		
		tableColumnVSImpactedTableColumns.put("llx_payment_expensereport-datep", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_payment_expensereport-datep").add("llx_payment_expensereport-rowid-rowid");
		tableColumnVSImpactedTableColumns.get("llx_payment_expensereport-datep").add("llx_payment_expensereport-fk_expensereport-rowid");
		tableColumnVSChangeType.put("llx_payment_expensereport-datep", "I");
		
		//build the source objects
		sourceTableVSRowIds.put("llx_projet", new ArrayList<String>());
//		for(int i=100; i<=217; i++){
//			sourceTableVSRowIds.get("llx_projet").add(i); 
//		}
//		sourceTableVSRowIds.get("llx_projet").add(219); 
//		sourceTableVSRowIds.get("llx_projet").add(220); 
//		sourceTableVSRowIds.get("llx_projet").add(218); //demoOld
		
		sourceTableVSRowIds.get("llx_projet").add("587"); 
		sourceTableVSRowIds.get("llx_projet").add("588"); 
		sourceTableVSRowIds.get("llx_projet").add("589");
		return null; 
				
//		List<TableEvent> rankedChangeList = new ArrayList<TableEvent>();
//		CreateEventList eventList = new CreateEventList(tableVSTableForeignKey, tableVSFatherTables,
//				tableVSChildTables, tableVSEventColumns,
//				tableColumnVSImpactedTableColumns, tableColumnVSChangeType,
//				sourceTableVSRowIds, "onlineshopping", "cdhdr2", "cdpos2", tableColumnVSActivity,tableVSChainedChildTables);
//		
//	
//		eventList.connect();
//		eventList.createChangeSequence();
//        
//        rankedChangeList = eventList.rankChangeSequence();
//        System.out.println("size of change list: " + rankedChangeList.size());
//        for(TableEvent change :  rankedChangeList){
//        	System.out.println("\n ****************");
//        	 System.out.println("\n change table: " + change.table);
//        	 System.out.println("\n change column: " + change.column);
//        	 System.out.println("\n change id: " + change.id);
//        	 System.out.println("\n change time: " + change.time);
//        	 System.out.println("\n activity: " + change.activity);
//        }       
//        return rankedChangeList;     			    		
	}
}
