package org.processmining.ocbc.loggeneration.mysql.dolibarr;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
 
public class ReimbursementLog {

	public static void main(String[] args) throws Exception {
		
	    //record the mapping from table name to class name; we create one class for each related table
	    Map<String, String> tableVSClass = new HashMap<String, String>();;

	    //for one table (name), record the tables (name) it relies on
	    Map<String, List<String>> tableVSDependentTables = new HashMap<String, List<String>>();    
	    
	    //record what the primary key of one table is called in its children table as foreign key
	    Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
	    
	    //record what the primary key of one table is called in its children table as foreign key
	   	Map<String, Map<String, String>> tableVSTableForeignKey = new HashMap<String, Map<String, String>>();
	   	
	    //record which classes one activity refers to
	    Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
	    
	    //record which table columns will be modified by one activity
	    Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
	    
	    //record which table columns will be modified by one activity
	    Map<String, List<String>> initialTableVSColumns = new HashMap<String, List<String>>();
	    
	    //for one table event column (table name + column name), which table column will be impacted through which column, table-column-[table-column-intermediacolumn]
	    //e.g., question-creationdate-[question-id-id,question-creationdate-id,question-body-id]
	    //e.g., order-creationdate-[order-id-id,order-creationdate-id,orderline-id-command...]
	    Map<String, List<String>> tableColumnVSImpactedTableColumns = new HashMap<String, List<String>>();
	    	    
	    //assign a change type to each table event column (table name + column name), e.g., "I" for insertion, "U" for update
	    Map<String, String> tableColumnVSChangeType = new HashMap<String, String>();
	    
	    //record which table columns are the attributes (e.g., resource) of an event column
	    Map<String, List<String>> tableColumnVSAttributesColumns = new HashMap<String, List<String>>();
	    
		tableVSClass.put("llx_projet", "project");
		tableVSClass.put("llx_expensereport", "expenses");	
		tableVSClass.put("llx_expensereport_det", "expense line");		
		tableVSClass.put("llx_user", "employee"); 
		tableVSClass.put("llx_payment_expensereport", "payment");   	

    	tableVSDependentTables.put("llx_projet", new ArrayList<String>());
    	tableVSDependentTables.get("llx_projet").add("llx_user"); 
    	tableVSDependentTables.put("llx_expensereport", new ArrayList<String>());
    	tableVSDependentTables.get("llx_expensereport").add("llx_user");
    	tableVSDependentTables.put("llx_expensereport_det", new ArrayList<String>());
    	tableVSDependentTables.get("llx_expensereport_det").add("llx_projet");
    	tableVSDependentTables.get("llx_expensereport_det").add("llx_expensereport");   	
    	tableVSDependentTables.put("llx_payment_expensereport", new ArrayList<String>());
    	tableVSDependentTables.get("llx_payment_expensereport").add("llx_user");
    	tableVSDependentTables.get("llx_payment_expensereport").add("llx_expensereport");
    	
    	
    	tableVSForeignKey.put("llx_projet", new ArrayList<String>());
		tableVSForeignKey.get("llx_projet").add("fk_projet");
    	tableVSForeignKey.put("llx_expensereport", new ArrayList<String>());
		tableVSForeignKey.get("llx_expensereport").add("fk_expensereport");
    	tableVSForeignKey.put("llx_user", new ArrayList<String>());
		tableVSForeignKey.get("llx_user").add("fk_user_creat");
		tableVSForeignKey.get("llx_user").add("fk_user_approve");
		tableVSForeignKey.get("llx_user").add("fk_user_refuse");
		tableVSForeignKey.get("llx_user").add("fk_user_valid");
		
		tableVSTableForeignKey.put("llx_projet", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_projet").put("llx_expensereport_det", "fk_projet");
		tableVSTableForeignKey.put("llx_expensereport", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_expensereport").put("llx_expensereport_det", "fk_expensereport");
		tableVSTableForeignKey.get("llx_expensereport").put("llx_payment_expensereport", "fk_expensereport");
		tableVSTableForeignKey.put("llx_user", new HashMap<String, String>());
		tableVSTableForeignKey.get("llx_user").put("llx_projet", "fk_user_creat");
		tableVSTableForeignKey.get("llx_user").put("llx_payment_expensereport", "fk_user_creat");
		//if there exist nultiple foreign keys referring to one table
		tableVSTableForeignKey.get("llx_user").put("llx_expensereport", "fk_user_author-fk_user_approve-fk_user_refuse");

    	    	
    	//add reference classes for activities
    	activityVSClasses.put("create project", new ArrayList<String>());
    	activityVSClasses.get("create project").add("project");
    	activityVSClasses.put("project start", new ArrayList<String>());
    	activityVSClasses.get("project start").add("project");
    	activityVSClasses.put("project end", new ArrayList<String>());
    	activityVSClasses.get("project end").add("project");
    	activityVSClasses.put("consume", new ArrayList<String>());
    	activityVSClasses.get("consume").add("expense line");
    	activityVSClasses.put("submit reimbursement", new ArrayList<String>());
    	activityVSClasses.get("submit reimbursement").add("expenses");
    	activityVSClasses.put("refuse", new ArrayList<String>());
    	activityVSClasses.get("refuse").add("expenses");
    	activityVSClasses.put("approve", new ArrayList<String>());
    	activityVSClasses.get("approve").add("expenses");
    	activityVSClasses.put("pay", new ArrayList<String>());
    	activityVSClasses.get("pay").add("payment");   	   	

		
    	activityVSModifiedColumns.put("create order", new ArrayList<String>());
    	activityVSModifiedColumns.get("create order").add("llx_commande-fk_soc");
    	activityVSModifiedColumns.put("pick item", new ArrayList<String>());
    	activityVSModifiedColumns.get("pick item").add("llx_commandedet-time_pick");
    	activityVSModifiedColumns.put("wrap item", new ArrayList<String>());
    	activityVSModifiedColumns.get("wrap item").add("llx_commandedet-time_wrap");
    	activityVSModifiedColumns.put("deliver items", new ArrayList<String>());
    	activityVSModifiedColumns.get("deliver items").add("llx_expedition-fk_soc");
	
    	initialTableVSColumns.put("llx_user", new ArrayList<String>());
    	initialTableVSColumns.get("llx_user").add("rowid");
    	initialTableVSColumns.get("llx_user").add("lastname");
    	initialTableVSColumns.get("llx_user").add("email");
    	
		//build the cdpos table format
		tableColumnVSImpactedTableColumns.put("llx_projet-datec", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-rowid-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-title-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-datec-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-fk_user_creat-rowid");
		tableColumnVSImpactedTableColumns.get("llx_projet-datec").add("llx_projet-fk_statut-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "I");
		tableColumnVSImpactedTableColumns.put("llx_projet-dateo", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_projet-dateo").add("llx_projet-dateo-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "U");
		tableColumnVSImpactedTableColumns.put("llx_projet-datee", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_projet-datee").add("llx_projet-datee-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "U");
		
		
		tableColumnVSImpactedTableColumns.put("llx_expensereport-date_valid", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_valid").add("llx_expensereport-date_valid-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_valid").add("llx_expensereport-fk_user_valid-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "U");
		tableColumnVSImpactedTableColumns.put("llx_expensereport-date_approve", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_approve").add("llx_expensereport-date_approve-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_approve").add("llx_expensereport-fk_user_approve-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "U");
		tableColumnVSImpactedTableColumns.put("llx_expensereport-date_refuse", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_refuse").add("llx_expensereport-date_refuse-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport-date_refuse").add("llx_expensereport-fk_user_refuse-rowid");
		tableColumnVSChangeType.put("llx_projet-datec", "U");
		
		tableColumnVSImpactedTableColumns.put("llx_expensereport_det-date", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-id-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-fk_projet-rowid");
		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport_det-fk_expensereport-rowid");		
//		tableColumnVSImpactedTableColumns.get("llx_expensereport_det-date").add("llx_expensereport-rowid-fk_expensereport");
		tableColumnVSChangeType.put("llx_expensereport_det-date", "I");
		
		
		tableColumnVSImpactedTableColumns.put("llx_payment_expensereport-datep", new ArrayList<String>());
		tableColumnVSImpactedTableColumns.get("llx_payment_expensereport-datep").add("llx_payment_expensereport-rowid-rowid");
		tableColumnVSImpactedTableColumns.get("llx_payment_expensereport-datep").add("llx_payment_expensereport-fk_expensereport-rowid");
		tableColumnVSImpactedTableColumns.get("llx_payment_expensereport-datep").add("llx_payment_expensereport-fk_user_creat-rowid");
		tableColumnVSChangeType.put("llx_payment_expensereport-datep", "I");


		tableColumnVSAttributesColumns.put("llx_projet-datec", new ArrayList<String>());
		tableColumnVSAttributesColumns.get("llx_projet-datec").add("resource-fk_user_creat");
		tableColumnVSAttributesColumns.put("llx_expensereport-date_valid", new ArrayList<String>());
		tableColumnVSAttributesColumns.get("llx_expensereport-date_valid").add("resource-fk_user_valid");
		tableColumnVSAttributesColumns.put("llx_expensereport-date_approve", new ArrayList<String>());
		tableColumnVSAttributesColumns.get("llx_expensereport-date_approve").add("resource-fk_user_approve");
		tableColumnVSAttributesColumns.put("llx_expensereport-date_refuse", new ArrayList<String>());
		tableColumnVSAttributesColumns.get("llx_expensereport-date_refuse").add("resource-fk_user_refuse");
		tableColumnVSAttributesColumns.put("llx_payment_expensereport-datep", new ArrayList<String>());
		tableColumnVSAttributesColumns.get("llx_payment_expensereport-datep").add("resource-fk_user_creat");

         
		ReimbursementEventList reimbursementEventList = new ReimbursementEventList();
//		CreateLogFromEventList database = new CreateLogFromEventList(tableVSClass, tableVSDependentTables, 
//				tableVSForeignKey, activityVSClasses, activityVSModifiedColumns, tableColumnVSImpactedTableColumns, 
//				tableColumnVSChangeType,tableVSTableForeignKey, tableColumnVSAttributesColumns);
//    	database.connect();   	
//    	
//    	//create initial objects
////    	for(String table : initialTableVSColumns.keySet()){
////    		database.extractInitialRootObjectsFromOneTable("onlineshopping", table, "rowid", 
////    				initialTableVSColumns.get(table), tableVSClass.get(table), null);     	
////    	}  	
//    	
//    	database.extractEventsFromEventList(reimbursementEventList.createEventList(), "onlineshopping");;     	
//        OutputXMLLog generateLog = new OutputXMLLog("E:\\DolibarrExpenseReport.xoc");
//        generateLog.createLog(database.getEventList());
	}
	
	
}