package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JTable;

import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class ActivityImpactingColumnPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {

    }
    
    private JComboBox<String> activityBox = new JComboBox<String>();
    private JComboBox<String> tableBox = new JComboBox<String>();
    private JComboBox<String> fieldBox = new JComboBox<String>();
    private JComboBox<String> intermediateKeyBox = new JComboBox<String>();
    private String dataname = "";
    
//    private JList selectedTableList;
    private DataModelInspector dataModelInspector;
    
    private SelectedTablePanel selectedTablePanel;
    private TableStructurePanel tableStructurePanel;
    private JButton removeButton;
    private JButton clearButton;
    private JButton addButton;
    private CreateTablePanel activityImpactingColumnTablePanel;
    
    //for one table event column (table name + column name), which table column will be impacted through which column, table-column-[table-column-intermediacolumn]
    //e.g., question-creationdate-[question-id-id,question-creationdate-id,question-body-id]
    //e.g., order-creationdate-[order-id-id,order-creationdate-id,orderline-id-command...]
    private Map<String, List<String>> tableColumnVSImpactedTableColumns = new HashMap<String, List<String>>();
  
    
    public ActivityImpactingColumnPanel(final SelectedTablePanel selectedTablePanel,
    		final TableStructurePanel tableStructurePanel, final DataModelInspector dataModelInspector) {
    	this.selectedTablePanel = selectedTablePanel;
    	this.tableStructurePanel = tableStructurePanel;
    	this.dataModelInspector = dataModelInspector;
    	
    	
    	
    	List<String> selectedTableList = dataModelInspector.getSelectedTablePanel().getSelectedTableList();
        for(String selectedTable : selectedTableList){
        	tableBox.addItem(selectedTable);
        }
        
        tableBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                String tablename = (String) tableBox.getSelectedItem();
                String currentTableName = selectedTablePanel.getTablename();
                if(tablename != null){
	                setDataname(tablename);
                    updateFieldBox(tablename);
                    updateIntermediateKeyBox(tablename, currentTableName);
                }
            }
        });
	
       
	
    	addButton = new JButton("add");
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the button");
				String activityField = (String) activityBox.getSelectedItem();
				String impactingTable = (String) tableBox.getSelectedItem();
				String impactingField = (String) fieldBox.getSelectedItem();
				String impactingIntermediateKey = (String) intermediateKeyBox.getSelectedItem();
				
				
				if(activityBox.getSelectedItem() != null && tableBox.getSelectedItem() != null && 
						fieldBox.getSelectedItem() != null && intermediateKeyBox.getSelectedItem() != null){
					List<Object> valueList = new ArrayList<Object>();
					valueList.add(activityField);
					valueList.add(impactingTable);
					valueList.add(impactingField);
					valueList.add(impactingIntermediateKey);
					activityImpactingColumnTablePanel.addRecordRow(valueList);
					activityImpactingColumnTablePanel.updateTable();
					
					//add the new reference relation into the variables(create table-column vs impacted table-column-key table mapping)	
					String currentTableName = selectedTablePanel.getTablename();
					String activityKey = currentTableName + "-" + activityField;
					String impactedValue = impactingTable + "-" + impactingField + "-" + impactingIntermediateKey;
					if(!tableColumnVSImpactedTableColumns.containsKey(activityKey)){
						tableColumnVSImpactedTableColumns.put(activityKey, new ArrayList<String>());
					}					
					if(!tableColumnVSImpactedTableColumns.get(activityKey).contains(impactedValue))
						tableColumnVSImpactedTableColumns.get(activityKey).add(impactedValue);
					
					for(String key : tableColumnVSImpactedTableColumns.keySet()){
						System.out.print("\n key: " + key);
						for(String value : tableColumnVSImpactedTableColumns.get(key)){
							System.out.print("\n value: " + value);
						}
					}
				}				
			}
		});
    	
    	 
    	clearButton = new JButton("clear");
    	clearButton.addActionListener(new ActionListener()
 		{
 			public void actionPerformed(ActionEvent e)
 			{			
 				JTable table = activityImpactingColumnTablePanel.getTable();
 				MyTableModel tableModel = (MyTableModel) table.getModel();
				String currentTableName = selectedTablePanel.getTablename();
				for(int i=0; i<activityBox.getItemCount(); i++){
					String tableAndActivityColumn = currentTableName + "-" + activityBox.getItemAt(i);
					tableColumnVSImpactedTableColumns.remove(tableAndActivityColumn);
				}				
				//remove the selected record from table
				tableModel.clearAllTableRows();
				tableModel.updateTable();
 			}																					
 		}); 
         
        removeButton = new JButton("remove");
        removeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				JTable table = activityImpactingColumnTablePanel.getTable();
				MyTableModel tableModel = (MyTableModel) table.getModel();
				int selectdRow  = table.getSelectedRow();
				if(selectdRow >= 0){					
					//remove the record from the (mapping) variables 				
					String activityField = (String) tableModel.getValueAt(selectdRow, 1);
					String impactingTable = (String) tableModel.getValueAt(selectdRow, 2);;
					String impactingField = (String) tableModel.getValueAt(selectdRow, 3);;
					String impactingIntermediateKey = (String) tableModel.getValueAt(selectdRow, 4);
					
					String currentTableName = selectedTablePanel.getTablename();
					String activityKey = currentTableName + "-" + activityField;
					String impactedValue = impactingTable + "-" + impactingField + "-" + impactingIntermediateKey;
					if(tableColumnVSImpactedTableColumns.containsKey(activityKey)){
						if(tableColumnVSImpactedTableColumns.get(activityKey).contains(impactedValue)){
							tableColumnVSImpactedTableColumns.get(activityKey).remove(impactedValue);
						}
						if(tableColumnVSImpactedTableColumns.get(activityKey).size() == 0){
							tableColumnVSImpactedTableColumns.remove(activityKey);
						}
					}	
					
					//remove the selected record from table
					tableModel.removeRecordRow(selectdRow);
					tableModel.updateTable();					
				}

			}																					
		});       
              
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BorderLayout());
        buttonPanel.setMaximumSize(new Dimension(500,40));
        clearButton.setMaximumSize(new Dimension(100,40));
        buttonPanel.add(removeButton, BorderLayout.LINE_START);
//        buttonPanel.add(clearButton);      
        buttonPanel.add(addButton, BorderLayout.LINE_END);
        
        activityBox.setPrototypeDisplayValue("length");
        tableBox.setPrototypeDisplayValue("table_max_length");
        fieldBox.setPrototypeDisplayValue("length");
        intermediateKeyBox.setPrototypeDisplayValue("table_max_length");
        activityBox.setRenderer(new ComboBoxRenderer(activityBox));
        activityBox.setToolTipText("activity field");
        tableBox.setRenderer(new ComboBoxRenderer(tableBox));
        tableBox.setToolTipText("possibly impacting table");
        fieldBox.setRenderer(new ComboBoxRenderer(fieldBox));
        fieldBox.setToolTipText("impacting field");
        intermediateKeyBox.setRenderer(new ComboBoxRenderer(intermediateKeyBox));
        intermediateKeyBox.setToolTipText("intermediate key");
        
    	JPanel selectionPanel = new JPanel();
    	selectionPanel.setMaximumSize(new Dimension(500,40));
    	selectionPanel.setLayout(new BoxLayout(selectionPanel, BoxLayout.X_AXIS));    
//    	tableBox.setMaximumSize(new Dimension(50,30));
//    	tableBox.setMaximumSize( tableBox.getPreferredSize() );
    	selectionPanel.add(activityBox);
    	selectionPanel.add(tableBox);
    	selectionPanel.add(fieldBox);
    	selectionPanel.add(intermediateKeyBox);
    	

    	
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        activityImpactingColumnTablePanel = new CreateTablePanel("");
        List<String> tableFieldRow = new ArrayList<String>();
        tableFieldRow.add("index");
        tableFieldRow.add("activity field");
        tableFieldRow.add("impacting table");
        tableFieldRow.add("impacting field");
        tableFieldRow.add("intermediate key");
        
        activityImpactingColumnTablePanel.setFieldRow(tableFieldRow);
        activityImpactingColumnTablePanel.updateTable();
        
        this.add(buttonPanel);     
        this.add(selectionPanel);
        this.add(activityImpactingColumnTablePanel.getScrollPane());
        this.setBorder(BorderFactory.createTitledBorder("activity impacting field"));        
    }
 
    /*
     * update the table activity impacting panel for the input table
     */
    public void update(String tableName){
    	System.out.println("update activity impacting panel");
    	//update table box and its child boxes
        String currentTableName = selectedTablePanel.getTablename();        
        updateActivityBox(currentTableName);      
        updateTableBox(currentTableName);        
        updateTable(currentTableName);
    }
    
    public void updateActivityBox(String currentTableName){
    	//update activity box-show all activity columns related the selected class
    	String selectedClassName = tableStructurePanel.getClassName();
        activityBox.removeAllItems();
        if(tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().containsKey(selectedClassName)){
			for(String activityColumnName : tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().get(selectedClassName).keySet()){	
				System.out.println("activityColumnName: " + activityColumnName);		
				activityBox.addItem(activityColumnName);	
			}
		}     
    }
    
    public void updateTableBox(String currentTableName){
    	tableBox.removeAllItems();            	
    	Map<String, List<String>> tableVSFatherTables = dataModelInspector.
    			getMappingFKToPKPanel().getTableVSFatherTablesMap();  
    	
    	Map<String, Map<String, List<String>>> tableVSChildTableForeignKeyList = 
    			dataModelInspector.getMappingFKToPKPanel().getTableVSChildTableVSForeignKeyListMap();
        //influence itself
        tableBox.addItem(currentTableName);
        //influence father table
        if(tableVSFatherTables.containsKey(currentTableName)){
            for(String fatherTable : tableVSFatherTables.get(currentTableName)){
            	tableBox.addItem(fatherTable);
            }
        }
        //influence child table
        if(tableVSChildTableForeignKeyList.containsKey(currentTableName)){
            for(String childTableName : tableVSChildTableForeignKeyList.get(currentTableName).keySet()){            	
                tableBox.addItem(childTableName);       
            }
        }
    }
    
    //update the impacted box
    public void updateFieldBox(String selectedTableBoxItem){
        try {
        	MyTableModel tableModel = (MyTableModel) dataModelInspector.
    				getLogGenerator().getDataImporterUI().getNameVSJtableMap().get(selectedTableBoxItem).getModel();
            fieldBox.removeAllItems();
            intermediateKeyBox.removeAllItems();
    		List<String> fieldList = tableModel.getFieldRow();
    		for(int n=0; n < fieldList.size(); n++){
    			fieldBox.addItem(fieldList.get(n));	
    		}

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //update the impacted box, the first parameter tablename is the table selected in the box,
    //the second parameter currentTableName is the table selected in the table list
    public void updateIntermediateKeyBox(String tablename, String currentTableName){
    	intermediateKeyBox.removeAllItems();
        if(tablename.equals(currentTableName)){
        	//only add pk (rowid) of impacted table into the intermediateKeyBox
        	if(tableStructurePanel.getClassName() != null && 
        			tableStructurePanel.getClassVSPKColumnsMap().get(tableStructurePanel.getClassName()) != null){
        		String rowId = tableStructurePanel.getClassVSPKColumnsMap().get(tableStructurePanel.getClassName()).get(0);
                intermediateKeyBox.addItem(rowId);
        	}	                    	
        }
        else{
        	Map<String, List<String>> tableVSFatherTables = dataModelInspector.
        			getMappingFKToPKPanel().getTableVSFatherTablesMap(); 
        	String currentClassName = tableStructurePanel.getClassName();
        	//impacting child table
        	if(tableVSFatherTables.containsKey(tablename) && 
        			tableVSFatherTables.get(tablename).contains(currentTableName)){
        		Map<String, List<String>> tableVSClassList = tableStructurePanel.getTableVSClassListMap();
        		//assume all classes have same fks
        		String childClassName = tableVSClassList.get(tablename).get(0);
        		System.out.println("impacting kfgz child table");
        		//only add foreign key of impacted table into the intermediateKeyBox
            	if(tableStructurePanel.getClassVSFKColumnsMap().get(childClassName) != null){
            		System.out.println("not empty, childClassName:" + childClassName);
            		for(String fk : tableStructurePanel.getClassVSFKColumnsMap().get(childClassName)){
            			System.out.println("fk: " + fk);
            			Map<String, Map<String, List<String>>> tableVSTableForeignKeyList = 
            	    			dataModelInspector.getMappingFKToPKPanel().getTableVSChildTableVSForeignKeyListMap();
            			if(tableVSTableForeignKeyList.containsKey(currentTableName)){
                 			List<String> fkList = tableVSTableForeignKeyList.get(currentTableName).get(tablename);
//                			if(fKey.equals(fk) || fKey.contains(fk)){
                			if(fkList.contains(fk)){//need to be modified in future, should be the path rather than intermediate key
                				intermediateKeyBox.addItem(fk);
                			}	
            			}		                       			
            		}
            	}       
        	}
        	//impacting parent table
        	else if(tableVSFatherTables.containsKey(currentTableName) && 
        			tableVSFatherTables.get(currentTableName).contains(tablename)){
        		System.out.println("impacting kfgz father table");
        		if(tableStructurePanel.getClassVSFKColumnsMap().get(currentClassName) != null){
            		for(String fk : tableStructurePanel.getClassVSFKColumnsMap().get(currentClassName)){		                    			       		                    			
            			Map<String, Map<String, List<String>>> tableVSTableForeignKeyList = 
            	    			dataModelInspector.getMappingFKToPKPanel().getTableVSChildTableVSForeignKeyListMap();		                    			
            			if(tableVSTableForeignKeyList.containsKey(tablename)){
                 			List<String> fkList = tableVSTableForeignKeyList.get(tablename).get(currentTableName);
//                			if(fKey.equals(fk) || fKey.contains(fk)){
                			if(fkList.contains(fk)){//need to be modified in future, should be the path rather than intermediate key
                				intermediateKeyBox.addItem(fk);
                			}	
            			}
            		}
            	}  
        	}       	           			                    			                    
        }
    }
    

    
    public void updateTable(String currentTableName){
        //update the mapping table
        activityImpactingColumnTablePanel.clearAllTableRows();
        for(String key : tableColumnVSImpactedTableColumns.keySet()){//key: llx_projet-datec
        	String activitySourceTable = key.split("-")[0];
        	String activityColumn = key.split("-")[1];
        	System.out.print("\n update key: " + key);
        	if(activitySourceTable.equals(currentTableName)){
        		for(String value : tableColumnVSImpactedTableColumns.get(key)){//value: llx_projet-rowid-rowid
					System.out.print("\n update impacting column value: " + value);
					List<Object> valueList = new ArrayList<Object>();
					String table = value.split("-")[0];
					String impactingColumn = value.split("-")[1];
					String intermediaKey = value.split("-")[2];
					valueList.add(activityColumn);
					valueList.add(table);
					valueList.add(impactingColumn);
					valueList.add(intermediaKey);
					activityImpactingColumnTablePanel.addRecordRow(valueList);
					activityImpactingColumnTablePanel.updateTable();
				}
        	}
        }
    }
    
    public String getDataname() {
        return dataname;
    }
 
    public void setDataname(String dataname) {
        this.dataname = dataname;
    }

    public Map<String, List<String>> getTableColumnVSImpactedTableColumnsMap(){
    	return tableColumnVSImpactedTableColumns;
    }
    
    public void setTableColumnVSImpactedTableColumnsMap(Map<String, List<String>> tableColumnVSImpactedTableColumns){
    	this.tableColumnVSImpactedTableColumns = tableColumnVSImpactedTableColumns;
    }

}