package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.processmining.ocbc.loggeneration.generator.plugin.XOCLogGeneratorPlugin;
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class DataModelInspector extends JPanel {
    public static void main(String[] args) throws Exception {
    	
        JFrame frame = new JFrame();
        frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static final int STARTX = 100;
    public static final int STARTY = 100;
    public int width = 1500;
    public int height = 600;

    private SelectedTablePanel selectedTablePanel;
    private TableStructurePanel tableStructurePanel;
    private ActivityImpactingColumnPanel activityImpactingColumnPanel;
    private MappingFKToPKPanel mappingFKToPKPanel;
    private RelateActivityToClassPanel relateActivityToClassPanel;
    private XOCLogGeneratorPlugin logGenerator;
    public DataModelInspector(XOCLogGeneratorPlugin logGenerator) throws Exception {
    	this.logGenerator = logGenerator;
 
        setLayout(new BorderLayout());
        
       

        JPanel wholePanel = new JPanel();
        wholePanel.setLayout(new BoxLayout(wholePanel, BoxLayout.Y_AXIS));
        
        selectedTablePanel = new SelectedTablePanel(this);
        tableStructurePanel = new TableStructurePanel(selectedTablePanel, this);
        activityImpactingColumnPanel = new ActivityImpactingColumnPanel( 
        		selectedTablePanel, tableStructurePanel, this);
        mappingFKToPKPanel = new MappingFKToPKPanel( 
        		selectedTablePanel, tableStructurePanel, this);
        relateActivityToClassPanel = new RelateActivityToClassPanel( 
        		selectedTablePanel, tableStructurePanel, this);   

        //set the size of configuraton panel (such as activityImpactingColumnPanel)
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
//        width = (int) (screenSize.getWidth());
//        height = (int) screenSize.getHeight();
        width = 1400;
        height = 800;
        
//        selectedTablePanel.setMaximumSize(new Dimension(width/2, height/2));
//        tableStructurePanel.setMaximumSize(new Dimension(width/2, height/2));
        JPanel topPanel = new JPanel();
        topPanel.setLayout(new BoxLayout(topPanel, BoxLayout.X_AXIS));
        OutputPanel outputPanel = new OutputPanel(this);      
        topPanel.add(selectedTablePanel);
		topPanel.add(tableStructurePanel);
        topPanel.add(outputPanel);

		

        activityImpactingColumnPanel.setMaximumSize(new Dimension(width/3, height/2));
        mappingFKToPKPanel.setMaximumSize(new Dimension(width/3, height/2));
        relateActivityToClassPanel.setMaximumSize(new Dimension(width/3, height/2));

		JPanel bottomPanel = new JPanel();
		bottomPanel.setLayout(new BoxLayout(bottomPanel, BoxLayout.X_AXIS));	
		bottomPanel.add(activityImpactingColumnPanel);
		bottomPanel.add(mappingFKToPKPanel);
		bottomPanel.add(relateActivityToClassPanel);
//		bottomPanel.add(Box.createHorizontalStrut(1));
//		bottomPanel.add(outputPanel);
		wholePanel.add(topPanel);
		wholePanel.add(bottomPanel);

		this.add(wholePanel);
    }
    
    /*
     * update all the child panels in the data model inspector for a table
     */
    public void update(String tableName){
    	System.out.println("update all tables by table name");
    	tableStructurePanel.update(tableName);
    	mappingFKToPKPanel.update(tableName);
    	activityImpactingColumnPanel.update(tableName);
    	relateActivityToClassPanel.update(tableName);

    }
    
    public TableStructurePanel getTableStructurePanel(){
    	return tableStructurePanel;
    }
     
    public SelectedTablePanel getSelectedTablePanel(){
    	return selectedTablePanel;
    }

    public ActivityImpactingColumnPanel getActivityImpactingColumnPanel(){
    	return activityImpactingColumnPanel;
    }
    
    public MappingFKToPKPanel getMappingFKToPKPanel(){
    	return mappingFKToPKPanel;
    }
    
    public RelateActivityToClassPanel getRelateActivityToClassPanel(){
    	return relateActivityToClassPanel;
    }

    public XOCLogGeneratorPlugin getLogGenerator(){
		return logGenerator;
    }
}