package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;
import org.processmining.ocbc.logconversion.configurations.ConfigurationConstants;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.impl.ClassNodeImpl;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class MappingFKToPKPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {

    }
    
    private JComboBox<String> fkBox = new JComboBox<String>();
    private JComboBox<String> fatherTableBox = new JComboBox<String>();
    private JComboBox<String> pkBox = new JComboBox<String>();
    private String dataname = "";
    
    private SelectedTablePanel selectedTablePanel;
    private TableStructurePanel tableStructurePanel;
    private JButton removeButton;
    private JButton addButton;
    private CreateTablePanel mappingFKToPKPanel;
    private DataModelInspector dataModelInspector;
    private List<String> tableFieldRow = new ArrayList<String>();
    //for one table foreign key (table name + fk column name), record the father table + pk
    //e.g., llx_commandedet-fk_command-[llx_commande-rowid, ...]
    //currently it is not used because we assume the pk of father table is "rowid"
    private Map<String, String> tableFKVSFatherTablePK = new HashMap<String, String>();    
    //for one table  (table name ), record all its father tables
    private Map<String, List<String>> tableVSFatherTables = new HashMap<String, List<String>>();
        
    private Map<String, Map<String, List<String>>> tableVSChildTableVSForeignKeyList = new HashMap<String, Map<String, List<String>>>();
    private Map<String, Map<String, String>> tableVSEventChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, List<String>>> tableVSEventChainedFatherTableVSFKs = new HashMap<String, Map<String, List<String>>>();
    private Map<String, Map<String, String>> tableVSObjectChainedChildTableVSFK = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, List<String>>> tableVSObjectChainedFatherTableVSFKs = new HashMap<String, Map<String, List<String>>>();

    public MappingFKToPKPanel(final SelectedTablePanel selectedTablePanel,
    		final TableStructurePanel tableStructurePanel, final DataModelInspector dataModelInspector) {
    	this.dataModelInspector = dataModelInspector;
    	
    	this.selectedTablePanel = selectedTablePanel;
    	this.tableStructurePanel = tableStructurePanel;

    	mappingFKToPKPanel = new CreateTablePanel("");

        tableFieldRow.add(ConfigurationConstants.index);
        tableFieldRow.add(ConfigurationConstants.fk);
        tableFieldRow.add(ConfigurationConstants.father_table);
        tableFieldRow.add(ConfigurationConstants.pk);
        tableFieldRow.add(ConfigurationConstants.e_c_chained);
        tableFieldRow.add(ConfigurationConstants.e_f_chained);
        tableFieldRow.add(ConfigurationConstants.o_c_chained);//if the father object appear, the child object appears too
        tableFieldRow.add(ConfigurationConstants.o_f_chained);//if the child object appear, the father object appears too

        
        mappingFKToPKPanel.setFieldRow(tableFieldRow);
        mappingFKToPKPanel.updateTable();
        
        //create the table change listener function
        mappingFKToPKPanel.getTable().getModel().addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {                                 	
                int col = e.getColumn();               
                int row = e.getFirstRow();  
                System.out.println("col: " + col);
                if(col >= 0){
                    String columnName = mappingFKToPKPanel.getTable().getModel().getColumnName(col);                   
                	MyTableModel model = (MyTableModel) mappingFKToPKPanel.getTable().getModel();
                    String table = dataModelInspector.getSelectedTablePanel().getTablename();
					String tableFK = (String) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.fk) + 1);				
					String fatherTable = (String) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.father_table) + 1);
					
					System.out.println("columnName: " + columnName);
					System.out.println("tableFK: " + tableFK);
					System.out.println("fatherTable: " + fatherTable);
					//if the event child chained column changed
                    if(columnName.equals(ConfigurationConstants.e_c_chained)){      	
    					System.out.println("e_c_chained change, " + 
    							(boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.e_c_chained) + 1));
                    	boolean chainedFlag = (boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.e_c_chained) + 1);
        				//add event chained flag
        				if(chainedFlag){
        					if(!tableVSEventChainedChildTableVSFK.containsKey(fatherTable)){
        						tableVSEventChainedChildTableVSFK.put(fatherTable, new HashMap<String, String>());
        					}
        					tableVSEventChainedChildTableVSFK.get(fatherTable).put(table, tableFK); 
        					
        				}
        				//remove event chained flag
        				else{
        					if(tableVSEventChainedChildTableVSFK.containsKey(fatherTable)){
        						if(tableVSEventChainedChildTableVSFK.get(fatherTable).containsKey(table)){
        							String tableFKValue = tableVSEventChainedChildTableVSFK.get(fatherTable).get(table);
        							if(tableFKValue.equals(tableFK)){
        								tableVSEventChainedChildTableVSFK.get(fatherTable).remove(table);
        							}
//        							//remove the empty key (without child values)
//        							if(tableVSEventChainedFatherTableVSFKs.containsKey(fatherTable) && 
//        									tableVSEventChainedFatherTableVSFKs.get(fatherTable).size() == 0){
//        								tableVSEventChainedFatherTableVSFKs.remove(fatherTable);
//        							}
        						}
        					}
        				}
                    }
                    //if the event father chained column changed
                    else if(columnName.equals(ConfigurationConstants.e_f_chained)){      	
    					System.out.println("e_f_chained change, " + 
    							(boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.e_f_chained) + 1));
                    	boolean chainedFlag = (boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.e_f_chained) + 1);
        				//add event chained flag
        				if(chainedFlag){      					
          					if(!tableVSEventChainedFatherTableVSFKs.containsKey(table)){
          						tableVSEventChainedFatherTableVSFKs.put(table, new HashMap<String, List<String>>());   						
        					}
        					if(!tableVSEventChainedFatherTableVSFKs.get(table).containsKey(fatherTable)){
        						tableVSEventChainedFatherTableVSFKs.get(table).put(fatherTable, new ArrayList<String>()); 
        					}
        					tableVSEventChainedFatherTableVSFKs.get(table).get(fatherTable).add(tableFK); 
        				}
        				//remove event chained flag
        				else{
        					if(tableVSEventChainedFatherTableVSFKs.containsKey(table)){
        						if(tableVSEventChainedFatherTableVSFKs.get(table).containsKey(fatherTable)){
        							if(tableVSEventChainedFatherTableVSFKs.get(table).get(fatherTable).contains(tableFK)){
        								tableVSEventChainedFatherTableVSFKs.get(table).get(fatherTable).remove(tableFK);
        							}   
        							//remove the empty key (without child values)
        							if(tableVSEventChainedFatherTableVSFKs.get(table).get(fatherTable).size() == 0){
        								tableVSEventChainedFatherTableVSFKs.get(table).remove(fatherTable);
        							}
        							if(tableVSEventChainedFatherTableVSFKs.get(table).size() == 0){
        								tableVSEventChainedFatherTableVSFKs.remove(table);
        							}
        						}
        					}
        				}
        				
                    }
                    //if the object child chained column changed
                    else if(columnName.equals(ConfigurationConstants.o_c_chained)){
                    	System.out.println("o_c_chained change, " + 
    							(boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.o_c_chained) + 1));
                    	boolean chainedFlag = (boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.o_c_chained) + 1);
        				//add object chained flag
        				if(chainedFlag){
        					if(!tableVSObjectChainedChildTableVSFK.containsKey(fatherTable)){
        						tableVSObjectChainedChildTableVSFK.put(fatherTable, new HashMap<String, String>());
        					}
        					tableVSObjectChainedChildTableVSFK.get(fatherTable).put(table, tableFK); 
        					
        				}
        				//remove object chained flag
        				else{
        					if(tableVSObjectChainedChildTableVSFK.containsKey(fatherTable)){
        						if(tableVSObjectChainedChildTableVSFK.get(fatherTable).containsKey(table)){
        							String tableFKValue = tableVSObjectChainedChildTableVSFK.get(fatherTable).get(table);
        							if(tableFKValue.equals(tableFK)){
        								tableVSObjectChainedChildTableVSFK.get(fatherTable).remove(table);
        							}
//          							//remove the empty key (without child values)
//        							if(tableVSEventChainedFatherTableVSFKs.get(fatherTable).size() == 0){
//        								tableVSEventChainedFatherTableVSFKs.remove(fatherTable);
//        							}
        						}
        					}
        				}
                    }
                    //if the object father chained column changed
                    else if(columnName.equals(ConfigurationConstants.o_f_chained)){
                        System.out.println("o_f_chained change, " + 
    							(boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.o_f_chained) + 1));
                    	boolean chainedFlag = (boolean) model.getValueAt(row, model.getColumnIndexByName(ConfigurationConstants.o_f_chained) + 1);
        				//add object chained flag
        				if(chainedFlag){
        					if(!tableVSObjectChainedFatherTableVSFKs.containsKey(table)){
        						tableVSObjectChainedFatherTableVSFKs.put(table, new HashMap<String, List<String>>());   						
        					}
        					if(!tableVSObjectChainedFatherTableVSFKs.get(table).containsKey(fatherTable)){
        						tableVSObjectChainedFatherTableVSFKs.get(table).put(fatherTable, new ArrayList<String>()); 
        					}
        					tableVSObjectChainedFatherTableVSFKs.get(table).get(fatherTable).add(tableFK);  					
        				}
        				//remove object chained flag
        				else{
        					if(tableVSObjectChainedFatherTableVSFKs.containsKey(table)){
        						if(tableVSObjectChainedFatherTableVSFKs.get(table).containsKey(fatherTable)){
        							if(tableVSObjectChainedFatherTableVSFKs.get(table).get(fatherTable).contains(tableFK)){
        								tableVSObjectChainedFatherTableVSFKs.get(table).get(fatherTable).remove(tableFK);
        							}   	
//        							//remove the empty key (without child values)
//        							if(tableVSEventChainedFatherTableVSFKs.get(table).get(fatherTable).size() == 0){
//        								tableVSEventChainedFatherTableVSFKs.get(table).remove(fatherTable);
//        							}
//           							if(tableVSEventChainedFatherTableVSFKs.get(table).size() == 0){
//        								tableVSEventChainedFatherTableVSFKs.remove(table);
//        							}
        						}
        					}
        				}
                    }
                } 
            }  
        }); 
        
    	
    	addButton = new JButton("add");
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the add table reference button");
				String table = selectedTablePanel.getTablename();
				String tableFK = (String) fkBox.getSelectedItem();
				String fatherTable = (String) fatherTableBox.getSelectedItem();
				String fatherTablePK = (String) pkBox.getSelectedItem();//currently, assume the "rowid" coloum is the id of each table
				
				// add the new reference relation into the table
				List<Object> valueList = new ArrayList<Object>();
				valueList.add(tableFK);
				valueList.add(fatherTable);
				valueList.add(fatherTablePK);
				//the flag indicating if the relation is chained (which means if the father appears, 
				//all its children will be pulled into the log in creating event list process)
				valueList.add(new Boolean(false));
				valueList.add(new Boolean(false));
				//the flag indicating if the relation is chained (which means if the father appears, 
				//all its children will be pulled into the log in creating object model process)
				valueList.add(new Boolean(false));
				//the flag indicating if the relation is chained (which means if the child appears, 
				//all its father will be pulled into the log in creating object model process)
				valueList.add(new Boolean(false));
				mappingFKToPKPanel.addRecordRow(valueList);
				mappingFKToPKPanel.updateTable();
				
				//add the new reference relation into the variables(create table vs father table mapping)		
				if(!tableVSFatherTables.containsKey(table)){
					tableVSFatherTables.put(table, new ArrayList<String>());
				}
				if(!tableVSFatherTables.get(table).contains(fatherTable)){
					tableVSFatherTables.get(table).add(fatherTable); 
				}
				
				//add the foreign key into the variable
				if(!tableVSChildTableVSForeignKeyList.containsKey(fatherTable)){
					tableVSChildTableVSForeignKeyList.put(fatherTable, new HashMap<String, List<String>>());
				}				
				if(!tableVSChildTableVSForeignKeyList.get(fatherTable).containsKey(table)){
					tableVSChildTableVSForeignKeyList.get(fatherTable).put(table, new ArrayList<String>()); 
				}				
				if(!tableVSChildTableVSForeignKeyList.get(fatherTable).get(table).contains(tableFK)){
					tableVSChildTableVSForeignKeyList.get(fatherTable).get(table).add(tableFK);
				}
							
				String tableAndFK = table + "-" + tableFK;
				String fatherTableAndPK = fatherTable + "-" + fatherTablePK;
				if(!tableFKVSFatherTablePK.containsKey(tableAndFK)){
					tableFKVSFatherTablePK.put(tableAndFK, fatherTableAndPK);
				}									
			}	   						
		});
    	
        removeButton = new JButton("remove");
        removeButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{			
				JTable jTable = mappingFKToPKPanel.getTable();
				MyTableModel tableModel = (MyTableModel) jTable.getModel();
				int selectdRow  = jTable.getSelectedRow();
				if(selectdRow >= 0){					
					//remove the record from the (mapping) variables 					
//					String tableName = (String) tableModel.getValueAt(selectdRow, 1);
					String tableName = dataModelInspector.getSelectedTablePanel().getTablename();
					String tableFK = (String) tableModel.getValueAt(selectdRow, tableFieldRow.indexOf(ConfigurationConstants.fk));
					String fatherTable = (String) tableModel.getValueAt(selectdRow, tableFieldRow.indexOf(ConfigurationConstants.father_table));
					String fatherTablePK = (String) tableModel.getValueAt(selectdRow, tableFieldRow.indexOf(ConfigurationConstants.pk));//currently, assume the "rowid" coloum is the id of each table				
					
					if(tableVSFatherTables.containsKey(tableName)){
						if(tableVSFatherTables.get(tableName).contains(fatherTable)){
							tableVSFatherTables.get(tableName).remove(fatherTable); 
//							if(tableVSFatherTables.get(tableName).size() == 0){
//								tableVSFatherTables.remove(tableName);
//							}
						}
					}
					
					if(tableVSChildTableVSForeignKeyList.containsKey(fatherTable)){
						if(tableVSChildTableVSForeignKeyList.get(fatherTable).containsKey(tableName)){	
							if(tableVSChildTableVSForeignKeyList.get(fatherTable).get(tableName).contains(tableFK)){
								tableVSChildTableVSForeignKeyList.get(fatherTable).get(tableName).remove(tableFK);
							}
						}
					}										
					
					String tableAndFK = tableName + "-" + tableFK;
					String fatherTableAndPK = fatherTable + "-" + fatherTablePK;
					if(tableFKVSFatherTablePK.containsKey(tableAndFK)){
						tableFKVSFatherTablePK.remove(tableAndFK);
					}	
								

    				//remove event child chained flag    
					if(tableVSEventChainedChildTableVSFK.containsKey(fatherTable)){
						if(tableVSEventChainedChildTableVSFK.get(fatherTable).containsKey(tableName)){
							String tableFKValue = tableVSEventChainedChildTableVSFK.get(fatherTable).get(tableName);
							if(tableFKValue.equals(tableFK)){
								tableVSEventChainedChildTableVSFK.get(fatherTable).remove(tableName);
							}
						}
					}					
					
					//remove event father chained flag       
					if(tableVSEventChainedFatherTableVSFKs.containsKey(tableName)){
						if(tableVSEventChainedFatherTableVSFKs.get(tableName).containsKey(fatherTable)){
							if(tableVSEventChainedFatherTableVSFKs.get(tableName).get(fatherTable).contains(tableFK)){
								tableVSEventChainedFatherTableVSFKs.get(tableName).get(fatherTable).remove(tableFK);
							}   							
						}
					}
					
    				//remove child-object-chained flag    
					if(tableVSObjectChainedChildTableVSFK.containsKey(fatherTable)){
						if(tableVSObjectChainedChildTableVSFK.get(fatherTable).containsKey(tableName)){
							String tableFKValue = tableVSObjectChainedChildTableVSFK.get(fatherTable).get(tableName);
							if(tableFKValue.equals(tableFK)){
								tableVSObjectChainedChildTableVSFK.get(fatherTable).remove(tableName);
							}
						}
					}
					
    				//remove father-object-chained flag    
					if(tableVSObjectChainedFatherTableVSFKs.containsKey(tableName)){
						if(tableVSObjectChainedFatherTableVSFKs.get(tableName).containsKey(fatherTable)){
							if(tableVSObjectChainedFatherTableVSFKs.get(tableName).get(fatherTable).contains(tableFK)){
								tableVSObjectChainedFatherTableVSFKs.get(tableName).get(fatherTable).remove(tableFK);
							}   							
						}
					}
					
					//remove the selected record from table
					tableModel.removeRecordRow(selectdRow);
					tableModel.updateTable();					
				}

			}																					
		});       
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BorderLayout());
        buttonPanel.setMaximumSize(new Dimension(500,40));
        buttonPanel.add(removeButton, BorderLayout.LINE_START);
//        buttonPanel.add(Box.createHorizontalStrut(10));
        buttonPanel.add(addButton, BorderLayout.LINE_END);
        
        fkBox.setPrototypeDisplayValue("foreign");
        fkBox.setRenderer(new ComboBoxRenderer(fkBox));
        fkBox.setToolTipText("foreign key");
        fatherTableBox.setPrototypeDisplayValue("father table");
        fatherTableBox.setRenderer(new ComboBoxRenderer(fkBox));
        fatherTableBox.setToolTipText("father table");
        pkBox.setPrototypeDisplayValue("foreign");
        pkBox.setRenderer(new ComboBoxRenderer(fkBox));
        pkBox.setToolTipText("referred key in father table");
        
    	JPanel selectionPanel = new JPanel();
    	selectionPanel.setMaximumSize(new Dimension(500,40));
    	selectionPanel.setLayout(new BoxLayout(selectionPanel, BoxLayout.X_AXIS));
    	//the childTableBox is currently useless
//    	selectionPanel.add(childTableBox);
    	selectionPanel.add(fkBox);
    	selectionPanel.add(fatherTableBox);
    	selectionPanel.add(pkBox);
        

    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(buttonPanel);
        this.add(selectionPanel);
        this.add(mappingFKToPKPanel.getScrollPane());
        this.setBorder(BorderFactory.createTitledBorder("table relation"));       
    }
 
    /*
     * update the table reference panel for the input table
     */
    public void update(String tableName){
		//update table box and its child boxes
		fatherTableBox.removeAllItems();
    	List<String> selectedTableList = dataModelInspector.getSelectedTablePanel().getSelectedTableList();
        for(String selectedTable : selectedTableList){
        	fatherTableBox.addItem(selectedTable);
        }
        
        if(fatherTableBox.getItemCount()>0) fatherTableBox.setSelectedItem(fatherTableBox.getItemAt(0));
     
		
		String currentTableName = tableName;
		String currentClassName = tableStructurePanel.getClassName();
		fkBox.removeAllItems();
		if(tableStructurePanel.getClassVSFKColumnsMap().get(currentClassName) != null){
			for(String fk : tableStructurePanel.getClassVSFKColumnsMap().get(currentClassName)){
				fkBox.addItem(fk);
			}	
		}

		//assume the pk of each table is "rowid"
		pkBox.removeAllItems();
		pkBox.addItem("rowid");

		mappingFKToPKPanel.clearAllTableRows();
		
		
		if(tableVSFatherTables.containsKey(currentTableName)){//if the current table has father tables
			for(String fatherTable : tableVSFatherTables.get(currentTableName)){
				if(tableVSChildTableVSForeignKeyList.containsKey(fatherTable) && 
						tableVSChildTableVSForeignKeyList.get(fatherTable).containsKey(currentTableName)){
					List<String> foreignKeyList = tableVSChildTableVSForeignKeyList.get(fatherTable).get(currentTableName);

					for(String fk : foreignKeyList){
						List<Object> valueList = new ArrayList<Object>();
						valueList.add(fk);
						valueList.add(fatherTable);
						valueList.add("rowid");//currently, assume the pk of each table is "rowid"
						boolean flag = false;
						if(tableVSEventChainedChildTableVSFK.containsKey(fatherTable) &&
								tableVSEventChainedChildTableVSFK.get(fatherTable).containsKey(currentTableName) &&
								tableVSEventChainedChildTableVSFK.get(fatherTable).get(currentTableName).equals(fk)){
							flag = true;
						}
						valueList.add(new Boolean(flag));	
						
						//get the e_f_chained value
						flag = false;
						if(tableVSEventChainedFatherTableVSFKs.containsKey(currentTableName)){
							if(tableVSEventChainedFatherTableVSFKs.get(currentTableName).containsKey(fatherTable)){
								if(tableVSEventChainedFatherTableVSFKs.get(currentTableName).get(fatherTable).contains(fk)){
									flag = true;
								}   
							}
						}
						valueList.add(new Boolean(flag));	
						
						//get the o_c_chained value
						flag = false;
						if(tableVSObjectChainedChildTableVSFK.containsKey(fatherTable) &&
								tableVSObjectChainedChildTableVSFK.get(fatherTable).containsKey(currentTableName) &&
								tableVSObjectChainedChildTableVSFK.get(fatherTable).get(currentTableName).equals(fk)){
							flag = true;
						}
						valueList.add(new Boolean(flag));	
						
						//get the o_f_chained value
						flag = false;
						if(tableVSObjectChainedFatherTableVSFKs.containsKey(currentTableName)){
							if(tableVSObjectChainedFatherTableVSFKs.get(currentTableName).containsKey(fatherTable)){
								if(tableVSObjectChainedFatherTableVSFKs.get(currentTableName).get(fatherTable).contains(fk)){
									flag = true;
								}   
							}
						}
						valueList.add(new Boolean(flag));	
						
						mappingFKToPKPanel.addRecordRow(valueList);
						mappingFKToPKPanel.updateTable();
					}
				}				
			}
		}
    }
    
    public String getDataname() {
        return dataname;
    }
 
    public void setDataname(String dataname) {
        this.dataname = dataname;
    }

    
    
    public Map<String, Map<String, String>> getTableVSEventChainedChildTableVSFKMap(){
    	return tableVSEventChainedChildTableVSFK;
    }
   
    public void setTableVSEventChainedChildTableVSFKMap(Map<String, Map<String, String>> tableVSEventChainedChildTableVSFK){
    	this.tableVSEventChainedChildTableVSFK = tableVSEventChainedChildTableVSFK;
    }
    
    public Map<String, Map<String, List<String>>> getTableVSEventChainedFatherTableVSFKsMap(){
    	return tableVSEventChainedFatherTableVSFKs;
    }
   
    public void setTableVSEventChainedFatherTableVSFKsMap(Map<String, Map<String, List<String>>> tableVSEventChainedFatherTableVSFKs){
    	this.tableVSEventChainedFatherTableVSFKs = tableVSEventChainedFatherTableVSFKs;
    }
    
    public Map<String, Map<String, String>> getTableVSObjectChainedChildTableVSFKMap(){
    	return tableVSObjectChainedChildTableVSFK;
    }
   
    public void setTableVSObjectChainedChildTableVSFKMap(Map<String, Map<String, String>> tableVSObjectChainedChildTableVSFK){
    	this.tableVSObjectChainedChildTableVSFK = tableVSObjectChainedChildTableVSFK;
    }
    
    public Map<String, Map<String, List<String>>> getTableVSObjectChainedFatherTableVSFKsMap(){
    	return tableVSObjectChainedFatherTableVSFKs;
    }
   
    public void setTableVSObjectChainedFatherTableVSFKsMap(Map<String, Map<String, List<String>>> tableVSObjectChainedFatherTableVSFKs){
    	this.tableVSObjectChainedFatherTableVSFKs = tableVSObjectChainedFatherTableVSFKs;
    }       
    
    public Map<String, String> getTableFKVSFatherTablePKsMap(){
    	return tableFKVSFatherTablePK;
    }
   
    public void setTableFKVSFatherTablePKsMap(Map<String, String> tableFKVSFatherTablePK){
    	this.tableFKVSFatherTablePK = tableFKVSFatherTablePK;
    }
    
    public Map<String, List<String>> getTableVSFatherTablesMap(){
    	return tableVSFatherTables;
    }
    
    public void setTableVSFatherTablesMap(Map<String, List<String>> tableVSFatherTables){
    	this.tableVSFatherTables = tableVSFatherTables;
    }
    
    public Map<String, Map<String, List<String>>> getTableVSChildTableVSForeignKeyListMap(){
    	return tableVSChildTableVSForeignKeyList;
    }
    
    public void setTableVSChildTableVSForeignKeyListMap(Map<String, Map<String, List<String>>> tableVSChildTableVSForeignKeyList){
    	this.tableVSChildTableVSForeignKeyList = tableVSChildTableVSForeignKeyList;
    }
    
    //construct the class model (class node list)
    public List<ClassNode> getClassModel(){
    	List<ClassNode> classNodeList = new ArrayList<ClassNode>();
    	//assume the name of a class node is unique
    	Map<String, ClassNode> classNameVSNodeMap = new HashMap<String, ClassNode>();
    	Map<String, List<String>> tableVSClassList = tableStructurePanel.getTableVSClassListMap();
    	//for each tables
//    	for(String table : tableVSClassList.keySet()){
//    		List<String> classNameList = tableVSClassList.get(table);
//    		//if the table has father tables
//    		if(tableVSFatherTables.containsKey(table)){
//    			//for each father table
//    			for(String fatherTable : tableVSFatherTables.get(table)){
//    				//for each class of the table
//    				for(String className : classNameList){
//    					ClassNode classNode;
//    					//if the class does not exist before
//    					if(!classNameVSNodeMap.keySet().contains(className)){
//    						classNode = new ClassNodeImpl();    					
//        					classNode.setNodeName(className);
//        					classNameVSNodeMap.put(className, classNode);  
//        					classNodeList.add(classNode);
//    					}
//    					else{
//    						classNode = classNameVSNodeMap.get(className);
//    					}
//    					
//     					List<String> fatherClassNameList = tableVSClassList.get(fatherTable);
//    					//for each father class of the father table
//        				for(String fatherClassName : fatherClassNameList){
//        					ClassNode fatherClassNode;
//        					//if the father class does not exist before
//        					if(!classNameVSNodeMap.keySet().contains(fatherClassName)){
//        						fatherClassNode = new ClassNodeImpl();    					
//        						fatherClassNode.setNodeName(fatherClassName);
//            					classNameVSNodeMap.put(fatherClassName, fatherClassNode);
//            					classNodeList.add(fatherClassNode);
//        					}
//        					else{
//        						fatherClassNode = classNameVSNodeMap.get(fatherClassName);
//        					}
//        					classNode.getRelatedClassNodes().add(fatherClassNode);
//        					fatherClassNode.getRelatedClassNodes().add(classNode);
//        				}
//    				}
//    				
//    			}
//    		}
//    	}
    	
    	for(String table : tableVSClassList.keySet()){
    		List<String> classNameList = tableVSClassList.get(table);
			//for each class of the table
			for(String className : classNameList){
				ClassNode classNode;
				//if the class does not exist before
				if(!classNameVSNodeMap.keySet().contains(className)){
					classNode = new ClassNodeImpl();    					
					classNode.setNodeName(className);
					classNameVSNodeMap.put(className, classNode);  
					classNodeList.add(classNode);
				}
				else{
					classNode = classNameVSNodeMap.get(className);
				}
	    		//if the table has father tables
	    		if(tableVSFatherTables.containsKey(table)){
	    			//for each father table
	    			for(String fatherTable : tableVSFatherTables.get(table)){
	    				if(tableVSClassList.containsKey(fatherTable)){
		    				List<String> fatherClassNameList = tableVSClassList.get(fatherTable);
		    				//for each father class of the father table
		    				for(String fatherClassName : fatherClassNameList){
		    					ClassNode fatherClassNode;
		    					//if the father class does not exist before
		    					if(!classNameVSNodeMap.keySet().contains(fatherClassName)){
		    						fatherClassNode = new ClassNodeImpl();    					
		    						fatherClassNode.setNodeName(fatherClassName);
		        					classNameVSNodeMap.put(fatherClassName, fatherClassNode);
		        					classNodeList.add(fatherClassNode);
		    					}
		    					else{
		    						fatherClassNode = classNameVSNodeMap.get(fatherClassName);
		    					}
		    					classNode.getRelatedClassNodes().add(fatherClassNode);
		    					fatherClassNode.getRelatedClassNodes().add(classNode);
		    				}
	    				}
	    			}
	    		}	    						
			}
    	}
    	//output the information
    	System.out.println("get class model");
    	for(ClassNode classNode : classNodeList){
    		System.out.println("classNode name: " + classNode.getNodeName());
    		for(ClassNode relatedClassNode : classNode.getRelatedClassNodes()){
    			System.out.println("relatedClassNode name: " + relatedClassNode.getNodeName());
    		}
    	}
    	
    	return classNodeList;
    }
}