package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JTable;

import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;
import org.processmining.ocbc.logconversion.classmodel.SearchAllPathsBetweenTwoNodes;
import org.processmining.ocbc.models.ClassNode;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class RelateActivityToClassPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {

    }
    
    private JComboBox<String> activityBox = new JComboBox<String>();
    private JComboBox<String> classBox = new JComboBox<String>();
    private JComboBox<String> pathBox = new JComboBox<String>();
    private JComboBox fatherTableBox = new JComboBox();
    private JComboBox pkBox = new JComboBox();
    private String dataname = "";
    
    private SelectedTablePanel selectedTablePanel;
    private TableStructurePanel tableStructurePanel;
    private JButton updateButton;
    private JButton addButton;
    private JButton removeButton;
    private CreateTablePanel relatingActivityToClassPanel;
    private DataModelInspector dataModelInspector;
    //for one table event column (table name + column name), which table column will be impacted through which column, table-column-[table-column-intermediacolumn]
    //e.g., question-creationdate-[question-id-id,question-creationdate-id,question-body-id]
    //e.g., order-creationdate-[order-id-id,order-creationdate-id,orderline-id-command...]
    private Map<String, List<String>> tableFKVSFatherTablePKs = new HashMap<String, List<String>>();
    private Map<String, List<String>> tableVSFatherTables = new HashMap<String, List<String>>();
    private Map<String, Map<String, String>> tableVSChildTableForeignKey = new HashMap<String, Map<String, String>>();
    private Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
    private Map<String, Map<String, String>> activityVSReferredClassVSPath = new HashMap<String, Map<String, String>>();
    
    public RelateActivityToClassPanel(final SelectedTablePanel selectedTablePanel,
    		final TableStructurePanel tableStructurePanel, final DataModelInspector dataModelInspector) {
    	this.dataModelInspector = dataModelInspector;
    	
    	this.selectedTablePanel = selectedTablePanel;
    	this.tableStructurePanel = tableStructurePanel;
//    	this.tableFKVSFatherTablePKs = dataModelInspector.getMappingFKToPKPanel().getTableFKVSFatherTablePKsMap();
    	addButton = new JButton("add");
    	addButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				System.out.print("\n click the button");
				String activityName = (String) activityBox.getSelectedItem();
				String className = (String) classBox.getSelectedItem();		
				String path = (String) pathBox.getSelectedItem();	
				
				if(activityBox.getSelectedItem() != null && classBox.getSelectedItem() != null){
					
				}

				List<Object> valueList = new ArrayList<Object>();
				valueList.add(activityName);
				valueList.add(className);
				valueList.add(path);

				relatingActivityToClassPanel.addRecordRow(valueList);
				relatingActivityToClassPanel.updateTable();
				
				//add the new reference relation into the variables(create activity vs class table mapping)					
				if(!activityVSClasses.containsKey(activityName)){
					activityVSClasses.put(activityName, new ArrayList<String>());
				}
				if(!activityVSClasses.get(activityName).contains(className)){
					activityVSClasses.get(activityName).add(className); 
				}	
				
				//add the new reference relation and path into the variables(create activity vs class vs path mapping)					
				if(!activityVSReferredClassVSPath.containsKey(activityName)){
					activityVSReferredClassVSPath.put(activityName, new HashMap<String, String>());
				}
				if(!activityVSReferredClassVSPath.get(activityName).keySet().contains(className)){
					activityVSReferredClassVSPath.get(activityName).put(className, path); 
				}
				
			}
		});
    	
    	 removeButton = new JButton("remove");
         removeButton.addActionListener(new ActionListener()
 		{
 			public void actionPerformed(ActionEvent e)
 			{			
 				JTable table = relatingActivityToClassPanel.getTable();
 				MyTableModel tableModel = (MyTableModel) table.getModel();
 				int selectdRow  = table.getSelectedRow();
 				if(selectdRow >= 0){					
 					//remove the record from the (mapping) variables 				
 					String activityName = (String) tableModel.getValueAt(selectdRow, 1);
 					String className = (String) tableModel.getValueAt(selectdRow, 2);
					
 					//remove the new activity reference from the variables				
 					if(activityVSClasses.containsKey(activityName)){
 						if(activityVSClasses.get(activityName).contains(className)){
 	 						activityVSClasses.get(activityName).remove(className); 
 	 					}	
 					}					
 					
 					//remove the new activity reference and path from the variables				
 					if(activityVSReferredClassVSPath.containsKey(activityName)){
 						if(activityVSReferredClassVSPath.get(activityName).keySet().contains(className)){
 							activityVSReferredClassVSPath.get(activityName).remove(className); 
 	 					}	
 					}
					
 					//remove the selected record from table
 					tableModel.removeRecordRow(selectdRow);
 					tableModel.updateTable();					
 				}
 			}																					
 		});       
         
         classBox.addActionListener(new ActionListener()
  		{
  			public void actionPerformed(ActionEvent e)
  			{			
  				System.out.println("classBox change");
  				//construct class model
  				List<ClassNode> classNodeList = dataModelInspector.getMappingFKToPKPanel().getClassModel();
  				String selectedClassName = tableStructurePanel.getClassName();
  				//update the path box
  				String selectedBoxClassName = (String) classBox.getSelectedItem();
  		        		        
  				SearchAllPathsBetweenTwoNodes searchAllPathsBetweenTwoNodes = new SearchAllPathsBetweenTwoNodes();
  				ClassNode startNode = null, endNode = null;
  				for(ClassNode classNode : classNodeList){
  					if(classNode.getNodeName().equals(selectedClassName)){
  						startNode = classNode;
  						break;
  					}
  				}
  				for(ClassNode classNode : classNodeList){
  					if(classNode.getNodeName().equals(selectedBoxClassName)){
  						endNode = classNode;
  						break;
  					}
  				}
  				
  				List<String> pathList = new ArrayList<String>();
  				searchAllPathsBetweenTwoNodes.clearPathList();
  				searchAllPathsBetweenTwoNodes.getPaths(startNode, null, startNode, endNode);
  				pathList.addAll(searchAllPathsBetweenTwoNodes.getPathList());
  				pathBox.removeAllItems();
  			    for(String path : pathList){
  			    	System.out.println("add path in classbox: " + path);
  			    	pathBox.addItem(path);
  			    }
  			}																					
  		});       
          
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new BorderLayout());
        buttonPanel.setMaximumSize(new Dimension(500,40));
        buttonPanel.add(removeButton, BorderLayout.LINE_START);
//         buttonPanel.add(Box.createHorizontalStrut(10));
        buttonPanel.add(addButton, BorderLayout.LINE_END);
         

        activityBox.setPrototypeDisplayValue("activity");
        activityBox.setRenderer(new ComboBoxRenderer(activityBox));
        activityBox.setToolTipText("activity name");
        classBox.setPrototypeDisplayValue("class");
        classBox.setRenderer(new ComboBoxRenderer(classBox));
        classBox.setToolTipText("class name");
        pathBox.setPrototypeDisplayValue("choose a path");
        pathBox.setRenderer(new ComboBoxRenderer(pathBox));
        pathBox.setToolTipText("path from the source table of activity to the source tabel of class");
        
    	JPanel selectionPanel = new JPanel();
    	selectionPanel.setMaximumSize(new Dimension(500,40));
    	selectionPanel.setLayout(new BoxLayout(selectionPanel, BoxLayout.X_AXIS));
    	selectionPanel.add(activityBox);
    	selectionPanel.add(classBox);
    	selectionPanel.add(pathBox); 	
        

    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    	relatingActivityToClassPanel = new CreateTablePanel("");
        List<String> tableFieldRow = new ArrayList<String>();
        tableFieldRow.add("index");
        tableFieldRow.add("activity");
        tableFieldRow.add("class");
        tableFieldRow.add("path");

        
        relatingActivityToClassPanel.setFieldRow(tableFieldRow);
        relatingActivityToClassPanel.updateTable();
        this.add(buttonPanel);      
        this.add(selectionPanel);
        this.add(relatingActivityToClassPanel.getScrollPane());
        this.setBorder(BorderFactory.createTitledBorder("activity referring class"));   
        
    }
 
    /*
     * update the table activity reference panel for the input table
     */
    public void update(String table){
    	System.out.println("update");
    	//update table box and its child boxes
		activityBox.removeAllItems();
		classBox.removeAllItems();
		pathBox.removeAllItems();
		
		String selectedTableName = table;
		System.out.println("table: " + table);
		String selectedClassName = tableStructurePanel.getClassName();
		
		
		//activity box show all activities of the selected class		
		if(tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().containsKey(selectedClassName)){
			for(String activityColumnName : tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().get(selectedClassName).keySet()){				
				if(tableStructurePanel.getClassVSColumnVSNameMap().get(selectedClassName) != null &&
						tableStructurePanel.getClassVSColumnVSNameMap().get(selectedClassName).get(activityColumnName) != null){
					String activityName = tableStructurePanel.getClassVSColumnVSNameMap().get(selectedClassName).get(activityColumnName);
					activityBox.addItem(activityName);
					System.out.println("activityName: " + activityName);	
				}			
			}
		}
	
		for(String tableName : tableStructurePanel.getTableVSClassListMap().keySet()){
			List<String> classNameList = tableStructurePanel.getTableVSClassListMap().get(tableName);
			for(String className : classNameList){
				classBox.addItem(className);
			}			
		}
		
		//construct class model
		List<ClassNode> classNodeList = dataModelInspector.getMappingFKToPKPanel().getClassModel();
		//update the path box
//		String selectedActivity = (String) activityBox.getSelectedItem();
		String selectedBoxClassName = (String) classBox.getSelectedItem();
        		        
		SearchAllPathsBetweenTwoNodes searchAllPathsBetweenTwoNodes = new SearchAllPathsBetweenTwoNodes();
		ClassNode startNode = null, endNode = null;
		for(ClassNode classNode : classNodeList){
			if(classNode.getNodeName().equals(selectedClassName)){
				startNode = classNode;
				break;
			}
		}
		for(ClassNode classNode : classNodeList){
			if(classNode.getNodeName().equals(selectedBoxClassName)){
				endNode = classNode;
				break;
			}
		}		
		List<String> pathList = new ArrayList<String>();
		searchAllPathsBetweenTwoNodes.clearPathList();
		searchAllPathsBetweenTwoNodes.getPaths(startNode, null, startNode, endNode);
		pathList.addAll(searchAllPathsBetweenTwoNodes.getPathList());
			 
	    for(String path : pathList){
	    	boolean existentFlag = false;
	    	for(int i=0; i<pathBox.getItemCount(); i++){
	    		if(pathBox.getItemAt(i).equals(path)){
	    			existentFlag = true;
	    			break;
	    		}
	    		
	    	}
	    	if(!existentFlag){
	    		System.out.println("add path in update: " + path);
	    		pathBox.addItem(path);
	    	}	    	
	    }

	    updateTable(table);

    }
    
	//update the table-show all related on table
    public void updateTable(String table) {
		String selectedClassName = tableStructurePanel.getClassName();
    	Map<String, List<String>> tableVSClassList = dataModelInspector.getTableStructurePanel().getTableVSClassListMap();
		relatingActivityToClassPanel.clearAllTableRows();
		if(tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().containsKey(selectedClassName)){
			for(String activityColumnName : tableStructurePanel.getClassVSActivityColumnVSAttributesColumnsMap().get(selectedClassName).keySet()){
				if(tableVSClassList.containsKey(table)){
					List<String> classList = tableVSClassList.get(table);
					for(String className : classList){
						if(tableStructurePanel.getClassVSColumnVSNameMap().get(className) != null){
							String activityName = tableStructurePanel.getClassVSColumnVSNameMap().get(className).get(activityColumnName);
							if(activityVSClasses.containsKey(activityName)){
								for(String classNameTemp : activityVSClasses.get(activityName)){
									String path = "";
									if(activityVSReferredClassVSPath.get(activityName) != null){
										path = activityVSReferredClassVSPath.get(activityName).get(classNameTemp);
									}								 
									List<Object> valueList = new ArrayList<Object>();
									valueList.add(activityName);
									valueList.add(classNameTemp);
									valueList.add(path);
									relatingActivityToClassPanel.addRecordRow(valueList);
									relatingActivityToClassPanel.updateTable();			        		
					        	}
							}
							System.out.println("activityName: " + activityName);	
						}									
					}		
				}							
			}			
		}
    }
    
    public String getDataname() {
        return dataname;
    }
 
    public void setDataname(String dataname) {
        this.dataname = dataname;
    }

    
    public Map<String, List<String>> getActivityVSClassesMap(){
    	return activityVSClasses;
    }
    
    public void setActivityVSClassesMap(Map<String, List<String>> activityVSClasses){
    	this.activityVSClasses = activityVSClasses;
    }
    
    public Map<String, Map<String, String>> getActivityVSReferredClassVSPathMap(){
    	return activityVSReferredClassVSPath;
    }
    
    public void setActivityVSReferredClassVSPathMap(Map<String, Map<String, String>> activityVSReferredClassVSPath){
    	this.activityVSReferredClassVSPath = activityVSReferredClassVSPath;
    }
   


}