package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.Component;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class SelectedTablePanel extends JPanel implements ListSelectionListener{
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private String tablename = "";
    private JLabel sourceLabel;
    private DefaultListModel<String> selectedTableListModel = new DefaultListModel<String>();;
    private JList<String> selectedTableList = new JList<String>(selectedTableListModel);

    private DataModelInspector dataModelInspector;
    private JPanel generatedPanel;
    
    public SelectedTablePanel(final DataModelInspector dataModelInspector) {
    	this.dataModelInspector = dataModelInspector;
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        generatedPanel = new JPanel();
    	updateTableSelectionPanel();
    	add(generatedPanel);
        

    }
 
 
    public String getTablename() {
        return tablename;
    }
 
    public void setTablename(String tablename) {
        this.tablename = tablename;
    }
 
    
    public List<String> getSelectedTableList() {
    	List<String> selectedTableNameList = new ArrayList<String>();
    	for(int i =0; i<selectedTableList.getModel().getSize(); i++){
    		selectedTableNameList.add(selectedTableList.getModel().getElementAt(i));
    	}
        return selectedTableNameList;
    }

    
    //set the JList through the format of a list of string
    public void setList(List<String> itemList){ 	
    	selectedTableListModel.clear();  	
    	for(String item : itemList){
    		selectedTableListModel.addElement(item);
    	}
    	selectedTableList.setModel(selectedTableListModel);
    	
    	//update the table vs class mapping, the class is initialize as table name
		Map<String, List<String>> tableVSClassList = dataModelInspector.getTableStructurePanel().getTableVSClassListMap();
    	for(int i=0; i<selectedTableListModel.getSize(); i++){
			String element = selectedTableListModel.getElementAt(i);
			if(!tableVSClassList.containsKey(element)){
				tableVSClassList.put(element, new ArrayList<String>());
			}       			
		}
    	
    	//remove the dead table in the tableVSClassList mapping
    	List<String> deadTableList = new ArrayList<String>();
    	for(String table : tableVSClassList.keySet()){
    		if(!selectedTableListModel.contains(table)){
    			deadTableList.add(table);  			
    		}
    		tableVSClassList.remove(deadTableList);
    	}
    	for(String table : deadTableList){
    		tableVSClassList.remove(table);
    	}		   	
    	updateTableSelectionPanel();
    }
    
    public void updateTableSelectionPanel(){	
    	generatedPanel.removeAll();
//    	JPanel middlePanel = new JPanel();
	    sourceLabel = new JLabel("selected tables: " + selectedTableList.getModel().getSize());
		sourceLabel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceLabel.setBorder(BorderFactory.createEmptyBorder(4, 5, 0, 5));

		JScrollPane sourceListScroller = new JScrollPane(selectedTableList);
		sourceListScroller.setPreferredSize(new Dimension(300, 400));
//		sourceListScroller.setMaximumSize(new Dimension(320, 480));
		sourceListScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		sourceListScroller.setAlignmentY(Component.TOP_ALIGNMENT);
		JPanel sourceListPanel = new JPanel();
		sourceListPanel.setLayout(new BoxLayout(sourceListPanel,
				BoxLayout.Y_AXIS));
		sourceListPanel.add(sourceLabel);
		sourceListPanel.add(sourceListScroller);
		sourceListPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceListPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 30));
		generatedPanel.add(sourceListPanel);
		
		generatedPanel.updateUI();

		
		selectedTableList.addListSelectionListener(this);
					
    }
    

	public void valueChanged(ListSelectionEvent e) {
		System.out.println("selected table changed, current selected table name: " + selectedTableList.getSelectedValue());
		String selectedTable = selectedTableList.getSelectedValue();
		setTablename(selectedTable);
		
		dataModelInspector.update(selectedTable);
		//update all the panels for this selected table
		
	}

}