package org.processmining.ocbc.loggeneration.panel.datamodel;
 
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.text.JTextComponent;

import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.MyTableModel;
import org.processmining.ocbc.log.model.impl.xConstants;

 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class TableStructurePanel extends JPanel {
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {
    	JFrame frame = new JFrame();
		frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());

		
		MyTableModel model = new MyTableModel();
        model.setName("index", 0);
        model.setName("field", 1);
        model.setName("type", 2);
        model.setName("attribute", 3);
        model.setName("event", 4);
        model.setName("pk", 5);
        model.setName("fk", 6);
        
		JTable table = new JTable(model);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);// 水平滚动条



        JScrollPane scrollpane = new JScrollPane(table);

    	JButton updateButton = new JButton("update");
    	
		frame.add(scrollpane);
		frame.setVisible(true);
    }

    
    private JButton addClassButton = new JButton("add");
    private JButton modifyClassButton = new JButton("modify");   
    private JButton removeClassButton = new JButton("remvoe");
    private JLabel classNameLabel;
    private JTextField classNameField;
    
    private JLabel activityNameLabel;
    private JTextField activityNameField;

    private JComboBox<String> activityColumnBox = new JComboBox<String>();
    private JComboBox<String> classColumnBox = new JComboBox<String>();
    
    private JTable table;
    private MyTableModel model;

    
    private JLabel fieldNumber;
    private JLabel eventColumnNumber;
    private JLabel attributeColumnNumber;
    private JLabel fkColumnNumber;
    private JLabel pkColumnNumber;
    
    private String tableName;
    private String globalClassName;

    private DataModelInspector dataModelInspector;
    
    
    //for one class from a table, assign constraint values to some columns, (Map<table-class, Map<column, value>>,
    //e.g., Map<llx_commande_fournisseur_log-order_created, Map<fk_status, "0">>
    private Map<String, Map<String, String>> tableClassVSColumnVSConstraint = new HashMap<String, Map<String, String>>();
    //for one activity column, assign a activity name to it
    //private Map<String, Map<String, String>> tableVSColumnVSName = new HashMap<String, Map<String, String>>();
    private Map<String, Map<String, String>> classVSColumnVSName = new HashMap<String, Map<String, String>>();
    //for one table (table name), assign a class name or multiple names (class1-class2-...) for it
//    private Map<String, String> tableVSClass = new HashMap<String, String>();
    private Map<String, List<String>> tableVSClassList = new HashMap<String, List<String>>();
    //for one table (table name), which columns (column names) will be considered as event source, e.g., question-[creationdata, closeddate] (events related to objects)
//    private Map<String, List<String>> tableVSEventColumns = new HashMap<String, List<String>>();
    //for one table (table name), which columns (column names) will be considered as attribute source, e.g., question-[id, title, content] (attributes of objects)
    private Map<String, List<String>> tableVSAttributeColumns = new HashMap<String, List<String>>();
    //for one class (class name), which columns (column names) will be considered as foreign keys, e.g., question-[fk-answer] 
    //    private Map<String, List<String>> tableVSFKColumns = new HashMap<String, List<String>>();
    private Map<String, List<String>> classVSFKColumns = new HashMap<String, List<String>>();
    
    //for one class (class name), which columns (column names) will be considered as primary keys, e.g., question-[id]
    private Map<String, List<String>> classVSPKColumns = new HashMap<String, List<String>>();
    
    //record which table columns are the attributes (e.g., resource) of an event column
    private Map<String, Map<String, List<String>>> classVSActivityColumnVSAttributeColumns = new HashMap<String, Map<String, List<String>>>();
    
    //indicate the filed name list
    private List<String> fieldNameList;
    public TableStructurePanel(final SelectedTablePanel selectedTablePanel, final DataModelInspector dataModelInspector) {
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.dataModelInspector = dataModelInspector;
    	
    	fieldNumber = new JLabel("field: 0");
    	eventColumnNumber = new JLabel("activity column: 0");
    	attributeColumnNumber = new JLabel("attribute column: 0");
    	fkColumnNumber = new JLabel("fk column: 0");
    	pkColumnNumber = new JLabel("pk column: 0");
    	
    	JPanel rowNumberPanel = new JPanel();
    	rowNumberPanel.setLayout(new BoxLayout(rowNumberPanel, BoxLayout.X_AXIS));
    	
    	rowNumberPanel.add(Box.createHorizontalStrut(30));  
    	rowNumberPanel.add(fieldNumber);
    	rowNumberPanel.add(Box.createVerticalStrut(10));
    	rowNumberPanel.add(attributeColumnNumber);
    	rowNumberPanel.add(Box.createVerticalStrut(10));
    	rowNumberPanel.add(eventColumnNumber);
    	rowNumberPanel.add(Box.createVerticalStrut(10));
    	rowNumberPanel.add(fkColumnNumber);
    	rowNumberPanel.add(Box.createVerticalStrut(10));
    	rowNumberPanel.add(pkColumnNumber);
    	rowNumberPanel.add(Box.createVerticalStrut(10));   	   	

    	JPanel operateButtonPanel = new JPanel();
    	operateButtonPanel.setLayout(new BoxLayout(operateButtonPanel, BoxLayout.X_AXIS));  	   	
    
    	JPanel namePanel = new JPanel();
        classNameLabel = new JLabel("class name:");
        classNameField = new JTextField();
        classNameField.setPreferredSize(new Dimension(100,10));
        classNameField.setMaximumSize(new Dimension(200,10));
        
        activityNameLabel = new JLabel("activity name:");
        activityNameField = new JTextField();
        activityNameField.setPreferredSize(new Dimension(100,15));
        activityNameField.setMaximumSize(new Dimension(200,50));

        classColumnBox.setPreferredSize(new Dimension(100,30));
        classColumnBox.setMaximumSize(new Dimension(200,30));
        classColumnBox.setPrototypeDisplayValue("class");
        classColumnBox.setRenderer(new ComboBoxRenderer(classColumnBox));
        classColumnBox.setToolTipText("class name");
		
        activityColumnBox.setPreferredSize(new Dimension(100,30));
        activityColumnBox.setMaximumSize(new Dimension(200,30));
        activityColumnBox.setPrototypeDisplayValue("class");
        activityColumnBox.setRenderer(new ComboBoxRenderer(activityColumnBox));
        activityColumnBox.setToolTipText("activity name");
        
        namePanel.setLayout(new BoxLayout(namePanel, BoxLayout.X_AXIS));
        namePanel.add(Box.createHorizontalStrut(30));
        namePanel.add(classNameLabel);
        namePanel.add(Box.createHorizontalStrut(30));       
        namePanel.add(classColumnBox);
        namePanel.add(Box.createHorizontalStrut(30));       
        namePanel.add(addClassButton);
        namePanel.add(Box.createHorizontalStrut(30));       
        namePanel.add(modifyClassButton);      
        namePanel.add(Box.createHorizontalStrut(30));       
        namePanel.add(removeClassButton);   
        namePanel.add(Box.createHorizontalStrut(100));
        namePanel.add(activityNameLabel);
        namePanel.add(Box.createHorizontalStrut(30));
        namePanel.add(activityColumnBox);
        namePanel.add(Box.createHorizontalStrut(30));
        

        final JTextComponent classColumnBoxText = (JTextComponent) classColumnBox.getEditor().getEditorComponent();
        addClassButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				String className = classColumnBoxText.getText();
				System.out.println("classColumnBoxText item: " + className);
				if(!className.equals("")){
					//add the class name into the list
					classColumnBox.addItem(className);
					if(!tableVSClassList.containsKey(tableName)){
						tableVSClassList.put(tableName, new ArrayList<String>());						
					}
					tableVSClassList.get(tableName).add(className);
					
					
					//initialize the mapping parameter
					classVSActivityColumnVSAttributeColumns.put(className, new HashMap<String, List<String>>());
					classVSColumnVSName.put(className, new HashMap<String, String>());
					for(int i=0; i<table.getRowCount(); i++){
    					String columnName = (String) model.getValueAt(i, fieldNameList.indexOf(xConstants.TABLEFIELDNAME)+1);
    					model.setRC(columnName, i, fieldNameList.indexOf(xConstants.CLASSATTRIBUTENAME)+1);
    					classVSColumnVSName.get(className).put(columnName, columnName);   					
    				}
                	classVSPKColumns.put(className, new ArrayList<String>());
                	String defaultPK = (String) model.getValueAt(0,1);
                	classVSPKColumns.get(className).add(defaultPK);
                	classVSFKColumns.put(className, new ArrayList<String>());
                	classVSColumnVSName.put(className, new HashMap<String, String>());
                	String tableClassComplex = tableName + "-" + className;
                	tableClassVSColumnVSConstraint.put(tableClassComplex, new HashMap<String, String>());
                	
                	updateTable(); 
                	globalClassName = (String) classColumnBox.getSelectedItem();
				}					
			}	        
	    });
        
//        modifyClassButton.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent arg0) {
//				String modifiedItem = classColumnBoxText.getText();
//				String selectedItem = (String) classColumnBox.getSelectedItem();
//				
//				System.out.println("modifyClassButton click");
//				System.out.println("modifiedItem: " + modifiedItem );
//				System.out.println("selectedItem: " + selectedItem );
//				if(classColumnBox.getSelectedItem() != null){
//					classColumnBox.setSelectedItem(classColumnBoxText.getText());
//				}
//				
//				
//				//update tableVSClass
//				if(tableVSClass.containsKey(tableName)){
//					String classNameSequence = tableVSClass.get(tableName);
//					//there just exists one class name
//					if(classNameSequence.equals(selectedItem)){
//						tableVSClass.put(tableName, modifiedItem);
//					}
//					//there exist multiple class names
//					else if(classNameSequence.contains(selectedItem)){
//						String newClassNameSequence = classNameSequence.replace(selectedItem, modifiedItem);
//						tableVSClass.put(tableName, newClassNameSequence);
//					}															
//				}
//								
//			}	        
//	    });
        
        removeClassButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
//				//when there is only one item in the list, disable
//				if(classColumnBox.getItemCount() > 1){
//					
//				}	
							
				String selectedItem = (String) classColumnBox.getSelectedItem();
				if(selectedItem != null){
					
					classColumnBox.removeItem(classColumnBox.getSelectedItem());
					
					//one table can have no corresponding classes; it means the table do not generate objects; we just use the objects in the table
					//as intermediary to link objects of other tables.
					if(tableVSClassList.containsKey(tableName)){
						if(tableVSClassList.get(tableName).contains(selectedItem)){
							tableVSClassList.get(tableName).remove(selectedItem);
						}												
					}
					
					String tableClassComplex = tableName + "-" + selectedItem;
					if(tableClassVSColumnVSConstraint.containsKey(tableClassComplex)){
						tableClassVSColumnVSConstraint.remove(tableClassComplex);
					}
					
				}					
				
				//update tableClassVSColumnVSConstraint
				
				
			}	        
	    });
        
//        //class box text change event
//        classColumnBoxText.getDocument().addDocumentListener(new DocumentListener() { 
//			public void changedUpdate(DocumentEvent e) {
//				// TODO Auto-generated method stub
//				classColumnBox.setSelectedItem(classColumnBoxText.getText());
//			}
//			public void insertUpdate(DocumentEvent e) {
//				// TODO Auto-generated method stub
//				classColumnBox.setSelectedItem(classColumnBoxText.getText());
//			}
//			public void removeUpdate(DocumentEvent e) {
//				// TODO Auto-generated method stub
//				classColumnBox.setSelectedItem(classColumnBoxText.getText());
//			} 
//        });
        
        classColumnBox.setEditable(true);

        //update the columns in the structure table related to the selected class
        classColumnBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                String classColumn = (String) classColumnBox.getSelectedItem();
                globalClassName = classColumn;
                System.out.println("classColumnBox: " + classColumn);
                
                updateStructureTableForSelectedClass(globalClassName);

    				               	
                
                model.fireTableStructureChanged();//necessary
                updateActivityBox();
                //update the RelateActivityToClassPanel panel and ActivityImpactingColumnPanel
                dataModelInspector.getRelateActivityToClassPanel().update(tableName);
                dataModelInspector.getActivityImpactingColumnPanel().update(tableName);
            }
        });
        

        activityColumnBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                String activityName = (String) activityColumnBox.getSelectedItem();
                String activityColumn = null;             
                if(classVSColumnVSName.containsKey(globalClassName)){
                	 Map<String, String> columnVSName = classVSColumnVSName.get(globalClassName);
                     for(String column : columnVSName.keySet()){
                     	String name = columnVSName.get(column);
                     	if(name.equals(activityName)){
                     		activityColumn = column;
                     		break;
                     	}
                     }
                }
                
                
                
                System.out.println("activityColumn: " + activityName);
                System.out.println("activityColumn: " + activityColumn);
                
                if(activityColumn != null){
                	System.out.println("set attribute for activity change");
                	if(!classVSActivityColumnVSAttributeColumns.containsKey(globalClassName)){
                		classVSActivityColumnVSAttributeColumns.put(globalClassName, new HashMap<String, List<String>>());
                	}
                  	if(!classVSActivityColumnVSAttributeColumns.get(globalClassName).containsKey(activityColumn)){
                		classVSActivityColumnVSAttributeColumns.get(globalClassName).put(activityColumn, new ArrayList<String>());
                	}
                  	
                	List<String> attributeColumnList = classVSActivityColumnVSAttributeColumns.get(globalClassName).get(activityColumn);
                	int rowNum = table.getRowCount();
                	
                	//update the attribute(a) column
    				for(int i=0; i<rowNum; i++){
    					String columnName = (String) model.getValueAt(i, 1);
    					if(attributeColumnList.contains(columnName)){
    						System.out.println("set true");
    						model.setRC(new Boolean(true),i, fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1);
    					}
    					else{
    						model.setRC(new Boolean(false),i, fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1);	
    					}
    					
    				}
    				attributeColumnNumber.setText("activity attribute column number: " + classVSActivityColumnVSAttributeColumns.get(globalClassName).get(activityColumn).size());	
                }
                model.fireTableStructureChanged();//necessary
            }
        });
    	

    	   
    	this.add(namePanel);
    	this.add(rowNumberPanel);    
        model = new MyTableModel(); 
        table = new JTable(model); 

        table.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
        
        table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);  
        //create the table content change listener function
        table.getModel().addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e)  
            {  
                      
                int col = e.getColumn();               
                int row = e.getFirstRow();  
		        int numRows = model.getRowCount();
                if(tableName != null && col>0){
            		int i = col;
		        	String columnName = model.getColumnName(i);
		        	List<String> columnList = new ArrayList<String>();
		        	
		        	if(columnName.equals(xConstants.CLASSACTIVITYFIELD)){
						String activityColumnName = (String) model.getValueAt(row, 1);
						if((boolean) model.getValueAt(row, col)){
			        		if(!classVSActivityColumnVSAttributeColumns.containsKey(globalClassName)){
			        			classVSActivityColumnVSAttributeColumns.put(globalClassName, new HashMap<String, List<String>>());
			        		}
			        		if(!classVSActivityColumnVSAttributeColumns.get(globalClassName).containsKey(activityColumnName)){
			        			classVSActivityColumnVSAttributeColumns.get(globalClassName).put(activityColumnName, new ArrayList<String>());
			        		}			        		
			        	}
						else{
							if(classVSActivityColumnVSAttributeColumns.containsKey(globalClassName) && 
									classVSActivityColumnVSAttributeColumns.get(globalClassName).containsKey(activityColumnName)){
								classVSActivityColumnVSAttributeColumns.get(globalClassName).remove(activityColumnName);
			        		}
						}

						//add impacting itself effect for each activity column
						Map<String, List<String>> tableColumnVSImpactedTableColumns = dataModelInspector.getActivityImpactingColumnPanel().getTableColumnVSImpactedTableColumnsMap();
						boolean value = (boolean) model.getValueAt(row, col);	
						String currentTableName = tableName;
						String activityField = (String) model.getValueAt(row, 1);						
						String impactingTable = tableName;
						String impactingField = activityField;
						String impactingIntermediateKey = "rowid";
						String activityKey = currentTableName + "-" + activityField;
						String impactedValue = impactingTable + "-" + impactingField + "-" + impactingIntermediateKey;
						System.out.println("change event, new value: " + value);
						//add new activity column
						if(value){
							if(!tableColumnVSImpactedTableColumns.containsKey(activityKey)){
								tableColumnVSImpactedTableColumns.put(activityKey, new ArrayList<String>());
							}					
							if(!tableColumnVSImpactedTableColumns.get(activityKey).contains(impactedValue))
								tableColumnVSImpactedTableColumns.get(activityKey).add(impactedValue);
						}
						else{
							if(tableColumnVSImpactedTableColumns.containsKey(activityKey)){
								tableColumnVSImpactedTableColumns.remove(activityKey);
							}		
						}
						eventColumnNumber.setText("activity column number: " + classVSActivityColumnVSAttributeColumns.get(globalClassName).size());
						//update the activityBox of the activity impacting panel
						updateActivityBox();
						dataModelInspector.getActivityImpactingColumnPanel().update(tableName);
						dataModelInspector.getRelateActivityToClassPanel().update(tableName);
						update(tableName);
		
		        	}			        	
		        	else if(columnName.equals(xConstants.ACTIVITYATTRIBUTE)){
				        
						List<String> attributeColumnList = new ArrayList<String>();
				        for (int j = 0; j < numRows; j++) {
				        	if((boolean) model.getValueAt(j, i)){
	                    		String attributeColumn = (String) model.getValueAt(j, 1);
	                    		attributeColumnList.add(attributeColumn);
				        	}
				        }
				        attributeColumnNumber.setText("activity attribute column number: " + attributeColumnList.size());	
				        
				        String activityName = (String) activityColumnBox.getSelectedItem();
		                String activityColumn = null;             
		                if(classVSColumnVSName.containsKey(globalClassName)){
		                	 Map<String, String> columnVSName = classVSColumnVSName.get(globalClassName);
		                     for(String column : columnVSName.keySet()){
		                     	String name = columnVSName.get(column);
		                     	if(name.equals(activityName)){
		                     		activityColumn = column;
		                     	}
		                     }
		                }
		                
				        if(activityColumn != null){
				        	if(!classVSActivityColumnVSAttributeColumns.containsKey(globalClassName)){
								classVSActivityColumnVSAttributeColumns.put(globalClassName, new HashMap<String, List<String>>());
								
							}
							classVSActivityColumnVSAttributeColumns.get(globalClassName).put(activityColumn, attributeColumnList);
				        }
						
						
				        
		        	}
		        	else if(columnName.equals(xConstants.CLASSFK)){
				        for (int j = 0; j < numRows; j++) {
				        	if((boolean) model.getValueAt(j, i)){
				        		columnList.add((String) model.getValueAt(j, 1));
				        	}
				        }
				        fkColumnNumber.setText("fk column number: " + columnList.size());
						if(classVSFKColumns.containsKey(globalClassName)){
							classVSFKColumns.remove(globalClassName);
							
						}
						classVSFKColumns.put(globalClassName, columnList);	
						//update the fkBox of the table reference panel
						dataModelInspector.getMappingFKToPKPanel().update(tableName);
		        	}
		        	else if(columnName.equals(xConstants.CLASSPK)){
				        for (int j = 0; j < numRows; j++) {
				        	if((boolean) model.getValueAt(j, i)){
				        		columnList.add((String) model.getValueAt(j, 1));
				        	}
				        }
				        pkColumnNumber.setText("pk column number: " + columnList.size());
						if(classVSPKColumns.containsKey(globalClassName)){
							classVSPKColumns.remove(globalClassName);
							
						}
						classVSPKColumns.put(globalClassName, columnList);	

		        	}		        	
		        	else if(columnName.equals(xConstants.CLASSCONSTRAINT)){
				        String selectedClass = (String) classColumnBox.getSelectedItem();
				        if(selectedClass != null){
				        	String modifiedColumn = (String) model.getValueAt(row, 1);
					        String tableClassComplex = tableName + "-" + selectedClass;
					        String newConstraint = (String) model.getValueAt(row, col);
	 					        
							if(!tableClassVSColumnVSConstraint.containsKey(tableClassComplex)){
								tableClassVSColumnVSConstraint.put(tableClassComplex, new HashMap<String, String>());								
							}
							if(newConstraint.equals("") && tableClassVSColumnVSConstraint.get(tableClassComplex).containsKey(modifiedColumn)){
								tableClassVSColumnVSConstraint.get(tableClassComplex).remove(modifiedColumn);
							}
							else{
								tableClassVSColumnVSConstraint.get(tableClassComplex).put(modifiedColumn, newConstraint);
							}							
				        }				        
		        	}
	                //update the name of column (field)
	                else if(columnName.equals(xConstants.CLASSATTRIBUTENAME)){
	                	System.out.println("name column changes: " + table);
	                	String selectedClassName = (String) classColumnBox.getSelectedItem();
	                	//if the selected class is not null
	                	if(selectedClassName != null){
		                	String columnNameOfModifiedRow = (String) model.getValueAt(row, 1);
		                	String oldName = classVSColumnVSName.get(selectedClassName).get(columnNameOfModifiedRow);	
		                	String newName = (String) model.getValueAt(row, col);
		                	//if the input name is not empty
		                    if(newName != null && !newName.equals( "")){                    	
		                    	//make sure the new name is unique (different from other names)
			                	List<String> existentNameList = new ArrayList<String>();                	
			                	for (int j = 0; j < numRows; j++) {
			                		String name = (String) model.getValueAt(j, i);
			                		existentNameList.add(name);
						        }
			                	existentNameList.remove(row);	
			                	//if the input name is different from other names
			                    if(!existentNameList.contains(newName)){
			                    	Map<String, String> columnVSNameMap = new HashMap<String, String>();			                	
				                	for (int j = 0; j < numRows; j++) {
				                		String name = (String) model.getValueAt(j, i);
				                		String column = (String) model.getValueAt(j, 1);
							        	if(name != null){
							        		columnVSNameMap.put(column, name);
							        	}
							        	else
							        		columnVSNameMap.put(column, column);
							        }			                
				                	if(classVSColumnVSName.containsKey(selectedClassName)){
				                		classVSColumnVSName.remove(selectedClassName);							
									}
				                	classVSColumnVSName.put(selectedClassName, columnVSNameMap);	
				                	updateActivityBox();
//				                	classColumnBox.setSelectedItem(selectedClassName);
//				                	globalClassName = (String) classColumnBox.getSelectedItem();
				                	dataModelInspector.getRelateActivityToClassPanel().update(tableName);
			                    }
			                    else{
			                    	model.setValueAt(oldName, row, col);
			                    	JOptionPane.showMessageDialog(null, "Wrong! The input name should be different from other names!");
			                    }	                	
		                    }
		                    else{
		                    	model.setValueAt(oldName, row, col);
		                    	JOptionPane.showMessageDialog(null, "Wrong! The input name should not be empty!");
		                    }
	                	}
	                } 
				}                    
            }  
        }); 
        
        JScrollPane scrollpane = new JScrollPane(table);
        scrollpane.setPreferredSize(new Dimension(500, 300));
        this.add(scrollpane);

    	this.setBorder(BorderFactory.createTitledBorder("table structure")); 
    }

    /*
     * update the structure panel for the input table
     */
    public void update(String tableName){
    	System.out.println("\n kfgz update the structure panel for the input table");
		this.tableName = tableName;
		if(tableName != null){			
			updateClassBox();
			updateTable();          
            updateActivityBox();
		}
    }
    
    //update the activity box, just show all activities of the selected class
    public void updateTable(){
		String selectedClassName = (String) classColumnBox.getSelectedItem();			
        System.out.println("\n tablename" + tableName);
       
        
		dataModelInspector.getLogGenerator().getDataImporterUI().getNameVSJtableMap().get(tableName);
		MyTableModel tableModel = (MyTableModel) dataModelInspector.
				getLogGenerator().getDataImporterUI().getNameVSJtableMap().get(tableName).getModel();	
		
		//set the filed name row (automatically add the index column)
		fieldNameList = new ArrayList<String>();
		fieldNameList.add(xConstants.TABLEFIELDNAME);
		fieldNameList.add(xConstants.CLASSATTRIBUTENAME);
//		fieldNameList.add(xConstants.TABLEFIELDTYPE);

		fieldNameList.add(xConstants.CLASSPK);
		fieldNameList.add(xConstants.CLASSFK);

		fieldNameList.add(xConstants.CLASSCONSTRAINT);
		fieldNameList.add(xConstants.CLASSACTIVITYFIELD);
		fieldNameList.add(xConstants.ACTIVITYATTRIBUTE);
		model.setFieldRow(fieldNameList);
		

		//indicate the filed row of the selected table
		List<String> fieldList = tableModel.getFieldRow();
		int rowNum = fieldList.size();//each field name corresponds to one row
		
		//update the index and filed column (related to the selected table)
		for(int n=0; n < fieldList.size(); n++){
			String columnName = fieldList.get(n);
			model.setRC(n+1, n, 0);  
			model.setRC(columnName, n, fieldNameList.indexOf(xConstants.TABLEFIELDNAME)+1);
		}
		
		updateStructureTableForSelectedClass(selectedClassName);
				
		//update the attribute(a) column (related to the selected activity)	  
		String activityName = (String) activityColumnBox.getSelectedItem();
		if(activityName == null){
			for(int n=0; n < fieldList.size(); n++){
//				model.setRC(new Boolean(false), n, (fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1));
				model.setRC("null", n, (fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1));
				
    		}
		}
		else if(classVSActivityColumnVSAttributeColumns.containsKey(globalClassName) && 
    			classVSActivityColumnVSAttributeColumns.get(globalClassName).containsKey(activityName)){
    		System.out.println("update the attribute of activity");
    		List<String> attributeColumnList = classVSActivityColumnVSAttributeColumns.get(globalClassName).get(activityName);
    		for(int n=0; n < fieldList.size(); n++){
    			String columnName = fieldList.get(n);
    			if(attributeColumnList.contains(columnName)){       			
        			model.setRC(new Boolean(true), n, (fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1));
        		}  
    			else{
    				model.setRC(new Boolean(false), n, (fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1));
    			}
    		}
    	}
    	
		model.setR(rowNum);      
		fieldNumber.setText("field number: " + rowNum);
		model.fireTableStructureChanged();
    }
    
    //update the activity, pk, fk, assigned name, constraint column (related to the selected class)
    public void updateStructureTableForSelectedClass(String selectedClassName){	
    	if(selectedClassName == null){
    		for(int n=0; n < model.getRowCount(); n++){
    			model.setRC("null", n, fieldNameList.indexOf(xConstants.CLASSACTIVITYFIELD)+1);
     		    model.setRC("null", n, fieldNameList.indexOf(xConstants.CLASSPK)+1);
     		    model.setRC("null", n, fieldNameList.indexOf(xConstants.CLASSFK)+1);
     		    model.setRC("null", n, fieldNameList.indexOf(xConstants.CLASSATTRIBUTENAME)+1);
     		    model.setRC("null", n, fieldNameList.indexOf(xConstants.CLASSCONSTRAINT)+1);
     		    model.setRC("null", n, fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1);
    		} 
    	}
    	else{
    		for(int n=0; n < model.getRowCount(); n++){
    			String columnName = (String) model.getValueAt(n, fieldNameList.indexOf(xConstants.TABLEFIELDNAME)+1);
    			System.out.println("columnName: " + columnName);
    		    model.setRC(new Boolean(false), n, fieldNameList.indexOf(xConstants.CLASSACTIVITYFIELD)+1);
    		    model.setRC(new Boolean(false), n, fieldNameList.indexOf(xConstants.CLASSPK)+1);
    		    model.setRC(new Boolean(false), n, fieldNameList.indexOf(xConstants.CLASSFK)+1);
//    		    model.setRC(new Boolean(false), n, fieldNameList.indexOf(xConstants.ACTIVITYATTRIBUTE)+1);
    		    model.setRC(columnName, n, fieldNameList.indexOf(xConstants.CLASSATTRIBUTENAME)+1);
    		    model.setRC("", n, fieldNameList.indexOf(xConstants.CLASSCONSTRAINT)+1);
    		          
    		    if(classVSActivityColumnVSAttributeColumns.containsKey(selectedClassName)){
    		    	Map<String, List<String>> activityColumnVSAttributeColumns = classVSActivityColumnVSAttributeColumns.get(selectedClassName);
    		    	eventColumnNumber.setText("activity column number: " + activityColumnVSAttributeColumns.size());
    				if(activityColumnVSAttributeColumns.keySet().contains(columnName)){
    					model.setRC(new Boolean(true), n, (fieldNameList.indexOf(xConstants.CLASSACTIVITYFIELD)+1));
    				}	
    			} 
    		    
    		    //if the table has ever been validated, get the section for one column name
    		    if(classVSPKColumns.containsKey(selectedClassName)){
    		    	pkColumnNumber.setText("pk column number: " + classVSPKColumns.get(selectedClassName).size());
    				if(classVSPKColumns.get(globalClassName).contains(columnName)){
    					model.setRC(new Boolean(true), n, fieldNameList.indexOf(xConstants.CLASSPK)+1);
    				}						
    			} 		    		
    		    
    		    //if the table has ever been validated, get the section for one column name
    		    if(classVSFKColumns.containsKey(selectedClassName)){
    		    	fkColumnNumber.setText("fk column number: " + classVSFKColumns.get(selectedClassName).size());
    				if(classVSFKColumns.get(globalClassName).contains(columnName)){
    					model.setRC(new Boolean(true), n, fieldNameList.indexOf(xConstants.CLASSFK)+1);
    				}						
    			}
    		    
    		    //if the table has ever been validated, get the assigned name for one column name
    		    if(classVSColumnVSName.containsKey(selectedClassName)){
    		    	System.out.println("column: " + columnName);
    		    	String name = classVSColumnVSName.get(selectedClassName).get(columnName);
    		    	System.out.println("name: " + name);
    		    	
    		    	if(name == null || name.equals("null")){
    		    		name = columnName;
    		    		classVSColumnVSName.get(selectedClassName).put(columnName, columnName);
    		    	}
    		    		
    		    	model.setRC(name, n, fieldNameList.indexOf(xConstants.CLASSATTRIBUTENAME)+1);						
    			} 

    		    
    		    //if the table has ever been validated, get the section for one column name
    		    String selectedClass = (String) classColumnBox.getSelectedItem();			       
    		    String tableClassComplex = tableName + "-" + selectedClass;
    		        
    		    //if the table has ever been validated, get the section for one column name
    		    if(tableClassVSColumnVSConstraint.containsKey(tableClassComplex)){
    		    	String name = tableClassVSColumnVSConstraint.get(tableClassComplex).get(columnName);
    		    	if(name == null){
    		    		name = "";
    		    	}
    		    	model.setRC(name, n, fieldNameList.indexOf(xConstants.CLASSCONSTRAINT)+1);						
    			}       		       		   
    		}
    	}
    }
    
    //update the activity box, just show all activities of the selected class
    public void updateActivityBox(){
		activityColumnBox.removeAllItems();			
		if(classVSActivityColumnVSAttributeColumns.containsKey(globalClassName)){
			System.out.println("updateActivityBox classVSActivityColumnVSAttributeColumns.containsKey(globalClassName)");
			for(String activityColumn : classVSActivityColumnVSAttributeColumns.get(globalClassName).keySet()){					
				if(classVSColumnVSName.get(globalClassName) != null &&
						classVSColumnVSName.get(globalClassName).get(activityColumn) != null){
					String activityName = classVSColumnVSName.get(globalClassName).get(activityColumn);
					System.out.println("updateActivityBox != null twice");
					activityColumnBox.addItem(activityName);
				}					
			}
		}
    }
        
    //update the class box, just show all activities of the selected class
    public void updateClassBox(){
		classColumnBox.removeAllItems();
		if(tableVSClassList.containsKey(tableName)){
			for(String className : tableVSClassList.get(tableName)){					
				classColumnBox.addItem(className);
			}
		}
		//if the table is not assigned to classes
		else{
			tableVSClassList.put(tableName, new ArrayList<String>());
		}
		globalClassName = (String) classColumnBox.getSelectedItem();
    }
    
    public Map<String, Map<String, String>>   getTableClassVSColumnVSConstraintMap(){
    	return tableClassVSColumnVSConstraint;
    }
    
    public void setTableClassVSColumnVSConstraintMap(
    		Map<String, Map<String, String>> tableClassVSColumnVSConstraint){
    	this.tableClassVSColumnVSConstraint = tableClassVSColumnVSConstraint;
    }
    
    public Map<String, Map<String, List<String>>>  getClassVSActivityColumnVSAttributesColumnsMap(){
    	return classVSActivityColumnVSAttributeColumns;
    }
    
    public void setClassVSActivityColumnVSAttributeColumnsMap(Map<String, Map<String, List<String>>> classVSActivityColumnVSAttributeColumns){
    	this.classVSActivityColumnVSAttributeColumns = classVSActivityColumnVSAttributeColumns;
    }    
    
    public Map<String, Map<String, String>>  getClassVSColumnVSNameMap(){
    	return classVSColumnVSName;
    }
    
    public void setClassVSColumnVSNameMap(Map<String, Map<String, String>> classVSColumnVSName){
    	this.classVSColumnVSName = classVSColumnVSName;
    }
    
    public Map<String, List<String>> getTableVSClassListMap(){
    	return tableVSClassList;
    }
    
    public void setTableVSClassListMap(Map<String, List<String>> tableVSClassList){
    	this.tableVSClassList = tableVSClassList;
    }      
    
    public Map<String, List<String>> getClassVSFKColumnsMap(){
    	return classVSFKColumns;
    }

    public void setClassVSFKColumnsMap(Map<String, List<String>> classVSFKColumns){
    	this.classVSFKColumns = classVSFKColumns;
    }
    
    public Map<String, List<String>> getClassVSPKColumnsMap(){
    	return classVSPKColumns;
    }
    
    public void setClassVSPKColumnsMap(Map<String, List<String>> classVSPKColumns){
    	this.classVSPKColumns = classVSPKColumns;
    }    
    
    public String getTableName(){
    	return tableName;
    }
    
    public String getClassName(){
    	return globalClassName;
    }
}
 
