package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.common.dialogue.IOFileDialogue;
import org.processmining.common.table.MyTableModel;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class CSVPanel extends JPanel implements ListSelectionListener{
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private String tablename = "";
    
    private Map<String, JTable> nameVSJtable;
    private File lastFile;
    
    private List<String> tableList;
    private JList<String> sourceList;
    private DefaultListModel<String> sourceListModel;
    private DefaultListModel<String> targetListModel;
    private JList<String> targetList;
    private JLabel sourceLabel;
    private JLabel targetLabel;
 
    private DataImporterInterface fatherPanel;
    
    private List<String> selectedTableList = new ArrayList<String>();
	int screenHeight = (int) Toolkit.getDefaultToolkit().getScreenSize().getHeight();
	int screenWidth = (int) Toolkit.getDefaultToolkit().getScreenSize().getWidth();
	private JComboBox<String> separatedValueBox = new JComboBox<String>();
	String delimiter = ",";
    public CSVPanel(DataImporterInterface fatherPanel) {
    	this.fatherPanel = fatherPanel;
    	this.nameVSJtable = fatherPanel.getNameVSJtableMap();
    	tableList = new ArrayList<String>();
    	JPanel generatedPanel = generateTableSelectionPanel();
    	add(generatedPanel);
    	this.setBorder(BorderFactory.createTitledBorder("import csv file(s)"));  
    }
 
    public CSVPanel(DataImporterInterface fatherPanel, int width, int height) {
    	this.screenWidth = width;
    	this.screenHeight = height;
    	this.fatherPanel = fatherPanel;
    	this.nameVSJtable = fatherPanel.getNameVSJtableMap();
    	tableList = new ArrayList<String>();
    	JPanel generatedPanel = generateTableSelectionPanel();
    	add(generatedPanel);
    	this.setBorder(BorderFactory.createTitledBorder("import csv file(s)"));
    }
 
    public String getTablename() {
        return tablename;
    }
 
    public void setTablename(String tablename) {
        this.tablename = tablename;
    }
 
  //used to configure tables by file
    public void setSelectedtTableList(List<String> selectedTableList) {
        this.selectedTableList = selectedTableList;
    }
    
    public JList<String> getSourceJList() {
        return sourceList;
    }
    
    public JList<String> getTargetJList() {
        return targetList;
    }
    
    public List<String> getTableList() {
        return tableList;
    }
 
    public void setTableList(List<String> tableList) {
        this.tableList = tableList;
    }
 
    public void polulateNonSelectedList(List<String> list){
		if(list != null){
			sourceListModel.removeAllElements();
			for(String tableName : list){
				sourceListModel.addElement(tableName);
			}
		}
		sourceList.setModel(sourceListModel);
    }
    
    public JPanel generateTableSelectionPanel(){	
    	JPanel middlePanel = new JPanel();
	    sourceLabel = new JLabel("imported files");
		sourceLabel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceLabel.setBorder(BorderFactory.createEmptyBorder(4, 5, 0, 5));
		//build source list
		sourceListModel = new DefaultListModel<String>();
		if(tableList != null){
			for(String tableName : tableList){
				sourceListModel.addElement(tableName);
			}
		}	
		sourceList = new JList<String>(sourceListModel);	
		sourceList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		sourceList.setVisibleRowCount(5);
		//build source list panel
		JScrollPane sourceListScroller = new JScrollPane(sourceList);
		sourceListScroller.setPreferredSize(new Dimension(screenWidth/6, screenHeight/3));
		sourceListScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		sourceListScroller.setAlignmentY(Component.TOP_ALIGNMENT);
		JPanel sourceListPanel = new JPanel();
		sourceListPanel.setLayout(new BoxLayout(sourceListPanel,BoxLayout.Y_AXIS));
		sourceListPanel.add(sourceLabel);
		sourceListPanel.add(sourceListScroller);
		sourceListPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceListPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 30));
		middlePanel.add(sourceListPanel);
				
		//build operating button panel
		JPanel buttonPanel = new JPanel();
		JButton toTargetButton = new JButton("    >    ");	
		JButton toSourceButton = new JButton("    <    ");		
		JButton allToTargetButton = new JButton("   >>   ");		
		JButton allToSourceButton = new JButton("   <<   ");
		JButton removeFileButton = new JButton("remove");
		JButton selectFileButton = new JButton("import");				
		JButton loadFileButton = new JButton("load");

		selectFileButton.setToolTipText("import local csv files");
		removeFileButton.setToolTipText("remove imported csv files");
		loadFileButton.setToolTipText("load the selected csv files into `Configure` interface for log generation");
		
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));		
		buttonPanel.add(separatedValueBox);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(selectFileButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(removeFileButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 30)));
		buttonPanel.add(toTargetButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(toSourceButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(allToTargetButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(allToSourceButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 30)));
		buttonPanel.add(loadFileButton);	
		
		buttonPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		buttonPanel.setBorder(BorderFactory.createEmptyBorder(15, 5, 15, 5));
		middlePanel.add(buttonPanel);
	
		targetLabel = new JLabel("selected files");
		targetLabel.setAlignmentY(Component.TOP_ALIGNMENT);
		targetLabel.setBorder(BorderFactory.createEmptyBorder(4, 5, 0, 5));
		//build target list
		targetListModel = new DefaultListModel<String>();
		targetList = new JList<String>(targetListModel);
		targetList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		targetList.setVisibleRowCount(5);
		//build target list panel
		JScrollPane targetListScroller = new JScrollPane(targetList);
		targetListScroller.setPreferredSize(new Dimension(screenWidth/6, screenHeight/3));
		targetListScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		targetListScroller.setAlignmentY(Component.TOP_ALIGNMENT);
		JPanel targetListPanel = new JPanel();
		targetListPanel.setLayout(new BoxLayout(targetListPanel,BoxLayout.Y_AXIS));
		targetListPanel.add(targetLabel);
		targetListPanel.add(targetListScroller);
		targetListPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		targetListPanel.setBorder(BorderFactory.createEmptyBorder(0, 30, 0, 0));
		middlePanel.add(targetListPanel);		
		
		separatedValueBox.addItem(",");
		separatedValueBox.addItem(";");
		separatedValueBox.addItem("|");
		separatedValueBox.addItem("^");
		separatedValueBox.setToolTipText("select or input a delimiter before importing files");
		separatedValueBox.addActionListener(new ActionListener() {			
			public void actionPerformed(ActionEvent e) {
				delimiter =	(String) separatedValueBox.getSelectedItem();	
			}
		});
		separatedValueBox.setPrototypeDisplayValue("t");
		separatedValueBox.setEditable(true);
		((JTextField)separatedValueBox.getEditor().getEditorComponent()).setColumns(1);
		
	
		selectFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				//change the cursor to waiting cursor
				fatherPanel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
				
				IOFileDialogue fileImporter = new IOFileDialogue();
            	fileImporter.show("CSV Files (.csv)","csv", JFileChooser.FILES_ONLY, "Select", lastFile);
            	JFileChooser fileChooser = fileImporter.getFileChooser();           	
            	File file = fileImporter.getSelectedFile();
				if(file != null){
					File[] files = fileChooser.getSelectedFiles();
					lastFile = file.getParentFile();
					transformCSVFilesToJTables(files, delimiter);
					List<String> nameList = new ArrayList<String>(nameVSJtable.keySet());
					addingIntoSourceList(nameList);
				}		
				
				//change the cursor to default cursor
				fatherPanel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			}
		});
		
		
		removeFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] indexSet = sourceList.getSelectedIndices();
				List<String> selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(sourceList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					sourceListModel.removeElement(selectedItem);
					sourceList.setModel(sourceListModel);
					nameVSJtable.remove(selectedItem);
					tableList.remove(selectedItem);
				}
				
				
				
				indexSet = targetList.getSelectedIndices();
				selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(targetList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					targetListModel.removeElement(selectedItem);
					targetList.setModel(targetListModel);
					nameVSJtable.remove(selectedItem);
					tableList.remove(selectedItem);
				}
				updateTableNumberLabel();
			}			
		});
		
		loadFileButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {	
				List<String> itemList = new ArrayList<String>();
			   	for(int i=0; i<targetListModel.getSize(); i++){
					String element = targetListModel.getElementAt(i);
					itemList.add(element);			
				}
				fatherPanel.getLogGenerator().getDataModelUI().getSelectedTablePanel().setList(itemList);;
			}			
		});
		
		//add listeners for the operating buttons and list changes
		toTargetButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] indexSet = sourceList.getSelectedIndices();
				List<String> selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(sourceList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					targetListModel.addElement(selectedItem);
					targetList.setModel(targetListModel);
					sourceListModel.removeElement(selectedItem);
					sourceList.setModel(sourceListModel);
				}
				updateTableNumberLabel();
			}
		});

		
		allToTargetButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				if(tableList != null){
					targetListModel.removeAllElements();
					for(String tableName : tableList){
						targetListModel.addElement(tableName);
						targetList.setModel(targetListModel);
					}
				}								
				sourceListModel.removeAllElements();				
				sourceList.setModel(sourceListModel);				
				updateTableNumberLabel();
			}
		});
		
		toSourceButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {				
				int[] indexSet = targetList.getSelectedIndices();
				List<String> selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(targetList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					sourceListModel.addElement(selectedItem);
					sourceList.setModel(sourceListModel);
					targetListModel.removeElement(selectedItem);
					targetList.setModel(targetListModel);
				}
				updateTableNumberLabel();
			}
		});
		
		allToSourceButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				if(tableList != null){
					sourceListModel.removeAllElements();
					for(String tableName : tableList){
						sourceListModel.addElement(tableName);
						sourceList.setModel(sourceListModel);
					}
				}							
				targetListModel.removeAllElements();				
				targetList.setModel(targetListModel);				
				updateTableNumberLabel();				
			}
		});

		
		sourceList.addListSelectionListener(this);
		targetList.addListSelectionListener(this);
		
		return middlePanel;
    }
    
    public void updateTableNumberLabel(){
		sourceLabel.setText("imported files: " + sourceListModel.size());
        targetLabel.setText("selected files: " + targetListModel.size());
    }

    
    @Override
    //Called whenever the value of the selection changes.
	public void valueChanged(ListSelectionEvent e) {
    	System.out.println("value of the selection changes");
    	String selectedItem = null;
		// TODO Auto-generated method stub
		if(e.getSource().equals(sourceList)){
			if(sourceList.getSelectedValue() != null){
				selectedItem = sourceList.getSelectedValue();
				setTablename(sourceList.getSelectedValue());
				targetList.setSelectedIndices(new int[]{});
				
				//empty the list in the database table panel
				fatherPanel.getDatabasePanel().getDatabaseTablePanel().getSourceJList().setSelectedIndices(new int[]{});
				fatherPanel.getDatabasePanel().getDatabaseTablePanel().getTargetJList().setSelectedIndices(new int[]{});
			}				
		}
		else if(e.getSource().equals(targetList)){
			if(targetList.getSelectedValue() != null){
				selectedItem = targetList.getSelectedValue();
				setTablename(targetList.getSelectedValue());
				sourceList.setSelectedIndices(new int[]{});
				
				//empty the list in the database table panel
				fatherPanel.getDatabasePanel().getDatabaseTablePanel().getSourceJList().setSelectedIndices(new int[]{});
				fatherPanel.getDatabasePanel().getDatabaseTablePanel().getTargetJList().setSelectedIndices(new int[]{});
			}			
		}			
		//update the contents of ContentPanel
		if(selectedItem != "" && selectedItem != null){
			fatherPanel.getContentPanel().updateTableContents(selectedItem, nameVSJtable.get(selectedItem));
		}		
	}
	
    //get the selected item list (from the target list) of the List<String> format
    public List<String> getSelectedTables(){
    	List<String> selectedTableList = new ArrayList<String>();
    	int listSize = targetList.getModel().getSize();
    	for(int i =0; i<listSize; i++){
    		String selectedContent = targetList.getModel().getElementAt(i);
    		selectedTableList.add(selectedContent);
    	}   	
		return selectedTableList;
    }
    

    //get the selected item list (from the target list) of the JList<String> format
    public JList<String> getSelectedTableList(){   	
    	DefaultListModel<String> selectedTableListModel = new DefaultListModel<String>();
    	for(String tableName : getSelectedTables()){
    		selectedTableListModel.addElement(tableName);
    	}
    	JList<String> selectedTableList = new JList<String>(selectedTableListModel);
    	selectedTableList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		return selectedTableList;
    }

  //put a item list of the List<String> format to the source list
    public void addingIntoSourceList(List<String> itemList){       
        //use the configuration file to configure tables (record the selected tables)
        for(String tableName : itemList){
        	if(!sourceListModel.contains(tableName) && !targetListModel.contains(tableName)){
        		sourceListModel.addElement(tableName);
        	}     	
        	if(!tableList.contains(tableName)){
        		tableList.add(tableName);
        	}          	
		}
    	sourceList.setModel(sourceListModel);
		targetList.setModel(targetListModel);
        sourceLabel.setText("imported files: " + sourceListModel.size());
        targetLabel.setText("selected files: " + targetListModel.size());
    }
    
    public void transformCSVFilesToJTables(File[] files, String delimiter){
        for(int i=0; i<files.length; i++){
        	File file = files[i];
        	System.out.println("file path: " + file);
        	String fileName = file.getName();
            String nameWithoutSuffix = fileName.substring(0, fileName.lastIndexOf('.'));
                       
        	if(!sourceListModel.contains(nameWithoutSuffix) && !targetListModel.contains(nameWithoutSuffix)){
        		MyTableModel model = new MyTableModel();
            	JTable table = new JTable(model);
                try { 
                    @SuppressWarnings("resource")
    				BufferedReader reader = new BufferedReader(new FileReader(file));//换成你的文件名
                    String columnNameLine = reader.readLine();//第一行信息，为标题信息，不用，如果需要，注释掉                
                    //set the field row
                    List<String> columnNameList = new ArrayList<String>();
                    String columnNameSet[] = columnNameLine.split(delimiter);//partition CSV header based on delimiter
                    for(int j=0; j<columnNameSet.length; j++){
                    	columnNameList.add(columnNameSet[j]);
                    	System.out.print(", " + columnNameSet[j]); 
                    }
                    System.out.print("****************************************" ); 
                    model.setFieldRow(columnNameList);
                    String line = null; 
                    while((line=reader.readLine())!=null){ 
                    	List<Object> valueList = new ArrayList<Object>();
                        String item[] = line.split(delimiter);//partition CSV body based on delimiter
                        for(int j=0; j<item.length; j++){
                        	valueList.add(item[j]);
                        	System.out.print(", " + item[j]); 
                        }                 
                        model.addRecordRow(valueList);
                        System.out.println("\n"); 
                    } 
                    model.fireTableStructureChanged();
                    if(model.getColumnCount() == 2){
                    	JOptionPane.showMessageDialog(null, "Warn! The table contains nothing. Please check the "
//                        		+ "delimiter you chose, the row number (<100000) or the column number (<200).");
                        		+ "delimiter you chose.");
                    }
                    
                } catch (Exception e) { 
                    e.printStackTrace(); 
                    JOptionPane.showMessageDialog(null, "Wrong! Fail to parse CSV files. Please check the "
                    		+ "delimiter you chose.");
                }                
                nameVSJtable.put(nameWithoutSuffix, table);
        	}
        	else{//there exist file with the same name, output the warning dialog
				JOptionPane.showMessageDialog(null, "the file " + nameWithoutSuffix + " already exists");
			}
        	
        }

    }
    
    public Map<String, JTable> getNameVSJtableMap(){
    	return nameVSJtable;
    }  
}