package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

import org.processmining.common.table.CreateTablePanel;
import org.processmining.common.table.MyTableModel;

 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class ContentPanel extends JPanel {
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static void main(String[] args) {
 
    }
   
    private JButton selectAllButton;
    private JButton selectMultipleButton;
    private JButton cancelAllButton;
    private JTable table;
    private MyTableModel model;
    private JLabel rowNumber;
    private JLabel selectedRowNumber;
    private CreateTablePanel tablePanel = new CreateTablePanel("");;
    private DataImporterInterface fatherPanel;
    int height = 400;
	int width = 600;
    private String currentTableName;
    //for one table (table name), which columns (column names) will be selected, e.g., question-[1,2,18] (filter the input tables)
    private Map<String, List<String>> tableVSSelectedRowIds = new HashMap<String, List<String>>();

    public ContentPanel(final DataImporterInterface fatherPanel) {
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    	this.fatherPanel = fatherPanel;         
    	rowNumber = new JLabel("row number: 0");
    	selectedRowNumber = new JLabel("selected row number: 0");
    	JPanel rowNumberPanel = new JPanel();
    	rowNumberPanel.setLayout(new BoxLayout(rowNumberPanel, BoxLayout.X_AXIS));
    	rowNumberPanel.add(rowNumber);
    	rowNumberPanel.add(Box.createHorizontalStrut(200));
    	rowNumberPanel.add(selectedRowNumber);
    	
    	selectAllButton = new JButton("select all");
    	selectMultipleButton = new JButton("select multiple");  	
    	cancelAllButton = new JButton("cancel all");
    	JPanel operateButtonPanel = new JPanel();
    	operateButtonPanel.setLayout(new BoxLayout(operateButtonPanel, BoxLayout.X_AXIS));
    	operateButtonPanel.add(selectAllButton);
    	operateButtonPanel.add(Box.createHorizontalStrut(100));
    	operateButtonPanel.add(selectMultipleButton);  	
    	operateButtonPanel.add(Box.createHorizontalStrut(100));
    	operateButtonPanel.add(cancelAllButton);   	   	
    	   	
        
        table = tablePanel.getTable();
        table.setPreferredScrollableViewportSize(new Dimension(width, height));
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);// 水平滚动条
        model = (MyTableModel) tablePanel.getTable().getModel();
        model.addTableModelListener(new TableModelListener()  
        {  
            @Override  
            public void tableChanged(TableModelEvent e) {  
                int col = e.getColumn();               
                int row = e.getFirstRow(); 
                if(col == 0){
                	System.out.println("check Changed");
                	boolean checkFlag = (boolean) model.getValueAt(row, 0);
                	String rowid = (String) model.getValueAt(row, 2);
                	

                	if(!tableVSSelectedRowIds.containsKey(currentTableName)){
                		tableVSSelectedRowIds.put(currentTableName, new ArrayList<String>());
                	}
                	
                	//add new checked rowid
                	if(checkFlag){              		
                    	System.out.println("checked rowid: " + rowid);
                    	if(!tableVSSelectedRowIds.get(currentTableName).contains(rowid)){
                    		tableVSSelectedRowIds.get(currentTableName).add(rowid);
                    	}                   	
                	}
                	else{              		
                        System.out.println("unchecked rowid: " + rowid);
                        if(tableVSSelectedRowIds.get(currentTableName).contains(rowid)){
                    		tableVSSelectedRowIds.get(currentTableName).remove(rowid);
                    	}   
                    }
                	selectedRowNumber.setText("selected row number: " + tableVSSelectedRowIds.get(currentTableName).size());
                }
                
		        
		        
            }
    	});
             
          
        selectAllButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
		        int numRows = model.getRowCount();
		        for (int i = 0; i < numRows; i++) {
		        	model.setValueAt(true, i, 0);
		        }
		        updateTableNumberLabel();
			}
		});
        
        selectMultipleButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] selectedRowSet = table.getSelectedRows();
				for(int i=0; i<selectedRowSet.length; i++){
					model.setValueAt(true, selectedRowSet[i], 0);
				}				
				updateTableNumberLabel();
			}
		});
        
        cancelAllButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
		        int numRows = model.getRowCount();
		        for (int i = 0; i < numRows; i++) {
		        	model.setValueAt(false, i, 0);
		        }
		        updateTableNumberLabel();
			}
		});            

        this.setSize(800, 400);
    	this.add(operateButtonPanel);
    	this.add(rowNumberPanel);
        this.add(tablePanel);
        this.setBorder(BorderFactory.createTitledBorder("table viewer")); 
    }

    public Map<String, List<String>> getTableVSSelectedRowIdsMap(){
    	return tableVSSelectedRowIds;
    }
    
    public void setTableVSSelectedRowIdsMap(Map<String, List<String>> tableVSSelectedRowIds){
    	this.tableVSSelectedRowIds = tableVSSelectedRowIds;
    }
    
    public void updateTableNumberLabel(){
    	int selectedRowCount = 0;
    	if(tableVSSelectedRowIds.containsKey(currentTableName)){
    		selectedRowCount = tableVSSelectedRowIds.get(currentTableName).size();
    	}
    	selectedRowNumber.setText("selected row number: " + selectedRowCount);
    	rowNumber.setText("row number: " + model.getRowCount());
    }
    
    public void updateTableContents(String tableName, JTable table){
    	System.out.println("updateTableContents");
    	if(tableVSSelectedRowIds.get(tableName) != null){
    		for(String selectedId : tableVSSelectedRowIds.get(tableName)){
        		System.out.println("selectedId: " + selectedId);
        	}
    	}	
    	currentTableName = tableName;   	
    	
    	
    	MyTableModel tableModel = (MyTableModel) table.getModel();	
    	int numRows = tableModel.getRowCount();
    	int numCols = tableModel.getColumnCount();   	
    	
    	List<String> filedRowWithCheck = new ArrayList<String>();
    	filedRowWithCheck.add("check");
       	filedRowWithCheck.add("index");
    	filedRowWithCheck.addAll(tableModel.getFieldRow());

    	List<String> columnNameList = new ArrayList<String>();
    	for(String columnName : filedRowWithCheck){
    		columnNameList.add(columnName);
    		System.out.println("columnName in content panel: " + columnName);
    	}
    	tablePanel.setFieldRow(columnNameList);
    	
    	for (int j = 0; j < numRows; j++) {
    		model.setRC(false, j, 0);
    		//if the table has ever been validated, get the section for one column name
    		if(tableVSSelectedRowIds.containsKey(tableName)){
    			System.out.println("tablename: " + tableName);
//	          	selectedRowNumber.setText("selected row number: " + tableVSSelectedRowIds.get(tableName).size());
	          	String rowId = (String) model.getValueAt(j, 2);
	          	System.out.println("rowId: " + rowId);
				if(tableVSSelectedRowIds.get(tableName).contains(rowId)){
					System.out.println("contain: " + rowId);
					model.setRC(new Boolean(true), j, 0);
				}						
			}      	
        }
    	
    	for (int j = 0; j < numRows; j++) {
    		for(int i=0; i< numCols; i++){
    			model.setRC(tableModel.getValueAt(j, i), j, i+1);
    		}      	
        }
    	
//    	model.setC(numCols);
    	model.setR(numRows);	
        model.fireTableStructureChanged();
        updateTableNumberLabel();
    }
    
    public DataImporterInterface getTableInspector(){
    	return fatherPanel;
    }
}
 
