package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.HashMap;
import java.util.Map;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTable;

import org.processmining.ocbc.loggeneration.generator.plugin.XOCLogGeneratorPlugin;
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class DataImporterInterface extends JPanel {
    public static void main(String[] args) throws Exception {
    	
    	DataImporterInterface databaseInspector = new DataImporterInterface(null);
        JFrame frame = new JFrame();
        frame.add(databaseInspector);
        frame.setSize(Toolkit.getDefaultToolkit().getScreenSize());
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);
    }
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private CSVPanel csvPanel;
    private SelectingConfigurationPanel selectingConfigurationPanel;
    private ContentPanel contentPanel;
    private DatabasePanel databasePanel;
    private XOCLogGeneratorPlugin logGenerator;
    private Map<String, JTable> nameVSJtable = new HashMap<String, JTable>();
    
    public DataImporterInterface(XOCLogGeneratorPlugin logGenerator) throws Exception {
    	this.logGenerator = logGenerator;
//    	int gridSize = 2; // try 4 or 5, etc. buttons are always 50x50
//        setLayout(new GridLayout(gridSize, gridSize));
    	this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.setSize(1000, 800);
        this.setMaximumSize(new Dimension(1000,8000));
        csvPanel = new CSVPanel(this, 1300, 800);
        selectingConfigurationPanel = new SelectingConfigurationPanel(this, 500, 800);
        contentPanel = new ContentPanel(this);
        databasePanel = new DatabasePanel(this);

        JSplitPane topPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        topPanel.setLeftComponent(csvPanel);
        topPanel.setRightComponent(selectingConfigurationPanel);
        topPanel.setResizeWeight(0.5);   
        
        JSplitPane bottomPanel = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        bottomPanel.setLeftComponent(databasePanel);
        bottomPanel.setRightComponent(contentPanel);
        bottomPanel.setResizeWeight(0.5); 
        
//        JSplitPane leftPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
//        leftPanel.setTopComponent(csvPanel);
//        leftPanel.setBottomComponent(databasePanel);
//        leftPanel.setResizeWeight(0.5);   
//        
//        JSplitPane rightPanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
//        rightPanel.setTopComponent(selectingConfigurationPanel);
//        rightPanel.setBottomComponent(contentPanel);
//        rightPanel.setResizeWeight(0.5);   
        
//        this.add(leftPanel);
//        this.add(rightPanel);
        this.add(topPanel);
        this.add(bottomPanel);
    }
    
    public XOCLogGeneratorPlugin getLogGenerator(){
		return logGenerator;
    }
    
    public CSVPanel getCSVPanel(){
		return csvPanel;
    }
    
    public ContentPanel getContentPanel(){
		return contentPanel;
    }
    
    public DatabasePanel getDatabasePanel(){
		return databasePanel;
    }
    
    public Map<String, JTable> getNameVSJtableMap(){
    	return nameVSJtable;
    }  
}