package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.processmining.ocbc.logconversion.configurations.ConfigurationConstants;

 
/**
 * @version 1.0
 * @author liangdong
 *
 */
 
public class DatabaseConnectionPanel extends JPanel {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    
    private JComboBox<String> driverBox = new JComboBox<String>();
    private String schemaName = ""; //record the selected schema name, such as "onlineshopping"
    private JLabel hostNameLabel = new JLabel("hostname:");
    private JLabel portLabel = new JLabel("port:");
    private JLabel userNameLabel = new JLabel("user:");
    private JLabel passwordLabel = new JLabel("password:");
    private JTextField hostNameField = new JTextField();
    private JTextField portField = new JTextField();
    private JTextField userNameField = new JTextField();
    private JTextField passwordField = new JTextField();
    private JButton connectButton = new JButton("connect");
    private Connection conn = null;
    private Map<String, String> parameterNameVSValue = new HashMap<String, String>();
    private DatabasePanel fatherPanel;
    
    public static void main(String[] args) {
 
    }
 
    public DatabaseConnectionPanel(final DatabasePanel fatherPanel) {
    	this.fatherPanel = fatherPanel;
    	driverBox.addItem("jdbc:mysql");
    	driverBox.setEditable(true);
    	
        connectButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
            	try {
            		String driver = driverBox.getSelectedItem().toString();
            		String hostName = hostNameField.getText();
            		String port = portField.getText();
            		String userName = userNameField.getText();
            		String password = passwordField.getText();
            		parameterNameVSValue.put(ConfigurationConstants.driver, driver);
            		parameterNameVSValue.put(ConfigurationConstants.host, hostName);
            		parameterNameVSValue.put(ConfigurationConstants.port, port);
            		parameterNameVSValue.put(ConfigurationConstants.userName, userName);
            		parameterNameVSValue.put(ConfigurationConstants.password, password);
            		Map<String, Map<String, String>> parameterMap = fatherPanel.getTablePanel().getLogGenerator().
            				getConfigurationParameters().getNameVSMapParameterMap();
            		parameterMap.put(ConfigurationConstants.connectionParameterNameVSValueMap, parameterNameVSValue);
            		
					connect(driver, hostName, port, userName, password);
                    Statement stmt = conn.createStatement();
                    String sql = "show databases;";
                    ResultSet rs = stmt.executeQuery(sql);
                    JComboBox<String> box = fatherPanel.getDatabaseTablePanel().getSchemaBox();
                    box.removeAllItems();
                    while (rs.next()) {
                        box.addItem(rs.getString(1));                       
                    }
                    if(parameterNameVSValue.get(ConfigurationConstants.schema) != null){                   	
                    	String schemaName = parameterNameVSValue.get(ConfigurationConstants.schema);
                    	System.out.println("not empty! schemaName: " + schemaName);
                    	for(int i=0; i<box.getItemCount(); i++){
                    		if(box.getItemAt(i).equals(schemaName)){
                    			box.setSelectedItem(schemaName);   
                    		}
                    	}       	   
                    }
                    //for convenience, set the default box just have one value: "onlineshopping"
//                    box.setSelectedItem("onlineshopping");                 
                    rs.close();
                    stmt.close();
                } catch (Throwable e) {
                    e.printStackTrace();
                    JOptionPane.showMessageDialog(null, "Failed to connect to the server!");
                }
            }
        });

        hostNameField.setPreferredSize(new Dimension(70,30));
        portField.setPreferredSize(new Dimension(70,30));
        userNameField.setPreferredSize(new Dimension(70,30));
        passwordField.setPreferredSize(new Dimension(70,30));
        add(driverBox);
        add(hostNameLabel);
        add(hostNameField);
        add(portLabel);
        add(portField);
        add(userNameLabel);
        add(userNameField);
        add(passwordLabel);
        add(passwordField);
        add(connectButton);
        

//        if(parameterNameVSValue.get(ConfigurationConstants.host) != null){
//        	hostNameField.setText(parameterNameVSValue.get(ConfigurationConstants.host));
//        }
        
    }
 
    public void updateConnectionParameterFields(){
    	if(parameterNameVSValue != null){
    		if(parameterNameVSValue.get(ConfigurationConstants.host) != null){
            	hostNameField.setText(parameterNameVSValue.get(ConfigurationConstants.host));
            }
            if(parameterNameVSValue.get(ConfigurationConstants.port) != null){
            	portField.setText(parameterNameVSValue.get(ConfigurationConstants.port));
            }
            if(parameterNameVSValue.get(ConfigurationConstants.userName) != null){
            	userNameField.setText(parameterNameVSValue.get(ConfigurationConstants.userName));
            }
            if(parameterNameVSValue.get(ConfigurationConstants.password) != null){
            	passwordField.setText(parameterNameVSValue.get(ConfigurationConstants.password));
            }
    	}       
    }
    
	public Connection connect(String driver, String host, String port, String userName, String password) throws Exception{
//		 String url = "jdbc:mysql://localhost:3306?"
//		            + "user=root&password=kfgz0874981211&useUnicode=true&characterEncoding=UTF8";
		 String url = driver + "://" + host + ":" + port
		            + "?user=" + userName + "&password=" + password + "&useUnicode=true&characterEncoding=UTF8";
	 
      try {
           new com.mysql.jdbc.Driver();
         
          // 一个Connection代表一个数据库连接
          conn = DriverManager.getConnection(url);
          System.out.println("成功加载MySQL驱动程序");
         
          // Statement里面带有很多方法，比如executeUpdate可以实现插入，更新和删除等
      } catch (SQLException e) {
          System.out.println("MySQL操作错误");
          e.printStackTrace();
      } catch (Exception e) {
          e.printStackTrace();
      } 	           
      return conn;
	}
	
    public String getSchemaName() {
        return schemaName;
    }
 
    public void setSchemaName(String schemaName) {
        this.schemaName = schemaName;
    }
 
    public Connection getConnection() {
        return conn;
    }
     
    public Map<String, String> getConnectionParameterNameVSValueMap() {
    	JComboBox<String> box = fatherPanel.getDatabaseTablePanel().getSchemaBox();
    	if(box.getSelectedItem() != null){
    		 parameterNameVSValue.put(ConfigurationConstants.schema, (String) box.getSelectedItem());
    	}       
        return parameterNameVSValue;
    }
    
    public void setConnectionParameterNameVSValueMap(Map<String, String> connectionParameterNameVSValueMap) {
        this.parameterNameVSValue = connectionParameterNameVSValueMap;;
        updateConnectionParameterFields();
    }
    
}