package org.processmining.ocbc.loggeneration.panel.importer;
 
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.common.frame.ComboBoxRenderer;
import org.processmining.common.table.MyTableModel;
 
/**
 * @version 1.0
 * @author liangdong
 *
 */
public class DatabaseTablePanel extends JPanel implements ListSelectionListener{
 
    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    private String tablename = "";
    
    private Map<String, JTable> nameVSJtable;
    private File lastFile;
    
    private List<String> tableList;
    private JList<String> sourceList;
    private DefaultListModel<String> sourceListModel;
    private DefaultListModel<String> targetListModel;
    private JList<String> targetList;
    private JLabel sourceLabel;
    private JLabel targetLabel;
 
    private DatabasePanel fatherPanel;
    
    private List<String> selectedTableList = new ArrayList<String>();
//	int screenHeight = (int) Toolkit.getDefaultToolkit().getScreenSize().getHeight();
//	int screenWidth = (int) Toolkit.getDefaultToolkit().getScreenSize().getWidth();
	
	int screenWidth = 1200;
	int screenHeight = 800;
	private Connection conn;
	private JComboBox<String> schemaBox = new JComboBox<String>();
	private String schemaName = ""; //record the selected schema name, such as "onlineshopping"
	 
    public DatabaseTablePanel(DatabasePanel fatherPanel) {
    	this.fatherPanel = fatherPanel;
    	if(fatherPanel == null){
    		System.out.println("fatherPanel is empty");
    	}
    	if(fatherPanel.getTablePanel() == null){
    		System.out.println("fatherPanel.getTablePanel() is empty");
    	}
    	if(fatherPanel.getTablePanel().getNameVSJtableMap() == null){
    		System.out.println("fatherPanel.getTablePanel().getNameVSJtableMap() is empty");
    	}
    	
    	this.nameVSJtable = fatherPanel.getTablePanel().getNameVSJtableMap();
    	tableList = new ArrayList<String>();
    	JPanel generatedPanel = generateTableSelectionPanel();
    	add(generatedPanel);
    	
    }

 
    public String getTablename() {
        return tablename;
    }
 
    public void setTablename(String tablename) {
        this.tablename = tablename;
    }
 
    public JList<String> getSourceJList() {
        return sourceList;
    }
    
    public JList<String> getTargetJList() {
        return targetList;
    }
    
  //used to configure tables by file
    public void setSelectedtTableList(List<String> selectedTableList) {
        this.selectedTableList = selectedTableList;
    }
    
    public List<String> getTableList() {
        return tableList;
    }
 
    public void setTableList(List<String> tableList) {
        this.tableList = tableList;
    }
 
    public void polulateNonSelectedList(List<String> list){
		if(list != null){
			sourceListModel.removeAllElements();
			for(String tableName : list){
				sourceListModel.addElement(tableName);
			}
		}
		sourceList.setModel(sourceListModel);
    }
    
    public JPanel generateTableSelectionPanel(){	
    	JPanel middlePanel = new JPanel();
	    sourceLabel = new JLabel("non-selected tables");
		sourceLabel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceLabel.setBorder(BorderFactory.createEmptyBorder(4, 5, 0, 5));
		//build source list
		sourceListModel = new DefaultListModel<String>();
		if(tableList != null){
			for(String tableName : tableList){
				sourceListModel.addElement(tableName);
			}
		}	
		sourceList = new JList<String>(sourceListModel);	
		sourceList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		sourceList.setVisibleRowCount(5);
		//build source list panel
		JScrollPane sourceListScroller = new JScrollPane(sourceList);
		sourceListScroller.setPreferredSize(new Dimension(screenWidth/6, screenHeight/3));
		sourceListScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		sourceListScroller.setAlignmentY(Component.TOP_ALIGNMENT);
		JPanel sourceListPanel = new JPanel();
		sourceListPanel.setLayout(new BoxLayout(sourceListPanel,BoxLayout.Y_AXIS));
		sourceListPanel.add(sourceLabel);
		sourceListPanel.add(sourceListScroller);
		sourceListPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		sourceListPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 30));
		middlePanel.add(sourceListPanel);
				
		//build operating button panel
		JPanel buttonPanel = new JPanel();
		JButton toTargetButton = new JButton("    >    ");	
		JButton toSourceButton = new JButton("    <    ");		
		JButton allToTargetButton = new JButton("   >>   ");		
		JButton allToSourceButton = new JButton("   <<   ");
		JButton removeFileButton = new JButton("remove");
		JButton selectFileButton = new JButton("view");				
		JButton loadFileButton = new JButton("load");

		schemaBox.setPrototypeDisplayValue("text");
		schemaBox.setRenderer(new ComboBoxRenderer(schemaBox));
		schemaBox.setToolTipText("select a schema");
		selectFileButton.setToolTipText("view the selected schema");
		loadFileButton.setToolTipText("load the selected tables into `Configure` interface for log generation");
		
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));
//		buttonPanel.add(new Label("schema:"));	
//		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(schemaBox);	
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(selectFileButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 30)));
		buttonPanel.add(toTargetButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(toSourceButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(allToTargetButton);
		buttonPanel.add(Box.createRigidArea(new Dimension(15, 15)));
		buttonPanel.add(allToSourceButton);		
//		buttonPanel.add(Box.createRigidArea(new Dimension(15, 30)));
//		buttonPanel.add(loadFileButton);	
		
		buttonPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		buttonPanel.setBorder(BorderFactory.createEmptyBorder(15, 5, 15, 5));
		middlePanel.add(buttonPanel);
		
		targetLabel = new JLabel("selected tables");
		targetLabel.setAlignmentY(Component.TOP_ALIGNMENT);
		targetLabel.setBorder(BorderFactory.createEmptyBorder(4, 5, 0, 5));
		//build target list
		targetListModel = new DefaultListModel<String>();
		targetList = new JList<String>(targetListModel);
		targetList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		targetList.setVisibleRowCount(5);
		//build target list panel
		JScrollPane targetListScroller = new JScrollPane(targetList);
		targetListScroller.setPreferredSize(new Dimension(screenWidth/6, screenHeight/3));
		targetListScroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		targetListScroller.setAlignmentY(Component.TOP_ALIGNMENT);
		JPanel targetListPanel = new JPanel();
		targetListPanel.setLayout(new BoxLayout(targetListPanel,BoxLayout.Y_AXIS));
		targetListPanel.add(targetLabel);
		targetListPanel.add(targetListScroller);
		targetListPanel.setAlignmentY(Component.TOP_ALIGNMENT);
		targetListPanel.setBorder(BorderFactory.createEmptyBorder(0, 30, 0, 0));
		middlePanel.add(targetListPanel);
		
		schemaBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
                String name = (String) schemaBox.getSelectedItem();
                conn = fatherPanel.getDatabaseConnectionPanel().getConnection();
                setSchemaName(name);
                
                try {
                    Statement stmt = conn.createStatement();
                    System.out.println("use " + "`" + name + "`");
                    stmt.execute("use " + "`" + name + "`");
                    stmt.close();
                } catch (Exception e) {
                    e.printStackTrace();
                }
 
            }
        });
		
		selectFileButton.addActionListener(new ActionListener() {      	 
            public void actionPerformed(ActionEvent arg0) { 
            	System.out.println("import tables");
            	conn = fatherPanel.getDatabaseConnectionPanel().getConnection();
            	if(conn != null){
                    try {
                        Statement stmt = conn.createStatement();
                        String sql = "show tables;";
                        ResultSet rs = stmt.executeQuery(sql);
                        tableList.clear();
                        while (rs.next()) {
                            tableList.add(rs.getString(1));
                        }
                        rs.close();
                        stmt.close();
                    } catch (Throwable e) {
                        e.printStackTrace();
                    }
                    

        			sourceListModel.removeAllElements();
        			for(String tableName : tableList){
        				sourceListModel.addElement(tableName);
        			}

            		
                    targetListModel.removeAllElements();				
    				targetList.setModel(targetListModel);
                    sourceLabel.setText("non-selected tables: " + tableList.size());
                    targetLabel.setText("selected tables: 0");
                    
                    //use the configuration file to configure tables (record the selected tables)
                    for(String selectedTable : selectedTableList){            	
                    	if(tableList.contains(selectedTable)){
                    		targetListModel.addElement(selectedTable);
                        	sourceListModel.removeElement(selectedTable);
                        	
                        	//create the jtable for the imported table
                        	transformDatabaseTableToJTable(selectedTable);
                    	}              		
        			}

                	sourceList.setModel(sourceListModel);
    				targetList.setModel(targetListModel);
                    sourceLabel.setText("non-selected tables: " + (tableList.size()-selectedTableList.size()));
                    targetLabel.setText("selected tables: " + selectedTableList.size());
                    
                    //update the selected table list in data model interface
                    updateSelectedTableListInDataModelUI();
            	}
            	else{
            		JOptionPane.showMessageDialog(null, "Wrong, no connection!");
            	}
            }
        });
		
//		loadFileButton.addActionListener(new ActionListener() {
//			@Override
//			public void actionPerformed(ActionEvent arg0) {	
//				List<String> itemList = new ArrayList<String>();
//			   	for(int i=0; i<targetListModel.getSize(); i++){
//					String element = targetListModel.getElementAt(i);
//					itemList.add(element);			
//				}
//			   	fatherPanel.getTablePanel().getLogGenerator().getDataModelUI().getSelectedTablePanel().setList(itemList);
//			}			
//		});
		
		//add listeners for the operating buttons and list changes
		toTargetButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				int[] indexSet = sourceList.getSelectedIndices();
				List<String> selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(sourceList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					targetListModel.addElement(selectedItem);
					targetList.setModel(targetListModel);
					sourceListModel.removeElement(selectedItem);
					sourceList.setModel(sourceListModel);
					transformDatabaseTableToJTable(selectedItem);
				}
				
				updateTableNumberLabel();
				updateSelectedTableListInDataModelUI();
			}
		});

		
		allToTargetButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				if(tableList != null){
					targetListModel.removeAllElements();
					for(String tableName : tableList){
						targetListModel.addElement(tableName);
						targetList.setModel(targetListModel);
						transformDatabaseTableToJTable(tableName);
					}
				}						
				sourceListModel.removeAllElements();				
				sourceList.setModel(sourceListModel);
				
				updateTableNumberLabel();
				updateSelectedTableListInDataModelUI();
			}
		});
		
		toSourceButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {				
				int[] indexSet = targetList.getSelectedIndices();
				List<String> selectedItemList = new ArrayList<String>();
				for(int i=0; i<indexSet.length; i++){
					int index = indexSet[i];
					if(index >= 0){
						selectedItemList.add(targetList.getModel().getElementAt(index));
					}
				}		
				//change the list by adding/removing object values instead of object indices;
				//otherwise, the index will shift when adding/removing items
				for(String selectedItem : selectedItemList){
					sourceListModel.addElement(selectedItem);
					sourceList.setModel(sourceListModel);
					targetListModel.removeElement(selectedItem);
					targetList.setModel(targetListModel);
				}
				updateTableNumberLabel();
				updateSelectedTableListInDataModelUI();
			}
		});
		
		allToSourceButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				if(tableList != null){
					sourceListModel.removeAllElements();
					for(String tableName : tableList){
						sourceListModel.addElement(tableName);
						sourceList.setModel(sourceListModel);
					}
				}
				
				
				targetListModel.removeAllElements();				
				targetList.setModel(targetListModel);
				
				updateTableNumberLabel();
				updateSelectedTableListInDataModelUI();
			}
		});

		
		sourceList.addListSelectionListener(this);
		targetList.addListSelectionListener(this);
		//add the click listener for the sourceList; when one item in the list is
		//click, we create one JTable object for the item
		MouseListener mouseListener = new MouseAdapter() {
		    public void mouseClicked(MouseEvent e) {		    	
		    	String selectedItem = sourceList.getSelectedValue();
		    	//update the contents of ContentPanel
				if(selectedItem != "" && selectedItem != null){
			  		System.out.println("not null, selectedItem name: " + selectedItem);
					if(!nameVSJtable.containsKey(selectedItem)){
				  		System.out.println("not contain key");
						transformDatabaseTableToJTable(selectedItem);
						
					}			
					System.out.println("nameVSJtable size: " + nameVSJtable.keySet().size());
					for(String name : nameVSJtable.keySet()){
						System.out.println("jtable name: " + name);
					}
					fatherPanel.getTablePanel().getContentPanel().updateTableContents(selectedItem, nameVSJtable.get(selectedItem));
				}	
		    }

		};
		sourceList.addMouseListener(mouseListener);
		
		return middlePanel;
    }
    
    public void updateSelectedTableListInDataModelUI(){
    	List<String> itemList = new ArrayList<String>();
	   	for(int i=0; i<targetListModel.getSize(); i++){
			String element = targetListModel.getElementAt(i);
			itemList.add(element);			
		}
	   	fatherPanel.getTablePanel().getLogGenerator().getDataModelUI().getSelectedTablePanel().setList(itemList);
    }
    
    public void updateTableNumberLabel(){
		sourceLabel.setText("non-selected items: " + sourceListModel.size());
        targetLabel.setText("selected items: " + targetListModel.size());
    }

    
    @Override
    //Called whenever the value of the selection changes.
	public void valueChanged(ListSelectionEvent e) {
    	System.out.println("value of the selection changes");
    	String selectedItem = null;
		// TODO Auto-generated method stub
		if(e.getSource().equals(sourceList)){
			if(sourceList.getSelectedValue() != null){
				selectedItem = sourceList.getSelectedValue();
				setTablename(sourceList.getSelectedValue());
				targetList.setSelectedIndices(new int[]{});
				

				//empty the list in the csv table panel
				fatherPanel.getTablePanel().getCSVPanel().getSourceJList().setSelectedIndices(new int[]{});
				fatherPanel.getTablePanel().getCSVPanel().getTargetJList().setSelectedIndices(new int[]{});
			}				
		}
		else if(e.getSource().equals(targetList)){
			if(targetList.getSelectedValue() != null){
				selectedItem = targetList.getSelectedValue();
				setTablename(targetList.getSelectedValue());
				sourceList.setSelectedIndices(new int[]{});
				
				//empty the list in the csv table panel
				fatherPanel.getTablePanel().getCSVPanel().getSourceJList().setSelectedIndices(new int[]{});
				fatherPanel.getTablePanel().getCSVPanel().getTargetJList().setSelectedIndices(new int[]{});
				
				//update the contents of ContentPanel
				if(selectedItem != "" && selectedItem != null){
			  		System.out.println("not null, selectedItem name: " + selectedItem);
					if(!nameVSJtable.containsKey(selectedItem)){
				  		System.out.println("not contain key");
						transformDatabaseTableToJTable(selectedItem);
						
					}			
					System.out.println("nameVSJtable size: " + nameVSJtable.keySet().size());
					for(String name : nameVSJtable.keySet()){
						System.out.println("jtable name: " + name);
					}
					fatherPanel.getTablePanel().getContentPanel().updateTableContents(selectedItem, nameVSJtable.get(selectedItem));
				}	
			}			
		}			
	
	}
	
    //get the selected item list (from the target list) of the List<String> format
    public List<String> getSelectedTables(){
    	List<String> selectedTableList = new ArrayList<String>();
    	int listSize = targetList.getModel().getSize();
    	for(int i =0; i<listSize; i++){
    		String selectedContent = targetList.getModel().getElementAt(i);
    		selectedTableList.add(selectedContent);
    	}   	
		return selectedTableList;
    }
    

    //get the selected item list (from the target list) of the JList<String> format
    public JList<String> getSelectedTableList(){   	
    	DefaultListModel<String> selectedTableListModel = new DefaultListModel<String>();
    	for(String tableName : getSelectedTables()){
    		selectedTableListModel.addElement(tableName);
    	}
    	JList<String> selectedTableList = new JList<String>(selectedTableListModel);
    	selectedTableList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		return selectedTableList;
    }

  //put a item list of the List<String> format to the source list
    public void addingIntoSourceList(List<String> itemList){       
        //use the configuration file to configure tables (record the selected tables)
        for(String tableName : itemList){
        	if(!sourceListModel.contains(tableName) && !targetListModel.contains(tableName)){
        		sourceListModel.addElement(tableName);
        	}     	
        	if(!tableList.contains(tableName) && !tableList.contains(tableName)){
        		tableList.add(tableName);
        	}          	
		}
    	sourceList.setModel(sourceListModel);
		targetList.setModel(targetListModel);
        sourceLabel.setText("non-selected tables: " + (tableList.size()-selectedTableList.size()));
        targetLabel.setText("selected tables: " + selectedTableList.size());
    }
    
    public void transformDatabaseTableToJTable(String tableName){   
  		System.out.println("enter transformDatabaseTableToJTable");
    	if(!nameVSJtable.containsKey(tableName)){
    		System.out.println("transformDatabaseTableToJTable");
    		MyTableModel model = new MyTableModel();
        	JTable table = new JTable(model);
            try {                    
                //set the field row
                List<String> columnNameList = new ArrayList<String>();
                Statement stmt = conn.createStatement();
                ResultSet rsColumn = stmt.executeQuery("desc " + tableName);
                System.out.println("create jtable: " + tableName);
                while (rsColumn.next()) {
                	columnNameList.add(rsColumn.getString(1));
                	System.out.println("rsColumn.getString(1): " + rsColumn.getString(1));
                }
                model.setFieldRow(columnNameList);
                System.out.println("columnNameList.size: " + columnNameList.size());
                //create the record rows
                String sql = "select * from " + tableName;
                ResultSet rs = stmt.executeQuery(sql);
                while (rs.next()) {
                	List<Object> valueList = new ArrayList<Object>();
                	for(int i=0; i<columnNameList.size(); i++){
                		valueList.add(rs.getString(i + 1));
                	}
                	model.addRecordRow(valueList);
                    
                } 
                model.fireTableStructureChanged();
                
            } catch (Exception e) { 
                e.printStackTrace(); 
            }            
            System.out.println("put into map, table name:" + tableName);
            nameVSJtable.put(tableName, table);
    	}      	
       
    }
    
    public Map<String, JTable> getNameVSJtableMap(){
    	return nameVSJtable;
    }  
    
    public JComboBox<String> getSchemaBox() {
        return schemaBox;
    }
    
    public String getSchemaName() {
        return schemaName;
    }
 
    public void setSchemaName(String schemaName) {
        this.schemaName = schemaName;
    }
}