package org.processmining.ocbc.loggeneration.postgresql.stackoverflow;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.loggeneration.postgresql.abstractlog.CreateLogFromChangeTables;
import org.processmining.ocbc.loggeneration.postgresql.outputlog.OutputXMLLog;



public class CloseQuestionLog {
	public static void main(String[] args) throws Exception {   	
		
	    //record the mapping from table name to class name; we create one class for each related table
	    Map<String, String> tableVSClass = new HashMap<String, String>();;

	    //for one table (name), record the tables (name) it relies on
	    Map<String, List<String>> tableVSDependentTables = new HashMap<String, List<String>>();    
	    
	    //record what the primary key of one table is called in its children table as foreign key
	    Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
	    
	    //record which classes one activity refers to
	    Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
	    
	  //record which table columns will be modified by one activity
	    Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
	    
		tableVSClass.put("questions", "question");
		tableVSClass.put("votes", "vote_c");
		
		tableVSDependentTables.put("votes", new ArrayList<String>());
		tableVSDependentTables.get("votes").add("questions");
		
		tableVSForeignKey.put("questions", new ArrayList<String>());
		tableVSForeignKey.get("questions").add("postid");
		
    	activityVSClasses.put("create question", new ArrayList<String>());
    	activityVSClasses.get("create question").add("question");
    	activityVSClasses.put("create vote_c", new ArrayList<String>());
    	activityVSClasses.get("create vote_c").add("vote_c");
    	activityVSClasses.put("close question", new ArrayList<String>());
    	activityVSClasses.get("close question").add("question");
    	
    	activityVSModifiedColumns.put("create question", new ArrayList<String>());
    	activityVSModifiedColumns.get("create question").add("questions-id");
    	activityVSModifiedColumns.put("close question", new ArrayList<String>());
    	activityVSModifiedColumns.get("close question").add("questions-closeddate");
    	activityVSModifiedColumns.put("create vote_c", new ArrayList<String>());
    	activityVSModifiedColumns.get("create vote_c").add("votes-id");
         
		CreateLogFromChangeTables database = new CreateLogFromChangeTables(tableVSClass, tableVSDependentTables, 
				tableVSForeignKey, activityVSClasses, activityVSModifiedColumns);
    	database.connect();   	
    	database.extractEventsFromChangeTable("ubuntu", "cdhdr", "cdpos");     	
        OutputXMLLog generateLog = new OutputXMLLog("E:\\outputStackoverflowLog.xoc");
        generateLog.createLog(database.getEventList(), xConstants.UPDATE);
        
    }
}