package org.processmining.ocbc.loggeneration.postgresql.stackoverflow;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.processmining.ocbc.log.model.impl.xConstants;
import org.processmining.ocbc.loggeneration.postgresql.abstractlog.CreateLogFromChangeTables;
import org.processmining.ocbc.loggeneration.postgresql.outputlog.OutputXMLLog;



public class EditAnswerLog {
	public static void main(String[] args) throws Exception {   	
		
	    //record the mapping from table name to class name; we create one class for each related table
	    Map<String, String> tableVSClass = new HashMap<String, String>();;

	    //for one table (name), record the tables (name) it relies on
	    Map<String, List<String>> tableVSDependentTables = new HashMap<String, List<String>>();    
	    
	    //record what the primary key of one table is called in its children table as foreign key, it may have different names in different tables
	    Map<String, List<String>> tableVSForeignKey = new HashMap<String, List<String>>();
	    
	    //record which classes one activity refers to
	    Map<String, List<String>> activityVSClasses = new HashMap<String, List<String>>();
	    
	  //record which table columns will be modified by one activity
	    Map<String, List<String>> activityVSModifiedColumns = new HashMap<String, List<String>>();
	    
		tableVSClass.put("questions", "question");
		tableVSClass.put("users", "user");
		tableVSClass.put("answers", "answer");

		
		tableVSDependentTables.put("questions", new ArrayList<String>());
		tableVSDependentTables.get("questions").add("users");		
		tableVSDependentTables.put("answers", new ArrayList<String>());
		tableVSDependentTables.get("answers").add("users");
		tableVSDependentTables.get("answers").add("questions");
		
		tableVSForeignKey.put("questions", new ArrayList<String>());
		tableVSForeignKey.get("questions").add("parentid");
		tableVSForeignKey.put("users", new ArrayList<String>());
		tableVSForeignKey.get("users").add("owneruserid");
		tableVSForeignKey.get("users").add("lasteditoruserid");
		
			
    	activityVSClasses.put("create question", new ArrayList<String>());
    	activityVSClasses.get("create question").add("question");
    	activityVSClasses.put("create answer", new ArrayList<String>());
    	activityVSClasses.get("create answer").add("answer");
    	activityVSClasses.put("edit answer", new ArrayList<String>());
    	activityVSClasses.get("edit answer").add("answer");
    	
    	activityVSModifiedColumns.put("create question", new ArrayList<String>());
    	activityVSModifiedColumns.get("create question").add("questions-id");
    	activityVSModifiedColumns.put("create answer", new ArrayList<String>());
    	activityVSModifiedColumns.get("create answer").add("answers-id");
    	activityVSModifiedColumns.put("edit answer", new ArrayList<String>());
    	activityVSModifiedColumns.get("edit answer").add("answers-lasteditdate");
        
    	List<Integer> idList = new ArrayList<Integer>();
    	idList.add(5);
    	idList.add(4);
    	idList.add(27);
    	idList.add(10);
    	idList.add(50);
    	idList.add(63);
    	idList.add(86);
    	idList.add(116);
    	idList.add(169);
    	idList.add(289);
    	idList.add(2194);
    	idList.add(99478);
    	idList.add(235);
    	idList.add(6369);
    	idList.add(1151);
    	idList.add(2950);
    	idList.add(2950);
 
   
    	
		CreateLogFromChangeTables database = new CreateLogFromChangeTables(tableVSClass, tableVSDependentTables, 
				tableVSForeignKey, activityVSClasses, activityVSModifiedColumns);
    	database.connect();  
    	database.extractInitialRootObjectsFromOneTable("ubuntu", "users", "id", "reputation", "user", idList);
    	database.extractEventsFromChangeTable("ubuntu", "cdhdr2", "cdpos2");     	
        OutputXMLLog generateLog = new OutputXMLLog("E:\\outputStackoverflowLog2.xoc");
        generateLog.createLog(database.getEventList(), xConstants.UPDATE);
        
    }
}