package org.processmining.ocbc.models;




public interface AOCEdge extends Edge{
	/**
	 * returns the activity of a AOC relation
	 * 
	 * @return
	 */
	public ActivityNode getActivityNode();
	
	/**
	 * returns the class of a AOC relation
	 * 
	 * @return
	 */
	public ClassNode getClassNode();
	
	
	/**
	 * returns the activity cardinality of a AOC relation
	 * 	 
	 * * @return
	 */
	public Cardinality getActivityAlwaysCardinality();
	
	/**
	 * returns the activity cardinality of a AOC relation
	 * 	 
	 * * @return
	 */
	public Cardinality getActivityEventuallyCardinality();
	
	/**
	 * returns the class cardinality of a AOC relation
	 * 
	 * @return
	 */
	public Cardinality getClassCardinality();
	
	/**
	 * sets the activity cardinality of a AOC relation
	 * 	 
	 * * @return
	 */
	public void setSourceAlwaysCardinality(Cardinality activityCardinality);
	
	/**
	 * sets the activity cardinality of a AOC relation
	 * 	 
	 * * @return
	 */
	public void setSourceEventuallyCardinality(Cardinality activityCardinality);
	
	/**
	 * sets the class cardinality of a AOC relation
	 * 
	 * @return
	 */
	public void setTargetCardinality(Cardinality classCardinality);
	
	public Object clone();
}