package org.processmining.ocbc.models.editor.interaction;

import java.awt.event.ActionEvent;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.CrelOCEdge;
import org.processmining.ocbc.models.CrelRTEdge;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.GraphPanel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;
import org.processmining.ocbc.models.visualization.cell.AOCEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ActivityCell;
import org.processmining.ocbc.models.visualization.cell.ActivityEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ClassCell;
import org.processmining.ocbc.models.visualization.cell.ClassEdgeCell;
import org.processmining.ocbc.models.visualization.cell.CrelEdgeCell;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;


public class EditorActionListenerDeleteElement implements EditorActionListener{
	OCBCModel model;
	GraphMouseListener graphMouseListener;
	GraphPanel graphPanel;
	InformationPanel informationPanel;
	
	public EditorActionListenerDeleteElement(OCBCModel model, GraphMouseListener graphMouseListener, 
			InformationPanel informationPanel, GraphPanel graphPanel){
		this.model = model;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.informationPanel = informationPanel;
	}
	
	public void actionPerformed(ActionEvent e) {
		MyOriginalCell cell= graphMouseListener.getSelectedCell();
		
		if(cell != null)
		{
			if(cell instanceof ClassCell) 
			{
				MyOriginalCell[] cells = new MyOriginalCell[1]; 
				cells[0] = cell;
				ClassCell classCell = (ClassCell) cell;
				model.getGraphCells().remove(cells[0]);
				model.getGraph().getGraphLayoutCache().remove(cells);
				ClassNode removeClassNode = null;
				for(ClassNode classNode : model.getAllClasses())
				{
					if(classNode.getID() == classCell.getID())
						removeClassNode = classNode;						
				}
				model.deleteClass(removeClassNode);
			}
			
			else if(cell instanceof ActivityCell) 
			{
				MyOriginalCell[] cells = new MyOriginalCell[1]; 
				cells[0] = cell;
				ActivityCell activityCell = (ActivityCell) cell;
				model.getGraphCells().remove(cells[0]);
				model.getGraph().getGraphLayoutCache().remove(cells);
				ActivityNode removeActivityNode = null;
				for(ActivityNode activityNode : model.getAllActivities())
				{
					if(activityNode.getID() == activityCell.getID())
						removeActivityNode = activityNode;						
				}		
				model.getAllActivities().remove(removeActivityNode);
			}
			
			else if(cell instanceof ClassEdgeCell) 
			{
				System.out.print("enter in cell instanceof ClassEdgeCell");
				MyOriginalCell[] cells = new MyOriginalCell[3]; 
				int i=0;
				ClassEdgeCell classEdgeCell = (ClassEdgeCell) cell;				
				for(MyOriginalCell searchCell : model.getGraphCells())
				{
					if(searchCell.getID() == classEdgeCell.getID())
					{
						cells[i] = searchCell;
						i++;						
					}						
				}				
				
				model.getGraphCells().remove(cells[0]);
				model.getGraphCells().remove(cells[1]);
				model.getGraphCells().remove(cells[2]);				
				model.getGraph().getGraphLayoutCache().remove(cells);
				
				
				ClassEdge removeClassEdge = null;
				for(ClassEdge classEdge: model.getAllClassRelations())
				{
					if(classEdge.getID() == classEdgeCell.getID())
						removeClassEdge = classEdge;						
				}
				model.getAllClassRelations().remove(removeClassEdge);				
			}
			
			else if(cell instanceof ActivityEdgeCell) 
			{
				System.out.print("enter in cell instanceof ActivityEdgeCell");
				MyOriginalCell[] cells = new MyOriginalCell[3]; 
				int i=0;
				ActivityEdgeCell activityEdgeCell = (ActivityEdgeCell) cell;				
				for(MyOriginalCell searchCell : model.getGraphCells())
				{
					if(searchCell.getID() == activityEdgeCell.getID())
					{
						cells[i] = searchCell;
						i++;						
					}						
				}				
				
				model.getGraphCells().remove(cells[0]);
				model.getGraphCells().remove(cells[1]);
				model.getGraphCells().remove(cells[2]);				
				model.getGraph().getGraphLayoutCache().remove(cells);
				
				
				ActivityEdge removeActivityEdge = null;
				for(ActivityEdge activityEdge: model.getAllActivityRelations())
				{
					if(activityEdge.getID() == activityEdgeCell.getID())
						removeActivityEdge = activityEdge;						
				}
				model.getAllActivityRelations().remove(removeActivityEdge);				
			}
			
			else if(cell instanceof AOCEdgeCell) 
			{
				System.out.print("enter in cell instanceof AOCEdgeCell");
				MyOriginalCell[] cells = new MyOriginalCell[3]; 
				int i=0;
				AOCEdgeCell aOCEdgeCell = (AOCEdgeCell) cell;				
				for(MyOriginalCell searchCell : model.getGraphCells())
				{
					if(searchCell.getID() == aOCEdgeCell.getID())
					{
						cells[i] = searchCell;
						i++;						
					}						
				}				
				
				model.getGraphCells().remove(cells[0]);
				model.getGraphCells().remove(cells[1]);
				model.getGraphCells().remove(cells[2]);				
				model.getGraph().getGraphLayoutCache().remove(cells);
				
				
				AOCEdge removeAOCEdge = null;
				for(AOCEdge aOCEdge: model.getAllAOCRelations())
				{
					if(aOCEdge.getID() == aOCEdgeCell.getID())
						removeAOCEdge = aOCEdge;						
				}
				model.getAllAOCRelations().remove(removeAOCEdge);				
			}
			
			else if(cell instanceof CrelEdgeCell) 
			{
				System.out.print("enter in cell instanceof CrelEdgeCell");
				MyOriginalCell[] cells = new MyOriginalCell[3]; 
				int i=0;
				CrelEdgeCell crelEdgeCell = (CrelEdgeCell) cell;				
				for(MyOriginalCell searchCell : model.getGraphCells())
				{
					if(searchCell.getID() == crelEdgeCell.getID())
					{
						cells[i] = searchCell;
						i++;						
					}						
				}				
				
				model.getGraphCells().remove(cells[0]);
				model.getGraphCells().remove(cells[1]);
				model.getGraphCells().remove(cells[2]);				
				model.getGraph().getGraphLayoutCache().remove(cells);
				
				if(crelEdgeCell.getOCRT().equals("OC"))
				{
					CrelOCEdge removeCrelOCEdge = null;
					for(CrelOCEdge crelOCEdge: model.getAllCrelOCRelations())
					{
						if(crelOCEdge.getID() == crelEdgeCell.getID())
							removeCrelOCEdge = crelOCEdge;						
					}
					model.getAllCrelOCRelations().remove(removeCrelOCEdge);	
				}
				else if(crelEdgeCell.getOCRT().equals("RT"));
				{
					CrelRTEdge removeCrelRTEdge = null;
					for(CrelRTEdge crelRTEdge: model.getAllCrelRTRelations())
					{
						if(crelRTEdge.getID() == crelEdgeCell.getID())
							removeCrelRTEdge = crelRTEdge;						
					}
					model.getAllCrelRTRelations().remove(removeCrelRTEdge);	
				}
			}
			graphMouseListener.setSelectedCell(null);
			graphMouseListener.getEditorPanel().mousePressed();
			
			informationPanel.updateInformation("succeed in deleting the node/edge");
			
			graphPanel.redraw();
		}	
	}

	public boolean isEnabled() {
		// TODO Auto-generated method stub
		return false;
	}

}
