package org.processmining.ocbc.models.editor.interaction;

import java.awt.event.ActionEvent;

import javax.swing.JSlider;
import javax.swing.JTextField;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.Cardinality;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.GraphPanel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;
import org.processmining.ocbc.models.visualization.cell.AOCEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ClassEdgeCell;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;


public class EditorActionListenerEditConstraint implements EditorActionListener{
	OCBCModel model;
	GraphMouseListener graphMouseListener;
	JTextField alwaysField;
	JTextField eventuallyField;
	JTextField classSideField;
	GraphPanel graphPanel;
	InformationPanel informationPanel;
	JSlider childIndex;
	
	public EditorActionListenerEditConstraint(OCBCModel model, GraphMouseListener graphMouseListener, JTextField alwaysField, 
			JTextField eventuallyField, JTextField classSideField, InformationPanel informationPanel, GraphPanel graphPanel, JSlider childIndex){
		this.model = model;
		this.alwaysField = alwaysField;
		this.eventuallyField = eventuallyField;
		this.classSideField = classSideField;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.childIndex = childIndex;
		this.informationPanel = informationPanel;
	}


	public void actionPerformed(ActionEvent e) {	
		
		MyOriginalCell cell= graphMouseListener.getSelectedCell();
		if(cell != null)
		{			
			System.out.print("cell != null ");
			
			if(cell instanceof ClassEdgeCell) 
			{
				ClassEdgeCell classEdgeCell = (ClassEdgeCell) cell;								
				String checkAlwaysResult = new Cardinality().checkCardinalityString(alwaysField.getText());
				String checkEventuallyResult = new Cardinality().checkCardinalityString(eventuallyField.getText());
				if(checkAlwaysResult.equals("true") && checkEventuallyResult.equals("true")){
					Cardinality alwaysCardinality = new Cardinality(alwaysField.getText());
					alwaysCardinality.setCardinalityTimeScope(2);
					Cardinality eventuallyCardinality = new Cardinality(eventuallyField.getText());	
					eventuallyCardinality.setCardinalityTimeScope(1);
					
					classEdgeCell.setCardinalityCharacters(alwaysCardinality.toString(), eventuallyCardinality.toString());						
					ClassEdge classEdge = (ClassEdge) classEdgeCell.getCorrespondingElement();
													    	
			    	if(classEdgeCell.getWhichEnd().equals("Source")){
			    		classEdge.setSourceAlwaysCardinality(alwaysCardinality);
			    		classEdge.setSourceEventuallyCardinality(eventuallyCardinality);
			    	}
			    		
			    	else{
			    		classEdge.setTargetAlwaysCardinality(alwaysCardinality);
			    		classEdge.setTargetEventuallyCardinality(eventuallyCardinality);
			    	}	
			    	informationPanel.updateInformation("succeed in modifying the constraint");
				}
				else
					informationPanel.updateInformation("Wrong! The always constraint or eventually constraint is not correct");	

			}
			
			else if(cell instanceof AOCEdgeCell){		
				AOCEdgeCell aOCEdgeCell = (AOCEdgeCell) cell;
				if(aOCEdgeCell.getWhichEnd().equals("Source")){
					
					String checkAlwaysResult = new Cardinality().checkCardinalityString(alwaysField.getText());
					String checkEventuallyResult = new Cardinality().checkCardinalityString(eventuallyField.getText());
					if(checkAlwaysResult.equals("true") && checkEventuallyResult.equals("true")){
						Cardinality alwaysCardinality = new Cardinality(alwaysField.getText());
						alwaysCardinality.setCardinalityTimeScope(2);
						Cardinality eventuallyCardinality = new Cardinality(eventuallyField.getText());	
						eventuallyCardinality.setCardinalityTimeScope(1);						
								
						aOCEdgeCell.setSourceCardinalityCharacters(alwaysCardinality.toString(), eventuallyCardinality.toString());						
						AOCEdge aOCEdge = (AOCEdge) aOCEdgeCell.getCorrespondingElement();
														    						    	
			    		aOCEdge.setSourceAlwaysCardinality(alwaysCardinality);
			    		aOCEdge.setSourceEventuallyCardinality(eventuallyCardinality);	
			    		
			    		informationPanel.updateInformation("succeed in modifying the constraint");   		
					}
					else
						informationPanel.updateInformation("Wrong! The always constraint or eventually constraint is not correct");	
										
				}		
				else if (aOCEdgeCell.getWhichEnd().equals("Target")){
					
					String checkResult = new Cardinality().checkCardinalityString(classSideField.getText());
					if(checkResult.equals("true")){
						Cardinality cardinality = new Cardinality(classSideField.getText());
						cardinality.setCardinalityTimeScope(0);					
						
						aOCEdgeCell.setTargetCardinalityCharacters(cardinality.toString());						
						AOCEdge aOCEdge = (AOCEdge) aOCEdgeCell.getCorrespondingElement();
														    						    	
			    		aOCEdge.setTargetCardinality(cardinality);	
			    		informationPanel.updateInformation("succeed in modifying the constraint");   		
					}
					else
						informationPanel.updateInformation("The format of the constraint string is wrong");					
				}
				else 
					System.out.print("\n Wrong! the end type is not Source or Target");
			}						
		}		
		
		
		graphPanel.redraw();
	}
	
	public boolean isEnabled(){
		MyOriginalCell cell = graphMouseListener.getSelectedCell();
		if(cell != null)
			return true;
		else
			return false;
	}
}
