package org.processmining.ocbc.models.editor.interaction;

import java.awt.event.ActionEvent;

import javax.swing.JSlider;
import javax.swing.JTextField;

import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.GraphPanel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;
import org.processmining.ocbc.models.visualization.cell.ActivityCell;
import org.processmining.ocbc.models.visualization.cell.ClassCell;
import org.processmining.ocbc.models.visualization.cell.LabelCell;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;


public class EditorActionListenerEditName implements EditorActionListener{
	OCBCModel model;
	GraphMouseListener graphMouseListener;
	JTextField text;
	GraphPanel graphPanel;
	InformationPanel informationPanel;
	JSlider childIndex;
	
	public EditorActionListenerEditName(OCBCModel model, GraphMouseListener graphMouseListener, JTextField text, 
			InformationPanel informationPanel, GraphPanel graphPanel, JSlider childIndex){
		this.model = model;
		this.text = text;
		this.graphMouseListener = graphMouseListener;
		this.graphPanel = graphPanel;
		this.childIndex = childIndex;
		this.informationPanel = informationPanel;
	}


	public void actionPerformed(ActionEvent e) {	
		
		MyOriginalCell cell= graphMouseListener.getSelectedCell();
		if(cell != null)
		{			
			System.out.print("cell != null ");
			if(cell instanceof ClassCell) 
			{
				System.out.print("change class node name ");
				ClassCell classCell = (ClassCell) cell;
				for(ClassNode classNode : model.getAllClasses())
				{
					if(classNode.getID() == classCell.getID())
						classNode.setNodeName(text.getText());
				}
				cell.setUserObject(text.getText());
				informationPanel.updateInformation("succeed in modifying the name");
			}
			
			else if(cell instanceof ActivityCell) 
			{
				ActivityCell activityCell = (ActivityCell) cell;
				for(ActivityNode activityNode : model.getAllActivities())
				{
					if(activityNode.getID() == activityCell.getID())
						activityNode.setNodeName(text.getText());
				}	
				cell.setUserObject(text.getText());
				informationPanel.updateInformation("succeed in modifying the name");
			}
			
			else if(cell instanceof LabelCell) 
			{
				System.out.print("change edge name ");
				LabelCell labelCell = (LabelCell) cell;
				for(ClassEdge classEdge : model.getAllClassRelations())
				{
					if(classEdge.getID() == labelCell.getID()){
						classEdge.setEdgeName(text.getText());
					}
				}	
				cell.setUserObject(text.getText());
				informationPanel.updateInformation("succeed in modifying the edge name");

			}
					
		}		
		
//		informationPanel.updateInformation("succeed in modifying the name or constraint");
		graphPanel.redraw();
	}
	
	public boolean isEnabled(){
		MyOriginalCell cell = graphMouseListener.getSelectedCell();
		if(cell != null)
			return true;
		else
			return false;
	}
}
