package org.processmining.ocbc.models.editor.interaction;

import java.awt.event.ActionEvent;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JTextField;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.mxgraph.examples.swing.editor.Component2Classes;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.panels.InformationPanel;




public class EditorActionListenerSave implements EditorActionListener{
	PluginContext context;
	OCBCModel model;
	JTextField field;
	InformationPanel informationPanel;
	
	public EditorActionListenerSave(PluginContext context, OCBCModel model, JTextField field, InformationPanel informationPanel){
		this.context = context;		
		this.field = field;
		this.model = model;
		this.informationPanel = informationPanel;
	}
	
	public void addInformationPanel(InformationPanel informationPanel){
		this.informationPanel = informationPanel;
	}
	
	public void actionPerformed(ActionEvent e) {
		//if the model is correct
		if(checkOCBCModel().equals("correct")){
//			context.getProvidedObjectManager().createProvidedObject(field.getText(),
//	        		model, OCBCModel.class, context);
//	        if (context instanceof UIPluginContext) {
//	               UIPluginContext uiPluginContext = (UIPluginContext) context;
//	               uiPluginContext.getGlobalContext().getResourceManager().getResourceForInstance(model)
//	                             .setFavorite(true);
//	        }	
			
			Component2Classes c2c = new Component2Classes();
			Set<String> set = new HashSet<String>();
			set.add("lelemtn");
			c2c.add("a", set);
			context.getProvidedObjectManager().createProvidedObject(field.getText(),
					c2c, Component2Classes.class, context);
	        if (context instanceof UIPluginContext) {
	               UIPluginContext uiPluginContext = (UIPluginContext) context;
	               uiPluginContext.getGlobalContext().getResourceManager().getResourceForInstance(c2c)
	                             .setFavorite(true);
	        }	
	        
	        informationPanel.updateInformation("finish saving the model to workspace");
		}
		else
			informationPanel.updateInformation(checkOCBCModel());		
	}
	
	public String checkOCBCModel(){
		String checkResult = "";
		//each behavior edge has corresponding "crel" edges
		for(ActivityEdge activityEdge : model.getAllActivityRelations()){
			if(activityEdge.getRelatedCrelOCRelations().size() + activityEdge.getRelatedCrelRTRelations().size() == 0){
				checkResult = checkResult + "\n the activity edge " + activityEdge.getReferenceNode().getCorrespondingCell().getUserObject()
						+ "-" + activityEdge.getTargetNode().getCorrespondingCell().getUserObject() + " has no corresponding crel edges;";
			}
		}
		if(checkResult.equals("")){
			checkResult = "correct";
		}
		else
			checkResult = "Error:" + checkResult;
		return checkResult;
	}
}
