package org.processmining.ocbc.models.impl;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.Cardinality;
import org.processmining.ocbc.models.ClassNode;

public class AOCEdgeImpl extends EdgeImpl implements AOCEdge{

	/**
	 * 
	 */
	private static final long serialVersionUID = 192179246641664160L;
	/**
	 * 
	 */

	private ActivityNode activityNode;
	private ClassNode classNode;
	private Cardinality activityAlwaysCardinality;
	private Cardinality activityEventuallyCardinality;
	private Cardinality classCardinality;

	public AOCEdgeImpl(String name, ActivityNode activityNode, ClassNode classNode, Cardinality activityAlwaysCardinality,
			Cardinality activityEventuallyCardinality, Cardinality classCardinality){
		this.name = name;
		this.activityNode = activityNode;
		this.classNode = classNode;
		this.activityAlwaysCardinality = activityAlwaysCardinality;
		this.activityEventuallyCardinality = activityEventuallyCardinality;
		this.classCardinality = classCardinality;
	}
	
	public AOCEdgeImpl(ActivityNode activityNode, ClassNode classNode){
		this("AOCEdge", activityNode, classNode, new Cardinality("*"), new Cardinality("*"), new Cardinality("*"));
	}
	
	public Object clone() {
		AOCEdgeImpl clone;
		try {
			clone = (AOCEdgeImpl) super.clone();
		} catch (CloneNotSupportedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		
		clone.activityNode =  (ActivityNode) activityNode.clone();
		clone.classNode =  (ClassNode) classNode.clone();
		clone.activityAlwaysCardinality = (Cardinality) activityAlwaysCardinality.clone();
		clone.activityEventuallyCardinality = (Cardinality) activityEventuallyCardinality.clone();
		clone.classCardinality = (Cardinality) classCardinality.clone();
		
		return clone;
	}
	
	public ActivityNode getActivityNode() {
		return activityNode;
	}


	public ClassNode getClassNode() {
		return classNode;
	}


	public Cardinality getActivityAlwaysCardinality() {
		return activityAlwaysCardinality;
	}
	
	public Cardinality getActivityEventuallyCardinality() {
		return activityEventuallyCardinality;
	}


	public Cardinality getClassCardinality() {
		return classCardinality;
	}


	public void setSourceAlwaysCardinality(Cardinality activityAlwaysCardinality) {
		this.activityAlwaysCardinality = activityAlwaysCardinality;
	}

	public void setSourceEventuallyCardinality(Cardinality activityEventuallyCardinality) {
		this.activityEventuallyCardinality = activityEventuallyCardinality;
	}

	public void setTargetCardinality(Cardinality classCardinality) {
		this.classCardinality = classCardinality;
	}
	
}