package org.processmining.ocbc.models.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassNode;

public class ActivityNodeImpl extends NodeImpl implements ActivityNode {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4841762426986469551L;
	/**
	 * 
	 */

	private List<ClassNode> relatedClassNodes;
	private List<ActivityNode> relatedActivityNodes;
	private List<AOCEdge> relatedAOCEdges;
	private List<ActivityEdge> relatedActivityEdges;
	
	
		
	public ActivityNodeImpl(String name, List<ClassNode> relatedClassNodes, List<ActivityNode> relatedActivityNodes, List<AOCEdge> relatedAOCEdges, List<ActivityEdge> relatedActivityEdges){
		this.name = name;
		this.relatedClassNodes = relatedClassNodes;
		this.relatedActivityNodes = relatedActivityNodes;
		this.relatedAOCEdges = relatedAOCEdges;
		this.relatedActivityEdges = relatedActivityEdges;
	}
	
	public ActivityNodeImpl(String name){
		this(name, new ArrayList<ClassNode>(), new ArrayList<ActivityNode>(), new ArrayList<AOCEdge>(), new ArrayList<ActivityEdge>());		
	}

	public Object clone() {
		ActivityNodeImpl clone;
		try {
			clone = (ActivityNodeImpl) super.clone();
		} catch (CloneNotSupportedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		
//		List<ClassNode> relatedClassNodesClone = new ArrayList<ClassNode>();
//		List<ActivityNode> relatedActivityNodesClone = new ArrayList<ActivityNode>();
//		List<ActivityEdge> relatedActivityEdgesClone = new ArrayList<ActivityEdge>();
//		List<AOCEdge> relatedAOCEdgesClone = new ArrayList<AOCEdge>();
//		
//		
//		for(ClassNode classNode : relatedClassNodes){
//			relatedClassNodesClone.add((ClassNode) classNode.clone());			
//		}
//		for(ActivityNode activityNode : relatedActivityNodes){
//			relatedActivityNodesClone.add((ActivityNode) activityNode.clone());			
//		}
//		for(ActivityEdge activityEdge : relatedActivityEdges){
//			relatedActivityEdgesClone.add((ActivityEdge) activityEdge.clone());			
//		}
//		for(AOCEdge aOCEdge : relatedAOCEdges){
//			relatedAOCEdgesClone.add((AOCEdge) aOCEdge.clone());			
//		}
//
//		clone.setRelatedClassNodes(relatedClassNodesClone);
//		clone.setRelatedActivityNodes(relatedActivityNodesClone);
//		clone.setRelatedActivityEdges(relatedActivityEdgesClone);
//		clone.setRelatedAOCEdges(relatedAOCEdgesClone);
		
		return clone;
	}
	
	public List<ClassNode> getRelatedClassNodes() {
		return relatedClassNodes;
	}

//	public List<AOCEdge> getRelatedAOCEdges() {
//		return relatedAOCEdges;
//	}

	public List<ActivityNode> getRelatedActivityNodes() {
		return relatedActivityNodes;
	}

//	public List<ActivityEdge> getRelatedActivityEdges() {
//		return relatedActivityEdges;
//	}

	public void setRelatedClassNodes(List<ClassNode> relatedClassNodes) {
		this.relatedClassNodes = relatedClassNodes;
	}

	public void setRelatedActivityNodes(List<ActivityNode> relatedActivityNodes) {
		this.relatedActivityNodes = relatedActivityNodes;
	}

	public void setRelatedAOCEdges(List<AOCEdge> relatedAOCEdges) {
		this.relatedAOCEdges = relatedAOCEdges;
	}

	public void setRelatedActivityEdges(List<ActivityEdge> relatedActivityEdges) {
		this.relatedActivityEdges = relatedActivityEdges;
	}	

}