package org.processmining.ocbc.models.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.CrelOCEdge;

public class ClassNodeImpl extends NodeImpl implements ClassNode{



	/**
	 * 
	 */
	private static final long serialVersionUID = 3261128652001186579L;
	/**
	 * 
	 */

	/**
	 * 
	 */
	private List<ClassNode> relatedClassNodes;
	private List<ActivityNode> relatedActivityNodes;
	private List<ClassEdge> relatedClassEdges;
	private List<AOCEdge> relatedAOCEdges;
	private List<CrelOCEdge> relatedCrelOCEdges;
	
		
	public ClassNodeImpl(String name, List<ClassNode> relatedClassNodes, List<ActivityNode> relatedActivityNodes, List<ClassEdge> relatedClassEdges, List<AOCEdge> relatedAOCEdges, List<CrelOCEdge> relatedCrelOCEdges){
		this.name = name;
		this.relatedClassNodes = relatedClassNodes;
		this.relatedActivityNodes = relatedActivityNodes;
		this.relatedClassEdges = relatedClassEdges;

		this.relatedAOCEdges = relatedAOCEdges;
		this.relatedCrelOCEdges = relatedCrelOCEdges;
	}
	
	public ClassNodeImpl(String name){
		this(name, new ArrayList<ClassNode>(), new ArrayList<ActivityNode>(), new ArrayList<ClassEdge>(), new ArrayList<AOCEdge>(), new ArrayList<CrelOCEdge>());		
	}

	public Object clone() {
		ClassNodeImpl clone;
		try {
			clone = (ClassNodeImpl) super.clone();
		} catch (CloneNotSupportedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		
//		List<ClassNode> relatedClassNodesClone = new ArrayList<ClassNode>();
//		List<ActivityNode> relatedActivityNodesClone = new ArrayList<ActivityNode>();
//		List<ClassEdge> relatedClassEdgesClone = new ArrayList<ClassEdge>();
//		List<AOCEdge> relatedAOCEdgesClone = new ArrayList<AOCEdge>();
//		List<CrelOCEdge> relatedCrelOCEdgesClone = new ArrayList<CrelOCEdge>();
//		
//		for(ClassNode classNode : relatedClassNodes){
//			relatedClassNodesClone.add((ClassNode) classNode.clone());			
//		}
//		for(ActivityNode activityNode : relatedActivityNodes){
//			relatedActivityNodesClone.add((ActivityNode) activityNode.clone());			
//		}
//		for(ClassEdge classEdge : relatedClassEdges){
//			relatedClassEdgesClone.add((ClassEdge) classEdge.clone());			
//		}
//		for(AOCEdge aOCEdge : relatedAOCEdges){
//			relatedAOCEdgesClone.add((AOCEdge) aOCEdge.clone());			
//		}
//		for(CrelOCEdge crelOCEdge : relatedCrelOCEdges){
//			relatedCrelOCEdgesClone.add((CrelOCEdge) crelOCEdge.clone());			
//		}
//		clone.setRelatedClassNodes(relatedClassNodesClone);
//		clone.setRelatedActivityNodes(relatedActivityNodesClone);
//		clone.setRelatedClassEdges(relatedClassEdgesClone);
//		clone.setRelatedAOCEdges(relatedAOCEdgesClone);
//		clone.setRelatedCrelOCEdges(relatedCrelOCEdgesClone);
		
		return clone;
	}
	
	public ClassNodeImpl(){		
		this("className");
	}
	
	public List<ClassNode> getRelatedClassNodes() {
		return relatedClassNodes;
	}
//
//	public List<ClassEdge> getRelatedClassEdges() {
//		return relatedClassEdges;
//	}

	public List<ActivityNode> getRelatedActivityNodes() {
		return relatedActivityNodes;
	}

//	public List<AOCEdge> getRelatedAOCEdges() {
//		return relatedAOCEdges;
//	}
//
//	public List<CrelOCEdge> getRelatedCrelOCEdges() {
//		return relatedCrelOCEdges;
//	}
	
	public void setRelatedClassNodes(List<ClassNode> relatedClassNodes) {
		this.relatedClassNodes = relatedClassNodes;
	}

	public void setRelatedActivityNodes(List<ActivityNode> relatedActivityNodes) {
		this.relatedActivityNodes = relatedActivityNodes;
	}

	public void setRelatedClassEdges(List<ClassEdge> relatedClassEdges) {
		this.relatedClassEdges = relatedClassEdges;
	}

	public void setRelatedAOCEdges(List<AOCEdge> relatedAOCEdges) {
		this.relatedAOCEdges = relatedAOCEdges;
	}	
	
	public void setRelatedCrelOCEdges(List<CrelOCEdge> relatedCrelOCEdges) {
		this.relatedCrelOCEdges = relatedCrelOCEdges;
	}

}