package org.processmining.ocbc.models.impl;

import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.CrelOCEdge;

public class CrelOCEdgeImpl extends EdgeImpl implements CrelOCEdge{

	/**
	 * 
	 */
	private static final long serialVersionUID = -941566483900005851L;
	/**
	 * 
	 */

	private ClassNode relatedClass;
	private ActivityEdge relatedActivityRelation;
	private String relatedClassId;//record the unique id of the related class, and mainly used for clone method
	private String relatedActivityRelationId;

	public CrelOCEdgeImpl(String name, ActivityEdge relatedActivityRelation, ClassNode relatedClass){
		this.name = name;
		this.relatedClass = relatedClass;
		this.relatedActivityRelation = relatedActivityRelation;
		this.relatedClassId = relatedClass.getID().toString();
		this.relatedActivityRelationId = relatedActivityRelation.getID().toString();
	}
	
//	public CrelRTEdgeImpl(String name){
//		this(name, new ClassEdgeImpl(), new ActivityEdgeImpl());
//	}
	
	public Object clone() {
		CrelOCEdgeImpl clone;
		try {
			clone = (CrelOCEdgeImpl) super.clone();
		} catch (CloneNotSupportedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		
		clone.relatedClass = (ClassNode) relatedClass.clone();
		clone.relatedActivityRelation =  (ActivityEdge) relatedActivityRelation.clone();

		return clone;
	}
	
	public ActivityEdge getRelatedActivityRelation() {
		return relatedActivityRelation;
	}

	public ClassNode getRelatedClass() {
		return relatedClass;
	}
	
	public String getRelatedActivityRelationId() {
		return relatedActivityRelationId;
	}

	public String getRelatedClasId() {
		return relatedClassId;
	}
	
}