package org.processmining.ocbc.models.impl;

import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.CrelRTEdge;

public class CrelRTEdgeImpl extends EdgeImpl implements CrelRTEdge{

	/**
	 * 
	 */
	private static final long serialVersionUID = -7665570107898404986L;
	private ClassEdge relatedClassRelation;
	private ActivityEdge relatedActivityRelation;

	public CrelRTEdgeImpl(String name, ActivityEdge relatedActivityRelation, ClassEdge relatedClassRelation){
		this.name = name;
		this.relatedClassRelation = relatedClassRelation;
		this.relatedActivityRelation = relatedActivityRelation;
	}
	
//	public CrelRTEdgeImpl(String name){
//		this(name, new ClassEdgeImpl(), new ActivityEdgeImpl());
//	}
	
	public Object clone() {
		CrelRTEdgeImpl clone;
		try {
			clone = (CrelRTEdgeImpl) super.clone();
		} catch (CloneNotSupportedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
		
		clone.relatedClassRelation = (ClassEdge) relatedClassRelation.clone();
		clone.relatedActivityRelation =  (ActivityEdge) relatedActivityRelation.clone();

		return clone;
	}
	
	public ActivityEdge getRelatedActivityRelation() {
		return relatedActivityRelation;
	}

	public ClassEdge getRelatedClassRelation() {
		return relatedClassRelation;
	}
	
}