package org.processmining.ocbc.models.impl;

import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;

import org.jgraph.graph.CellViewRenderer;
import org.jgraph.graph.DefaultCellViewFactory;
import org.jgraph.graph.EdgeView;
import org.jgraph.graph.VertexRenderer;
import org.jgraph.graph.VertexView;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;
  
  
  
//Define EllipseCell  
public class EllipseCell extends MyOriginalCell {  
  /**
	 * 
	 */
	private static final long serialVersionUID = 3408129944662490195L;
	// Empty Constructor  
    public EllipseCell() {  
      this(null);  
    }  
  // Construct Cell for Userobject  
    public EllipseCell(Object userObject) {  
    super(userObject);  
     }  
}  
  
//Define the View for an EllipseCell  
class EllipseView extends VertexView {  
   
   /**
	 * 
	 */
	private static final long serialVersionUID = -6101969803274562556L;
static EllipseRenderer renderer = new EllipseRenderer();  
 // Constructor for Superclass  
   public EllipseView(Object cell) {  
   super(cell);  
 }  
 // Returns Perimeter Point for Ellipses  
   public Point2D getPerimeterPoint(EdgeView edge, Point2D source, Point2D p) {  
        if (getRenderer() instanceof EllipseRenderer)  
            return ((EllipseRenderer) getRenderer()).getPerimeterPoint(this,  
                    source, p);  
        return super.getPerimeterPoint(edge, source, p);  
    }  
   
 // Returns the Renderer for this View  
   public CellViewRenderer getRenderer() {  
   return renderer;  
 }  
 // Define the Renderer for an EllipseView  
   static class EllipseRenderer extends VertexRenderer {  
    /**
	 * 
	 */
	private static final long serialVersionUID = -4560911716897456336L;

	public void paint(Graphics g) {   
       
       try {  
            if (gradientColor != null && !preview && isOpaque()) {  
                setOpaque(false);  
                Graphics2D g2d = (Graphics2D) g;  
                 g2d.setPaint(new GradientPaint(0, 0, getBackground(),  
                        getWidth(), getHeight(), gradientColor, true));  
                 g2d.drawOval(0, 0, getWidth(), getHeight());      
                 g2d.fillOval(0, 0, getWidth(), getHeight());  
                   
                 //System.out.println(getWidth()+" "+getHeight());  
                //g2d.fillRect(0, 0, getWidth(), getHeight());  
            }  
            super.paint(g);  
            paintSelectionBorder(g);  
        } catch (IllegalArgumentException e) {  
            // JDK Bug: Zero length string passed to TextLayout constructor  
        }  
   }  
 }  
}  
  
  
class MyView extends DefaultCellViewFactory  
{  
/**
	 * 
	 */
	private static final long serialVersionUID = 637364982351524582L;

	//  Overrides JGraph.createVertexView  
    protected VertexView createVertexView(Object v) {  
      // Return an EllipseView for EllipseCells  
      if (v instanceof EllipseCell)  
        return new EllipseView(v);  
//      else if(v instanceof DiamondCell)  
//          return new DiamondView(v);  
      // Else Call Superclass  
      return super.createVertexView(v);  
    }  
}  