package org.processmining.ocbc.models.io;

import java.io.File;
import java.io.FileOutputStream;

import org.processmining.contexts.uitopia.annotations.UIExportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ocbc.models.OCBCModel;

/** 
 * Class with the export plugin for a collection of processes
 * 
 * @author Andrea Burattin
 */
@Plugin(
	name = "Export OCBC Model (.ocbcmml)",
	returnLabels = {},
	returnTypes = {},
	parameterLabels = { "OCBC Model", "File" },
	userAccessible = true
)
@UIExportPlugin(
	description = "Export OCBC Model (.ocbcmml)",//show the type in window for recording files
	extension = "ocbcmml" // the suffix name
)
public class ExportOCBCModel {

	/**
	 * This plugin is used to export a OCBC model
	 * 
	 * @param context
	 * @param ocbc model
	 * @param file
	 * @throws Exception 
	 */
	@PluginVariant(
		variantLabel = "Export OCBC Model (.ocbcmml)",
		requiredParameterLabels = { 0, 1 }
	) 
	public void exportPLGProcessCollection(PluginContext context, OCBCModel model, File file) throws Exception {
		context.log("Export started..."); 
		System.out.println("ocbcmml output");
		
		FileOutputStream output = new FileOutputStream(file);
		ExportToFile.exportToFile(model, output) ;
		context.log("Export complete!");
	} 
	

}

