package org.processmining.ocbc.models.io;

import java.io.File;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.ocbc.models.impl.OCBCModelImpl;


///** 
// * Class with the export plugin for a collection of processes
// * 
// * @author Andrea Burattin
// */
//@Plugin(
//	name = "Export OCBC Model (.ocbc)",
//	returnLabels = {},
//	returnTypes = {},
//	parameterLabels = { "OCBC Model", "File" },
//	userAccessible = true
//)
//@UIExportPlugin(
//	description = "Export OCBC Model (.ocbc)",//show the type in window for recording files
//	extension = "ocbc" // the suffix name
//)
public class ExportProcessCollection {

	/**
	 * This plugin is used to export a OCBC model
	 * 
	 * @param context
	 * @param processCollection
	 * @param file
	 * @throws Exception 
	 */
	@PluginVariant(
		variantLabel = "Export OCBC Model (.ocbc)",
		requiredParameterLabels = { 0, 1 }
	) 
	public void exportPLGProcessCollection(PluginContext context, OCBCModelImpl model, File file) throws Exception {
		context.log("Export started..."); 
		System.out.println("ocbc output");
		
    try{
	   
//	    FileOutputStream fout = new FileOutputStream("E:\\first2.ocbcm");
    	FileOutputStream fout = new FileOutputStream(file);
	    ObjectOutputStream oos = new ObjectOutputStream(fout);  
	    System.out.println("start write");
	    
	    
//	    OCBCModel model2 = new OCBCModelImpl("last");
	    oos.writeObject(model);
	    oos.close();
	    System.out.println("Done");
	   
    }catch(Exception ex){
	   ex.printStackTrace();
    }
		
		context.log("Export complete!");
	} 
	

}

