package org.processmining.ocbc.models.io;

import java.awt.Color;
import java.awt.geom.Rectangle2D;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JScrollPane;

import org.jgraph.JGraph;
import org.jgraph.graph.GraphConstants;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.ocbc.models.AOCEdge;
import org.processmining.ocbc.models.ActivityEdge;
import org.processmining.ocbc.models.ActivityNode;
import org.processmining.ocbc.models.ClassEdge;
import org.processmining.ocbc.models.ClassNode;
import org.processmining.ocbc.models.CrelOCEdge;
import org.processmining.ocbc.models.CrelRTEdge;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.impl.OCBCModelImpl;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;



///**
// * Class with the import plugin for a collection of processes
// * 
// * @author Andrea Burattin
// */
//@Plugin(
//	name = "Import OCBC Model (.ocbc)",
//	parameterLabels = { "File" },
//	returnLabels = { "Imported process collection" },
//	returnTypes = { ocbc.models.class },
//	userAccessible = true
//)
//@UIImportPlugin(
//		description = "Export OCBC Model (.ocbc)",//show the type in window for recording files
//		extensions = { "ocbc" }// the suffix name
//)
public class ImportProcessCollection extends AbstractImportPlugin {

	/**
	 * This plugin is used to import a process collection object
	 * 
	 * @param context
	 * @param input
	 * @param filename
	 * @param fileSizeInBytes
	 * @return
	 * @throws IOException 
	 */
	protected Object importFromStream(
			PluginContext context, 
			InputStream input, 
			String filename, 
			long fileSizeInBytes)
			throws Exception {
		context.log("Import started..."); 
		System.out.println("input OCBC model start");


		OCBCModel model = new OCBCModelImpl("hello world");
		
		System.out.println(filename);
//		FileInputStream fout = new FileInputStream(filename);
//		FileInputStream fout = new FileInputStream("E:\\abc.ocbc");
		ObjectInputStream oos = new ObjectInputStream(input); 
//		ObjectInputStream oos = new ObjectInputStream(fout);   
	    model = (OCBCModel) oos.readObject();
		context.log("Import complete!");
		System.out.println("input OCBC model end");
		return model;
	}
	
	   public static void main (String args[]) throws ClassNotFoundException, IOException {
		   		   
		   System.out.print("start read");
		   OCBCModel model = new OCBCModelImpl("hello world");
		  //
		   FileInputStream fout = new FileInputStream("E:\\last-last.ocbc");
		   @SuppressWarnings("resource")
		   ObjectInputStream oos = new ObjectInputStream(fout);   
		   model = (OCBCModel) oos.readObject();
		   
		   
//	        GraphModel model = new DefaultGraphModel();  
//	        GraphLayoutCache view = new GraphLayoutCache(model, new ModelCellViewFactory());  
//	 //       GraphLayoutCache view = new GraphLayoutCache(model, new DefaultCellViewFactory());   
//	        JGraph graph = new JGraph(model, view); 
	        JGraph graph = model.getGraph();
		   
		   System.out.print("read");
		   System.out.print(model.getModelName());
		   List<ClassNode> allClasses = model.getAllClasses();
		   System.out.print(allClasses.size());
//		   System.out.print(allClasses.get(0).getNodeName());
		   System.out.print(graph.getModel().getRootCount());
		   //graph.getInsets().;
		   
		   
		   
		   MyOriginalCell cell = new MyOriginalCell(new String("new"));  
	        GraphConstants.setBounds(cell.getAttributes(), new Rectangle2D.Double(240,240,75,65));  
	        GraphConstants.setGradientColor(cell.getAttributes(),Color.red);  
	        GraphConstants.setOpaque(cell.getAttributes(), true);  

//	        graph.getGraphLayoutCache().insert(cell);
	        
		   JFrame frame = new JFrame();  
	        frame.setSize(1000, 500);  
	        frame.setTitle("Activity Diagram");  
	        frame.getContentPane().add(new JScrollPane(graph));  
	          
	         frame.setBounds(50, 50, 700, 800);  
	          
	         frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);  
	         frame.setVisible(true);  
	         
	         for(ClassNode element: model.getAllClasses())
	         {	        	 
	        	 System.out.print("\n" + element.getNodeName());
	         }
	         System.out.print("\n" + "ActivityNode");
	         for(ActivityNode element: model.getAllActivities())
	         {	        	 
	        	 System.out.print("\n" + element.getNodeName());
	         }
	         System.out.print("\n" + "ClassEdge");
	         for(ClassEdge element: model.getAllClassRelations())
	         {	        	 
//	        	 System.out.print("\n" + element.getEdgeName());
//	        	 System.out.print("\n" + element.getSourceNode().getNodeName());
//	        	 System.out.print("\n" + "start"+element.getSourceCardinality().getStartValue()+"  end" + element.getSourceCardinality().getEndValue());
//	        	 System.out.print("\n" + element.getTargetNode().getNodeName());
//	        	 System.out.print("\n" + "start"+element.getTargetCardinality().getStartValue()+"  end" + element.getTargetCardinality().getEndValue());
//	        
	         }
	         System.out.print("\n" + "ActivityEdge" );
	         
	         for(ActivityEdge element: model.getAllActivityRelations())
	         {	        	 
	        	 System.out.print("\n" + element.getEdgeName());
	        	 System.out.print("\n" + element.getReferenceNode().getNodeName());
	        	
	        	 System.out.print("\n" + element.getTargetNode().getNodeName());	
	        	 System.out.print("\n" + "CardinalityType"+element.getCardinalityType());
	         }
	         System.out.print("\n" + "AOCEdge");
	         for(AOCEdge element: model.getAllAOCRelations())
	         {	        	 
	        	 System.out.print("\n" + element.getEdgeName());
	        	 System.out.print("\n" + element.getActivityNode().getNodeName());
//	        	 System.out.print("\n" + "start"+element.getActivityCardinality().getStartValue()+"  end" + element.getActivityCardinality().getEndValue());	        	 
//	        	 System.out.print("\n" + "timescope"+element.getActivityCardinality().getCardinalityTimeScope());	        	 
//	        	 
	        	 System.out.print("\n" + element.getClassNode().getNodeName());	
	        	 System.out.print("\n" + "start"+element.getClassCardinality().getStartValue()+"  end" + element.getClassCardinality().getEndValue());
	        	 System.out.print("\n" + "timescope"+element.getClassCardinality().getCardinalityTimeScope());	
	         }
	         
	         System.out.print("\n" + "CrelOCEdge");
	         for(CrelOCEdge element: model.getAllCrelOCRelations())
	         {	        	 
	        	 System.out.print("\n" + element.getEdgeName());
	        	 System.out.print("\n" + element.getRelatedActivityRelation().getReferenceNode().getNodeName());
//	        	 System.out.print("\n" + "start"+element.getActivityCardinality().getStartValue()+"  end" + element.getActivityCardinality().getEndValue());	        	 
	        	 System.out.print("\n" + element.getRelatedClass().getNodeName());	
//	        	 System.out.print("\n" + "start"+element.getClassCardinality().getStartValue()+"  end" + element.getClassCardinality().getEndValue());
	        	 
	         }
	         
	         System.out.print("\n" + "CrelRTEdge");
	         for(CrelRTEdge element: model.getAllCrelRTRelations())
	         {	        	 
	        	 System.out.print("\n" + element.getEdgeName());
	        	 System.out.print("\n" + element.getRelatedActivityRelation().getReferenceNode().getNodeName());
//	        	 System.out.print("\n" + "start"+element.getActivityCardinality().getStartValue()+"  end" + element.getActivityCardinality().getEndValue());	        	 
	        	 System.out.print("\n" + element.getRelatedClassRelation().getSourceNode().getNodeName());	
//	        	 System.out.print("\n" + "start"+element.getClassCardinality().getStartValue()+"  end" + element.getClassCardinality().getEndValue());
	        	 
	         }
	   }
}
