package org.processmining.ocbc.models.visualization;

import org.jgraph.graph.DefaultCellViewFactory;
import org.jgraph.graph.EdgeView;
import org.jgraph.graph.PortView;
import org.jgraph.graph.VertexView;
import org.processmining.ocbc.models.visualization.cell.AOCEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ActivityCell;
import org.processmining.ocbc.models.visualization.cell.ActivityEdgeCell;
import org.processmining.ocbc.models.visualization.cell.ClassCell;
import org.processmining.ocbc.models.visualization.cell.ClassEdgeCell;
import org.processmining.ocbc.models.visualization.cell.LabelCell;
import org.processmining.ocbc.models.visualization.cell.TransparentCell;
import org.processmining.ocbc.models.visualization.cell.TransparentPortCell;
import org.processmining.ocbc.models.visualization.declare.DEdgeView;
import org.processmining.ocbc.models.visualization.view.AOCEdgeView;
import org.processmining.ocbc.models.visualization.view.ActivityEdgeView;
import org.processmining.ocbc.models.visualization.view.ActivityView;
import org.processmining.ocbc.models.visualization.view.ClassEdgeView;
import org.processmining.ocbc.models.visualization.view.ClassView;
import org.processmining.ocbc.models.visualization.view.LabelView;
import org.processmining.ocbc.models.visualization.view.TransparentCellView;
import org.processmining.ocbc.models.visualization.view.TransparentPortView;

public class ModelCellViewFactory extends DefaultCellViewFactory {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7288009143327540248L;

//	public ModelCellViewFactory() {
//	}
//
//	@Override
//	public CellView createView(GraphModel model, Object cell) {
//		CellView view = null;
//		if (model.isPort(cell))
//			view = createPortView(cell);
//		else if (model.isEdge(cell))
//			view = createEdgeView(cell);
//		else
//			view = createTheVertexView(cell);
//		return view;
//	}
//
//	protected AbstractCellView createTheVertexView(Object cell) {
//		
//		if (cell instanceof ClassCell) {
//			return new ClassView(cell);
//		} 
//		else if (cell instanceof AOCEdgeCell) {
//			return new AOCEdgeView(cell);
//		} 
//		return new MultiLineVertexView(cell);
//	}

	protected EdgeView createEdgeView(Object cell) {
		if (cell instanceof ClassEdgeCell) 
		{
//			return new ClassEdgeView(cell);
			System.out.print("cell instanceof ClassEdgeCell");
			return new ClassEdgeView(cell);
		}
		else if (cell instanceof AOCEdgeCell) 
		{
//			return new ClassEdgeView(cell);
			System.out.print("cell instanceof AOCEdgeCell");
			return new AOCEdgeView(cell);
		}
		
		else if (cell instanceof ActivityEdgeCell) 
		{
//			return new ClassEdgeView(cell);
			System.out.print("cell instanceof ActivityEdgeCell");
			return new ActivityEdgeView(cell);
		}
		else 
		{
			System.out.print("cell instanceof DEdgeView");
			return new DEdgeView(cell);		
		}
	}

	protected VertexView createVertexView(Object object) {
		if (object instanceof ClassCell) 
			return new ClassView(object);	
//			return new TransparentCellView(object);	
		else if (object instanceof ActivityCell) 
			return new ActivityView(object);
		else if (object instanceof TransparentCell) 
			return new TransparentCellView(object);
//			return super.createVertexView(object);
		else if (object instanceof LabelCell) 
			return new LabelView(object);
		else 
			return super.createVertexView(object);
		
	}

	/**
	 * Constructs a PortView view for the specified object.
	 * 
	 * @param cell
	 *            Object
	 * @return PortView
	 */
	protected PortView createPortView(Object cell) {
		if (cell instanceof TransparentPortCell) {
			return new TransparentPortView(cell);
		} else {
			return new PortView(cell);
		}
	}

}
