package org.processmining.ocbc.models.visualization;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JSplitPane;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.mxgraph.examples.swing.GraphEditor;
import org.processmining.mxgraph.examples.swing.GraphEditor.CustomGraph;
import org.processmining.mxgraph.examples.swing.GraphEditor.CustomGraphComponent;
import org.processmining.mxgraph.examples.swing.editor.EditorMenuBar;
import org.processmining.mxgraph.io.mxCodec;
import org.processmining.mxgraph.util.mxConstants;
import org.processmining.mxgraph.util.mxXmlUtils;
import org.processmining.mxgraph.view.mxGraph;
import org.processmining.ocbc.models.OCBCModel;
import org.processmining.ocbc.models.editor.plugins.OCBCEditorConstants;
import org.w3c.dom.Document;


public class OCBCModelVisualizer {

//	@Plugin(name = "OCBC model 3", 
//			returnLabels = { "OCBC Model Editor" }, 
//			returnTypes = { JComponent.class }, 
//			parameterLabels = {	"OCBC model 3" })
//	@Visualizer
	public JComponent visualize(UIPluginContext context, OCBCModel modelOriginal){
		System.out.println("\n edit(UIPluginContext context, OCBCModel model) in org.processmining.ocbc.models.visualization");	
		OCBCModel model = (OCBCModel) modelOriginal.clone();
		model.setModelEnvironment(mxConstants.model_editor);
		
		System.out.println("\n activity name number: " + model.getAllActivityNames().size());
		
		for(String name : model.getAllActivityNames()){
			System.out.println("\n activity name: " + name);
		}
		
		if(model.getModelVersion() == null || model.getModelVersion().equals(OCBCEditorConstants.VERSION2_0)){			
			
//			editor.setOCBCModel(model);
			
//			Document document = model.getModelFile();
			Document document = mxXmlUtils.parseXml(model.getModelString());
			mxGraph graphX = new CustomGraph();
			if(document != null){
				System.out.println("\n input document");
				
				System.out.println("\n document.getChildNodes().getLength(): " + document.getChildNodes().getLength());
				
				mxCodec codec = new mxCodec(document);
				codec.decode(document.getDocumentElement(),graphX.getModel());				
			}
			
			System.out.println("\n graph activity relation number: " + graphX.getActivityRelationList().size());
			
			System.out.println("\n before build editor");	
			GraphEditor editor = new GraphEditor("mxGraph Editor", new CustomGraphComponent(graphX), model);
			
			System.out.println("\n before setGraphX");	
			model.setGraphX(graphX);
			
			System.out.println("\n before setContext");	
			editor.setContext(context);
//			this.editor = editor;
			
			System.out.print("\n refresh graph 2017");
			editor.refreshGraph();
			
			JFrame frame = new JFrame();
			
			JSplitPane completePanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
			
			completePanel.setTopComponent(new EditorMenuBar(editor));
			completePanel.setBottomComponent(editor);
			completePanel.setResizeWeight(0.02);
			completePanel.setEnabled(false);
			frame.getContentPane().add(completePanel);

			
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			
			System.out.println("\n before setJMenuBar");	
			frame.setJMenuBar(new EditorMenuBar(editor));
			return (JComponent) frame.getContentPane();
		}		
		else{
			return null;
		}
	}
}

