package org.processmining.ocbc.models.visualization.declare;

import java.awt.Color;
import java.awt.Polygon;
import java.awt.Shape;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import org.jgraph.graph.EdgeRenderer;
import org.jgraph.graph.GraphConstants;

/**
 * <p>
 * Title:
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2006
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author not attributable
 * @version 1.0
 */
public class DEdgeRenderer extends EdgeRenderer {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2245131380109364539L;

	protected transient Color middleColor;

	/** Painting attributes of the current edgeview */
	protected transient int lineNumber;
	protected transient float width;

	public static final int ARROW_NONE = 0;

	/**
	 * Represents a classic arrow decoration for the beginning or ending of
	 * edges.
	 * 
	 * @see #setLineBegin(Map,int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_CLASSIC = 1;

	/**
	 * Represents a technical arrow decoration for the beginning or ending of
	 * edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_TECHNICAL = 2;

	/**
	 * Represents a simple arrow decoration for the beginning or ending of
	 * edges.
	 * 
	 * @see #setLineBegin(Map,int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_SIMPLE = 4;

	/**
	 * Represents a circle decoration for the beginning or ending of edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_CIRCLE = 5;

	/**
	 * Represents a line decoration for the beginning or ending of edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_LINE = 7;

	/**
	 * Represents a double line decoration for the beginning or ending of edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_DOUBLELINE = 8;

	/**
	 * Represents a diamond decoration for the beginning or ending of edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */
	public static final int ARROW_DIAMOND = 9;

	/** Represents an orthogonal line style */
	public static final int STYLE_ORTHOGONAL = 11;

	/** Represents a bezier line style */
	public static final int STYLE_BEZIER = 12;

	/** Represents an spline line style */
	public static final int STYLE_SPLINE = 13;
	
	/** Represents an double arrow style */
	public static final int ARROW_DOUBLETRIANGLE = 15;
	
	/** Represents an double arrow style */
	public static final int ARROW_TRIANGLECIRCLE = 16;
	
	/** Represents an double arrow style */
	public static final int ARROW_DOUBLETRIANGLECIRCLE = 17;
	
	/**
	 * Constructs a renderer that may be used to render edges.
	 */
	public DEdgeRenderer() {
		super();
	}

	/*
	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
	 * of fifferent color.
	 */
//	@Override
//	public void paint(final Graphics g) {
////		final Graphics2D g2 = (Graphics2D) g;
////		super.paint(g);
////		
//		System.out.print("enter paint DEdgeRenderer");
////		if (view.lineShape != null) {
////			g2.setColor(Color.yellow);
////			g2.draw(view.lineShape);
////		}
//		
//		if (view.isLeaf()) {
//			Shape edgeShape = view.getShape();
//			// Sideeffect: beginShape, lineShape, endShape
//			if (edgeShape != null) {
//				Graphics2D g2 = (Graphics2D) g;
//				g2.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL,
//						RenderingHints.VALUE_STROKE_PURE);
//				setOpaque(false);
//				super.paint(g);
//				translateGraphics(g);
//				// Hook for pre-painting
//				beforeEdgePaint(g);
//				// Actual edge drawing
//				paintEdge(g);
//				// Drawing of any selection
//				paintSelection(g);
//				// Drawing of labels
//				paintLabels(g);
//				// Hook for post-painting
//				afterEdgePaint(g);
//			}
//		} else {
//			paintSelectionBorder(g);
//		}
//	}
	
//	@Override
//	/**
//	 * Returns the shape of the view according to the last rendering state
//	 */
//	public Shape getShape() {
//		if (sharedPath != null)
//			return sharedPath;
//		else {
//			return sharedPath = (GeneralPath) getEdgeRenderer().createShape();
//		}
//	}
	

	/**
	 * Paint double arrows.
	 * 
	 * @param size
	 *            int
	 * @param style
	 *            int
	 * @param src
	 *            Point2D
	 * @param dst
	 *            Point2D
	 * @return Shape
	 */
	@Override	
	protected Shape createLineEnd(int size, int style, Point2D src, Point2D dst) {
		if (src == null || dst == null)
			return null;
		
		System.out.print("triger the override Shape createLineEnd");
		size = size*2;
		int d = (int) Math.max(1, dst.distance(src));
		int ax = (int) -(size * (dst.getX() - src.getX()) / d);
		int ay = (int) -(size * (dst.getY() - src.getY()) / d);
		if (style == GraphConstants.ARROW_DIAMOND) {
			Polygon poly = new Polygon();
			poly.addPoint((int) dst.getX(), (int) dst.getY());
			poly.addPoint((int) (dst.getX() + ax / 2 + ay / 3),
					(int) (dst.getY() + ay / 2 - ax / 3));
			Point2D last = (Point2D) dst.clone();
			dst.setLocation(dst.getX() + ax, dst.getY() + ay);
			poly.addPoint((int) dst.getX(), (int) dst.getY());
			poly.addPoint((int) (last.getX() + ax / 2 - ay / 3),
					(int) (last.getY() + ay / 2 + ax / 3));
			return poly;

		} else if (style == GraphConstants.ARROW_TECHNICAL
				|| style == GraphConstants.ARROW_CLASSIC) {
			Polygon poly = new Polygon();
			poly.addPoint((int) dst.getX(), (int) dst.getY());
			poly.addPoint((int) (dst.getX() + ax + ay / 2), (int) (dst.getY()
					+ ay - ax / 2));
			Point2D last = (Point2D) dst.clone();
			if (style == GraphConstants.ARROW_CLASSIC) {
				dst.setLocation((int) (dst.getX() + ax * 2 / 3),
						(int) (dst.getY() + ay * 2 / 3));
				poly.addPoint((int) dst.getX(), (int) dst.getY());
			} else if (style == GraphConstants.ARROW_DIAMOND) {
				dst.setLocation(dst.getX() + 2 * ax, dst.getY() + 2 * ay);
				poly.addPoint((int) dst.getX(), (int) dst.getY());
			} else
				dst.setLocation((int) (dst.getX() + ax),
						(int) (dst.getY() + ay));
			poly.addPoint((int) (last.getX() + ax - ay / 2), (int) (last.getY()
					+ ay + ax / 2));
			return poly;

		} else if (style == GraphConstants.ARROW_SIMPLE) {
			GeneralPath path = new GeneralPath(GeneralPath.WIND_NON_ZERO, 4);
			path.moveTo((float) (dst.getX() + ax + ay / 2), (float) (dst.getY()
					+ ay - ax / 2));
			path.lineTo((float) dst.getX(), (float) dst.getY());
			path.lineTo((float) (dst.getX() + ax - ay / 2), (float) (dst.getY()
					+ ay + ax / 2));
			return path;

		} else if (style == GraphConstants.ARROW_CIRCLE) {
			Ellipse2D ellipse = new Ellipse2D.Float((float) (dst.getX() + ax
					/ 2 - size / 2), (float) (dst.getY() + ay / 2 - size / 2),
					size, size);
			dst.setLocation(dst.getX() + ax, dst.getY() + ay);
			return ellipse;

		} else if (style == GraphConstants.ARROW_LINE
				|| style == GraphConstants.ARROW_DOUBLELINE) {
			GeneralPath path = new GeneralPath(GeneralPath.WIND_NON_ZERO, 4);
			path.moveTo((float) (dst.getX() + ax / 2 + ay / 2),
					(float) (dst.getY() + ay / 2 - ax / 2));
			path.lineTo((float) (dst.getX() + ax / 2 - ay / 2),
					(float) (dst.getY() + ay / 2 + ax / 2));
			if (style == GraphConstants.ARROW_DOUBLELINE) {
				path.moveTo((float) (dst.getX() + ax / 3 + ay / 2),
						(float) (dst.getY() + ay / 3 - ax / 2));
				path.lineTo((float) (dst.getX() + ax / 3 - ay / 2),
						(float) (dst.getY() + ay / 3 + ax / 2));
			}
			return path;
			
		} else if (style == ARROW_DOUBLETRIANGLE) {
			
			Polygon poly = new Polygon();
			poly.addPoint((int) dst.getX(), (int) dst.getY());
			poly.addPoint((int) (dst.getX() + ax + ay / 2), (int) (dst.getY()
					+ ay - ax / 2));
			poly.addPoint((int) dst.getX() + ax, (int) dst.getY() + ay);
			poly.addPoint((int) (dst.getX() + 2*ax + ay / 2), (int) (dst.getY()
					+ 2*ay - ax / 2));
			Point2D last = (Point2D) dst.clone();
			
			poly.addPoint((int) (last.getX() + 2*ax - ay / 2), (int) (last.getY()
					+ 2*ay + ax / 2));
			poly.addPoint((int) dst.getX() + ax, (int) dst.getY() + ay);
			
			poly.addPoint((int) (last.getX() + ax - ay / 2), (int) (last.getY()
					+ ay + ax / 2));							
			return poly;	
			
		} else if (style == ARROW_TRIANGLECIRCLE) {
			Polygon poly = new Polygon();
			poly.addPoint((int) dst.getX() + ax, (int) dst.getY() + ay);
			poly.addPoint((int) (dst.getX() + 2*ax + ay / 2), (int) (dst.getY()
					+ 2*ay - ax / 2));
			Point2D last = (Point2D) dst.clone();
			
			poly.addPoint((int) (last.getX() + 2*ax - ay / 2), (int) (last.getY()
					+ 2*ay + ax / 2));
			
			Ellipse2D ellipse = new Ellipse2D.Float((float) (dst.getX() + ax
					/ 2 - size / 2), (float) (dst.getY() + ay / 2 - size / 2),
					size, size);

			Area area = new Area(poly);
			area.add(new Area(ellipse));			
			return area;	
			
		}	else if (style == ARROW_DOUBLETRIANGLECIRCLE) {

			Polygon poly = new Polygon();
			poly.addPoint((int) dst.getX() + ax, (int) dst.getY() + ay);
			poly.addPoint((int) (dst.getX() + 2*ax + ay / 2), (int) (dst.getY()
					+ 2*ay - ax / 2));
			poly.addPoint((int) dst.getX() + 2*ax, (int) dst.getY() + 2*ay);
			poly.addPoint((int) (dst.getX() + 3*ax + ay / 2), (int) (dst.getY()
					+ 3*ay - ax / 2));
			Point2D last = (Point2D) dst.clone();
			
			poly.addPoint((int) (last.getX() + 3*ax - ay / 2), (int) (last.getY()
					+ 3*ay + ax / 2));
			poly.addPoint((int) dst.getX() + 2*ax, (int) dst.getY() + 2*ay);
			
			poly.addPoint((int) (last.getX() + 2*ax - ay / 2), (int) (last.getY()
					+ 2*ay + ax / 2));
			
			Ellipse2D ellipse = new Ellipse2D.Float((float) (dst.getX() + ax
					/ 2 - size / 2), (float) (dst.getY() + ay / 2 - size / 2),
					size, size);
			
			Area area = new Area(poly);
			area.add(new Area(ellipse));			
			return area;			
		}	
		return null;
	}
}
