package org.processmining.ocbc.models.visualization.view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import org.jgraph.graph.GraphConstants;
import org.processmining.ocbc.models.visualization.cell.MyOriginalCell;

import com.jgraph.components.labels.MultiLineVertexRenderer;

public class ClassRenderer extends MultiLineVertexRenderer {

	public static enum EventType {
		TIMEOUT("TO"), MESSAGE("Mes");
		private final String s;

		EventType(String s) {
			this.s = s;
		}

		public String toString() {
			return s;
		}
	};

	/**
	 * 
	 */
	private static final long serialVersionUID = 4910262989128580150L;
	
	private MyOriginalCell cell;
	protected EventType type;

	public ClassRenderer(Object cell) {
		this.cell = (MyOriginalCell) cell;
	}
	
	public void paint(Graphics g) {   	       
       try {  
            if (gradientColor != null && !preview && isOpaque()) {  
                setOpaque(false);  
                Graphics2D g2d = (Graphics2D) g;  	                
                g2d.setPaint(Color.yellow);  
                int height = (int) GraphConstants.getBounds(cell.getAttributes()).getHeight();
                int width = (int) GraphConstants.getBounds(cell.getAttributes()).getWidth();
                g2d.drawRoundRect(0, 0, width, height, 30, 30);
                g2d.fillRoundRect(0, 0, width, height, 30, 30);
            }  
            super.paint(g);  
            paintSelectionBorder(g);  
        } catch (IllegalArgumentException e) {  
            // JDK Bug: Zero length string passed to TextLayout constructor  
        }  
	}
}
