package org.processmining.ocbc.models.visualization.view;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Stroke;

import org.jgraph.graph.AttributeMap;
import org.jgraph.graph.CellView;
import org.jgraph.graph.GraphConstants;
import org.processmining.ocbc.models.visualization.declare.DEdgeRenderer;
import org.processmining.ocbc.models.visualization.declare.DEdgeView;
import org.processmining.ocbc.models.visualization.declare.DGraphConstants;



public class CrelEdgeRenderer extends DEdgeRenderer {

	private static final long serialVersionUID = -2245131380109364539L;

	protected transient Color middleColor;

	/** Painting attributes of the current edgeview */
	protected transient int lineNumber;
	protected transient float width;
	
	/**
	 * Represents no decoration for the beginning or ending of edges.
	 * 
	 * @see #setLineBegin(Map, int)
	 * @see #getLineBegin(Map)
	 * @see #setLineEnd(Map, int)
	 * @see #getLineEnd(Map)
	 */

	/**
	 * Installs the attributes of specified cell in this renderer instance. This
	 * means, retrieve every published key from the cells hashtable and set
	 * global variables or superclass properties accordingly.
	 * 
	 * @param view
	 *            the cell view to retrieve the attribute values from.
	 */
	/**
	 * Constructs a renderer that may be used to render edges.
	 */
	public CrelEdgeRenderer() {
		super();
//		paint(getGraphics());
//		super.installAttributes(getDEdgeView());
	}
	
	@Override
	protected void installAttributes(final CellView view) {
		super.installAttributes(view);
		final AttributeMap map = view.getAllAttributes();
		lineNumber = DGraphConstants.getLineNumber(map);

		width = lineWidth;
		lineWidth = switchWidth(lineNumber);

	}

	/**
	 * getDEdgeView
	 * 
	 * @return DEdgeView
	 */
	public DEdgeView getDEdgeView() {
		if (view instanceof DEdgeView) {
			return (DEdgeView) view;
		}
		return null;
	}

	/*
	 * rewritten method paint from EdgeRenderer. Added extra edge in them middle
	 * of fifferent color.
	 */
	@Override
	public void paint(final Graphics g) {
		final Graphics2D g2 = (Graphics2D) g;
		super.paint(g);
		System.out.println("triger CrelEdgeRenderer");
		drawLines(g2);
	}

	/**
	 * @param g2
	 *            Graphics2D
	 */
	private void drawLines(final Graphics2D g2) {
//		lineNumber = 2;
//		if (lineNumber > 1) {
//			Color color = getForeground();
//			for (int i = lineNumber - 1; i > 0; i--) {
//				final float w = switchWidth(i);
//				color = switchColor(color);
//				drawLine(g2, w, color);
//			}
//		}
	}

	private float switchWidth(final int number) {
		return width * ((2 * number) - 1);
	}

	private Color switchColor(final Color color) {
		Color c = getForeground();
		if (color != null) {
			if (color.equals(this.getBackground())) {
				c = this.getForeground();
			} else {
				c = this.getBackground();
			}
		}
		return c;
	}

	/**
	 * @param g2
	 *            Graphics2D
	 * @param width
	 *            int
	 * @param color
	 *            Color
	 */
	private void drawLine(final Graphics2D g2, final float width, final Color color) {
//		if (view.lineShape != null) {
////			g2.setColor(color);
//			g2.setColor(Color.black);
//			g2.setStroke(getStroke(width));
//			System.out.println("change color");
//			g2.draw(view.lineShape);
////			Polygon poly =  createLineEnd(size, style, src, dst) ;
//		}
	}

	private Stroke getStroke(final float width) {
		Stroke s = null;
		if (lineDash != null) { // Dash For Line Only
			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, lineDash, dashOffset);
		} else {
			s = new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
		}

		if (selected) { // Paint Selected
			s = GraphConstants.SELECTION_STROKE;
		}
		return s;
	}


}
