package org.processmining.ocbc.performance.logprojection;

import org.processmining.ocbc.performance.logprojection.DataManager.StringHandler;
import org.processmining.ocbc.performance.logprojection.sorting.AlphanumComparator;

public class AlphanumLiteralIndexSorter {

	private int[] litIndices;
	private StringHandler stringHandler;
	private final AlphanumComparator comparator = new AlphanumComparator();

	public void sort(StringHandler stringHandler, int[] litIndices) {
		this.stringHandler = stringHandler;
		this.litIndices = litIndices;
		int number = litIndices.length - 1;

		quicksortLiteral(0, number);

	}

	private void quicksortLiteral(int low, int high) {

		int i = low, j = high;
		// Get the pivot element from the middle of the list
		String pivot = stringHandler.getLiteral(litIndices[low + (high - low)
				/ 2]);

		// Divide into two lists
		while (i <= j) {
			// If the current value from the left list is smaller then the
			// pivot element then get the next element from the left list
			while (comparator.compare(stringHandler.getLiteral(litIndices[i]),
					pivot) < 0) {
				i++;
			}
			// If the current value from the right list is larger then the
			// pivot element then get the next element from the right list
			while (comparator.compare(stringHandler.getLiteral(litIndices[j]),
					pivot) > 0) {
				j--;
			}

			// If we have found a values in the left list which is larger
			// then the pivot element and if we have found a value in the right
			// list which is smaller then the pivot element then we exchange the
			// values. As we are done we can increase i and j
			if (i <= j) {
				exchange(i, j);
				i++;
				j--;
			}
		}
		// Recursion
		if (low < j)
			quicksortLiteral(low, j);
		if (i < high)
			quicksortLiteral(i, high);
	}

	private void exchange(int i, int j) {
		int temp = litIndices[i];
		litIndices[i] = litIndices[j];
		litIndices[j] = temp;
	}
}
