package org.processmining.ocbc.performance.logprojection;

import gnu.trove.map.TObjectIntMap;

import java.io.Serializable;
import java.util.Collection;
import java.util.Map;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XEvent;
import org.processmining.ocbc.performance.logprojection.calculators.ClassifierAttribute;

public class XEventDataManager extends DataManager<XEvent> {

	private static final long serialVersionUID = 1L;

	private final Map<String, XExtension> key2extension;

	public <M extends Map<String, XExtension> & Serializable> XEventDataManager(
			M key2extension, StringHandler stringHandler,
			Collection<XAttribute> attributes, TObjectIntMap<String> lit2index) {
		super(stringHandler, attributes, lit2index, 4 * 1024 * 1024, 2, true);
		this.key2extension = key2extension;
	}

	@Override
	protected XEvent readObjectFromBlock(byte[] array, int ptr,
			boolean forAddingAttributes) {
		XAttributeMap attributes = FACTORY.createAttributeMap();

		Attribute[] globalKeys = getKeys();

		for (int i = 0; i < globalKeys.length; i++) {
			if (!(globalKeys[i] instanceof ClassifierAttribute)) {
				readAttributeIntoScope(globalKeys, ptr, array, i, attributes,
						key2extension, forAddingAttributes);
			}
		}

		return FACTORY.createEvent(attributes);
	}

	public int getTraceForEvent(int number) {
		int block = (number * bytesReservedPerObject) >>> shift;
		int ptr = (number * bytesReservedPerObject) & mask;

		byte[] array = store[block];

		return readInt(array, ptr);
	}

}
