package org.processmining.ocbc.performance.logprojection.calculators;

import java.util.Arrays;

import org.deckfour.xes.model.XAttribute;
import org.processmining.ocbc.performance.logprojection.Attribute;

public class ClassifierAttribute extends Attribute {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8552577681192375485L;
	private static final String C_PREF = "C: ";
	private String[] keys;

	public ClassifierAttribute(XAttribute attribute, long defaultValue,
			String... keys) {
		super(attribute, defaultValue, true);
		this.keys = keys;
		this.prefix = C_PREF;
	}

	public ClassifierAttribute(String key, byte type, long defaultValue,
			String... keys) {
		super(key, type, defaultValue, true);
		this.keys = keys;
		this.prefix = C_PREF;
	}

	public ClassifierAttribute(char[] key, byte type, long defaultValue,
			String... keys) {
		super(key, type, defaultValue, true);
		this.keys = keys;
		this.prefix = C_PREF;
	}

	public String[] getOriginalKeys() {
		return keys;
	}

	public boolean equals(Object o) {
		if (o instanceof ClassifierAttribute) {
			ClassifierAttribute a = (ClassifierAttribute) o;
			// return a.type == type && Arrays.equals(a.key, key);
			return Arrays.equals(a.key, key);
		}
		return false;
	}

	public int hashCode() {
		// return Arrays.hashCode(key) + 37 * type;
		return Arrays.hashCode(key);
	}

	public String toString() {
		return "C: " + getKey();
	}

}
