package org.processmining.ocbc.performance.logprojection.calculators;

import java.util.Set;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.model.XAttributable;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeLiteral;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XVisitor;

public class XLightLiteralAttribute implements XAttributeLiteral {

	public static class WithIndex extends XLightLiteralAttribute {

		private static final long serialVersionUID = -3317890660377267450L;
		private int index;

		public WithIndex(String key, int index) {
			this(key, index, null);
		}

		public WithIndex(String key, int index, XExtension xExtension) {
			super(key, "", xExtension);
			this.index = index;
		}

		public int getIndex() {
			return index;
		}

	}

	private static final long serialVersionUID = -6155157039186992717L;
	private String key;
	private String value;
	private XExtension xExtension;

	public XLightLiteralAttribute(String key, String value) {
		this.key = key;
		this.value = value;
	}

	public XLightLiteralAttribute(String key, String value,
			XExtension xExtension) {
		this(key, value);
		this.xExtension = xExtension;
	}

	@Override
	public void accept(XVisitor arg0, XAttributable arg1) {
	}

	@Override
	public XExtension getExtension() {
		return xExtension;
	}

	@Override
	public String getKey() {
		return key;
	}

	@Override
	public XAttributeMap getAttributes() {
		return null;
	}

	@Override
	public Set<XExtension> getExtensions() {
		return null;
	}

	@Override
	public boolean hasAttributes() {
		return false;
	}

	@Override
	public void setAttributes(XAttributeMap arg0) {

	}

	@Override
	public int compareTo(XAttribute o) {
		return 0;
	}

	@Override
	public String getValue() {
		return value;
	}

	@Override
	public void setValue(String value) {
		this.value = value;
	}

	public String toString() {
		return value;
	}

	public Object clone() {
		return null;
	}
}
