package org.processmining.ocbc.performance.logprojection.calculators;

import java.util.Date;
import java.util.Set;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.model.XAttributable;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XAttributeTimestamp;
import org.deckfour.xes.model.XVisitor;

public class XLightTimestampAttribute implements XAttributeTimestamp {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5968014503327087854L;

	private String key;
	private long value;
	private XExtension xExtension;

	public XLightTimestampAttribute(String key, long value) {
		this.key = key;
		this.value = value;
	}

	public XLightTimestampAttribute(String key, long value,
			XExtension xExtension) {
		this(key, value);
		this.xExtension = xExtension;
	}

	@Override
	public void accept(XVisitor arg0, XAttributable arg1) {
	}

	@Override
	public XExtension getExtension() {
		return xExtension;
	}

	@Override
	public String getKey() {
		return key;
	}

	@Override
	public XAttributeMap getAttributes() {
		return null;
	}

	@Override
	public Set<XExtension> getExtensions() {
		return null;
	}

	@Override
	public boolean hasAttributes() {
		return false;
	}

	@Override
	public void setAttributes(XAttributeMap arg0) {

	}

	@Override
	public int compareTo(XAttribute o) {
		return 0;
	}

	@Override
	public Date getValue() {
		return new Date(value);
	}

	@Override
	public long getValueMillis() {
		return value;
	}

	@Override
	public void setValue(Date arg0) {
		this.value = arg0.getTime();
	}

	@Override
	public void setValueMillis(long arg0) {
		this.value = arg0;
	}

	public String toString() {
		return getValue().toString();
	}

	public Object clone() {
		return null;
	}

}
