package org.processmining.ocbc.performance.logprojection.filters;

import org.processmining.ocbc.performance.logprojection.Attribute;
import org.processmining.ocbc.performance.logprojection.DataManager;
import org.processmining.ocbc.performance.logprojection.LogView;

/**
 * equality of AbstractEventFilters is based on the attribute they refer to and
 * nothing more.
 * 
 * @author bfvdonge
 * 
 */
public abstract class AbstractEventFilter implements EventFilter {

	protected final int attributeIndex;
	protected final DataManager<?> manager;
	protected final Attribute attribute;

	public AbstractEventFilter(LogView view, Attribute attribute) {
		this.attribute = attribute;
		if (attribute.isEventAttribute()) {
			attributeIndex = view.getEventDataManager().getKeyIndex(attribute);
			manager = view.getEventDataManager();
		} else {
			attributeIndex = view.getTraceDataManager().getKeyIndex(attribute);
			manager = view.getTraceDataManager();
		}
	}

	public boolean equals(Object o) {
		return (o instanceof AbstractEventFilter)
				&& ((AbstractEventFilter) o).attribute.equals(attribute);
	}

	public int hashCode() {
		return attribute.hashCode();
	}
}
