package org.processmining.ocbc.performance.logprojection.filters;

import java.util.Arrays;

import org.processmining.ocbc.performance.logprojection.Attribute;
import org.processmining.ocbc.performance.logprojection.LogView;

public final class LiteralAttributeFilter extends AbstractEventFilter {

	private int[] literalIndicesToKeep;

	public LiteralAttributeFilter(LogView view, Attribute attribute,
			int... literalIndicesToKeep) {
		super(view, attribute);
		this.literalIndicesToKeep = literalIndicesToKeep;
		Arrays.sort(literalIndicesToKeep);

	}

	@Override
	public boolean keepEvent(LogView view, int traceIndex, int eventIndex) {
		int val;
		if (attribute.isEventAttribute()) {
			val = getValue(eventIndex);
		} else {
			val = getValue(traceIndex);
		}
		return Arrays.binarySearch(literalIndicesToKeep, val) >= 0;
	}

	private int getValue(int objectIndex) {
		switch (attribute.getType()) {
		case Attribute.LITR:
			return manager.getAttributeValueLiteralIndex(objectIndex,
					attributeIndex);
		default:
			return -1;
		}
	}

}
