package org.processmining.ocbc.performance.logprojection.lightxlog;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import org.jfree.chart.util.RelativeDateFormat;
import org.processmining.ocbc.performance.logprojection.Attribute;
import org.processmining.ocbc.performance.logprojection.DataManager;
import org.processmining.ocbc.performance.logprojection.LogView;

public abstract class AbstractAttributable {

	protected static final DateFormat DATEFORMATABS = new SimpleDateFormat();
	protected static final DateFormat DATEFORMATREL = new RelativeDateFormat();

	protected final LogView view;
	protected final DataManager<?> manager;
	protected final int number;

	public AbstractAttributable(LogView view, DataManager<?> manager, int number) {
		this.view = view;
		this.manager = manager;
		this.number = number;
	}

	public Attribute[] getAttributeKeys() {
		return manager.getKeys();
	}

	public boolean getAttributeValueBoolean(Attribute key) {
		return manager.getAttributeValueBoolean(number, key);
	}

	public boolean getAttributeValueBoolean(int attrIndex) {
		return manager.getAttributeValueBoolean(number, attrIndex);
	}

	public long getAttributeValueDiscrete(Attribute key) {
		return manager.getAttributeValueDiscrete(number, key);
	}

	public long getAttributeValueDiscrete(int attrIndex) {
		return manager.getAttributeValueDiscrete(number, attrIndex);
	}

	public double getAttributeValueContinuous(Attribute key) {
		return manager.getAttributeValueContinuous(number, key);
	}

	public double getAttributeValueContinuous(int attrIndex) {
		return manager.getAttributeValueContinuous(number, attrIndex);
	}

	public long getAttributeValueTimestamp(Attribute key) {
		return manager.getAttributeValueTimestamp(number, key);
	}

	public long getAttributeValueTimestamp(int attrIndex) {
		return manager.getAttributeValueTimestamp(number, attrIndex);
	}

	public String getAttributeValueLiteral(Attribute key) {
		return manager.getAttributeValueLiteral(number, key);
	}

	public String getAttributeValueLiteral(int attrIndex) {
		return manager.getAttributeValueLiteral(number, attrIndex);
	}

	public int getAttributeValueLiteralIndex(Attribute key) {
		return manager.getAttributeValueLiteralIndex(number, key);
	}

	public int getAttributeValueLiteralIndex(int attrIndex) {
		return manager.getAttributeValueLiteralIndex(number, attrIndex);
	}

	public abstract String getName();

}
