package org.processmining.ocbc.performance.logprojection.plugins.dottedchart.filtering;

import java.util.List;

import org.processmining.ocbc.performance.logprojection.filters.EventFilter;

public interface AttributeFilterPanel {

	public static enum Type {
		EVENT, FIRSTEVENTINTRACE, LASTEVENTINTRACE, ANYEVENTINTRACE
	};

	/**
	 * This method is called when the panel is about to be shown.
	 */
	public void opening();

	/**
	 * This method is called when the panel is about to be closed
	 */
	public void closing();

	/**
	 * After closing, the filters to add will be retrieved through this method
	 * 
	 * @return
	 */
	public List<EventFilter> getFiltersToAdd();

	/**
	 * After closing, the filters to remove will be retrieved through this
	 * method
	 * 
	 * @return
	 */
	public List<EventFilter> getFiltersToRemove();

	/**
	 * returns the type of attribute filter panel
	 * 
	 * @return
	 */
	public Type getType();

	/**
	 * returns the number of attributes included in this panel
	 * 
	 * @return
	 */
	public int getAttributeCount();
}