package org.processmining.ocbc.performance.logprojection.plugins.dottedchart.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;

import javax.swing.JFrame;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.util.ui.widgets.InspectorPanel;
import org.processmining.ocbc.performance.logprojection.LogView;
import org.processmining.ocbc.performance.logprojection.plugins.dottedchart.DottedChart.DottedChartException;

public class DottedChartInspector extends InspectorPanel {

	private DottedChartPanel panel;

	public DottedChartInspector(LogView view, PluginContext context) throws DottedChartException {
		this(view, null, context);
	}

	public DottedChartInspector(LogView view, Frame owner) throws DottedChartException {
		this(view, owner, null);
	}

	@Deprecated
	public DottedChartInspector(LogView view) throws DottedChartException {
		this(view, null, null);
	}

	protected DottedChartInspector(LogView view, Frame owner, PluginContext context) throws DottedChartException {
		super(owner != null ? owner : context instanceof UIPluginContext ? ((UIPluginContext) context)
				.getGlobalContext().getUI() : (Frame) null);

		panel = new DottedChartPanel(view);
		if (context != null) {
			panel.addListener(context);
		}

		setLayout(new BorderLayout());
		add(panel);

		// add legend
		addInfo("Legend", new LegendDialog(panel.getDottedChart()));

		getInspector().setMinimumSize(new Dimension(100, 100));
		getInspector().setMaximumSize(new Dimension(200, 200));

	}

	public void updatePanelBasedOnLogView(LogView view, PluginContext context) throws DottedChartException{
		remove(panel);
		panel = new DottedChartPanel(view);
		if (context != null) {
			panel.addListener(context);
		}

		setLayout(new BorderLayout());
		add(panel);
	}
	
	public DottedChartPanel getDottedChartPanel() {
		return panel;
	}

	public LogView getLogView() {
		return panel.getLogView();
	}

	public static void main(String[] args) throws Exception{  					

        System.out.println("************log information*******************");
		
//		JComponent resultWithModel = modelPerspective.conformanceChecking(null, inputLog, inputModel);
		JFrame frame = new JFrame();
//		frame.getContentPane().add(resultWithModel);
		frame.setSize(1800, 1000);
		frame.setVisible(true);	       
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		DottedChartInspector inspectorPanel = new DottedChartInspector(null, frame);
    }
}
