package org.processmining.ocbc.performance.logprojection.sorting;

import org.processmining.ocbc.performance.logprojection.Attribute;
import org.processmining.ocbc.performance.logprojection.LogView;

public class FirstEventAttributeTraceSorter extends
		AbstractEventBasedTraceSorter {

	public FirstEventAttributeTraceSorter(LogView view, Attribute attribute) {
		super(view, attribute);
	}

	@Override
	public int compare(Integer o1, Integer o2) {
		if (view.getTraceLength(o1) == 0) {
			if (view.getTraceLength(o2) == 0) {
				return o1.intValue() - o2.intValue();
			}
			return 1;
		}
		if (view.getTraceLength(o2) == 0) {
			return -1;
		}
		int e1 = view.getFirstEventNumber(o1.intValue());
		int e2 = view.getFirstEventNumber(o2.intValue());
		int res = compare(view.getEventDataManager(), e1, e2);
		if (res == 0) {
			return o1 - o2;
		} else {
			return res;
		}
	}

	@Override
	public String getDescription() {
		return "Sort on " + attribute.getKey() + " of first event.";
	}

	public boolean equals(Object o) {
		if (o instanceof FirstEventAttributeTraceSorter) {
			return ((FirstEventAttributeTraceSorter) o).attribute
					.equals(attribute);
		}
		return false;
	}
}