package org.processmining.ocbc.performance.logprojection.sorting;

import org.processmining.ocbc.performance.logprojection.Attribute;
import org.processmining.ocbc.performance.logprojection.LogView;

public class TraceAttributeSorter extends AbstractEventBasedTraceSorter {

	public TraceAttributeSorter(LogView view, Attribute attribute) {
		super(view, attribute);
	}

	@Override
	public int compare(Integer o1, Integer o2) {
		int res = compare(view.getTraceDataManager(), o1, o2);
		if (res == 0) {
			return o1 - o2;
		} else {
			return res;
		}

	}

	@Override
	public String getDescription() {
		return "Sort on " + attribute.getKey() + " of trace.";
	}

	public boolean equals(Object o) {
		if (o instanceof TraceAttributeSorter) {
			return ((TraceAttributeSorter) o).attribute.equals(attribute);
		}
		return false;
	}

}
